/* This is the collection of routines and event handlers for the RDB Profiler feature to be added
   to AppView.

   The Profiler generates a table of the different resource types within an application, and the
   number of records and bytes used in each resource type.  This helps users to find out which
   parts of an application are using the most space.

   In AppView's case it'd probably be bitmaps and strings from the About box.
*/

#ifndef PROFILERHANDLER_H
#define PROFILERHANDLER_H

typedef struct {
  ULong type;
  ULong numRecords;
  ULong numBytes;
} TableEntry;
typedef TableEntry *TableEntryPtr;

typedef struct {
  UInt numEntries;
  TableEntry entry[10];
} ProfileType;
typedef ProfileType *ProfileTypePtr;

/* find the entry in the table with given type.  If not present, add it. */
/* resizes handle if necessary */
UInt getEntryIndex(VoidHand table, ULong type);
Int compareTableEntries(const VoidPtr a, const VoidPtr b, Long other);

Boolean ProfilerHandleEvent(EventPtr event);

#endif
