/***********************************************************************
 * 
 *
 * PROJECT:			Mendeleev Periodic Table
 *
 * FILE:				Mendeleev.c 
 *
 *       
 *
 * DESCRIPTION: Simple Periodic Table
 *		
 *
 * REVISION HISTORY:
 * 	 
 *
 **********************************************************************/
 
#include <Pilot.h>				// all the system toolbox headers
#include "StarterRsc.h"			// application resource defines
#include <FeatureMgr.h>	

#define version20	0x02000000	// P4. PalmOS 2.0 version number
 
/***********************************************************************
 * Global variables for this module
 **********************************************************************/
static MenuBarPtr		CurrentMenu = NULL;	// P2. ptr to current menu
static Word				CurrentView;
static int				LastActiveForm;
static CharPtr			strElementData="";
static UInt				currentElement;

/***********************************************************************
 * Prototypes for internal functions
 **********************************************************************/
static void StartApplication(void);

static void SetCurrentMenu(Word rscID);	// P2. set new current menu

static Boolean Table2FormHandleEvent(EventPtr event);
static Boolean MainFormHandleEvent(EventPtr event);
static Boolean ElementFormHandleEvent(EventPtr event);
static Boolean AboutFormHandleEvent(EventPtr event);
static Err RomVersionCompatible (DWord requiredVersion, Word launchFlags);
static Boolean ApplicationHandleEvent(EventPtr event);
static void EventLoop(void);



static Boolean SetElementData(FormPtr frm,UInt number);

static char* arElementData[111][28]=
{
{"1","H","Hydrogen","1766","GAS","1520","1.00794","14.4","0.79","0.32","13.598","0.0899","20.268","14.025","N/A","0.001815","14.304","3.75","HEX","N/A","N/A","N/A","-0.374","79.9","0.3326","2.2","2.20","7.18"},
{"2","He","Helium","1895","GAS","0.008","4.002602","N/A","0.49","0.93","24.587","0.1787","4.215","0.95","N/A","0.00152","5.193","3.57","HEX","N/A","N/A","N/A","0.326","0.0","0.00747","N/A","N/A","12.3"},
{"3","Li","Lithium","1817","SOL","20","6.941","13.10","2.05","1.23","5.392","0.53","1615","453.7","0.108","0.847","3.6","3.49","BCC","N/A","N/A","N/A","-0.190","0.91","70.5","1.0","0.98","3.01"},
{"4","Be","Beryllium","1798","SOL","2.6","9.012182","5.0","1.40","0.90","9.322","1.85","2745","1560.0","0.313","2.00","1.82","2.29","HEX","1.567","N/A","N/A","0.779","0.005","0.0076","1.5","1.57","4.9"},
{"5","B","Boron","1828","SOL","10","10.811","4.6","1.17","0.82","8.298","2.34","4275","2300.0","1.0e-12","0.270","1.02","8.73","TET","0.576","N/A","N/A","0.530","1.7","767.0","2.0","2.04","4.29"},
{"6","C","Carbon","N/A","SOL","480","12.011","4.58","0.91","0.77","11.260","2.62","4470.0","4100.0","0.00061","1.29","0.71","3.57","DIA","N/A","N/A","N/A","0.6648","0.001","0.0035","2.5","2.55","6.27"},
{"7","N","Nitrogen","1772","GAS","25","14.00674","17.3","0.75","0.75","14.534","1.251","77.35","63.14","N/A","0.0002598","1.04","4.039","HEX","1.051","N/A","N/A","0.936","0.49","1.90","3.1","3.04","7.30"},
{"8","O","Oxygen","1774","GAS","474000","15.9994","14.0","0.65","0.73","13.618","1.429","90.18","50.35","N/A","0.0002674","0.92","6.83","CUB","N/A","N/A","N/A","0.5805","0.000","0.00019","3.5","3.44","7.54"},
{"9","F","Fluorine","1886","GAS","950","18.9984032","17.1","0.57","0.72","17.422","1.696","84.95","53.48","N/A","0.000279","0.82","N/A","MCL","N/A","N/A","N/A","0.5654","0.0008","0.0096","4.1","3.98","10.41"},
{"10","Ne","Neon","1898","GAS","7e-5","20.1797","16.7","0.51","0.71","21.564","0.901","27.096","24.553","N/A","0.000493","0.904","4.43","FCC","N/A","N/A","N/A","0.4547","0.008","0.039","N/A","N/A","10.6"},
{"11","Na","Sodium","1807","SOL","23000","22.989768","23.7","2.23","1.54","5.139","0.97","1156","371.0","0.139","1.41","1.23","4.23","BCC","N/A","N/A","N/A","0.363","1.62","0.530","1.0","0.93","2.85"},
{"12","Mg","Magnesium","1808","SOL","23000","24.3050","13.97","1.72","1.36","7.646","1.74","1363","922","0.226","1.56","1.02","3.21","HEX","1.624","N/A","N/A","0.5375","0.077","0.063","1.2","1.31","3.75"},
{"13","Al","Aluminum","1825","SOL","82000","26.981539","10.0","1.82","1.18","5.986","2.70","2793","933.25","0.377","2.37","0.90","4.05","FCC","N/A","N/A","N/A","0.3449","0.0085","0.231","1.5","1.61","3.23"},
{"14","Si","Silicon","1823","SOL","277000","28.0855","12.1","1.46","1.11","8.151","2.33","3540.0","1685","2.52e-12","1.48","0.71","5.43","DIA","N/A","N/A","N/A","0.4149","0.015","0.171","1.7","1.90","4.77"},
{"15","P","Phosphorus","1669","SOL","1000","30.97362","17.0","1.23","1.06","10.486","1.82","550.0","317.30","1.0e-17","0.00235","0.77","7.17","CUB","N/A","N/A","N/A","0.513","0.006","0.172","2.1","2.19","5.62"},
{"16","S","Sulfur","N/A","SOL","260","32.066","15.5","1.09","1.02","10.360","2.07","717.75","388.36","0.5e-23","0.00269","0.71","10.47","ORC","2.339","N/A","1.229","0.2847","0.007","0.53","2.4","2.58","6.22"},
{"17","Cl","Chlorine","1774","GAS","130","35.4527","22.7","0.97","0.99","12.967","3.17","239.1","172.16","N/A","0.000089","0.48","6.24","ORC","1.324","N/A","0.718","0.95792","5.2","33.5","2.8","3.16","8.30"},
{"18","Ar","Argon","1894","GAS","1.2","39.948","28.5","0.88","0.98","15.759","1.784","87.30","83.81","N/A","0.0001772","0.520","5.26","FCC","N/A","N/A","N/A","0.1909","0.22","0.675","N/A","N/A","7.70"},
{"19","K","Potassium","1807","SOL","21000","39.0983","45.46","2.77","2.03","4.341","0.86","1032","336.35","0.139","1","0.75","5.23","BCC","N/A","N/A","N/A","0.371","0.25","2.1","0.9","0.82","2.42"},
{"20","Ca","Calcium","1808","SOL","41000","40.078","29.9","2.23","1.91","6.113","1.55","1757","1112","0.298","2.00","0.63","5.58","FCC","N/A","N/A","N/A","0.490","0.03","0.43","1.0","1.00","2.2"},
{"21","Sc","Scandium","1879","SOL","16","44.955910","15.0","2.09","1.62","6.54","3.0","3104","1812","0.0177","0.158","0.6","3.31","HEX","1.594","N/A","N/A","1.229","4.5","27.2","1.2","1.36","3.34"},
{"22","Ti","Titanium","1791","SOL","5600","47.88","10.64","2.00","1.45","6.82","4.50","3562","1943","0.0234","0.219","0.52","2.95","HEX","1.588","N/A","N/A","-0.330","2.67","6.09","1.3","1.54","3.45"},
{"23","V","Vanadium","1830","SOL","160","50.9415","8.78","1.92","1.34","6.74","5.8","3682","2175","0.0489","0.307","0.49","3.02","BCC","N/A","N/A","N/A","-0.0382","5.187","5.08","1.5","1.63","3.6"},
{"24","Cr","Chromium","1797","SOL","100","51.9961","7.23","1.85","1.18","6.766","7.19","2945","2130.0","0.0774","0.937","0.45","2.88","BCC","N/A","N/A","N/A","0.3635","1.83","3.07","1.6","1.66","3.72"},
{"25","Mn","Manganese","1774","SOL","950","54.93085","1.39","1.79","1.17","7.435","7.43","2335","1517","0.00695","0.0782","0.48","8.89","CUB","N/A","N/A","N/A","-0.373","0.40","13.3","1.6","1.55","3.72"},
{"26","Fe","Iron","N/A","SOL","41000","55.847","7.1","1.72","1.17","7.870","7.86","3135","1809","0.0993","0.802","0.44","2.87","BCC","N/A","N/A","N/A","0.954","0.39","2.56","1.6","1.83","4.06"},
{"27","Co","Cobalt","1737","SOL","20","58.93320","6.7","1.67","1.16","7.86","8.90","3201","1768","0.172","1.00","0.42","2.51","HEX","1.622","N/A","N/A","0.250","4.8","37.18","1.7","1.88","4.3"},
{"28","Ni","Nickel","1751","SOL","80","58.69","6.59","1.62","1.15","7.635","8.90","3187","1726","0.143","0.907","0.44","3.52","FCC","N/A","N/A","N/A","1.03","5.2","4.49","1.8","1.91","4.40"},
{"29","Cu","Copper","N/A","SOL","50","63.546","7.1","1.57","1.17","7.726","8.96","2836","1357.6","0.596","4.01","0.38","3.61","FCC","N/A","N/A","N/A","0.7718","0.52","3.78","1.8","1.90","4.48"},
{"30","Zn","Zinc","1746","SOL","75","65.39","9.2","1.53","1.25","9.394","7.14","1180.0","692.73","0.166","1.16","0.39","2.66","HEX","1.856","N/A","N/A","0.5680","0.077","1.11","1.7","1.65","4.45"},
{"31","Ga","Gallium","1875","SOL","18","69.723","11.8","1.81","1.26","5.999","5.91","2478","302.90","0.0678","0.406","0.37","4.51","ORC","1.695","N/A","1.001","0.7288","0.0","2.9","1.8","1.81","3.2"},
{"32","Ge","Germanium","1886","SOL","1.8","72.61","13.6","1.52","1.22","7.899","5.32","3107","1210.4","1","0.599","0.32","5.66","DIA","N/A","N/A","N/A","0.81929","0.17","2.3","2.0","2.01","4.6"},
{"33","As","Arsenic","N/A","SOL","1.5","74.92159","13.1","1.33","1.20","9.81","5.72","876","1081","0.0345","0.500","0.33","4.13","RHL","N/A","54.10","N/A","0.658","0.060","4.5","2.2","2.18","5.3"},
{"34","Se","Selenium","1817","SOL","0.05","78.96","16.45","1.22","1.16","9.752","4.80","958","494","1.0e-12","0.0204","0.32","4.36","HEX","1.136","N/A","N/A","0.797","0.33","11.7","2.5","2.55","5.89"},
{"35","Br","Bromine","1826","LIQ","0.37","79.904","23.5","1.12","1.14","11.814","3.12","332.25","265.90","N/A","0.00122","0.473","6.67","ORC","0.672","N/A","1.307","0.679","0.10","6.9","2.7","2.96","7.59"},
{"36","Kr","Krypton","1898","GAS","1e-5","83.80","38.9","1.03","1.12","13.999","3.74","119.80","115.78","N/A","0.0000949","0.248","5.72","FCC","N/A","N/A","N/A","0.780","0.03","25.0","N/A","N/A","6.8"},
{"37","Rb","Rubidium","1861","SOL","90","85.4678","55.9","2.98","2.16","4.177","1.53","961","312.64","0.0779","0.582","0.363","5.59","BCC","N/A","N/A","N/A","0.708","0.3","0.38","0.9","0.82","2.34"},
{"38","Sr","Strontium","1790","SOL","370","87.62","33.7","2.45","1.91","5.695","2.6","1650.0","1041","0.0762","0.353","0.30","6.08","FCC","N/A","N/A","N/A","0.702","0.04","1.28","1.0","0.95","2.0"},
{"39","Y","Yttrium","1794","SOL","30","88.90585","19.8","2.27","1.62","6.38","4.5","3611","1799","0.0166","0.172","0.30","3.65","HEX","1.571","N/A","N/A","0.775","0.15","1.28","1.1","1.22","3.19"},
{"40","Zr","Zirconium","1789","SOL","190","91.224","14.1","2.16","1.45","6.84","6.49","4682","2125","0.0236","0.227","0.27","3.23","HEX","1.593","N/A","N/A","0.716","0.16","0.185","1.2","1.33","3.64"},
{"41","Nb","Niobium","1801","SOL","20","92.90638","10.87","2.09","1.34","6.88","8.55","5017","2740.0","0.0693","0.537","0.26","3.30","BCC","N/A","N/A","N/A","0.7054","0.0024","1.15","1.2","1.6","4.0"},
{"42","Mo","Molybdenum","1778","SOL","1.5","95.94","9.4","2.01","1.30","7.099","10.2","4912","2890.0","0.187","1.38","0.25","3.15","BCC","N/A","N/A","N/A","0.695","0.28","2.55","1.3","2.16","3.9"},
{"43","Tc","Technetium","1937","RAD","7e-4","98.9063","8.5","1.95","1.27","7.28","11.5","4538","2473","0.067","0.506","0.21","2.74","HEX","1.604","N/A","N/A","0.68","0.0","20.0","1.4","1.9","3.91"},
{"44","Ru","Ruthenium","1844","SOL","0.001","101.07","8.3","1.89","1.25","7.37","12.2","4423","2523","0.137","1.17","0.238","2.70","HEX","1.584","N/A","N/A","0.721","0.07","2.56","1.4","2.2","4.5"},
{"45","Rh","Rhodium","1803","SOL","2e-4","102.90550","8.3","1.83","1.25","7.46","12.4","3970.0","2236","0.211","1.50","0.242","3.90","FCC","N/A","N/A","N/A","0.588","0.0","145.0","1.5","2.28","4.30"},
{"46","Pd","Palladium","1803","SOL","6e-4","106.42","8.9","1.79","1.28","8.34","12.0","3237","1825","0.0950","0.718","0.24","3.89","FCC","N/A","N/A","N/A","0.591","0.093","6.9","1.4","2.20","4.45"},
{"47","Ag","Silver","N/A","SOL","0.07","107.8682","10.3","1.75","1.34","7.576","10.5","2436","1234","0.630","4.29","0.235","4.09","FCC","N/A","N/A","N/A","0.5922","0.58","63.3","1.4","1.93","4.44"},
{"48","Cd","Cadmium","1817","SOL","0.11","112.411","13.1","1.71","1.48","8.993","8.65","1040.0","594.18","0.138","0.968","0.23","2.98","HEX","1.886","N/A","N/A","0.51","2.4","2520.0","1.5","1.69","4.33"},
{"49","In","Indium","1863","SOL","0.049","114.82","15.7","2.00","1.44","5.786","7.31","2346","429.76","0.116","0.816","0.23","4.59","TET","1.076","N/A","N/A","0.4065","0.54","193.8","1.5","1.78","3.1"},
{"50","Sn","Tin","N/A","SOL","2.2","118.710","16.3","1.72","1.41","7.344","7.30","2876","505.06","0.0917","0.666","0.227","5.82","TET","0.546","N/A","N/A","0.6228","0.022","0.626","1.7","1.96","4.30"},
{"51","Sb","Antimony","N/A","SOL","0.2","121.75","18.23","1.53","1.40","8.641","6.68","1860.0","904","0.0288","0.243","0.21","4.51","RHL","N/A","57.6","N/A","0.5641","0.3","5.1","1.8","2.05","4.85"},
{"52","Te","Tellurium","1782","SOL","0.005","127.60","20.5","1.42","1.36","9.009","6.24","1261","722.65","2.0e-6","0.0235","0.20","4.45","HEX","1.33","N/A","N/A","0.543","0.02","4.7","2.0","2.1","5.49"},
{"53","I","Iodine","1804","SOL","0.14","126.90447","25.74","1.32","1.33","10.451","4.92","458.4","386.7","8.0e-16","0.00449","0.214","7.27","ORC","0.659","N/A","1.347","0.528","0.0","6.2","2.2","2.66","6.76"},
{"54","Xe","Xenon","1898","GAS","2e-6","131.29","37.3","1.24","1.31","12.130","5.89","165.03","161.36","N/A","0.0000569","0.158","6.20","FCC","N/A","N/A","N/A","0.485","0.0","23.9","N/A","2.6","5.85"},
{"55","Cs","Cesium","1860","SOL","3","132.90543","71.07","3.34","2.35","3.894","1.87","944","301.55","0.0489","0.359","0.24","6.05","BCC","N/A","N/A","N/A","0.542","0.21","29.0","0.9","0.79","2.18"},
{"56","Ba","Barium","1808","SOL","500","137.327","39.24","2.78","1.98","5.212","3.5","2171","1002","0.030","0.184","0.204","5.02","BCC","N/A","N/A","N/A","0.525","0.01","1.2","1.0","0.89","2.4"},
{"57","La","Lanthanum","1839","SOL","32","138.9055","20.73","2.74","1.69","5.577","6.7","3730.0","1193","0.0126","0.135","0.19","3.75","HEX","1.619","N/A","N/A","0.824","1.13","8.97","1.1","1.10","3.1"},
{"58","Ce","Cerium","1803","SOL","68","140.115","20.67","2.70","1.65","5.47","6.78","3699","1071","0.0115","0.114","0.19","5.16","FCC","N/A","N/A","N/A","0.484","0.0","0.63","1.1","1.12","3.0"},
{"59","Pr","Praseodymium","1885","SOL","9.5","140.90765","20.8","2.67","1.65","5.42","6.77","3785","1204","0.0148","0.125","0.19","3.67","HEX","1.614","N/A","N/A","0.445","0.016","11.5","1.1","1.13","3.0"},
{"60","Nd","Neodymium","1925","SOL","38","144.24","20.6","2.64","1.64","5.49","7.00","3341","1289","0.0157","0.165","0.19","3.66","HEX","1.614","N/A","N/A","0.769","11.","50.5","1.1","1.14","3.0"},
{"61","Pm","Promethium","1945","RAD","TRC","146.9151","22.39","2.62","1.63","5.55","6.475","3785","1204","N/A","0.179","0.18","N/A","N/A","N/A","N/A","N/A","1.26","1.3","168.4","1.1","N/A","3.0"},
{"62","Sm","Samarium","1879","SOL","7.9","150.36","19.95","2.59","1.62","5.63","7.54","2064","1345","0.00956","0.133","0.20","9.00","RHL","N/A","23.13","N/A","0.42","50.","5670.","1.1","1.17","3.1"},
{"63","Eu","Europium","1901","SOL","2.1","151.965","28.9","2.56","1.85","5.67","5.26","1870.0","1090.0","0.0112","0.139","0.18","4.61","BCC","N/A","N/A","N/A","0.668","2.2","4600.","1.0","N/A","3.1"},
{"64","Gd","Gadolinium","1880","SOL","7.7","157.25","19.9","2.54","1.61","6.14","7.89","3539","1585","0.00736","0.106","0.23","3.64","HEX","1.588","N/A","N/A","0.95","158.0","48890.","1.1","1.20","3.3"},
{"65","Tb","Terbium","1843","SOL","1.1","158.92534","19.2","2.51","1.59","5.85","8.27","3496","1630.0","0.00889","0.111","0.18","3.60","HEX","1.581","N/A","N/A","0.738","0.004","23.4","1.1","N/A","3.2"},
{"66","Dy","Dysprosium","1886","SOL","6","162.50","19.0","2.49","1.59","5.93","8.54","2835","1682","0.0108","0.107","0.17","3.59","HEX","1.573","N/A","N/A","1.69","54.5","940.","1.1","1.22","N/A"},
{"67","Ho","Holmium","1878","SOL","1.4","164.93032","18.7","2.47","1.58","6.02","8.80","2968","1743","0.0124","0.162","0.16","3.58","HEX","1.570","N/A","N/A","0.808","0.36","64.7","1.1","1.23","3.3"},
{"68","Er","Erbium","1843","SOL","3.8","167.26","18.4","2.45","1.57","6.10","9.05","3136","1795","0.0117","0.143","0.17","3.56","HEX","1.570","N/A","N/A","0.803","1.2","159.2","1.1","1.24","3.3"},
{"69","Tm","Thulium","1879","SOL","0.48","168.93421","18.1","2.42","1.56","6.18","9.33","2220.0","1818","0.0150","0.168","0.16","3.54","HEX","1.570","N/A","N/A","0.705","0.41","105.","1.1","1.25","3.4"},
{"70","Yb","Ytterbium","1878","SOL","5.3","173.04","24.79","2.40","1.74","6.254","6.98","1467","1097","0.0351","0.349","0.15","5.49","FCC","N/A","N/A","N/A","1.24","3.0","35.1","1.1","N/A","3.5"},
{"71","Lu","Lutetium","1907","SOL","0.51","174.967","17.78","2.25","1.56","5.426","9.84","3668","1936","0.0185","0.164","0.15","3.51","HEX","1.585","N/A","N/A","0.73","0.1","76.4","1.1","1.27","3.0"},
{"72","Hf","Hafnium","1923","SOL","3.3","178.49","13.6","2.16","1.44","7.0","13.1","4876","2500.0","0.0312","0.230","0.14","3.20","HEX","1.582","N/A","N/A","0.777","2.6","104.1","1.2","1.3","3.8"},
{"73","Ta","Tantalum","1802","SOL","2","180.9479","10.90","2.09","1.34","7.89","16.6","5731","3287","0.0761","0.575","0.14","3.31","BCC","N/A","N/A","N/A","0.691","0.02","20.6","1.4","1.5","4.11"},
{"74","W","Tungsten","1783","SOL","1","183.85","9.53","2.02","1.30","7.98","19.3","5828","3680.0","0.189","1.74","0.13","3.16","BCC","N/A","N/A","N/A","0.477","2.00","18.4","1.4","2.36","4.40"},
{"75","Re","Rhenium","1925","SOL","4e-4","186.207","8.85","1.97","1.28","7.88","21.0","5869","3453","0.0542","0.479","0.13","2.76","HEX","1.615","N/A","N/A","0.92","0.9","90.7","1.5","1.9","4.02"},
{"76","Os","Osmium","1804","SOL","1e-4","190.2","8.49","1.92","1.26","8.7","22.4","5285","3300.0","0.109","0.876","0.13","2.74","HEX","1.579","N/A","N/A","1.10","0.4","16.0","1.5","2.2","4.9"},
{"77","Ir","Iridium","1804","SOL","3e-6","192.22","8.54","1.87","1.27","9.1","22.5","4701","2716","0.197","1.47","0.130","3.84","FCC","N/A","N/A","N/A","1.06","0.2","425.3","1.6","2.20","5.4"},
{"78","Pt","Platinum","1735","SOL","0.001","195.08","9.10","1.83","1.30","9.0","21.4","4100.0","2045","0.0966","0.716","0.13","3.92","FCC","N/A","N/A","N/A","0.963","0.13","10.3","1.4","2.28","5.6"},
{"79","Au","Gold","N/A","SOL","0.0011","196.96654","10.2","1.79","1.34","9.225","19.3","3130.0","1337.58","0.452","3.17","0.128","4.08","FCC","N/A","N/A","N/A","0.763","0.36","98.65","1.4","2.54","5.77"},
{"80","Hg","Mercury","N/A","LIQ","0.05","200.59","14.82","1.76","1.49","10.437","13.53","630.0","234.28","0.0104","0.0834","0.139","2.99","RHL","N/A","70.45","N/A","1.266","6.7","372.3","1.5","2.00","4.91"},
{"81","Tl","Thallium","1861","SOL","0.6","204.3833","17.2","2.08","1.48","6.108","11.85","1746","577","0.0617","0.461","0.13","3.46","HEX","1.599","N/A","N/A","0.8785","0.14","3.43","1.4","1.62","3.2"},
{"82","Pb","Lead","N/A","SOL","14","207.2","18.17","1.81","1.47","7.416","11.4","2023","600.6","0.0481","0.353","0.13","4.95","FCC","N/A","N/A","N/A","0.94003","0.003","0.171","1.6","2.33","3.90"},
{"83","Bi","Bismuth","N/A","SOL","0.048","208.98037","21.3","1.63","1.46","7.289","9.8","1837","544.52","0.00867","0.0787","0.12","4.75","RHL","N/A","57.14","N/A","0.85256","0.0072","0.0338","1.7","2.02","4.69"},
{"84","Po","Polonium","1898","RAD","TRC","208.9824","22.23","1.53","1.46","8.42","9.4","1235","527","0.0219","0.20","0.12","3.35","SCB","N/A","N/A","N/A","N/A","N/A","N/A","1.8","2.0","5.16"},
{"85","At","Astatine","1940","RAD","TRC","209.9871","N/A","1.43","1.45","9.5","N/A","610.0","575","N/A","0.017","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","2.0","2.2","6.2"},
{"86","Rn","Radon","1898","GAS","TRC","222.0176","50.5","1.34","1.43","10.748","9.91","211","202","N/A","0.0000364","0.09","N/A","FCC","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","5.1"},
{"87","Fr","Francium","1939","RAD","0","223.0197","N/A","3.50","2.50","4.0","N/A","950.0","300.0","0.03","0.15","N/A","N/A","BCC","N/A","N/A","N/A","0.8495","0.0072","0.036","0.9","0.7","N/A"},
{"88","Ra","Radium","1898","RAD","6e-7","226.0254","45.20","3.00","2.40","5.279","5","1809","973","N/A","0.186","0.12","N/A","N/A","N/A","N/A","N/A","1.0","0.0","12.8","1.0","0.89","N/A"},
{"89","Ac","Actinium","1899","RAD","TRC","227.0278","22.54","3.20","2.20","6.9","10.07","3473","1323","N/A","0.12","N/A","5.31","FCC","N/A","N/A","N/A","N/A","N/A","N/A","1.0","1.1","N/A"},
{"90","Th","Thorium","1828","RAD","12","232.0381","19.9","3.16","1.65","6.95","11.7","5061","2028","0.0653","0.540","0.12","5.08","FCC","N/A","N/A","N/A","0.984","0.0","7.37","1.1","1.3","N/A"},
{"91","Pa","Protactinium","1917","RAD","TRC","231.0359","15.0","3.14","N/A","N/A","15.4","N/A","N/A","0.0529","0.47","0.12","3.92","TET","0.825","N/A","N/A","0.91","0.0","200.6","1.1","1.5","N/A"},
{"92","U","Uranium","1789","RAD","2.4","238.0289","12.59","3.11","1.42","6.08","18.90","4407","1405","0.0380","0.276","0.12","2.85","ORC","1.736","N/A","2.056","0.8417","0.004","7.57","1.2","1.38","N/A"},
{"93","Np","Neptunium","1940","RAD","0","237.0482","11.62","3.08","N/A","N/A","20.4","N/A","910.0","0.00822","0.063","0.12","4.72","ORC","1.035","N/A","1.411","1.055","0.0","175.9","1.2","1.36","N/A"},
{"94","Pu","Plutonium","1940","RAD","TRC","244.0642","12.32","3.05","N/A","5.8","19.8","3503","913","0.00666","0.0674","0.13","N/A","MCL","N/A","N/A","N/A","1.41","0.0","558.","1.2","1.28","N/A"},
{"95","Am","Americium","1945","RAD","0","243.0614","17.86","3.02","N/A","6.0","13.6","2880.0","1268","0.022","0.1","0.11","N/A","N/A","N/A","N/A","N/A","0.83","0.0","75.3","1.2","1.3","N/A"},
{"96","Cm","Curium","1944","RAD","0","247.0703","18.28","2.99","N/A","N/A","13.511","N/A","1340.0","N/A","0.1","N/A","N/A","N/A","N/A","N/A","N/A","0.7","0.0","0.0","1.2","1.3","N/A"},
{"97","Bk","Berkelium","1949","RAD","0","247.0703","N/A","2.97","N/A","N/A","N/A","N/A","N/A","N/A","0.1","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","1.2","1.3","N/A"},
{"98","Cf","Californium","1950","RAD","0","251.0796","N/A","2.95","N/A","N/A","N/A","N/A","900.0","N/A","0.1","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","1.2","1.3","N/A"},
{"99","Es","Einsteinium","1952","RAD","0","252.0829","N/A","2.92","N/A","N/A","N/A","N/A","N/A","N/A","0.1","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","1.2","1.3","3.5"},
{"100","Fm","Fermium","1953","RAD","0","257.0951","N/A","2.90","N/A","N/A","N/A","N/A","N/A","N/A","0.1","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","1.2","1.3","N/A"},
{"101","Md","Mendelevium","1955","RAD","0","258.0986","N/A","2.87","N/A","N/A","N/A","N/A","N/A","N/A","0.1","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","1.2","1.3","N/A"},
{"102","No","Nobelium","1957","RAD","0","259.1009","N/A","2.85","N/A","N/A","N/A","N/A","N/A","N/A","0.1","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","1.3","N/A"},
{"103","Lr","Lawrencium","1961","RAD","0","260.1053","N/A","2.82","N/A","N/A","N/A","N/A","N/A","N/A","0.1","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","1.3","N/A"},
{"104","Rf","Rutherfordium","1969","RAD","0","261.1087","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","0.23","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"},
{"105","Db","Dubnium","1970","RAD","0","262.1138","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","0.58","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"},
{"106","Sg","Seaborgium","1974","RAD","0","263.1182","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"},
{"107","Bh","Bohrium","1976","RAD","0","262.1229","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"},
{"108","Hs","Hassium","N/A","RAD","0","265","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"},
{"109","Mt","Meitnerium","1982","RAD","0","266","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"},
{"110","Unn","Ununnilium","1987","RAD","0","270","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"},
{"111","Unu","Unnununium","1987","RAD","0","272","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"}

};
/***********************************************************************
 *
 * FUNCTION:    RomVersionCompatible
 *
 * DESCRIPTION: P4. Check that the ROM version meets your
 *              minimum requirement.  Warn if the app was switched to.
 *
 * PARAMETERS:  requiredVersion - minimum rom version required
 *                                (see sysFtrNumROMVersion in SystemMgr.h 
 *                                for format)
 *              launchFlags     - flags indicating how the application was
 *											 launched.  A warning is displayed only if
 *                                these flags indicate that the app is 
 *											 launched normally.
 *
 * RETURNED:    zero if rom is compatible else an error code
 *                             
 ***********************************************************************/
static Err RomVersionCompatible (DWord requiredVersion, Word launchFlags)
{
	DWord romVersion;
	
	
	// See if we're on in minimum required version of the ROM or later.
	// The system records the version number in a feature.  A feature is a
	// piece of information which can be looked up by a creator and feature
	// number.
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
		{
		// If the user launched the app from the launcher, explain
		// why the app shouldn't run.  If the app was contacted for something
		// else, like it was asked to find a string by the system find, then
		// don't bother the user with a warning dialog.  These flags tell how
		// the app was launched to decided if a warning should be displayed.
		if ((launchFlags & (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
			{
			//FrmAlert (RomIncompatibleAlert);
		
			// Pilot 1.0 will continuously relaunch this app unless we switch to 
			// another safe one.  The sysFileCDefaultApp is considered "safe".
			if (romVersion < 0x02000000)
				AppLaunchWithCommand(sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL);
			}
		
		return (sysErrRomIncompatible);
		}

	return 0;
}

/***********************************************************************
 *
 * FUNCTION:     SetElementData
 *
 * DESCRIPTION:  This routine sets element information to corresponding fields
 *
 * PARAMETERS:   pointer to the form and number of the element.
 *
 * RETURNED:     true if OK.
 *
 ***********************************************************************/
static Boolean SetElementData(FormPtr frm,UInt number)
{
		FieldPtr fldPtr;
		UInt i,property;
			
		Handle newHandle;
		CharPtr newText;
		
		property=0; 
		
		for (i=1305;i<=1329;i++)
		{
			fldPtr = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, i));
			
			strElementData=arElementData[number][property];
			newHandle = MemHandleNew(StrLen(strElementData) + 1);
			newText = MemHandleLock(newHandle);

			StrCopy(newText, strElementData);

			MemHandleUnlock(newHandle);			
			FldSetTextHandle(fldPtr, newHandle);
			
			FldDrawField(fldPtr);

			newHandle=NULL;
			fldPtr=NULL;
			
			property++;
		}


	return 0;
}

/***********************************************************************
 *
 * FUNCTION:     StartApplication
 *
 * DESCRIPTION:  This routine sets up the initial state of the application.
 *
 * PARAMETERS:   None.
 *
 * RETURNED:     Nothing.
 *
 ***********************************************************************/
static void StartApplication(void)
{
	FormPtr	frm;

	CurrentView=Table1Form;
	
	// Initialize and draw the main memo pad form.
	frm = FrmInitForm(Table1Form);	
	FrmSetActiveForm(frm);
	
	FrmDrawForm(frm);

	SetCurrentMenu(MainFormMenuBar);		// P2. set the current menu to the main menu

}

/***********************************************************************
 *
 * FUNCTION:    SetCurrentMenu
 *
 * DESCRIPTION: P2. This routine loads the specified menu resource and makes
 *              it the current menu.  
 *
 * PARAMETERS:  rscID  - resource id of the new menu
 *
 * RETURNED:    nothing
 *
 ***********************************************************************/
static void SetCurrentMenu(Word rscID)
{
	// Dispose of an existing current menu.
	if (CurrentMenu)
		MenuDispose(CurrentMenu);
	
	// Set the current menu and remember it.
	CurrentMenu = MenuInit(rscID);
}


/***********************************************************************
 *
 * FUNCTION:		Table2FormHandleEvent
 *
 * DESCRIPTION:	Handles processing of events for the main form.
 *
 * PARAMETERS:		event		- the most recent event.
 *
 * RETURNED:		True if the event is handled, false otherwise.
 *
 ***********************************************************************/
static Boolean Table2FormHandleEvent(EventPtr event)
{
	Boolean  handled= false;

	UInt elementNum;
	switch(event->eType)
	{
		case ctlSelectEvent:
	
			if (event->data.ctlEnter.controlID==Table2Table1Button)
			{
 				FrmGotoForm(Table1Form);
 				handled=true;
 			}else
 			
 			if (event->data.ctlEnter.controlID)
	   		{


		   		elementNum=event->data.ctlEnter.controlID;
		   		
		   		if (elementNum>=188 && elementNum<=190)
		   		{
		   			elementNum-=88;
		   			}else
		   			
		   		elementNum-=100;//offset for control id to match element id
		   			

				currentElement=elementNum-1;
				
		   		FrmSetControlValue (FrmGetFormPtr(100) ,FrmGetObjectIndex(FrmGetFormPtr(100),event->data.ctlEnter.controlID),0);

		   		LastActiveForm=100;
	   			FrmGotoForm(ElementInfoForm);
							

	   		}
			handled=true;
					
			break;
		
		case frmOpenEvent:
		
			FrmDrawForm(FrmGetActiveForm());
			handled= true;
			break;
	
		case menuEvent:
				
			// A menu item was selected.
			// The get info being the only menu item, display the info form.
			
			// First clear the menu status from the display.
			MenuEraseStatus(CurrentMenu);
			
			LastActiveForm=100;
			
			// Load the info form, then display it.
			FrmGotoForm(AboutForm);
				 		
			handled = true;
			break;

	}
		return(handled);

}
/***********************************************************************
 *
 * FUNCTION:		ElementFormHandleEvent
 *
 * DESCRIPTION:	Handles processing of events for the main form.
 *
 * PARAMETERS:		event		- the most recent event.
 *
 * RETURNED:		True if the event is handled, false otherwise.
 *
 ***********************************************************************/
static Boolean ElementFormHandleEvent(EventPtr event)
{
	Boolean  handled= false;
	FormPtr frm;
	

	
	switch(event->eType)
	{
		case ctlSelectEvent:
		if (event->data.ctlEnter.controlID==ElementInfoOKButton)
			{
 				
 				FrmEraseForm(FrmGetFormPtr(1300));
	 	 			
	 	 		if(LastActiveForm==100)
	 	 		{
		 			FrmGotoForm(Table2Form);
		 		}else
			 		FrmGotoForm(Table1Form);
			 		
 				
 			}
 			handled=true;

			break;
		
		case frmOpenEvent:
		
			FrmDrawForm(FrmGetActiveForm());
			
			frm = FrmGetActiveForm ();
			
			SetElementData(frm,currentElement);

			handled= true;
			break;
	}
		return(handled);

}
/***********************************************************************
 *
 * FUNCTION:		AboutFormHandleEvent
 *
 * DESCRIPTION:	Handles processing of events for the About form.
 *
 * PARAMETERS:		event		- the most recent event.
 *
 * RETURNED:		True if the event is handled, false otherwise.
 *
 ***********************************************************************/
static Boolean AboutFormHandleEvent(EventPtr event)
{
	Boolean  handled= false;
	FormPtr frm;
	

	
	switch(event->eType)
	{
		case ctlSelectEvent:
		if (event->data.ctlEnter.controlID==AboutOKButton)
			{
 				
 				FrmEraseForm(FrmGetFormPtr(1200));
	 	 	 
	 	 	 	if(LastActiveForm==100)
	 	 		{
		 			FrmGotoForm(Table2Form);
		 		}else
			 		FrmGotoForm(Table1Form);		 	 		
			 		
 				
 			}
			handled=true;
			break;
		
		case frmOpenEvent:
		
			FrmDrawForm(FrmGetActiveForm());
			
			frm = FrmGetActiveForm ();
	
			handled= true;
			break;
	}
		return(handled);

}


/***********************************************************************
 *
 * FUNCTION:		MainFormHandleEvent
 *
 * DESCRIPTION:	Handles processing of events for the main form.
 *
 * PARAMETERS:		event		- the most recent event.
 *
 * RETURNED:		True if the event is handled, false otherwise.
 *
 ***********************************************************************/
static Boolean MainFormHandleEvent(EventPtr event)
{
	Boolean		handled = false;
	EventType	newEvent;
	//FormPtr		frm;
	UInt elementNum;
	switch (event->eType)
	{
		case ctlSelectEvent:
	
		if (event->data.ctlEnter.controlID==Table1ExitButton)
		{
			// A control button is pressed and released.
			// The exit button being the only button, stop the application.
		   	MemSet(&newEvent, sizeof(EventType), 0);
		   	newEvent.eType = appStopEvent;
		   	EvtAddEventToQueue(&newEvent);
		   	handled = true;
	   		
	   	}else
	   	
			if (event->data.ctlEnter.controlID==Table1Table2Button)
			{
				FrmGotoForm(Table2Form);
				handled = true;

	   		}else
	   		
	   		if (event->data.ctlEnter.controlID)
	   		{
		   		elementNum=event->data.ctlEnter.controlID;
		   		FrmSetControlValue (FrmGetFormPtr(1) ,FrmGetObjectIndex(FrmGetFormPtr(1),event->data.ctlEnter.controlID),0);
		   		
		   		//to ingnore 7 and 8 (lanthanoids and actinoids)
		   		if (elementNum!=7 && elementNum!=8)
		   		{
			   		if (elementNum>=29 && elementNum<=35)
		   			elementNum+=74;
		   							
					currentElement=elementNum-1;
					   		
				    LastActiveForm=1;  		
		   			FrmGotoForm(ElementInfoForm);
		   		}
		   		handled = true;
				
	   		}
	   			

   			handled = true;
			break;

		case frmOpenEvent:
		
			FrmDrawForm(FrmGetActiveForm());	
			handled=true;
			break;
	
		case menuEvent:
				// P2. process menu events for this form
			
			// A menu item was selected.
			// The get info being the only menu item, display the info form.

			LastActiveForm=1;
			
			// First clear the menu status from the display.
			MenuEraseStatus(CurrentMenu);
			
			// Load the info form, then display it.
			FrmGotoForm(AboutForm);
				 		
			handled = true;
			break;
			
			
		}

	return (handled);
}

/***********************************************************************
 *
 * FUNCTION:    ApplicationHandleEvent
 *
 * DESCRIPTION: P3. This routine loads a form resource and sets the event handler for the form.
 *
 * PARAMETERS:  event  - a pointer to an EventType structure
 *
 * RETURNED:    True if the event has been handled and should not be
 *						passed to a higher level handler.
 *
 ***********************************************************************/
static Boolean ApplicationHandleEvent (EventPtr event)
{
	FormPtr	frm;
	Word		formId;
	Boolean	handled = false;

	if (event->eType == frmLoadEvent)
		{
		// load the form resource specified in the event then activate the form.
		formId = event->data.frmLoad.formID;
		frm = FrmInitForm(formId);
		FrmSetActiveForm(frm);

		// set the event handler for the form.  The handler of the currently 
		// active form is called by FrmDispatchEvent each time it receives an event.
		switch (formId)
			{
			case Table1Form:
				FrmSetEventHandler(frm, MainFormHandleEvent);
				break;
		
			case Table2Form:
				FrmSetEventHandler(frm, Table2FormHandleEvent);
				break;
				
			case ElementInfoForm:
				FrmSetEventHandler(frm, ElementFormHandleEvent);
				break;
	
			case AboutForm:
				FrmSetEventHandler(frm, AboutFormHandleEvent);
				break;
				
            default:
//                ErrFatalDisplay("Invalid Form Load Event");
                break;


			}
		handled = true;
		}
	
	return (handled);
}
/***********************************************************************
 *
 * FUNCTION:		EventLoop
 *
 * DESCRIPTION:	A simple loop that obtains events from the Event
 *						Manager and passes them on to various applications and
 *						system event handlers before passing them on to
 *						FrmHandleEvent for default processing.
 *
 * PARAMETERS:		None.
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void EventLoop(void)
{
	EventType	event;
	Word			error;
	
	do{
		// Get the next available event.
		EvtGetEvent(&event, evtWaitForever);
		

		
		// Give the system a chance to handle the event.
		if (! SysHandleEvent(&event))

			// P2. Give the menu bar a chance to update and handle the event.	
			if (! MenuHandleEvent(0, &event, &error))

				// P3. Give the application a chance to handle the event.
				if (! ApplicationHandleEvent(&event))

					// P3. Let the form object provide default handling of the event.
					FrmDispatchEvent(&event);
		}
		while (event.eType != appStopEvent);
}


/***********************************************************************
 *
 * FUNCTION:		PilotMain
 *
 * DESCRIPTION:	This function is the equivalent of a main() function
 *						under standard C.  It is called by the Emulator to begin
 *						execution of this application.
 *
 * PARAMETERS:		cmd - command specifying how to launch the application.
 *						cmdPBP - parameter block for the command.
 *						launchFlags - flags used to configure the launch.			
 *
 * RETURNED:		Any applicable error code.
 *
 ***********************************************************************/
DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
	Word error;		// P4. error starting the app
	
	// P4. This app makes use of PalmOS 2.0 features.  It will crash if
	// run on an earlier version of PalmOS.  Detect and warn if this happens,
	// then exit.
	error = RomVersionCompatible (version20, launchFlags);
	if (error)
		return error;

	// P4. This app doesn't support any action codes.
	if (cmd != sysAppLaunchCmdNormalLaunch) return sysErrParamErr;
	
	// Initialize the application's global variables and database.
	StartApplication();
   
	// P3. Start the first form.
	FrmGotoForm(CurrentView);
		
	// Start the event loop.
	EventLoop();
	
	// P5. Clean up before exiting the applcation.
//	StopApplication();
	
	return 0;
}



