//  Program : Strip (Secure Tool for Recalling Important Passwords) 
//  Description: A secure password and account manager for the Palm(t) Computing Platform 
//  Copyright (C) 1999  Stephen J Lombardo
//  
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//  
//  Strip has been written and developed by Stephen J Lombardo (Zetetic Enterprises) 1999
//  
//  Contact Info:
//  lombardos@zetetic.net
//  http://www.zetetic.net/
//  Zetetic Enterprises
//  348 Wasington Ave 
//  Clifton NJ, 07011
//  
//  Bug reports and feature requests should be sent to bugs@zetetic.net.
//  
//  
//  ------RSA Data Security, Inc. MD5 Message Digest Algorithm-------------
//  Strip uses the MD5 message digest algorithm, Copyright (C) 1990, 
//  RSA Data Security, Inc. All rights reserved. See md5.c or md5.h 
//  for specific terms and warranty disclaimer from RSA Data Security Inc.
//  -----------------------------------------------------------------------
//  

//------Idea block encryption---------------------------------------
//Strip uses the Idea block encryption algoritm, Copyright (C) Ascom. All rights reserved.
//Idea is a patented algorithm. It is free for non commercial use, if you wish to use 
//this product or the Idea algorithm in general for commercial purposes, you must purchase a license
//from Ascom at http://www.ascom.ch/infosec/idea/pricing.html
//-----------------------------------------------------------------------

//        <**  DO NOT EXPORT **>
//Strip uses strong cryptography. "Idea" is a block algoritm with a
//128 bit key length, and "MD5" creates a 128 bit message digest. In the 
//United states it is currently illegal to export products describing
//or incorporating encryption techniques with key lengths greater
//than 40 bits. It is therefore illegal to export this program in
//any format. Please dont get the government on my back...
//  
//  

#define StripSystemForm 1001
#define SystemList 1003
#define EditSystem 1004
#define NewSystem 1005
#define DeleteSystem 1006

#define makeNewSystem 2002
#define addSystemName 2005
#define addSystemOk 2006
#define addSystemCancel 2007

#define PasswordForm 2020
#define PasswordOk 2021
#define PasswordField 2022
#define CoverPasswordField 2029
#define EchoOffCheckbox 2030

#define ChangePasswordForm 2023
#define ChangePasswordOk 2024
#define ChangePasswordCancel 2025
#define ChangePasswordField 2026
#define ChangePasswordCurrentField 2027
#define ChangePasswordNewField 2028


#define EditSystemForm 3003
#define EditSystemName 3006
#define editSystemOk 3007
#define editSystemCancel 3008
#define OpenSystem 3009

#define StripAccountForm 4004
#define accountList 4006
#define OpenAccount 4007
#define NewAccount 4008
#define DeleteAccount 4009
#define EditAccount 4011
#define DoneAccount 4012
#define AccountSystemName 4013 

#define makeNewAccount 5005
#define addAccountUsername 5008
#define addAccountPassword 5010
#define addAccountOk 5011
#define addAccountCancel 5012
#define GenericError 5013
#define versionId 5014

#define ShowAccount 5016
#define AccountUsername 5018
#define AccountPassword 5020
#define AccountClose 5022
#define ShowAccountSystemName 5024

#define addAccountType 5025
#define EditAccountType 5026
#define AccountType 5027


#define DeleteAlert 5033

#define EditAccountForm 6003
#define EditAccountUsername 6008
#define EditAccountPassword 6010
#define editAccountOk 6011
#define editAccountCancel 6012
#define EditAccountComment 6013
#define EditAccountPopupTrigger 6020
#define EditAccountPopupList 6021



#define EditUndo 7001
#define EditCut 7002
#define EditCopy 7003
#define EditPaste 7004
#define EditSelectAll 7006
#define EditKeyboard 7007
#define EditGrafitti 7008
#define AboutMe 7010
#define EditMenuID 7011
#define aboutAlert 7013
#define AboutOk 7014
#define ChPass 7015
#define AppInfo 7016
#define NewSysPull 7017
#define NewAccPull 7018
#define EditSysPull 7019
#define SystemMenuID 7012
#define AccountMenuID 7020
#define ShowMenuID 7021
#define EditAccPull 7022
#define BeamAccPull 7023
#define BeamSysPull 7024


#define EditAccountScrollbar 8001
#define AccountScrollbar 8002
#define encryptAlert 8003

#define infoDialog 8004

#define EditCommentOk 8008
#define EditAccountCommentForm 8010
#define EditAccountCommentButton 8011
#define AddAccountCommentButton 8012
#define AccountCommentButton 8013

#define aboutHelp 9001
#define systemHelp 9002
#define commentHelp 9003
 
#define generatePassword 9100
#define generatePasswordHelp 9101
#define generatePasswordLength 9102
#define generatePasswordPopupTrigger 9103
#define generatePasswordPopupList 9104
#define generatePasswordOk 9105
#define generatePasswordCancel 9106   
#define generatePWButton 9107                                                                                    
#define pwNum 9108
#define pwAlNum 9109
#define pwAlNumM 9110

#define addAccountPasswordScrollbar  9200
#define EditAccountPasswordScrollbar  9201
#define AccountPasswordScrollbar  9202
#define preferenceScreen  9203
#define preferenceScreenHelp  9204
#define preferenceScreenOk  9205
#define preferenceScreenCancel  9206
#define prSAN  9207
#define prSAT  9208
#define prOAN  9209
#define prOAT  9210
#define PrefMenu 9211
#define poLock 9220
#define FindHeaderString 9221

#define ZeteticLogo 9222
#define pleaseWait 9223

