/*
* Big Two - A popular poker game for Palm OS.
* Copyright (C) 2000  Woo Kok Tong
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
* Contact the author at onehy@magix.com.sg or visit http://come.to/palmos 
*/

#define cardWidth			20
#define cardHeight		28

// ========== Big Two Form ==========
#define formID_bigtwo			1000
#define menuID_bigtwo			1001
#define menuitemID_howtoplay  1002
#define menuitemID_about      1003
#define menuitemID_new      	1004
#define menuitemID_score      1005
#define menuitemID_prefs      1006
#define menuitemID_high	      1007
#define menuitemID_reset      1008
#define labelID_p2				1100
#define labelID_p3				1101
#define labelID_p4				1102
#define labelID_you				1103
#define labelID_youpass			1104
#define labelID_p2pass			1105
#define labelID_p3pass			1106
#define labelID_p4pass			1107
#define labelID_yourplay1		1108
#define labelID_yourplay2		1109
#define labelID_autopass		1110
#define fieldID_p2left			1200
#define fieldID_p3left			1201
#define fieldID_p4left			1202
#define cardID_0					1300
#define cardID_1					1301
#define cardID_2					1302
#define cardID_3					1303
#define cardID_4					1304
#define cardID_5					1305
#define cardID_6					1306
#define cardID_7					1307
#define cardID_8					1308
#define cardID_9					1309
#define cardID_10					1310
#define cardID_11					1311
#define cardID_12					1312
#define buttonID_play			1400
#define buttonID_pass			1401
#define buttonID_toggle			1402
#define buttonID_lead			1403
#define buttonID_clear			1404
#define bitmapID_rank			1500
#define bitmapID_suit			1501
#define bitmapID_clear			1502
#define bitmapID_diamond		1503
#define bitmapID_heart			1504

// ========== Score Form ==========
#define formID_score				2000
#define labelID_hand				2001
#define labelID_total			2002
//#define labelID_games			2003
#define labelID_p2s				2004
#define labelID_p3s				2005
#define labelID_p4s				2006
#define labelID_yous				2007
// must keep this order
#define fieldID_youhand			2103
#define fieldID_p2hand			2104
#define fieldID_p3hand			2105
#define fieldID_p4hand			2106
#define fieldID_youtotal		2107
#define fieldID_p2total			2108
#define fieldID_p3total			2109
#define fieldID_p4total			2110
//#define fieldID_yougames		2111
//#define fieldID_p2games			2112
//#define fieldID_p3games			2113
//#define fieldID_p4games			2114
#define buttonID_ok				2201
#define buttonID_resetgames	2202

// ========== Preferences Form ==========
#define formID_prefs				3000
#define labelID_gamespeed		3001
#define labelID_sortcards		3002
#define buttonID_medium			3100
#define buttonID_slow			3101
#define buttonID_fast			3102
#define buttonID_rank			3103
#define buttonID_suit			3104
#define checkboxID_autopass	3200
#define helpStr_prefs			3300

// ========== Game Over Form ==========
#define formID_gameover			4000
#define labelID_overallscore	4001
#define labelID_newhigh			4002
#define labelID_entername		4003
#define labelID_bad1				4004
#define labelID_bad2				4005
#define labelID_good1			4006
#define labelID_good2			4007
#define labelID_excellent1		4008
#define labelID_excellent2		4009
#define fieldID_overallscore	4100
#define fieldID_name				4101

// ========== High Score Form ==========
#define formID_highscore		5000
#define labelID_1					5001
#define labelID_2					5002
#define labelID_3					5003
#define labelID_4					5004
#define labelID_5					5005
#define fieldID_name1			5100
#define fieldID_name2			5101
#define fieldID_name3			5102
#define fieldID_name4			5103
#define fieldID_name5			5104
#define fieldID_score1			5105
#define fieldID_score2			5106
#define fieldID_score3			5107
#define fieldID_score4			5108
#define fieldID_score5			5109

#define alertID_about			1000
#define alertID_new				1001
#define alertID_invalidplay	1002
//#define alertID_gameover		1003
#define alertID_pass				1004
#define alertID_resethigh		1005

#define helpStr_bigtwo			1000
