
#ifndef PFilterManagerINCLUDED
#define PFilterManagerINCLUDED


#include "PCollection.h"

#include "global.h"

#include "pstring.h"


class PBottle;
class PBottleRecord;
class PFilter;



class PFilterManager
{

private:

	static PCollection filtersName_;
	static PFilter currentFilter_;
	static short currentFilterIndex_;

	static char** filtersList_;


public:

	static Boolean init();
	static void destroy();


	PFilterManager() {};
	~PFilterManager() {};

	static char** getFiltersList(Boolean withAll = false);
	static short getNbFilters();

	static Boolean getRecordWithCurrentFilter(PRecord& rec);
	static Boolean releaseCurrentFilterRecord();

	static Boolean addCurrentFilter();
	static Boolean removeCurrentFilter();
	static Boolean saveCurrentFilter();


	//static char* getCurrentFilterName();
	static PFilter& getCurrentFilter() { return currentFilter_; };
	static short getCurrentFilterIndex() { return currentFilterIndex_-1; };
	static char* getCurrentFilterName();

	static Boolean setCurrentFilterIndex(short index);

	//static void setCurrentFilter(PFilter* filter) { currentFilter_ = filter; };
	//static Boolean setCurrentFilter(const PString& name);
	//static void setCurrentFilterIndex(short index);

	
	static Boolean matchFilter(PRecord& rec);
	static void createFilteredList();

};

#endif

