

#ifndef PYearQualityINCLUDED
#define PYearQualityINCLUDED

#include "global.h"
#include "pcollection.h"



extern char* Bordeaux_Rouges_Medoc		;
extern char* Bordeaux_Rouges_St_Emil	;

extern char* Bordeaux_Blancs_Sauternes ;
extern char* Bordeaux_Blancs_Graves	;

extern char* Alsace					;

extern char* Bourgogne_Blancs_Cote_Dor	;
extern char* Bourgogne_Rouge_Cote_Dor	;
extern char* Bourgogne_Rouge_Chablis	;

extern char* Rhone_Nord				;
extern char* Rhone_Sud					;

extern char* Rhin						;
extern char* Mosel						;

extern char* Toscane					;

extern char* California_Cabs			;
extern char* California_Chards			;



#define FirstYear 1961			//const short FirstYear	= 1961;
#define LastYear 1996			//const short LastYear	= 1996;
#define NbYears (LastYear-FirstYear+1)	//const short NbYears		= LastYear-FirstYear+1;
const short NbRegions	= 15;


const char NO_TIP		= 0;
const char DRINK		= 1;
const char DRINK_WAIT	= 2;
const char WAIT			= 3;
const char AVOID		= 4;

class QualityAndTipsForYear
{
public:

	char minQuality_;	// 0-10 - -1->No quality for this year
	char maxQuality_;	// 0-10 - -1->No quality for this year
	char tip_;			// 0=No tip, 1=ToDrink, 2=WaitOrDrink, 3=Wait

};

class Regions
{
public:

	QualityAndTipsForYear year_[NbYears];

};




class PYearQuality
{
public:

	PYearQuality();
	~PYearQuality();

	static Boolean init();
	static void initRegions();
	static void destroy();

	static char** getRegionList();
	
	static short getNbRegions();
	static short getNbYears();
	static short getFirstYear();

	static short getNbLinesForYears();

	static short getSelectedRegion() { return selectedRegion_; };
	static void setSelectedRegion(short region) { selectedRegion_ = region; };

	static Regions* getRegionQuality(short nb);
	static char* getRegionName(short nb);


private:

	static PCollection list_;
	static Regions regions_[NbRegions];

	static short selectedRegion_;

};

#endif

