

PROG_NAME = cavist-fu.prc

#EDIT_FORM = table_edit_form.o
EDIT_FORM = static_edit_form.o

START_OBJS = start.o
MID_OBJS =  prefs_form.o wine_quality.o pdatabasemanager.o  pcontext.o main_form.o PYearQuality.o global.o multilanguage.o gcrt0.o filter_form.o ppreferences.o cavist.o $(EDIT_FORM) pcollection.o pbottle.o pstring.o
END_OBJS = plistmanager.o precord.o pdatabase.o pdate.o pfilter.o pfiltermanager.o

OBJS = $(START_OBJS) $(MID_OBJS) $(END_OBJS)




CC = c:/pilot-gcc/bin/m68k-palmos-coff-gcc




#Debug version
#CFLAGS  = -O1 -g -DML_FRENCH -DDEBUG
#PILRC = pilrc.exe -L FRENCH



#French
#CFLAGS  = -O1 -g -DML_FRENCH
#PILRC = pilrc.exe -L FRENCH

#French - DEMO
CFLAGS  = -O1 -g -DML_FRENCH -DDEMO_VERSION
PILRC = pilrc.exe -L FRENCH



#English
#CFLAGS  = -O1 -g -DML_ENGLISH
#PILRC = pilrc.exe -L ENGLISH

#English - DEMO
#CFLAGS  = -O1 -g -DML_ENGLISH -DDEMO_VERSION
#PILRC = pilrc.exe -L ENGLISH





LINKFLAGS  = -O1 -static -g


TXT2BITM	= txt2bitm
OBJRES		= c:/pilot-gcc/bin/m68k-palmos-coff-obj-res
BUILDPRC	= c:/pilot-gcc/bin/build-prc

ICONTEXT = "Cavist"
APPID = CVST

OUTDIR = ./
INTDIR = ./debug/


all: $(PROG_NAME)
	ls -l *.prc



clean:
	rm -rf *.[oa] cavist *.bin bin.res *.grc



$(PROG_NAME):	bin.res code0000.cavist.bin code0001.cavist.bin data0000.cavist.bin
	$(BUILDPRC) $(PROG_NAME) $(ICONTEXT) $(APPID) code0001.cavist.grc code0000.cavist.grc data0000.cavist.grc *.bin pref0000.cavist.grc

code0000.cavist.bin: cavist
	$(OBJRES) cavist

code0001.cavist.bin: code0000.cavist.bin

data0000.cavist.bin: code0000.cavist.bin

bin.res:	cavist.rcp				\
			ids.h
			$(PILRC) cavist.rcp 
			touch bin.res



cavist: $(OBJS) \
		gcrt0.o
	$(CC) $(LINKFLAGS) -nostartfiles $(OBJS) -o cavist

gcrt0.o:
	/bin/sh.exe copy_file.bat




multilanguage.o:	multilanguage.cpp		\
                    multilanguage.h
	$(CC) $(CFLAGS) -c multilanguage.cpp -o multilanguage.o

start.o:
	$(CC) $(CFLAGS) -c start.c -o start.o

ppreferences.o:	ppreferences.cpp		\
			    ppreferences.h
	$(CC) $(CFLAGS) -c ppreferences.cpp -o ppreferences.o

pcontext.o:	pcontext.cpp		\
			pcontext.h
	$(CC) $(CFLAGS) -c pcontext.cpp -o pcontext.o

pdatabase.o:	pdatabase.cpp		\
				pdatabase.h
	$(CC) $(CFLAGS) -c pdatabase.cpp -o pdatabase.o

precord.o:		precord.cpp				\
				precord.h
	$(CC) $(CFLAGS) -c precord.cpp -o precord.o





pfiltermanager.o:	pfiltermanager.cpp		\
					pfiltermanager.h		\
					global.h
	$(CC) $(CFLAGS) -c pfiltermanager.cpp -o pfiltermanager.o

plistmanager.o:		plistmanager.cpp		\
					plistmanager.h
	$(CC) $(CFLAGS) -c plistmanager.cpp -o plistmanager.o

pdatabasemanager.o:		pdatabasemanager.h		\
						pdatabasemanager.cpp
	$(CC) $(CFLAGS) -c pdatabasemanager.cpp -o pdatabasemanager.o



PYearQuality.o:	PYearQuality.cpp		\
				PYearQuality.h			\
				cprotos.h
	$(CC) $(CFLAGS) -c PYearQuality.cpp -o PYearQuality.o

pcollection.o:	pcollection.cpp			\
				pcollection.h			\
				cprotos.h
	$(CC) $(CFLAGS) -c pcollection.cpp -o pcollection.o

pbottle.o:		pbottle.cpp				\
				pbottle.h				\
				cprotos.h
	$(CC) $(CFLAGS) -c pbottle.cpp -o pbottle.o

pfilter.o:		pfilter.cpp				\
				pfilter.h				\
				cprotos.h
	$(CC) $(CFLAGS) -c pfilter.cpp -o pfilter.o

pstring.o:		pstring.cpp				\
				pstring.h
	$(CC) $(CFLAGS) -c pstring.cpp -o pstring.o

pdate.o:		pdate.cpp				\
				pdate.h
	$(CC) $(CFLAGS) -c pdate.cpp -o pdate.o

global.o:		global.cpp				\
				global.h
	$(CC) $(CFLAGS) -c global.cpp -o global.o




cavist.o:	cavist.cpp					\
			cprotos.h
	$(CC) $(CFLAGS) -c cavist.cpp -o cavist.o

main_form.o:	main_form.cpp
	$(CC) $(CFLAGS) -c main_form.cpp -o main_form.o

static_edit_form.o:	static_edit_form.cpp
	$(CC) $(CFLAGS) -c static_edit_form.cpp -o static_edit_form.o

table_edit_form.o:	table_edit_form.cpp
	$(CC) $(CFLAGS) -c table_edit_form.cpp -o table_edit_form.o

filter_form.o:	filter_form.cpp
	$(CC) $(CFLAGS) -c filter_form.cpp -o filter_form.o

note_form.o:	note_form.cpp
	$(CC) $(CFLAGS) -c note_form.cpp -o note_form.o

wine_quality.o:	wine_quality.cpp
	$(CC) $(CFLAGS) -c wine_quality.cpp -o wine_quality.o

prefs_form.o:	prefs_form.cpp
	$(CC) $(CFLAGS) -c prefs_form.cpp -o prefs_form.o
