
#include "global.h"
#include "ids.h"


#include "cprotos.h"

#include "pstring.h"

#include "pfilter.h"
#include "pfiltermanager.h"

#include "plistmanager.h"

#include "pcontext.h"






//---------------------------------------------------------------
Boolean setStringToField(long id, const PString& value)
{
	MESSAGE2("FrmGetActiveForm");
	FormPtr form = FrmGetActiveForm();
	char* text;
	PString str;
	FieldPtr field;
	VoidHandle handle;




    /*
    FldGetAttributes(field, &fldAttr);

    if(fldAttr.editable)
    {
        Word fldLen      = FldGetTextLength(field);
        Boolean hasFocus = fldAttr.hasFocus;

        if(hasFocus)
            FldReleaseFocus(field);

        if(bufLen)
        {
            FldSetSelection(field, 0, fldLen);
            FldInsert(field, buffer, bufLen);
        }
        else 
            FldDelete(field, 0, fldLen);

        if(hasFocus)
            FldGrabFocus(field);
    }
    else
    {
    */






	
	MESSAGE2("getObjectPtr");
	field = (FieldType*)GetObjectPtr(id);
#ifdef DEBUG
	if (field == 0)
		MessageBox("The field pointer is NULL");
#endif


    MESSAGE2("FldGetTextLength");
    Word fldLen = FldGetMaxChars(field)+1;


	MESSAGE2("FldGetTextHandle");
	handle = (VoidHandle)FldGetTextHandle(field);
#ifdef DEBUG
	if (handle != 0)
		MessageBox("Warning, the handle is not null");
#endif

    Word strLen = value.Length()+1;
    if (strLen > fldLen)
        strLen = fldLen;
	str.print("MemHandleNew len:'%ld'", strLen);
	MESSAGE2(str.data());
	handle = MemHandleNew(fldLen+1);
#ifdef DEBUG
	if (handle == 0)
		MessageBox("Impossible to allocate new Handle");
#endif
	
	MESSAGE2("MemHandleLock");
	text = (char*)MemHandleLock(handle);
	MESSAGE2("DmWrite");
	MemMove(text, value.data(), strLen);
    text[strLen-1] = 0; // end of string
	MESSAGE2("MemHandleUnlock");
	MemHandleUnlock(handle);


	MESSAGE2("FldSetTextHandle");
	FldSetTextHandle(field, (Handle)handle);



	MESSAGE2("FldGetAttributes");
	FieldAttrType attr;
	FldGetAttributes(field, &attr);
	
	attr.usable = true;
	attr.visible = true;
	attr.editable = true;
	attr.singleLine = true;
	attr.insPtVisible = true;
	attr.underlined = true;

	MESSAGE2("FldSetAttributes");
	FldSetAttributes(field, &attr);


	MESSAGE2("End of setStringToField");
	return true;
}

	



//---------------------------------------------------------------
Boolean getStringFromField(long id, PString& value)
{
	MESSAGE2("Begin of getStringFromField");
	PString str;
	FieldPtr field;
	VoidHandle handle;

	
	MESSAGE2("GetObjectPtr");
	field = (FieldType*)GetObjectPtr(id);
#ifdef DEBUG
	if (field == 0)
	{
		MessageBox("The field pointer is NULL");
		return false;
	}
#endif
	
	MESSAGE2("FldGetTextHandle");
	handle = (VoidHandle)FldGetTextHandle(field);
#ifdef DEBUG
	if (handle == 0)
	{
		MessageBox("Impossible to get the TEXT handle for field");
		return false;
	}
#endif
	MESSAGE2("FldSetTextHandle");
	FldSetTextHandle(field, 0);

	MESSAGE2("MemHandleLock");
	char* text = (char*)MemHandleLock(handle);
#ifdef DEBUG
	if (text == 0)
		MessageBox("Text == 0");
#endif
	MESSAGE2("value = text");
	value = text;
	MESSAGE2("MemHandleUnlock");
	MemHandleUnlock(handle);
	MESSAGE2("MemHandleFree");
	MemHandleFree(handle);

	MESSAGE2("End of getStringFromField");
	return true;
}








//-----------------------------------------------------------

void about();
void help();

//-----------------------------------------------------------






//-----------------------------------------------------------
Boolean AskString(PString& name)
{
	PString str;
	FormPtr form = FrmInitForm(ASK_STRING_FORM_ID);
	char* text;
	
	FieldPtr field = (FieldPtr)FrmGetObjectPtr(form , FrmGetObjectIndex(form, STRING_FLD_ID));

	VoidHandle handle = MemHandleNew(1);
	text = (char*)MemHandleLock(handle);
	text[0] = 0;
	MemHandleUnlock(handle);
	FldSetTextHandle(field, (Handle)handle);

	FrmSetFocus(form, FrmGetObjectIndex(form, STRING_FLD_ID));

	Word buttonHit = FrmDoDialog(form);

	handle = (VoidHandle)FldGetTextHandle(field);
	FldSetTextHandle(field, (Handle)0);
	text = (char*)MemHandleLock(handle);
	str = text;
	MemHandleUnlock(handle);
	MemHandleFree(handle);

	FrmDeleteForm(form);

	if (buttonHit == CANCEL_BT)
	{
		return false;
	}

	name = str;
	return true;
}




//-----------------------------------------------------------
Boolean setFilterToFields()
{
	PString str;

	PFilter& filter = PFilterManager::getCurrentFilter();

	ControlPtr ctl;
	// Name
	ctl = (ControlPtr)GetObjectPtr(FT_FILTER_POPUP_ID);
	CtlSetLabel(ctl, filter.getName().data());

	// Type
	ctl = (ControlPtr)GetObjectPtr(FT_TYPE_POPUP_ID);
	if (filter.getType() == "")
	{
		CtlSetLabel(ctl, PContext::getAllString());
	}
	else
	{
		CtlSetLabel(ctl, filter.getType().data());
	}
	
	// Capacite
	ctl = (ControlPtr)GetObjectPtr(FT_CAPA_POPUP_ID);
	if (filter.getCapacite() == "")
	{
		CtlSetLabel(ctl, PContext::getAllString());
	}
	else
	{
		CtlSetLabel(ctl, filter.getCapacite().data());
	}
	
	// Older-Younger
	ctl = (ControlPtr)GetObjectPtr(FT_MILL_POPUP_ID);
	if (filter.getOlder())
	{
		CtlSetLabel(ctl, Plus_Vieux);
	}
	else
	{
		CtlSetLabel(ctl, Plus_Jeune);
	}

	// Millesime
	str = "";
	if (filter.getMillesime() != 0)
	{
		str.print("%d", filter.getMillesime());
	}
	setStringToField(FT_MILL_FLD_ID, str);

	
	// Nombre de bouteilles
	str = "";
	if (filter.getAtLeastNumber() != 0)
	{
		str.print("%d", filter.getAtLeastNumber());
	}
	setStringToField(FT_NB_BOTTLES_ID, str);

	// Drink_Max
	str = "";
	if (filter.getToDrinkMax() != 0)
	{
		str.print("%d", filter.getToDrinkMax());
	}
	setStringToField(DRINK_MAX, str);

	// Search string
	setStringToField( FT_STRING_FLD_ID, filter.getSearchString() );

	return true;
}
















//-----------------------------------------------------------
Boolean setFieldsToFilter()
{
	PString str;

	PFilter& filter = PFilterManager::getCurrentFilter();

	// Millesime
	getStringFromField(FT_MILL_FLD_ID, str);
	filter.setMillesime(str.IntOf());

	// At least number
	getStringFromField(FT_NB_BOTTLES_ID, str);
	filter.setAtLeastNumber(str.IntOf());

	// Drink_Max
	getStringFromField(DRINK_MAX, str);
	filter.setToDrinkMax(str.IntOf());

	// Search string
	getStringFromField(FT_STRING_FLD_ID, str);
	filter.setSearchString(str);

	return true;
}

















//-----------------------------------------------------------
Boolean newFilter()
{

	PFilter& filter = PFilterManager::getCurrentFilter();
	PString name = "";

	do
	{
		if (!AskString(name))
			return false;
	} while(name == "");
	
	filter.reset();
	filter.setName(name);

	if (!PFilterManager::addCurrentFilter())
		return false;

	return true;
}







//-----------------------------------------------------------
Boolean updateFilters()
{

	ListPtr list = (ListPtr)GetObjectPtr(FT_FILTERS_LIST_ID);

	PFilter& filter = PFilterManager::getCurrentFilter();
	if (filter.getName() == "")
	{
		if (Yes == AskYesNo( Creer_nouveau_filtre ))
		{
			if (!newFilter())
			{
				return false;
			}
		}
		else
			return false;
	}

	LstSetListChoices(list, PFilterManager::getFiltersList(), (UShort)PFilterManager::getNbFilters());
	if (!setFilterToFields())
		return false;

	FrmDrawForm( FrmGetActiveForm() );
	return true;
}






//-----------------------------------------------------------
Boolean filterEventHandler(EventType* event)
{
	int       handled = 0;
	FormPtr   form;

	switch (event->eType)
	{
	case frmOpenEvent:
		{
			form = FrmGetActiveForm();
			FrmDrawForm(form);

			if (!updateFilters())
			{
				FrmGotoForm(MAIN_FORM_ID);
				break;
			}
			PFilterManager::saveCurrentFilter();

			handled = 1;
		}
		break;
    
	case ctlSelectEvent:  // A control button was pressed and released.
	{
		switch(event->data.ctlEnter.controlID)
		{
//------------------------------------------------------------
		case DONE_BT:
			{
				setFieldsToFilter();
				PFilterManager::saveCurrentFilter();

				FrmGotoForm(MAIN_FORM_ID);
				handled = 1;
			}
			break;

//------------------------------------------------------------
		case RENAME_BT:
			{
				PFilter& filter = PFilterManager::getCurrentFilter();
				setFieldsToFilter();

				PString name = filter.getName();
				if (!AskString(name))
					break;
				filter.setName(name);

				PFilterManager::saveCurrentFilter();
				updateFilters();
			}
			break;

//------------------------------------------------------------
		case DELETE_BT:
			{
				if (Yes == AskYesNo( Effacer_Filtre ))
				{
					PFilter& filter = PFilterManager::getCurrentFilter();
					setFieldsToFilter();
					PFilterManager::removeCurrentFilter();
					if (PFilterManager::getNbFilters() == 0)
						FrmGotoForm(MAIN_FORM_ID);
					else
					{
						PFilterManager::setCurrentFilterIndex(0);
						updateFilters();
					}
				}
				handled = 1;
			}
			break;

//------------------------------------------------------------
		case NEW_BT:
			{
				PFilter& filter = PFilterManager::getCurrentFilter();
				setFieldsToFilter();
				PFilterManager::saveCurrentFilter();

				newFilter();
				
				updateFilters();
				PFilterManager::saveCurrentFilter();
			}
			break;

//------------------------------------------------------------
		case FT_TYPE_POPUP_ID:
			{
				ListPtr list = (ListPtr)GetObjectPtr(FT_TYPE_LIST_ID);
				LstSetListChoices(list, PListManager::getAllTypeList(), (short)PListManager::getNbTypeItems());
				LstPopupList(list);
				
				static PString str;
				str = LstGetSelectionText(list, LstGetSelection(list));

				ControlPtr ctl = (ControlPtr)GetObjectPtr(FT_TYPE_POPUP_ID);
				CtlSetLabel(ctl, str.data());

				if (str == PContext::getAllString())
					str = "";
				PFilterManager::getCurrentFilter().setType(str);
			}
			break;

//------------------------------------------------------------
		case FT_CAPA_POPUP_ID:
			{
				ListPtr list = (ListPtr)GetObjectPtr(FT_CAPA_LIST_ID);
				LstSetListChoices(list, PListManager::getAllCapaciteList(), (short)PListManager::getNbCapaItems());
				LstPopupList(list);
				
				static PString str;
				str = LstGetSelectionText(list, LstGetSelection(list));

				ControlPtr ctl = (ControlPtr)GetObjectPtr(FT_CAPA_POPUP_ID);
				CtlSetLabel(ctl, str.data());

				if (str == PContext::getAllString())
					str = "";
				PFilterManager::getCurrentFilter().setCapacite(str);
			}
			break;

//------------------------------------------------------------
		case FT_MILL_POPUP_ID:
			{
				ListPtr list = (ListPtr)GetObjectPtr(FT_MILL_LIST_ID);
				LstPopupList(list);
				
				long i = LstGetSelection(list);
				if (i==0)
					PFilterManager::getCurrentFilter().setOlder(true);
				else
					PFilterManager::getCurrentFilter().setOlder(false);

				static PString str;
				str = LstGetSelectionText(list, (short)i);
				ControlPtr ctl = (ControlPtr)GetObjectPtr(FT_MILL_POPUP_ID);
				CtlSetLabel(ctl, str.data());
			}
			break;

//------------------------------------------------------------
		case FT_FILTER_POPUP_ID:
			{
				setFieldsToFilter();
				PFilterManager::saveCurrentFilter();
				
				ListPtr list = (ListPtr)GetObjectPtr(FT_FILTERS_LIST_ID);
				short num = PFilterManager::getNbFilters();
				if (num > 10)
					num = 10;
				LstSetHeight(list, num);
				LstPopupList(list);
				
				PFilterManager::setCurrentFilterIndex( LstGetSelection(list) );
				updateFilters();
			}
			break;

		};
	}
	break;

	case menuEvent:
	{
		switch (event->data.menu.itemID)
		{
		case RESET_MNU_ID:
			{
				PFilter& filter = PFilterManager::getCurrentFilter();
				setFieldsToFilter();
				filter.reset();
				updateFilters();
				PFilterManager::saveCurrentFilter();
			}
			break;

		case ABOUT_MNU_ID:
			about();
			break;

		case HELP_MNU_ID:
			help();
			break;
		}
		handled = 1;
	}
	break;

	case nilEvent:
		handled = 1;
		break;
	}

	return handled;
}


