
#include "global.h"

#include "ids.h"
#include "cprotos.h"


#include "pstring.h"
#include "pbottle.h"
#include "PCollection.h"

#include "ppreferences.h"
#include "plistmanager.h"
#include "pfiltermanager.h"
#include "pfilter.h"

#include "pdatabase.h"
#include "PContext.h"

#include "callback.h"


void help();
void about();


Boolean InEditMode = true;
Boolean InOneLessMode = false;
Boolean InHistMode = false;


//---------------------------------------------------------------
void ListDrawData(Word itemNum, RectanglePtr bounds, CharPtr *itemsText)
{
    CALLBACK_PROLOGUE

	//WinDrawChars("Pas grand chose  ecrire     ", 24, 0, bounds->topLeft.y);

	MESSAGE("Drawing");
	PDatabase* db = (PDatabase*)itemsText[0];
	PCollection* list = (PCollection*)itemsText[1];
	PBottle* pbottle = (PBottle*)itemsText[2];

    if (list == 0 || db == 0 || pbottle == 0)
	{
		MessageBox("The list or the DB is null");
		return;
	}

   	PBottle& bottle = *pbottle;
    bottle.resetData();

	long index = (long)list->getAt(itemNum);
	if (index == -1)
	{
		MessageBox("Index not valid");
		return;
	}

	MESSAGE("Get record");
	PString str;
	PRecord rec;


	if (!db->getRecord(index, rec))
	{
		MessageBox("Can't get the record");
		return;
	}
	if(!bottle.loadSmall(rec))
	{
    	MESSAGE("Release record");
    	db->releaseRecord(index);
	    MESSAGE("Remove record");
        db->removeRecord(index);
		MessageBox(Impossible_de_charger);
		return;
	}
	MESSAGE("Release");
	db->releaseRecord(index);
	MESSAGE("Released.");

    //return;
	
	short x, y, len;
	RectangleType rect;
	y = bounds->topLeft.y;

	MESSAGE("Quantity");
	x = 0;
	rect = *bounds;
	rect.topLeft.x = x;
	WinEraseRectangle(&rect, 0);
	x+=2;
	str.print("%d", bottle.getQuantite());
	len = (short)str.Length();
	if (len>3)len=3;
	WinDrawChars(str.data(), len, x, y);

	x = 13;
	rect = *bounds;
	rect.topLeft.x = x;
	WinEraseRectangle(&rect, 0);
	x+=2;
    if (PPreferences::getShowAppelationInMainView())
    {
	    MESSAGE("Appelation ");
	    len = (short)bottle.getAppelation().Length();
	    if (len>25) len=25;
	    WinDrawChars(bottle.getAppelation().data(), len, x, y);
    }
    else
    {
	    MESSAGE("Cru ");
	    len = (short)bottle.getCru().Length();
	    if (len>25) len=25;
	    WinDrawChars(bottle.getCru().data(), len, x, y);
    }

	MESSAGE("Type");
	x = 105;
	rect = *bounds;
	rect.topLeft.x = x;
	WinEraseRectangle(&rect, 0);
	x+=2;
	str = bottle.getType();
	len = (short)str.Length();
	if (len>7)len=7;
	WinDrawChars(str.data(), (short)len, x, y);

	MESSAGE("Millesime");
	x = 135;
	rect = *bounds;
	rect.topLeft.x = x;
	WinEraseRectangle(&rect, 0);
	x+=2;
	str.print("%d", bottle.getMillesime());
	len = (short)str.Length();
	if (len>4)len=4;
	WinDrawChars(str.data(), (short)len, x, y);

    MESSAGE("OK");
    

    CALLBACK_EPILOGUE
}








//---------------------------------------------------------------
bool loadTableItems()//short tableDataOffset)
{
	MESSAGE("loadTableItems");
	
	static VoidPtr drawData[3] = {0, 0, 0};


	PFilterManager::createFilteredList();


	ListPtr list = (ListPtr)GetObjectPtr(MAIN_LIST_ID);

	
	LstSetSelection(list, 0);
#ifdef DEBUG
	if (list == 0)
		MessageBox("The list pointer is NULL");
#endif





	drawData[0] = &PContext::getBottlesDatabase();
	drawData[1] = &PContext::getFilteredCollection();
	drawData[2] = &PContext::getTheBottle();



	LstSetListChoices(list, (char**)drawData, PContext::getFilteredCollection().getSize() );
	LstSetDrawFunction(list, ListDrawData);

	

	
	long index = PContext::getFilteredCollection().getIndexOf( (void*)PContext::selectedBottle() );
	if (index < 0)
		PContext::setSelectedBottle(-1);
	LstSetSelection(list, (short)index);

	
	MESSAGE("FrmDrawForm");
	FrmDrawForm( FrmGetActiveForm() );



	ControlPtr ctl;
	ctl = (ControlPtr)GetObjectPtr( FILTER_POPUP_ID );
	CtlSetLabel(ctl, PFilterManager::getCurrentFilterName());

	ctl = (ControlPtr)GetObjectPtr(EDIT_BT);
	CtlSetValue(ctl, InEditMode);
	ctl = (ControlPtr)GetObjectPtr(ONE_LESS_BT);
	CtlSetValue(ctl, InOneLessMode);
	ctl = (ControlPtr)GetObjectPtr(HIST_BT);
	CtlSetValue(ctl, InHistMode);


	MESSAGE("loadTableItems done.");
	return true;
}




void doNothing(void* elem);

//---------------------------------------------------------------
void caveIdeale();

//---------------------------------------------------------------
void yearQuality()
{
    FrmGotoForm(WINE_QUALITY_FORM_ID);
}


//---------------------------------------------------------------
void statistics()
{
	//MessageBox("Salut1");

	// Nb bottles
	short nbBottles = 0;
	short unknownNbBottles = 0;
    PDatabase& db = PContext::getBottlesDatabase();
	short nbBottlesType = db.getNumRecords();

	// Nb bottles by type (Red...)
	PBottle& bottle = PContext::getTheBottle();
	PRecord& rec = PContext::getTheRecord();
	PCollection& types = PListManager::getTypeCollection();
	PCollection nbTypes(doNothing, 0);
	MESSAGE("Create types");
	short j;
	for (j=0; j<types.getSize(); j++)
	{
		nbTypes.add(0);
        if (nbTypes.getAt(j) != 0)
            MessageBox("Error");
	}
    if (nbTypes.getSize() != types.getSize())
    {
        MessageBox("Invalid size");
    }
	short nb;
	MESSAGE("bottles   ");
	nbBottles = 0;
	for (short i=0; i<nbBottlesType; i++)
	{
		PContext::getBottlesDatabase().getRecord(i, rec);
		
        MESSAGE("load");
		bottle.load(rec);
        MESSAGE("getQuantite");
		nbBottles += bottle.getQuantite();

		PString str, temp;
        Boolean found = false;
		for (j=0; (j<types.getSize())&&!found; j++)
		{
            MESSAGE("getAt");
			str = (char*)types.getAt(j);
            MESSAGE("getType");
			if ( str == bottle.getType() )
			{
                MESSAGE("1  ");
				nb = (short)nbTypes.getAt(j);
                MESSAGE("2  ");
				nb += bottle.getQuantite();
                MESSAGE("3  ");
				nbTypes.setAt(j, (void*)nb);
                MESSAGE("4  ");
                found = true;
			}
            MESSAGE("OK done");
		}
        if (!found)
        {
            unknownNbBottles += bottle.getQuantite();
        }
        MESSAGE("OK hyper done");

		PContext::getBottlesDatabase().releaseRecord(i);
	}


	MESSAGE("Create str");
	// Good string
	PString str;
	str.print(X_Bouteilles_Dont, nbBottles);


	MESSAGE("concat string");
	PString pstr;
	PString temp;
	for (j=0; j<types.getSize(); j++)
	{
        pstr = "Unknown";
		nb = (long)nbTypes.getAt(j);
		if (nb != 0)
		{
			pstr = (char*)types.getAt(j);
			temp.print("%d", nb);
			str += temp;
			str += De;
			str += pstr;
			str += "\n";
		}
	}

    // Unknown types
    if (unknownNbBottles != 0)
    {
        PString str2;
        temp.print("%d", unknownNbBottles);
	    str2 += temp;
	    str2 += De;
	    str2 += Inconnu;
	    str2 += "\n";

        str += str2;
    }
    


	if (nbBottlesType == 0 || nbBottles == 0)
	{
		str = Pas_De_Bouteilles;
	}

	MessageBox( str.data() );
	MESSAGE("MessageBox done");
}



void history(PBottle& editedBottle);

//---------------------------------------------------------------
Boolean mainEventHandler(EventType* event)
{
	int       handled = 0;
	FormPtr   form;

	
	switch (event->eType)
	{
	case frmOpenEvent:
		{
			loadTableItems();

			handled = 1;
		}
		break;
    
	case ctlSelectEvent:  // A control button was pressed and released.
	{
		switch(event->data.ctlEnter.controlID)
		{
		case NEW_BT:
			{
				PContext::setSelectedBottle(-1);
				FrmGotoForm(EDIT_FORM_ID);
			}
			handled = 1;
			break;

		case EDIT_BT:
			{
				InEditMode = true;
				InOneLessMode = false;
				InHistMode = false;

				ControlPtr ctl;
				ctl = (ControlPtr)GetObjectPtr(EDIT_BT);
				CtlSetValue(ctl, InEditMode);
				ctl = (ControlPtr)GetObjectPtr(ONE_LESS_BT);
				CtlSetValue(ctl, InOneLessMode);
				ctl = (ControlPtr)GetObjectPtr(HIST_BT);
				CtlSetValue(ctl, InHistMode);
			}
			handled = 1;
			break;

		case HIST_BT:
			{
				InEditMode = false;
				InOneLessMode = false;
				InHistMode = true;

				ControlPtr ctl;
				ctl = (ControlPtr)GetObjectPtr(EDIT_BT);
				CtlSetValue(ctl, InEditMode);
				ctl = (ControlPtr)GetObjectPtr(ONE_LESS_BT);
				CtlSetValue(ctl, InOneLessMode);
				ctl = (ControlPtr)GetObjectPtr(HIST_BT);
				CtlSetValue(ctl, InHistMode);
			}
			handled = 1;
			break;

		case ONE_LESS_BT:
			{
				InEditMode = false;
				InOneLessMode = true;
				InHistMode = false;

				ControlPtr ctl;
				ctl = (ControlPtr)GetObjectPtr(EDIT_BT);
				CtlSetValue(ctl, InEditMode);
				ctl = (ControlPtr)GetObjectPtr(ONE_LESS_BT);
				CtlSetValue(ctl, InOneLessMode);
				ctl = (ControlPtr)GetObjectPtr(HIST_BT);
				CtlSetValue(ctl, InHistMode);
			}
			handled = 1;
			break;

		case FILTER_POPUP_ID:
			{
				ListPtr list = (ListPtr)GetObjectPtr(FILTERS_LIST_ID);
				LstSetListChoices(list, PFilterManager::getFiltersList(true), PFilterManager::getNbFilters()+1);
				short num = PFilterManager::getNbFilters()+1;
				if (num > 10)
					num = 10;
				LstSetHeight(list, num);
				LstPopupList(list);

				PFilterManager::setCurrentFilterIndex(LstGetSelection(list)-1);

				ControlPtr ctl = (ControlPtr)GetObjectPtr(FILTER_POPUP_ID);
				MESSAGE("GetFilterName");
				char* name = PFilterManager::getCurrentFilterName();
				MESSAGE("FilterName getted");
				CtlSetLabel(ctl, name);
				MESSAGE("Loading");
				loadTableItems();
				MESSAGE("Loaded");
				handled = 1;
			}
			break;

		case FILTER_BT:
			FrmGotoForm(FILTER_FORM_ID);
			handled = 1;
			break;
		};
	}
	break;

//--------------------------------------------------------------------------
   	case keyDownEvent:		// P13.  Handle the physical scroll buttons
	   	if (event->data.keyDown.chr == pageUpChr)
        {
    		MESSAGE("keyDownEvent - UP");
    		ListPtr list = (ListPtr)GetObjectPtr(MAIN_LIST_ID);

            short sel = LstGetSelection(list);
            sel--;
            if (sel < 0)
            {
                sel = 0;
            }
            LstSetSelection(list, sel);

       		handled = true;
   		}
	   	else if (event->data.keyDown.chr == pageDownChr)
   		{
    		MESSAGE("keyDownEvent - DOWN");
    		ListPtr list = (ListPtr)GetObjectPtr(MAIN_LIST_ID);

            short sel = LstGetSelection(list);
            sel++;
            if ( sel >= LstGetNumberOfItems(list) )
                sel = LstGetNumberOfItems(list)-1;
            LstSetSelection(list, sel);

       		handled = true;
   		}
		break;

//--------------------------------------------------------------------------
	case lstSelectEvent:
	{
		MESSAGE("lstSelectEvent");
		ListPtr list = (ListPtr)GetObjectPtr(MAIN_LIST_ID);

		long sel = LstGetSelection(list);
		PContext::setSelectedBottle( (long)PContext::getFilteredCollection().getAt(sel) );
		if (InEditMode)
		{
			if (PContext::selectedBottle() == -1)
			{
				MessageBox( Selectionner_pour_faire );
			}
			else
			{
				MESSAGE("FrmGotoForm");
				FrmGotoForm(EDIT_FORM_ID);
			}
		
		}
//--------------------------------------------------------------------------
		else
		{
			PDatabase& db = PContext::getBottlesDatabase();
			if (PContext::selectedBottle() == -1)
			{
				MessageBox( Selectionner_pour_faire );
				break;
			}
			PRecord& rec = PContext::getTheRecord();
			PBottle& bottle = PContext::getTheBottle();
			
			if (!db.getRecord(PContext::selectedBottle(), rec))
			{
				MessageBox("ERROR: Can't get the record");
				break;
			}
			bottle.loadWithEvents(rec);

			if (InOneLessMode)
			{

				// Add event
				bottle.addEvent(Une_De_Moins);

				bottle.setQuantite(bottle.getQuantite()-1);
				if (bottle.getQuantite() <= 0)
					bottle.setQuantite(0);
				bottle.save(rec);
				db.releaseRecord( PContext::selectedBottle() );


				if (bottle.getQuantite() == 0)
				{
					if (Yes == AskYesNo( Possedez_Plus_Supprimer ))
					{
						db.removeRecord(PContext::selectedBottle());
						PContext::setSelectedBottle(-1);
					}
				}

			}
			else if (InHistMode)
			{
				db.releaseRecord( PContext::selectedBottle() );
				history(bottle);
			}
			else
			{
				MessageBox("Unexpected Error in edition");
			}

			loadTableItems();
		}
		handled = 1;
	}
	break;

//--------------------------------------------------------------------------
	case menuEvent:
	{
		switch (event->data.menu.itemID)
		{
        case PREFS_MNU_ID:
            {
                FrmGotoForm(PREFS_FORM_ID);
            }
            break;

		case CLONE_MNU_ID:
			{
				if (PContext::selectedBottle() == -1)
				{
					MessageBox( Selectionner_pour_faire );
				}
				else
				{
					PDatabase& db = PContext::getBottlesDatabase();

					PBottle& bottle = PContext::getTheBottle();
					PRecord& rec = PContext::getTheRecord();
					
					if ( !PContext::getRecordWithSelectedBottle(rec) )
					{
						MessageBox("Can't get the selected bottle");
						break;
					}
					//bottle.loadWithEvents(rec);
                    bottle.load(rec);
                    bottle.addEvent(Creation);
					db.releaseRecord( PContext::selectedBottle() );

					short index = db.createRecord(0, rec);
					if (index != -1)
					{
						bottle.save(rec);
						PContext::setSelectedBottle(index);
						db.releaseRecord(index);
						loadTableItems();
					}
					else
					{
						MessageBox("Can't create the record");
					}

				}
				handled = 1;
			}
			break;

		case COUNT_MNU_ID:
			statistics();
			handled = 1;
			break;

		case SORT_APPEL_MNU_ID:
			PContext::sortByAppelation();
			loadTableItems();
			break;

		case ASC_SORT_NUMBER_MNU_ID:
			PContext::sortByNumber(true);
			loadTableItems();
			break;

		case DESC_SORT_NUMBER_MNU_ID:
			PContext::sortByNumber(false);
			loadTableItems();
			break;

		case ASC_SORT_MILL_MNU_ID:
			PContext::sortByMillesime(true);
			loadTableItems();
			break;

		case DESC_SORT_MILL_MNU_ID:
			PContext::sortByMillesime(false);
			loadTableItems();
			break;

		case ABOUT_MNU_ID:
			about();
			break;

		case HELP_MNU_ID:
			help();
			break;

		case YEAR_QUALITY_MNU_ID:
			yearQuality();
			handled = 1;
			break;

		case CAVE_IDEALE_MNU_ID:
			caveIdeale();
			handled = 1;
			break;

		}
		handled = 1;
	}
	break;

//--------------------------------------------------------------------------
	case nilEvent:
		handled = 1;
		break;
	}

	return handled;
}



