
#ifndef PCollectionINCLUDED
#define PCollectionINCLUDED


#include "precord.h"


// Destroy items function
typedef void removeElementType(void* element);
typedef removeElementType* removeElementPtr;


// Sort functions
typedef Boolean compareElementsType(void* elem1, void* elem2);
typedef compareElementsType* compareElementPtr;




class PCollection
{

public:

	PCollection(removeElementPtr func, void* def, long limit = 0);
    void construct(removeElementPtr func, void* def, long limit = 0);
	~PCollection();

	long add(void* coll);

	void remove(void* coll);

	void* getAt(long index);
	const void* getAt(long index) const;
	long getIndexOf(void* coll) const;

	void clear();
	void clearAndDestroy();

	void sort(compareElementPtr func, Boolean ascending);

	long getSize() const { return nbUsedElements_; };

	voidPtr* getData() { return list_; };

	//friend PRecord& operator<<(PRecord& buff, const PCollection& b);
	//friend PRecord& operator>>(PRecord& buff, PCollection& b);


	Boolean setAt(long i, void* coll);


protected:

	void resize(long newSize);


private:

	long nbUsedElements_;
	long allocated_;

	voidPtr* list_;

	removeElementPtr removeFunction_;

	long limit_;
	void* default_;

};

#endif

