

#include "PContext.h"

#include "callback.h"

#include "pbottle.h"
#include "pdatabase.h"

#include "cprotos.h"


void doNothing(void* elem)
{
}

//----------------------------------------------------------

PCollection		    PContext::theFilteredCollection_(0, 0, 0);

short				PContext::selectedBottle_ = -1;

PBottle			    PContext::theBottle_;
PRecord			    PContext::theRecord_;
PString			    PContext::theNoteString_;

PDatabase			PContext::filtersDb_(0);
PDatabase			PContext::bottlesDb_(10);

char*				PContext::allString_ = 0;
char*				PContext::naString_ = 0;


//----------------------------------------------------------
long getFreeHeapSize(const char* msg);

//----------------------------------------------------------
Boolean PContext::init()
{
    //getFreeHeapSize("Before theFilteredCollection_");
	theFilteredCollection_.construct(doNothing, (void*)-1);
    //getFreeHeapSize("After theFilteredCollection_");


	// The unique bottle
    MESSAGE("construct theBottle");
	theBottle_.construct();
    //getFreeHeapSize("theBottle_");
	// The unique PRecord
	theRecord_.construct();
    //getFreeHeapSize("theRecord_");
	// The unique note string
	theNoteString_.construct();
    //getFreeHeapSize("theNoteString_");


	allString_ = Tous;
	naString_ = Non_Disponible;


	filtersDb_.construct(0);
	if (!filtersDb_.openOrCreate('FILT', "cavistFiltersDB"))
	{
		MessageBox("Can't open the database");
		return false;
	}
    //getFreeHeapSize("filtersDb_");

	bottlesDb_.construct(10);
	if (!bottlesDb_.openOrCreate('BOTL', "cavistBottlesDB"))
	{
		MessageBox("Can't open the database");
		return false;
	}
    //getFreeHeapSize("bottlesDb_");

	return true;
}

//----------------------------------------------------------
void PContext::destroy()
{
	MESSAGE("PContext");

	filtersDb_.close();
	bottlesDb_.close();
}

//--------------------------------------------------------------------------
short PContext::selectedBottle()
{
	return selectedBottle_;
}

//--------------------------------------------------------------------------
void PContext::setSelectedBottle(short bottle)
{
	selectedBottle_ = bottle;
}

//--------------------------------------------------------------------------
Boolean PContext::getRecordWithSelectedBottle(PRecord& rec)
{
	if (selectedBottle() == -1)
		return false;

	if (!getBottlesDatabase().getRecord( selectedBottle(), rec ))
		return false;

	return true;
}

//--------------------------------------------------------------------------
Boolean PContext::releaseSelectedBottle()
{
	if (selectedBottle() == -1)
		return false;

	if (!getBottlesDatabase().releaseRecord( selectedBottle() ))
		return false;

	return true;
}












//--------------------------------------------------------------------------
Int compareByQuantity(void* p1, void* p2, Int asc, SortRecordInfoPtr infos1, SortRecordInfoPtr infos2, VoidHand appInfoH)
{
	CALLBACK_PROLOGUE

    MESSAGE("Begin");
    char* b1 = (char*)p1;
    char* b2 = (char*)p2;

	if (asc == 0)
        asc = -1;
    else
        asc = 1;

    char ver;
    ver = b1[0];
    MESSAGE("ver");
	Int ret = 0;
    if (PBottle::testVersion(ver))
    {
        MESSAGE("Good bottle");
        char q1;
        char q2;
        q1 = *(char*)&b1[1];
        q2 = *(char*)&b2[1];

        if ( q1 > q2 )
            ret = -asc;
		else if ( q1 < q2 )
            ret = asc;
		else
	        ret = 0;
    }
    else
        MESSAGE("Wrong bottle");


    MESSAGE("End");

	CALLBACK_EPILOGUE
	return ret;
}

//----------------------------------------------------------
void PContext::sortByNumber(Boolean asc)
{
    getBottlesDatabase().quickSort(compareByQuantity, asc);
}





//----------------------------------------------------------
Int compareByAppelation(void* p1, void* p2, Int asc, SortRecordInfoPtr infos1, SortRecordInfoPtr infos2, VoidHand appInfoH)
{
	CALLBACK_PROLOGUE

    MESSAGE("Begin");
    char* b1 = (char*)p1;
    char* b2 = (char*)p2;

	if (asc == 0)
        asc = -1;
    else
        asc = 1;

    char ver;
    ver = b1[0];
    MESSAGE("ver");
	Int ret = 0;
    if (PBottle::testVersion(ver))
    {
        b1 = &b1[4];
        b2 = &b2[4];
        ret = StrCompare(b1, b2);
        ret = ret*asc;
    }
    else
        MESSAGE("Wrong bottle");


    MESSAGE("End");

	CALLBACK_EPILOGUE
	return ret;
}

//----------------------------------------------------------
void PContext::sortByAppelation()
{
	getBottlesDatabase().quickSort(compareByAppelation, true);
}








//----------------------------------------------------------
Int compareByMillesime(void* p1, void* p2, Int asc, SortRecordInfoPtr infos1, SortRecordInfoPtr infos2, VoidHand appInfoH)
{
	CALLBACK_PROLOGUE

    MESSAGE("Begin");
    char* b1 = (char*)p1;
    char* b2 = (char*)p2;

	if (asc == 0)
        asc = -1;
    else
        asc = 1;

    char ver;
    ver = b1[0];
    MESSAGE("ver");
	Int ret = 0;
    if (PBottle::testVersion(ver))
    {
        MESSAGE("Good bottle");
        short mill1;
        short mill2;
        mill1 = *(short*)&b1[2];
        mill2 = *(short*)&b2[2];

        if ( mill1 > mill2 )
        {
            ret = -asc;
        }

        if ( mill1 < mill2 )
        {
            ret = asc;
	    }
    }
    else
        MESSAGE("Wrong bottle");


    MESSAGE("End");

	CALLBACK_EPILOGUE
	return ret;
}

//----------------------------------------------------------
void PContext::sortByMillesime(Boolean asc)
{
	getBottlesDatabase().quickSort(compareByMillesime, asc);
}



