
#ifndef PContextINCLUDED
#define PContextINCLUDED


#include "global.h"
#include "pstring.h"

#include "pbottle.h"


class PCollection;
class PBottleRecord;
class PDatabase;

class PContext
{
public:

	static Boolean init();
	static void destroy();

	static void sortByAppelation();
    static void sortByNumber(Boolean asc);
	static void sortByMillesime(Boolean asc);

	static char* getNotAvailableString()		{ return naString_; };
	static char* getAllString()				{ return allString_; };

	static short selectedBottle();
	static void setSelectedBottle(short b);

	static PBottle& getTheBottle()					{ theBottle_.resetData(); return theBottle_; };
	static PRecord& getTheRecord()					{ return theRecord_; };
	static PString& getTheNoteString()				{ return theNoteString_; };

	static PCollection& getFilteredCollection()		{ return theFilteredCollection_; };

	static PDatabase& getFiltersDatabase()			{ return filtersDb_; };
	static PDatabase& getBottlesDatabase()			{ return bottlesDb_; };

	static Boolean getRecordWithSelectedBottle(PRecord& rec);
	static Boolean releaseSelectedBottle();


private:

	static PCollection theFilteredCollection_;

	static short selectedBottle_;

	static PBottle theBottle_;
	static PRecord theRecord_;
	static PString theNoteString_;

	static PDatabase filtersDb_;
	static PDatabase bottlesDb_;

	static char* allString_;
	static char* naString_;

};

#endif

