

#ifndef PDatabaseINCLUDED
#define PDatabaseINCLUDED


#include "global.h"
#include "pstring.h"


#define CREATOR_ID		'CVST'
#define TYPE_ID			'DATA'


class PDatabase
{

public:

	PDatabase(short maxRecords);
    void construct(short maxRecords);
    ~PDatabase();

	Boolean openOrCreate(long type, const PString& str);
	Boolean open(const PString& str);
	void close();
	Boolean remove();

	short createRecord(long size, PRecord& rec);
	Boolean removeRecord(short index);

	//PRecord* detachRecord(long index);
	//Boolean attachRecord(PRecord* record);

	Boolean getRecord(short at, PRecord& rec);
	Boolean releaseRecord(short index);

	short getNumRecords();

	Boolean quickSort(DmComparF* func, Boolean asc);


private:

	LocalID localId_;
	DmOpenRef ref_;
	PString name_;

	short maxRecords_;

};

#endif

