
#ifndef PDateINCLUDED
#define PDateINCLUDED


#include "global.h"

#include "precord.h"


class PString;


#ifdef CAVIST_MFC
typedef struct {
	Word day   :5;
	Word month :4;
	Word year  :7;
} DateType;
#endif



class PDate
{
public:

	PDate();
	PDate(const PDate& other);
	PDate(char jour, char mois, long annee);
	~PDate();

	PDate& operator=(const PDate& date);

	Boolean fromString(const PString& str);
	void toString(PString& str) const;

	char getDay() const { return (char)date_.day; };
	char getMonth() const { return (char)date_.month; };
	short getYear() const { return (1900+date_.year); };

	void setDay(long nb)	{ date_.day = (char)nb; };
	void setMonth(long nb)	{ date_.month = (char)nb; };
	void setYear(short nb);


	friend PRecord& operator<<(PRecord& buff, const PDate& b);
	friend PRecord& operator>>(PRecord& buff, PDate& b);


	bool isNull() const { return	(date_.day == 0) &&
									(date_.month == 0) &&
									(date_.year == 0); };

    static PDate today();


private:

	DateType date_;

};

bool operator!=(const PDate& date1, const PDate& date2);

#endif

