

#ifndef PFilterINCLUDED
#define PFilterINCLUDED



#include "pstring.h"
#include "precord.h"



class PBottle;



void removeFilter(void* element);



class PFilter
{

	friend class PFilterManager;

private:

	PFilter();
	void construct();

	PString name_;

	PString type_;
	PString capacite_;
	short millesime_;
	char older_;
	short atLeastNumber_;
	PString searchString_;
	short toDrinkMax_;


public:

	PFilter(const PString& name);
	~PFilter();

	void reset();

	friend PRecord& operator<<(PRecord& buff, const PFilter& b);
	friend PRecord& operator>>(PRecord& buff, PFilter& b);


	static char getCurrentFilterVersion();
	static Boolean testVersion(char version);

	Boolean load(PRecord& buffer);
	void save(PRecord& buffer);
	
	
	const PString& getName() { return name_; };
	const PString& getType() { return type_; };
	const PString& getCapacite() { return capacite_; };
	short getMillesime() { return millesime_; };
	Boolean getOlder(){ return (Boolean)older_; };
	short getAtLeastNumber() { return atLeastNumber_; };
	const PString& getSearchString(){ return searchString_; };
	short getToDrinkMax() { return toDrinkMax_; };

	void setName(const PString& n) { name_ = n; };
	void setType(const PString& t) { type_ = t; };
	void setCapacite(const PString& c) { capacite_ = c; };
	void setMillesime(short m) { millesime_ = m; };
	void setOlder(Boolean  o){ older_ = (char)o; };
	void setAtLeastNumber(short n) { atLeastNumber_ = n; };
	void setSearchString(const PString& s){ searchString_ = s; };
	void setToDrinkMax(short d) { toDrinkMax_ = d; };


private:

	static char currentFilterVersion_;

};

#endif

