
#include "plistmanager.h"
#include "pfiltermanager.h"

#include "pcollection.h"

#include "ppreferences.h"

#include "pbottle.h"
#include "pcontext.h"

#include "cprotos.h"




//----------------------------------------------------------

PCollection PListManager::plants_(0, 0, 0);

PCollection PListManager::typeCollection_(0, 0, 0);
PCollection PListManager::capaCollection_(0, 0, 0);
PCollection PListManager::lcapaCollection_(0, 0, 0);
PCollection PListManager::apprNumbersCollection_(0, 0, 0);
PCollection PListManager::apprStarsCollection_(0, 0, 0);

char** PListManager::allTypeList_ = 0;
char** PListManager::allCapaList_ = 0;

char** PListManager::typeList_ = 0;
char** PListManager::capaList_ = 0;
char** PListManager::apprNumbersList_ = 0;
char** PListManager::apprStarsList_ = 0;

long PListManager::typeNb_ = -1;
long PListManager::capaNb_ = -1;
long PListManager::apprNumbersNb_ = -1;
long PListManager::apprStarsNb_ = -1;

char* PListManager::defaultType_ = 0;
char* PListManager::defaultCapa_ = 0;
char* PListManager::defaultAppr_ = 0;

long PListManager::currentListVersion_ = 200;


void doNothing(void* elem);

//----------------------------------------------------------
void PListManager::destroy()
{

	VoidHandle handle;
	if (allTypeList_ != 0)
	{
		MESSAGE2("allTypeList_");
		handle = MemPtrRecoverHandle(allTypeList_);
		MemHandleUnlock(handle);
		MemHandleFree(handle);
	}
	
	if (typeList_ != 0)
	{
		MESSAGE2("typeList_");
		handle = MemPtrRecoverHandle(typeList_);
		MemHandleUnlock(handle);
		MemHandleFree(handle);
	}
	if (allCapaList_ != 0)
	{
		MESSAGE2("allCapaList_");
		handle = MemPtrRecoverHandle(allCapaList_);
		MemHandleUnlock(handle);
		MemHandleFree(handle);
	}

	if (capaList_ != 0)
	{
		MESSAGE2("capaList_");
		handle = MemPtrRecoverHandle(capaList_);
		MemHandleUnlock(handle);
		MemHandleFree(handle);
	}

	if (apprStarsList_ != 0)
	{
		MESSAGE2("apprStarsList_");
		handle = MemPtrRecoverHandle(apprStarsList_);
		MemHandleUnlock(handle);
		MemHandleFree(handle);
	}
	if (apprNumbersList_ != 0)
	{
		MESSAGE2("apprNumbersList_");
		handle = MemPtrRecoverHandle(apprNumbersList_);
		MemHandleUnlock(handle);
		MemHandleFree(handle);
	}
}

//----------------------------------------------------------
Boolean PListManager::init()
{
	PListManager::currentListVersion_ = 200;

    MESSAGE("0");

	typeCollection_.construct(doNothing, 0);
	
	capaCollection_.construct(doNothing, 0);
	lcapaCollection_.construct(doNothing, 0);
	
	apprStarsCollection_.construct(doNothing, 0);
    apprNumbersCollection_.construct(doNothing, 0);

	plants_.construct(removeString, 0);

    MESSAGE("1");	

	allTypeList_ = 0;
	allCapaList_ = 0;

	typeList_ = 0;
	capaList_ = 0;
	apprNumbersList_ = 0;
    apprStarsList_ = 0;

    MESSAGE("11");


	typeCollection_.add( Rouge );
    typeCollection_.add( Blanc );
    typeCollection_.add( Rose );
    typeCollection_.add( Dessert );
    typeCollection_.add( Champagne );
    typeCollection_.add( Mousseux );
    typeCollection_.add( Liquoreux );
    typeCollection_.add( Aperitif );
    typeCollection_.add( Autres );




    apprStarsCollection_.add( Sans_avis );
    apprStarsCollection_.add("*");
    apprStarsCollection_.add("**");
    apprStarsCollection_.add("***");
    apprStarsCollection_.add("****");
    apprStarsCollection_.add("*****");
    apprStarsCollection_.add("***** *");
    apprStarsCollection_.add("***** **");
    apprStarsCollection_.add("***** ***");
    apprStarsCollection_.add("***** ****");
    apprStarsCollection_.add("***** *****");

    apprNumbersCollection_.add( Sans_avis );
    apprNumbersCollection_.add("1");
    apprNumbersCollection_.add("2");
    apprNumbersCollection_.add("3");
    apprNumbersCollection_.add("4");
    apprNumbersCollection_.add("5");
    apprNumbersCollection_.add("6");
    apprNumbersCollection_.add("7");
    apprNumbersCollection_.add("8");
    apprNumbersCollection_.add("9");
    apprNumbersCollection_.add("10");



	capaCollection_.add( Flacon );
	capaCollection_.add( Demi );
	capaCollection_.add( Pot );
	capaCollection_.add( Vaudoise );
	capaCollection_.add( Bouteille );
	capaCollection_.add( Litre );
	capaCollection_.add( Magnum );
	capaCollection_.add( Jeroboam );
	capaCollection_.add( Rehoboam );
	capaCollection_.add( Mathusalem );
	capaCollection_.add( Salmanazar );
	capaCollection_.add( Balthasar );
	capaCollection_.add( Nabuchod );
	capaCollection_.add( AutresND );


    
    lcapaCollection_.add("0.18");
	lcapaCollection_.add("0.37");
	lcapaCollection_.add("0.50");
	lcapaCollection_.add("0.70");
	lcapaCollection_.add("0.75");
	lcapaCollection_.add("1.00");
	lcapaCollection_.add("1.50");
	lcapaCollection_.add("3.00");
	lcapaCollection_.add("4.30");
	lcapaCollection_.add("6.00");
	lcapaCollection_.add("9.00");
	lcapaCollection_.add("12.0");
	lcapaCollection_.add("15.0");
	lcapaCollection_.add("????");




    defaultType_ = Type;
	defaultCapa_ = Contenance;
	defaultAppr_ = Appreciation;
    //defaultType_ = (char*)typeCollection_.getAt(0);
	//defaultCapa_ = (char*)capaCollection_.getAt(4);
	//defaultAppr_ = (char*)apprStarsCollection_.getAt(3);



	return true;
}

//-----------------------------------------------------------------
void PListManager::setStarsAsDefaultAppreciation(Boolean val)
{
	if (val) // Stars
	{
     	defaultAppr_ = (char*)apprStarsCollection_.getAt(5);
	}
	else
	{
     	defaultAppr_ = (char*)apprNumbersCollection_.getAt(5);
	}
}

//-----------------------------------------------------------------
Boolean PListManager::load(PRecord& buffer, long version)
{
	// Lists version from 200 to 299
	if (version != currentListVersion_)
		return false;

	// No list load at this time
	return true;
}

//-----------------------------------------------------------------
void PListManager::save(PRecord& buffer)
{
	// No list save at this time
	buffer << currentListVersion_;
	buffer << "Save on LISTS not implemented";
	return;
}

void* resizePointer(void* ptr, long size)
{
	if (size == 0)
	{
		MessageBox("Size == 0 -> size = 1");
		size = 1;
	}
	

    MESSAGE("In resizePointer");
	VoidHandle handle;
	if (ptr == 0)
	{
		MESSAGE("Creating new in resizePointer");
		handle = MemHandleNew(size);
	}
	else
	{
		MESSAGE("Recover    ");
		handle = MemPtrRecoverHandle(ptr);
		if (handle == 0)
			MessageBox("Handle == 0 in resizePointer");
		MESSAGE("Unlock");
		MemHandleUnlock(handle);
		MESSAGE("Resize");
		MemHandleResize(handle, size);
	}
	MESSAGE("Locking");
	void* aptr = MemHandleLock(handle);
	MESSAGE("Done");
	return aptr;
}

//----------------------------------------------------------
char** PListManager::getAllTypeList()
{
	if (allTypeList_ == 0)
	{
		typeNb_ = typeCollection_.getSize();
#ifdef DEBUG
		if (typeNb_ == 0)
		{
			MessageBox("Can't create the allTypeList_");
			return 0;
		}
#endif
		allTypeList_ = (char**)resizePointer(allTypeList_, (typeNb_+1)*sizeof(char*) );
		allTypeList_[0] = PContext::getAllString();

		for (long i=0;i<typeNb_;i++)
		{
			allTypeList_[i+1] = (char*)typeCollection_.getAt(i);
		}
	}

	return allTypeList_;
}

//----------------------------------------------------------
char** PListManager::getTypeList()
{
	if (typeList_ == 0)
	{
		typeNb_ = typeCollection_.getSize();
#ifdef DEBUG
		if (typeNb_ == 0)
		{
			MessageBox("Can't create the typeList_");
			return 0;
		}
#endif
		typeList_ = (char**)resizePointer(typeList_, typeNb_*sizeof(char*));

		for (long i=0;i<typeNb_;i++)
		{
			typeList_[i] = (char*)typeCollection_.getAt(i);
		}
	}

	return typeList_;
}

//----------------------------------------------------------
char** PListManager::getAllCapaciteList()
{
	if (allCapaList_ == 0)
	{
		capaNb_ = capaCollection_.getSize();
#ifdef DEBUG
		if (capaNb_ == 0)
		{
			MessageBox("Can't create the allCapaList_");
			return 0;
		}
#endif
		allCapaList_ = (char**)resizePointer(allCapaList_, (capaNb_+1)*sizeof(char*) );
		allCapaList_[0] = PContext::getAllString();

		for (long i=0;i<capaNb_;i++)
		{
			allCapaList_[i+1] = (char*)capaCollection_.getAt(i);
		}
	}

	return allCapaList_;
}

//----------------------------------------------------------
char** PListManager::getCapaciteList()
{
	if (capaList_ == 0)
	{
		capaNb_ = capaCollection_.getSize();
#ifdef DEBUG
		if (capaNb_ == 0)
		{
			MessageBox("Can't create the capaList_");
			return 0;
		}
#endif
		capaList_ = (char**)resizePointer(capaList_, (capaNb_)*sizeof(char*) );

		for (long i=0;i<capaNb_;i++)
		{
			capaList_[i] = (char*)capaCollection_.getAt(i);
		}
	}

	return capaList_;
}

//----------------------------------------------------------
char** PListManager::getAppreciationList()
{
	if (apprStarsList_ == 0)
	{
		apprStarsNb_ = apprStarsCollection_.getSize();
#ifdef DEBUG
		if (apprStarsNb_ == 0)
		{
			MessageBox("Can't create the apprStarsList_");
			return 0;
		}
#endif
		apprStarsList_ = (char**)resizePointer(apprStarsList_, apprStarsNb_*sizeof(char*) );

		for (long i=0;i<apprStarsNb_;i++)
		{
			apprStarsList_[i] = (char*)apprStarsCollection_.getAt(i);
		}
	}

    if (apprNumbersList_ == 0)
    {
		apprNumbersNb_ = apprNumbersCollection_.getSize();
#ifdef DEBUG
		if (apprNumbersNb_ == 0)
		{
			MessageBox("Can't create the apprNumbersList_");
			return 0;
		}
#endif
		apprNumbersList_ = (char**)resizePointer(apprNumbersList_, apprNumbersNb_*sizeof(char*) );

		for (long i=0;i<apprNumbersNb_;i++)
		{
			apprNumbersList_[i] = (char*)apprNumbersCollection_.getAt(i);
		}
    }

    if (PPreferences::getStarsForAppreciation())
	    return apprStarsList_;
    else
        return apprNumbersList_;
}


//--------------------------------------------------------------------------
char* PListManager::getCapaciteString(BYTE capa)
{
	char* str = (char*)capaCollection_.getAt(capa);
	if (str == 0)
		return PContext::getNotAvailableString();
	
	return str;
}

//--------------------------------------------------------------------------
char* PListManager::getCapaString(char* capa)
{
	static char* str = 0;
	getCapaString(capa, str);
	if (str == 0)
		str = PContext::getNotAvailableString();
	return str;
}

//--------------------------------------------------------------------------
void PListManager::getCapaString(char* capa, char*& ret)
{
	ret = 0;
	for (long i=0;i<capaCollection_.getSize();i++)
	{
		char* str = (char*)capaCollection_.getAt(i);
		if (str == 0)
			return;

		if (StrCompare(str, capa) == 0)
		{
			str = (char*)lcapaCollection_.getAt(i);
			if (str == 0)
				return;

			ret = str;
			return;
		}
	}

	return;
}

//--------------------------------------------------------------------------
char* PListManager::getTypeString(BYTE type)
{
	char* str = (char*)typeCollection_.getAt(type);
	if (str == 0)
		return PContext::getNotAvailableString();
	
	return str;
}

//--------------------------------------------------------------------------
long PListManager::getNbAppreciationItems()
{
    if (apprStarsNb_ != apprNumbersNb_)
        MessageBox("Nb differents!");
    
    return apprStarsNb_;
}

//--------------------------------------------------------------------------
char* PListManager::getAppreciationString(BYTE note)
{
    char* str;
    if (PPreferences::getStarsForAppreciation())
    {
    	str = (char*)apprStarsCollection_.getAt(note);
	    if (str == 0)
		    return PContext::getNotAvailableString();
    }
    else
    {
    	str = (char*)apprNumbersCollection_.getAt(note);
	    if (str == 0)
		    return PContext::getNotAvailableString();
    }
	
	return str;
}

