

#ifndef PListManagerINCLUDED
#define PListManagerINCLUDED


#include "global.h"
#include "precord.h"


class PCollection;
class PBottle;
class PString;



class PListManager
{

private:

	static PCollection plants_;

	static PCollection typeCollection_;
	static PCollection capaCollection_;
	static PCollection lcapaCollection_;
	static PCollection apprStarsCollection_;
    static PCollection apprNumbersCollection_;

	static char** allTypeList_;
	static char** allCapaList_;

	static char** typeList_;
	static char** capaList_;
	static char** apprNumbersList_;
	static char** apprStarsList_;

	static long typeNb_;
	static long capaNb_;
	static long apprNumbersNb_;
    static long apprStarsNb_;

    static char* defaultType_;
	static char* defaultCapa_;
	static char* defaultAppr_;


	static long currentListVersion_;



public:


	friend PRecord& operator<<(PRecord& buff, const PListManager& b);
	friend PRecord& operator>>(PRecord& buff, PListManager& b);

	static Boolean init();
	static void destroy();
	
	static Boolean load(PRecord& buffer, long version);
	static void save(PRecord& buffer);

	static char** getAllTypeList();
	static char** getAllCapaciteList();

	static char** getTypeList();
	static char** getCapaciteList();
	static char** getAppreciationList();

	static void setStarsAsDefaultAppreciation(Boolean val);

	static PCollection& getTypeCollection() { return typeCollection_; };

	static long getNbCapaItems() { return capaNb_; };
	static long getNbTypeItems() { return typeNb_; };
	static long getNbAppreciationItems();

	static char* getCapaciteString(BYTE capa);
	static char* getCapaString(char* capa);
	static void getCapaString(char* capa, char*& ret);
	static char* getTypeString(BYTE type);
	static char* getAppreciationString(BYTE note);


	static char* getDefaultType() { return defaultType_; };
	static char* getDefaultCapa() { return defaultCapa_; };
	static char* getDefaultAppr() { return defaultAppr_; };


	static bool addPlant(const PString& str);
	static bool resetPlants();

};

#endif

