
#include "global.h"
#include "cprotos.h"

#include "ppreferences.h"

#include "plistmanager.h"
#include "PContext.h"
#include "PFilterManager.h"
#include "pdatabase.h"
#include "PYearQuality.h"




//---------------------------------------------------------------------

short PPreferences::id_ = 1;
short PPreferences::selectedBottleIndex_ = 0;
short PPreferences::selectedFilterIndex_ = -1;
short PPreferences::selectedRegion_ = 0;

char  PPreferences::starsForAppreciation_ = 1;
char  PPreferences::showAppelationInMainView_ = 1;



//---------------------------------------------------------------------
PPreferences::PPreferences()
{
}
PPreferences::~PPreferences()
{
}

//---------------------------------------------------------------------
Boolean PPreferences::getStarsForAppreciation()
{
	return (Boolean )starsForAppreciation_;
}

//---------------------------------------------------------------------
void PPreferences::setStarsForAppreciation(Boolean val)
{
	starsForAppreciation_ = (char)val;
	PListManager::setStarsAsDefaultAppreciation(starsForAppreciation_);
}

//---------------------------------------------------------------------
Boolean PPreferences::getShowAppelationInMainView()
{
    return (Boolean)showAppelationInMainView_;
}

//---------------------------------------------------------------------
void PPreferences::setShowAppelationInMainView(Boolean val)
{
    showAppelationInMainView_ = (char)val;
}

//---------------------------------------------------------------------
void PPreferences::setPrefs()
{
	if (selectedBottleIndex_ >= 0 && selectedBottleIndex_ < PContext::getBottlesDatabase().getNumRecords())
		PContext::setSelectedBottle( selectedBottleIndex_ );

	if (selectedFilterIndex_ >= 0 && selectedFilterIndex_ < PContext::getFiltersDatabase().getNumRecords())
		PFilterManager::setCurrentFilterIndex( selectedFilterIndex_ );

	selectedRegion_ = 0;
}

//---------------------------------------------------------------------
void PPreferences::retrieve()
{
	selectedRegion_ = PYearQuality::getSelectedRegion();
	selectedBottleIndex_ = PContext::selectedBottle();
	selectedFilterIndex_ = PFilterManager::getCurrentFilterIndex();
}

//---------------------------------------------------------------------
Boolean PPreferences::load(PRecord& buffer)
{
	buffer.lock();

	buffer >> id_;
	buffer >> selectedBottleIndex_;
	buffer >> selectedFilterIndex_;
	buffer >> selectedRegion_;

    buffer >> starsForAppreciation_;
    buffer >> showAppelationInMainView_;

	buffer.unlock();

	return true;
}

//---------------------------------------------------------------------
void PPreferences::save(PRecord& buffer)
{
    MESSAGE("lock");
	buffer.lock();
    MESSAGE("reset");
	buffer.reset();

    MESSAGE("<< id ");
	buffer << id_;
    MESSAGE("<< selectedBottleIndex_");
	buffer << selectedBottleIndex_;
    MESSAGE("<< selectedFilterIndex_");
	buffer << selectedFilterIndex_;
    MESSAGE("<< selectedRegion_");
	buffer << selectedRegion_;
    MESSAGE("<< starsForAppreciation_");
    buffer << starsForAppreciation_;
    MESSAGE("<< showAppelationInMainView_");
    buffer << showAppelationInMainView_;

    MESSAGE("unlock");
	buffer.unlock();
    MESSAGE("PPref::save done.");
}


