
#ifndef PBufferINCLUDED
#define PBufferINCLUDED


#include "global.h"


class PDatabase;
class PString;

class PRecord
{

	friend class PDatabase;

public:

	PRecord();
	void construct();
	PRecord(VoidHandle handle);
	~PRecord();

	// Common
	void reset();

	// InBuffer
	void append(const char* data, long len = 0);

	// OutBuffer
	void get(char* data, long len);
	void get(PString& str);
	Boolean hasStillData();


	void lock();
	void unlock();

	void setHandle(VoidHandle h)	{ handle_ = h; };
	VoidHandle getHandle()			{ return handle_; };

	void setBuffer(char* data, long len, Boolean toLock = true) { data_ = data; allocSize_ = len; toLock_ = toLock; };
	char* getData() { return data_; };

#ifdef CAVIST_MFC

	long getSize() { return index_; };
	void detachData() { data_ = 0; index_ = 0; };


#endif


private:

	void allocNewLen(long newLen);


	// Data
	long allocSize_;
	long index_;
	char* data_;
    Boolean toLock_;

	VoidHandle handle_;

};

PRecord& operator>>(PRecord& buff, float& f);
PRecord& operator<<(PRecord& buff, float f);

PRecord& operator>>(PRecord& buff, long& val);
PRecord& operator<<(PRecord& buff, long val);

PRecord& operator>>(PRecord& buff, char& c);
PRecord& operator<<(PRecord& buff, char c);

PRecord& operator>>(PRecord& buff, short& c);
PRecord& operator<<(PRecord& buff, short c);

#endif

