

#include "global.h"

#include "ids.h"

#include <System/SysAll.h>
#include <UI/UIAll.h>



#include "cprotos.h"

#include "plistmanager.h"

#include "pstring.h"
#include "pbottle.h"
#include "PCollection.h"

#include "floatmgr.h"

#include "PContext.h"
#include "precord.h"
#include "pdatabase.h"




void about();
void help();


//---------------------------------------------------------------
void editNote(PString& note)
{
	//MessageBox("Note not implemented now.");
	//return;
	PString& str = PContext::getTheNoteString();
	str = note;

	FormPtr form = FrmInitForm(NOTE_FORM_ID);
	
	//FrmSetEventHandler(form, editNoteEventHandler);
	Word fldIndex = FrmGetObjectIndex(form, NOTE_FLD_ID);
	FieldPtr field = (FieldPtr)FrmGetObjectPtr(form, fldIndex);
	
	Handle handle = (Handle)MemHandleNew(str.Length()+2);
	char* text = (char*)MemHandleLock((VoidHandle)handle);
	text[0] = 0;
	StrCopy(text, str.data());
	MemHandleUnlock((VoidHandle)handle);
	
	FldSetTextHandle(field, handle);
	FrmSetFocus(form, fldIndex);
	
	Word hit = FrmDoDialog(form);
	
	fldIndex = FrmGetObjectIndex(form, NOTE_FLD_ID);
	field = (FieldPtr)FrmGetObjectPtr(form, fldIndex);

	handle = (Handle)FldGetTextHandle(field);
	FldSetTextHandle(field, 0);

	text = (char*)MemHandleLock((VoidHandle)handle);
	str = text;
	MemHandleUnlock((VoidHandle)handle);
	MemHandleFree((VoidHandle)handle);

	FrmDeleteForm(form);

	if (hit == DONE_BT)
	    note = PContext::getTheNoteString();
}

//---------------------------------------------------------------

Boolean setStringToField(long id, const PString& value);
Boolean getStringFromField(long id, PString& value);

//---------------------------------------------------------------







//-------------------------------------------------------
Boolean setDateAchatToField(const PDate& date)
{
    MESSAGE("setDateAchatToField");
	static PString str;
	str = "";
	date.toString(str);

	ControlType* bt = (ControlType*)GetObjectPtr(ACHAT_SELECT_ID);
	CtlSetLabel(bt, str.data());

    MESSAGE("setDateAchatToField done");
	return true;
}













Boolean setContenances(const PString& capa)
{
	ListPtr list =(ListPtr)GetObjectPtr(CAPA_LIST_ID);
	ControlPtr pop = (ControlPtr)GetObjectPtr(CAPA_POPUP_ID);


	if (capa == "")
		CtlSetLabel(pop, PListManager::getDefaultCapa());
	else
		CtlSetLabel(pop, capa.data());

	
	char** ptr = PListManager::getCapaciteList();
	short nb = (short)PListManager::getNbCapaItems();
#ifdef DEBUG
	if (ptr == 0 || nb == 0)
		MessageBox("Error in Type list");
#endif
	LstSetListChoices(list, ptr, nb);

	return true;
}






Boolean setTypes(const PString& type)
{
	ListPtr list =(ListPtr)GetObjectPtr(TYPE_LIST_ID);
	ControlPtr pop = (ControlPtr)GetObjectPtr(TYPE_POPUP_ID);

	
	if (type == "")
    {
        CtlSetLabel(pop, PListManager::getDefaultType());
    }
	else
		CtlSetLabel(pop, type.data());

	
	char** ptr = PListManager::getTypeList();
	short nb = (short)PListManager::getNbTypeItems();
#ifdef DEBUG
	if (ptr == 0 || nb == 0)
		MessageBox("Error in Type list");
#endif
	LstSetListChoices(list, ptr, nb);

	return true;
}






Boolean setNotes(const PString& note)
{
	ListPtr list =(ListPtr)GetObjectPtr(NOTE_LIST_ID);
	ControlPtr pop = (ControlPtr)GetObjectPtr(NOTE_POPUP_ID);


	if (note == "")
		CtlSetLabel(pop, PListManager::getDefaultAppr());
	else
		CtlSetLabel(pop, note.data());

	
	char** ptr = PListManager::getAppreciationList();
	short nb = (short)PListManager::getNbAppreciationItems();
#ifdef DEBUG
	if (ptr == 0 || nb == 0)
		MessageBox("Error in Type list");
#endif
	LstSetListChoices(list, ptr, nb);

	return true;
}












//-------------------------------------------------------
static void setBottleToFields(const PBottle& editedBottle)
{
    MESSAGE("setBottleToFields");
	PString str;
	
	if(editedBottle.getQuantite() > 0)
		str.print("%d", editedBottle.getQuantite());
	else
		str = "";
	MESSAGE("Quantite");
	setStringToField(NUMBER_FLD_ID, str);

	if (editedBottle.getMillesime() > 1900)
		str.print("%d", editedBottle.getMillesime());
	else
		str = "";
	MESSAGE("Millesime");
	setStringToField(MILLESIME_FLD_ID, str);

	MESSAGE("Appelation");
	setStringToField(APPELATION_FLD_ID, editedBottle.getAppelation());

	// Capa
	MESSAGE("Contenance");
	setContenances(editedBottle.getContenance());
	// Type
	MESSAGE("Type");
	setTypes(editedBottle.getType());

	MESSAGE("plant");
	setStringToField(PLANT_FLD_ID, editedBottle.getCepage());

	MESSAGE("region");
	setStringToField(REGION_FLD_ID, editedBottle.getRegion());

	MESSAGE("casier");
	setStringToField(CASIER_FLD_ID, editedBottle.getCasier());

	

	if (editedBottle.getToDrinkMax() > 1900)
		str.print("%d", editedBottle.getToDrinkMax());
	else
		str = "";
	MESSAGE("drink max");
	setStringToField(DRINK_MAX, str);
	
	if (editedBottle.getToDrinkMin() > 1900)
		str.print("%d", editedBottle.getToDrinkMin());
	else
		str = "";
	MESSAGE("drink min");
	setStringToField(DRINK_MIN, str);


	
	MESSAGE("Cru");
	setStringToField(NOM_DU_CRU_FLD_ID, editedBottle.getCru());

	
	// Note
	MESSAGE("Appr");
	setNotes(editedBottle.getAppreciation());


	// Date to do
	MESSAGE("date");
	setDateAchatToField(editedBottle.getDateAchat());

	MESSAGE("lieu");
	setStringToField(LIEU_FLD_ID, editedBottle.getLieuAchat() );


	MESSAGE("prix");
	setStringToField(PRIX_FLD_ID, editedBottle.getPrix() );

	MESSAGE("classe");
	setStringToField(CLASSE_FLD_ID, editedBottle.getClasse() );

	MESSAGE("producteur");
	setStringToField(PRODUCTEUR_FLD_ID, editedBottle.getProducteur());

    MESSAGE("setBottleToFields done");

}




















//---------------------------------------------------------------
static void setFieldsToBottle(PBottle& editedBottle)
{
	PString str;
	MESSAGE("NUMBER_FLD_ID");
	getStringFromField(NUMBER_FLD_ID, str);
	editedBottle.setQuantite( (char)str.IntOf() );

	MESSAGE("MILLESIME_FLD_ID");
	getStringFromField(MILLESIME_FLD_ID, str);
	editedBottle.setMillesime( (short)str.IntOf() );

	MESSAGE("APPELATION_FLD_ID");
	getStringFromField(APPELATION_FLD_ID, str);
	editedBottle.setAppelation(str);

	// Type already done.
	// Capa already done.

	MESSAGE("PLANT_FLD_ID");
	getStringFromField(PLANT_FLD_ID, str);
	editedBottle.setCepage(str);

	MESSAGE("REGION_FLD_ID");
	getStringFromField(REGION_FLD_ID, str);
	editedBottle.setRegion(str);

	MESSAGE("CASIER_FLD_ID");
	getStringFromField(CASIER_FLD_ID, str);
	editedBottle.setCasier(str);

	
	
	MESSAGE("DRINK_MAX");
	getStringFromField(DRINK_MAX, str);
	editedBottle.setToDrinkMax( str.IntOf() );
	
	MESSAGE("DRINK_MIN");
	getStringFromField(DRINK_MIN, str);
	editedBottle.setToDrinkMin( str.IntOf() );



	MESSAGE("NOM_DU_CRU_FLD_ID");
	getStringFromField(NOM_DU_CRU_FLD_ID, str);
	editedBottle.setCru(str);


	// Appreciation already done.
	

	// Date already done when user select it

	

	MESSAGE("LIEU_FLD_ID");
	getStringFromField(LIEU_FLD_ID, str);
	editedBottle.setLieuAchat(str);

	MESSAGE("PRIX_FLD_ID");
	getStringFromField(PRIX_FLD_ID, str);
	editedBottle.setPrix(str);

	MESSAGE("CLASSE_FLD_ID");
	getStringFromField(CLASSE_FLD_ID, str);
	editedBottle.setClasse(str);

	MESSAGE("PRODUCTEUR_FLD_ID");
	getStringFromField(PRODUCTEUR_FLD_ID, str);
	editedBottle.setProducteur(str);
	
	//getStringFromField(COMMENTAIRE_FLD_ID, str);
	//editedBottle.setCommentaire(str);

}







//-------------------------------------------------------
void clearListValues()
{
    MESSAGE("clearListValues");
	ControlPtr pop;
	ListPtr list;

	char* str = PContext::getAllString();

	
	list = (ListPtr)GetObjectPtr(CAPA_LIST_ID);
	LstSetListChoices(list, 0, 0);
	
	pop = (ControlPtr)GetObjectPtr(CAPA_POPUP_ID);
	CtlSetLabel(pop, str);


	
	list = (ListPtr)GetObjectPtr(TYPE_LIST_ID);
	LstSetListChoices(list, 0, 0);

	pop = (ControlPtr)GetObjectPtr(TYPE_POPUP_ID);
	CtlSetLabel(pop, str);



	list = (ListPtr)GetObjectPtr(NOTE_LIST_ID);
	LstSetListChoices(list, 0, 0);

	pop = (ControlPtr)GetObjectPtr(NOTE_POPUP_ID);
	CtlSetLabel(pop, str);

    MESSAGE("clearListValues done.");
}





void history(PBottle& editedBottle)
{
    PString str;

    const PCollection& coll = editedBottle.getJournal();
    PJournalEvent* event;
    str = "";
    for (long i=0; i<coll.getSize(); i++)
    {
        event = (PJournalEvent*)coll.getAt(i);
        if (event != 0)
        {
            str += event->image();
        }
        else
            MessageBox("NULL Event");
    }
    if (coll.getSize() == 0)
    {
        str = Pas_d_evenements;
    }
    MessageBox(str.data());
	return;
}


//-------------------------------------------------------
Boolean editEventHandler(EventType* event)
{
    PString str;
    str.print("editEventHandler: '%d'", event->eType);
	MESSAGE(str.data());

	static PBottle editedBottle;
    static PBottle oldBottle;

	int handled = 0;
	FormPtr form;
	str = "";

	switch(event->eType) 
	{
	case frmOpenEvent:
        oldBottle = editedBottle;
		MESSAGE("Open edit form");
		editedBottle.resetData();
		if (PContext::selectedBottle() != -1)	// New one
		{
			editedBottle.resetData();
			PRecord& rec = PContext::getTheRecord();
			if (!PContext::getRecordWithSelectedBottle(rec))
			{
				MessageBox("Can't get the selected bottle");
				FrmGotoForm(MAIN_FORM_ID);
			}
			else
			{
				editedBottle.loadWithEvents(rec);
				PContext::releaseSelectedBottle();
			}
		}
        else
        {
            // Defaults
            editedBottle = PBottle();
        }

		form = FrmGetActiveForm();
		
		setBottleToFields(editedBottle);
		
		FrmDrawForm(form);
		// Must be drawn after FrmDrawForm()
		setDateAchatToField(editedBottle.getDateAchat());
        FrmSetFocus(form, FrmGetObjectIndex(form, NUMBER_FLD_ID));
        

		handled = 1;
		break;
    
	case ctlSelectEvent:  // A control button was pressed and released.
	{
		switch(event->data.ctlEnter.controlID)
		{
//--------------------------------------------------------------------------
		case CANCEL_BT:
			setFieldsToBottle(editedBottle);
			clearListValues();
			FrmGotoForm(MAIN_FORM_ID);
			handled = 1;
			break;

		case DONE_BT:
            {
                form = FrmGetActiveForm();
			    setFieldsToBottle(editedBottle);

			    if (!editedBottle.isAllMandatorySet())
			    {
				    if (No == AskYesNo( Champs_obligatoires ))
				    {
					    setBottleToFields(editedBottle);
					    break;
				    }
			    }
			    else
			    {
				    PRecord& rec = PContext::getTheRecord();
				    PDatabase& db = PContext::getBottlesDatabase();
				    short index;
				    if (PContext::selectedBottle() == -1)	// New one
				    {
					    index = db.createRecord(0, rec);
					    if (index == -1)
					    {
                            MESSAGE("Index == -1");
						    clearListValues();
						    FrmGotoForm(MAIN_FORM_ID);
						    break;
					    }

                        editedBottle.addEvent(Creation);

					    editedBottle.save(rec);
					    PContext::setSelectedBottle(index);
				    }
				    else
				    {
					    index = PContext::selectedBottle();
					    db.getRecord(index, rec);
                    
                        if (oldBottle != editedBottle)
                        {
					        editedBottle.addEvent(Modification);
                        }
					    
					    editedBottle.save(rec);
				    }
				    db.releaseRecord(index);
			    }

			    clearListValues();
			    FrmGotoForm(MAIN_FORM_ID);
			    handled = 1;
            }
			break;

		case NOTE_BT:
			{
				editNote( (PString&)editedBottle.getCommentaire() );
			}
			break;

		case DELETE_BT:
			{
        		if (PContext::selectedBottle() != -1)	// New one
                {
    				if (Yes == AskYesNo( Effacer_bouteille ))
		    		{
				        short index = PContext::selectedBottle();
				        if (index == -1)
					        break;
				        PDatabase& db = PContext::getBottlesDatabase();
				        MESSAGE("Deleting");
				        db.removeRecord(index);
				        MESSAGE("Deleted");
				        PContext::setSelectedBottle(-1);
				        FrmGotoForm(MAIN_FORM_ID);
			        }
                }
                else
                {
                    MessageBox( Nouvelle_bouteille );
                }
			}
	        handled = 1;
			break;

//--------------------------------------------------------------------------
		case ACHAT_SELECT_ID:
			{
				SWord day, month, year;
				PDate date = editedBottle.getDateAchat();
				if (date.isNull())
				{
                    date = PDate::today();
				}
				day = date.getDay();
				month = date.getMonth();
				year = date.getYear();

				PString title = Choisir_date;
				MESSAGE("SelectDayV10");
				SelectDayV10(&month, &day, &year, title.data());
				MESSAGE("SelectDayV10 done");
				date = PDate((char)day, (char)month, (short)year);
				MESSAGE("setDateAchat");
				editedBottle.setDateAchat( date );
				MESSAGE("setDateAchatToField");
				setDateAchatToField( date );
				MESSAGE("DONE.");
				handled = 1;
			}
			break;

//--------------------------------------------------------------------------
		case CAPA_POPUP_ID:
			{
				ListPtr list = (ListPtr)GetObjectPtr(CAPA_LIST_ID);
				ControlPtr pop = (ControlPtr)GetObjectPtr(CAPA_POPUP_ID);

				LstPopupList(list);

				editedBottle.setContenance( LstGetSelectionText(list, LstGetSelection(list) ) );
				CtlSetLabel(pop, editedBottle.getContenance().data());

				handled = 1;
			}
			break;
		
		case TYPE_POPUP_ID:
			{
				ListPtr list = (ListPtr)GetObjectPtr(TYPE_LIST_ID);
				ControlPtr pop = (ControlPtr)GetObjectPtr(TYPE_POPUP_ID);

				LstPopupList(list);

				editedBottle.setType( LstGetSelectionText(list, LstGetSelection(list) ) );
				CtlSetLabel(pop, editedBottle.getType().data());

				handled = 1;
			}
			break;

		case NOTE_POPUP_ID:
			{
				ListPtr list = (ListPtr)GetObjectPtr(NOTE_LIST_ID);
				ControlPtr pop = (ControlPtr)GetObjectPtr(NOTE_POPUP_ID);

				LstPopupList(list);

				editedBottle.setAppreciation( LstGetSelectionText(list, LstGetSelection(list) ) );
				CtlSetLabel(pop, editedBottle.getAppreciation().data());

				handled = 1;
			}
			break;
		};
	}
	break;

//------------------------------------------------------
	case menuEvent:
	{
		switch (event->data.menu.itemID)
		{
        case EVENTS_MNU_ID:
            {
				history(editedBottle);
            }
            break;

		case RESET_MNU_ID:
			{
				setFieldsToBottle(editedBottle);
				editedBottle.resetData();
				setBottleToFields(editedBottle);
				
				FormPtr form = (FormPtr)FrmGetActiveForm();
				FrmDrawForm(form);
			}
			break;

		case ABOUT_MNU_ID:
			about();
			break;

		case HELP_MNU_ID:
			help();
			break;
		}
		handled = 1;
	}
	break;

	case nilEvent:
		handled = 1;
		break;
	}

	return handled;
}

