

#include "global.h"

#include "ids.h"

#include <System/SysAll.h>
#include <UI/UIAll.h>



#include "cprotos.h"

#include "plistmanager.h"

#include "pstring.h"
#include "pbottle.h"
#include "PCollection.h"

#include "floatmgr.h"

#include "PContext.h"
#include "precord.h"
#include "pdatabase.h"




void about();
void help();


//---------------------------------------------------------------
void editNote(PString& note)
{
	//MessageBox("Note not implemented now.");
	//return;
	PString& str = PContext::getTheNoteString();
	str = note;

	FormPtr form = FrmInitForm(NOTE_FORM_ID);
	
	//FrmSetEventHandler(form, editNoteEventHandler);
	Word fldIndex = FrmGetObjectIndex(form, NOTE_FLD_ID);
	FieldPtr field = (FieldPtr)FrmGetObjectPtr(form, fldIndex);
	
	Handle handle = (Handle)MemHandleNew(str.Length()+2);
	char* text = (char*)MemHandleLock((VoidHandle)handle);
	text[0] = 0;
	StrCopy(text, str.data());
	MemHandleUnlock((VoidHandle)handle);
	
	FldSetTextHandle(field, handle);
	FrmSetFocus(form, fldIndex);
	
	Word hit = FrmDoDialog(form);
	
	fldIndex = FrmGetObjectIndex(form, NOTE_FLD_ID);
	field = (FieldPtr)FrmGetObjectPtr(form, fldIndex);

	handle = (Handle)FldGetTextHandle(field);
	FldSetTextHandle(field, 0);

	text = (char*)MemHandleLock((VoidHandle)handle);
	str = text;
	MemHandleUnlock((VoidHandle)handle);
	MemHandleFree((VoidHandle)handle);

	FrmDeleteForm(form);

	//if (hit == 0)
	note = PContext::getTheNoteString();
}









Boolean setContenances(const PString& capa)
{
	ListPtr list =(ListPtr)GetObjectPtr(CAPA_LIST_ID);
	ControlPtr pop = (ControlPtr)GetObjectPtr(CAPA_POPUP_ID);


	if (capa == "")
#ifdef ML_FRENCH
		CtlSetLabel(pop, "Contenance");
#endif
#ifdef ML_ENGLISH
		CtlSetLabel(pop, "Capacity");
#endif
	else
		CtlSetLabel(pop, capa.data());

	
	char** ptr = PListManager::getCapaciteList();
	short nb = (short)PListManager::getNbCapaItems();
#ifdef DEBUG
	if (ptr == 0 || nb == 0)
		MessageBox("Error in Type list");
#endif
	LstSetListChoices(list, ptr, nb);

	return true;
}






Boolean setTypes(const PString& type)
{
	ListPtr list =(ListPtr)GetObjectPtr(TYPE_LIST_ID);
	ControlPtr pop = (ControlPtr)GetObjectPtr(TYPE_POPUP_ID);

	
	if (type == "")
		CtlSetLabel(pop, "Type");
	else
		CtlSetLabel(pop, type.data());

	
	char** ptr = PListManager::getTypeList();
	short nb = (short)PListManager::getNbTypeItems();
#ifdef DEBUG
	if (ptr == 0 || nb == 0)
		MessageBox("Error in Type list");
#endif
	LstSetListChoices(list, ptr, nb);

	return true;
}






Boolean setNotes(const PString& note)
{
	ListPtr list =(ListPtr)GetObjectPtr(NOTE_LIST_ID);
	ControlPtr pop = (ControlPtr)GetObjectPtr(NOTE_POPUP_ID);


	if (note == "")
#ifdef ML_FRENCH
		CtlSetLabel(pop, "Apprciation");
#endif
#ifdef ML_ENGLISH
		CtlSetLabel(pop, "Rating");
#endif
	else
		CtlSetLabel(pop, note.data());

	
	char** ptr = PListManager::getAppreciationList();
	short nb = (short)PListManager::getNbAppreciationItems();
#ifdef DEBUG
	if (ptr == 0 || nb == 0)
		MessageBox("Error in Type list");
#endif
	LstSetListChoices(list, ptr, nb);

	return true;
}
















void history(PBottle& editedBottle)
{
    PString str;

    const PCollection& coll = editedBottle.getJournal();
    PJournalEvent* event;
    str = "";
    for (long i=0; i<coll.getSize(); i++)
    {
        event = (PJournalEvent*)coll.getAt(i);
        if (event != 0)
        {
            str += event->image();
        }
        else
            MessageBox("NULL Event");
    }
    if (coll.getSize() == 0)
    {
#ifdef ML_FRENCH
        str = "Pas d'evenements";
#endif
#ifdef ML_ENGLISH
        str = "No events";
#endif
    }
    MessageBox(str.data());
	return;
}












//-------------------------------------------------------

VoidHandle unpackedBottle = 0;

short quantiteLength	= 3;
short millesimeLength	= 4;
short appelationLength	= 30;
short typeLength		= 30;
short contenanceLength	= 30;
short cruLength			= 30;
short regionLength		= 30;
short appreciationLength	= 30;
short classeLength		= 30;
short toDrinkMinLength	= 4;
short toDrinkMaxLength	= 4;
short producteurLength	= 30;
short cepageLength		= 30;
short dateAchatLength	= 2;
short lieuAchatLength	= 30;
short prixLength		= 30;
short casierLength		= 30;

//----------------------------------------------------------
short quantiteOffset		= 0;
short millesimeOffset		= quantiteOffset + quantiteLength;
short appelationOffset		= millesimeOffset + millesimeLength;
short typeOffset			= appelationOffset + appelationLength;
short contenanceOffset		= typeOffset + typeLength;
short cruOffset				= contenanceOffset + contenanceLength;
short regionOffset			= cruOffset + cruLength;
short appreciationOffset	= regionOffset + regionLength;
short classeOffset			= appreciationOffset + appreciationLength;
short toDrinkMinOffset		= classeOffset + classeLength;
short toDrinkMaxOffset		= toDrinkMinOffset + toDrinkMinLength;
short producteurOffset		= toDrinkMaxOffset + toDrinkMaxLength;
short cepageOffset			= producteurOffset + producteurLength;
short dateAchatOffset		= cepageOffset + cepageLength;
short lieuAchatOffset		= dateAchatOffset + dateAchatLength;
short prixOffset			= lieuAchatOffset + lieuAchatLength;
short casierOffset			= prixOffset + prixLength;
short totalLength			= casierOffset + casierLength;

//----------------------------------------------------------
tableItemStyles quantiteType	= textTableItem;
tableItemStyles millesimeType	= textTableItem;
tableItemStyles appelationType	= textTableItem;
tableItemStyles typeType		= popupTriggerTableItem;
tableItemStyles contenanceType	= popupTriggerTableItem;
tableItemStyles cruType			= textTableItem;
tableItemStyles regionType		= textTableItem;
tableItemStyles appreciationType= popupTriggerTableItem;
tableItemStyles classeType		= textTableItem;
tableItemStyles toDrinkMinType	= textTableItem;
tableItemStyles toDrinkMaxType	= textTableItem;
tableItemStyles producteurType	= textTableItem;
tableItemStyles cepageType		= textTableItem;
tableItemStyles dateAchatType	= dateTableItem; //Date
tableItemStyles lieuAchatType	= textTableItem;
tableItemStyles prixType		= textTableItem;
tableItemStyles casierType		= textTableItem;

//----------------------------------------------------------
typedef struct
{
	char* name;
	short offset;
	short len;
	tableItemStyles type;

} OneCell;

const short nbFields = 17;
OneCell cells[nbFields] = {	{ 0, quantiteOffset, quantiteLength, quantiteType },
							{ 0, millesimeOffset, millesimeLength, millesimeType },
							{ 0, appelationOffset, appelationLength, appelationType },
							{ 0, typeOffset, typeLength, typeType },
							{ 0, contenanceOffset, contenanceLength, contenanceType },
							{ 0, cruOffset, cruLength, cruType },
							{ 0, regionOffset, regionLength, regionType },
							{ 0, appreciationOffset, appreciationLength, appreciationType },
							{ 0, classeOffset, classeLength, classeType },
							{ 0, toDrinkMinOffset, toDrinkMinLength, toDrinkMinType },
							{ 0, toDrinkMaxOffset, toDrinkMaxLength, toDrinkMaxType },
							{ 0, producteurOffset, producteurLength, producteurType },
							{ 0, cepageOffset, cepageLength, cepageType },
							{ 0, dateAchatOffset, dateAchatLength, dateAchatType },
							{ 0, lieuAchatOffset, lieuAchatLength, lieuAchatType },
							{ 0, prixOffset, prixLength, prixType },
							{ 0, casierOffset, casierLength, casierType } };

//-------------------------------------------------------
void initTableEdit()
{
	cells[0].name = "Quantite";
	cells[1].name = "Millesime";
	cells[2].name = "Appelation";
	cells[3].name = "Type";
	cells[4].name = "Contenance";
	cells[5].name = "Cru";
	cells[6].name = "Region";
	cells[7].name = "Appreciation";
	cells[8].name = "Classe";
	cells[9].name = "A boire ds";
	cells[10].name = "A boire jusqu'";
	cells[11].name = "Producteur";
	cells[12].name = "Cepage";
	cells[13].name = "Date achat";
	cells[14].name = "Lieu d'achat";
	cells[15].name = "Prix";
	cells[16].name = "Casier";
}

//-------------------------------------------------------
void CopyString(char* data, short offset, const PString& str, short max)
{
	if (str.Length() >= max)
	{
		((char*)str.data())[max] = 0;
	}
	MemMove(&data[offset], (char*)str.data(), str.Length()+1);
}

//-------------------------------------------------------
void CopyNum(char* data, short offset, short num, short max)
{
	PString str;
	str.convert(num);
	CopyString(data, offset, str, max);
}

//-------------------------------------------------------
void unpackBottle(PBottle& bottle)
{
	if (unpackedBottle == 0)
		unpackedBottle = MemHandleNew(totalLength);

	char* data = (char*)MemHandleLock(unpackedBottle);


	CopyNum(data, quantiteOffset, bottle.getQuantite(), quantiteLength);
	CopyNum(data, millesimeOffset, bottle.getMillesime(), millesimeLength);

	CopyString(data, appelationOffset, bottle.getAppelation(), appelationLength);
	CopyString(data, typeOffset, bottle.getType(), typeLength);
	CopyString(data, contenanceOffset, bottle.getContenance(), contenanceLength);
	CopyString(data, cruOffset, bottle.getCru(), cruLength);
	CopyString(data, regionOffset, bottle.getRegion(), regionLength);
	CopyString(data, appreciationOffset, bottle.getAppreciation(), appreciationLength);
	CopyString(data, classeOffset, bottle.getClasse(), classeLength);
	
	CopyNum(data, toDrinkMinOffset, bottle.getToDrinkMin(), toDrinkMinLength);
	CopyNum(data, toDrinkMaxOffset, bottle.getToDrinkMax(), toDrinkMaxLength);
	
	CopyString(data, producteurOffset, bottle.getProducteur(), producteurLength);
	CopyString(data, cepageOffset, bottle.getCepage(), cepageLength);
	
	MemMove(&data[dateAchatOffset], (char*)&bottle.getDateAchat(), dateAchatLength);
	
	CopyString(data, lieuAchatOffset, bottle.getLieuAchat(), lieuAchatLength);
	CopyString(data, prixOffset, bottle.getPrix(), prixLength);
	CopyString(data, casierOffset, bottle.getCasier(), casierLength);

	MemHandleUnlock(unpackedBottle);

}

//-------------------------------------------------------
void packBottle(PBottle& bottle)
{
	char* data = (char*)MemHandleLock(unpackedBottle);

	PString str;

	str = &data[quantiteOffset];
	bottle.setQuantite(	str.IntOf() );
	str = &data[millesimeOffset];
	bottle.setMillesime( str.IntOf() );

	bottle.setAppelation(&data[appelationOffset]);
	bottle.setType(&data[typeOffset]);
	bottle.setContenance(&data[contenanceOffset]);
	bottle.setCru(&data[cruOffset]);
	bottle.setRegion(&data[regionOffset]);
	bottle.setAppreciation(&data[appreciationOffset]);
	bottle.setClasse(&data[classeOffset]);

	str = &data[toDrinkMinOffset];
	bottle.setToDrinkMin( str.IntOf() );
	str = &data[toDrinkMaxOffset];
	bottle.setToDrinkMax( str.IntOf() );
	
	bottle.setProducteur(&data[producteurOffset]);
	bottle.setCepage(&data[cepageOffset]);
	
	bottle.setDateAchat(*(PDate*)&data[dateAchatOffset]);
	
	bottle.setLieuAchat(&data[lieuAchatOffset]);
	bottle.setPrix(&data[prixOffset]);
	bottle.setCasier(&data[casierOffset]);

	MemHandleUnlock(unpackedBottle);

}

//-------------------------------------------------------
void updateTableValues()
{
	TablePtr table = (TablePtr)GetObjectPtr(EDIT_TABLE_ID);

	MESSAGE("Begin");
	TblSetColumnUsable(table, 0, true);
	TblSetColumnUsable(table, 1, true);

    char* data = (char*)MemHandleLock(unpackedBottle);
	Word nbRows = TblGetNumberOfRows(table);
	Word lastRow = TblGetLastUsableRow(table);
	Word curRow;
	for (short i=0; i<nbRows; i++)
	{
		curRow = i+lastRow;
		if (i+lastRow > nbFields)
		{
			TblSetRowUsable(table, curRow, false);
		}
		else
		{
			TblSetItemStyle(table, curRow, 0, labelTableItem);
			TblSetItemPtr(table, curRow, 0, cells[i].name);

			TblSetItemStyle(table, curRow, 1, cells[i].type);
			TblSetItemPtr(table, curRow, 1, (void*)unpackedBottle);
			TblSetItemInt(table, curRow, 1, cells[i].offset);

			TblSetRowUsable(table, curRow, true);
			TblSetRowSelectable(table, curRow, true);

			if (cells[i].type == dateTableItem)
			{
				TblSetItemInt(table, curRow, 1, *(short*)(data[cells[i].offset]));
			}
		}
	}
    MemHandleUnlock(unpackedBottle);

}

//-------------------------------------------------------
void destroyAll()
{
	MemHandleFree(unpackedBottle);
	unpackedBottle = 0;
}

//-------------------------------------------------------
Boolean editEventHandler(EventType* event)
{
	MESSAGE("editEventHandler");

	static PBottle editedBottle;

	int handled = 0;
	FormPtr form;
	PString str;

	switch (event->eType) 
	{
	case frmOpenEvent:
		{
			initTableEdit(); // Strings init
			MESSAGE("Open edit form");
			editedBottle.resetData();
			if (PContext::selectedBottle() != -1)	// New one
			{
				editedBottle.resetData();
				PRecord& rec = PContext::getTheRecord();
				if (!PContext::getRecordWithSelectedBottle(rec))
				{
					MessageBox("Can't get the selected bottle");
					destroyAll();
					FrmGotoForm(MAIN_FORM_ID);
				}
				else
				{
					editedBottle.loadWithEvents(rec);
					PContext::releaseSelectedBottle();
					unpackBottle(editedBottle);
				}
			}
			else
			{
				unpackBottle(editedBottle);
			}

			form = FrmGetActiveForm();
			FrmDrawForm(form);
			handled = 1;
		}
		break;
    
	case ctlSelectEvent:  // A control button was pressed and released.
	{
		switch(event->data.ctlEnter.controlID)
		{
//--------------------------------------------------------------------------
		case CANCEL_BT:
			destroyAll();
			FrmGotoForm(MAIN_FORM_ID);
			handled = 1;
			break;

		case DONE_BT:
			{
				form = FrmGetActiveForm();
				packBottle(editedBottle);
				if (!editedBottle.isAllMandatorySet())
				{
#ifdef ML_FRENCH
					if (No == AskYesNo("Tous les champs obligatoires n'ont pas t entrs. Les changemenmts ne seront pas pris en compte. Abandonner?"))
#endif
#ifdef ML_ENGLISH
					if (No == AskYesNo("Not all the manadatory fields are set. The changes will be discraded. Do you want to abort?"))
#endif
					{
						break;
					}
				}
				else
				{
					PRecord& rec = PContext::getTheRecord();
					PDatabase& db = PContext::getBottlesDatabase();
					short index;
					if (PContext::selectedBottle() == -1)	// New one
					{
						index = db.createRecord(0, rec);
						if (index == -1)
						{
							MESSAGE("Index == -1");
							destroyAll();
							FrmGotoForm(MAIN_FORM_ID);
							break;
						}

						editedBottle.addEvent("Creation");

						editedBottle.save(rec);
						PContext::setSelectedBottle(index);
					}
					else
					{
						index = PContext::selectedBottle();
						db.getRecord(index, rec);
                    
						editedBottle.addEvent("Modification");
						
						editedBottle.save(rec);
					}
					db.releaseRecord(index);
				}
				destroyAll();
				FrmGotoForm(MAIN_FORM_ID);
				handled = 1;
			}
			break;

		case NOTE_BT:
			{
				editNote( (PString&)editedBottle.getCommentaire() );
			}
			break;

		case DELETE_BT:
			{
        		if (PContext::selectedBottle() != -1)	// New one
                {
#ifdef ML_FRENCH
    				if (Yes == AskYesNo("Etes vous sr de vouloir effacer cette bouteille?"))
#endif
#ifdef ML_ENGLISH
	    			if (Yes == AskYesNo("Do you really want to delete this bottle?"))
#endif
		    		{
				        short index = PContext::selectedBottle();
				        if (index == -1)
					        break;
				        PDatabase& db = PContext::getBottlesDatabase();
				        MESSAGE("Deleting");
				        db.removeRecord(index);
				        MESSAGE("Deleted");
				        PContext::setSelectedBottle(-1);
						destroyAll();
				        FrmGotoForm(MAIN_FORM_ID);
			        }
                }
                else
                {
#ifdef ML_FRENCH
                    MessageBox("Cette bouteille est nouvelle. Vous ne pouvez pas l'effacer");
#endif
#ifdef ML_ENGLISH
                    MessageBox("This is a new bottle. Can't delete it");
#endif
                }
			}
	        handled = 1;
			break;
		}
		break;
	}
	break;

//------------------------------------------------------
	case menuEvent:
	{
		switch (event->data.menu.itemID)
		{
        case EVENTS_MNU_ID:
            {
				history(editedBottle);
            }
            break;

		case RESET_MNU_ID:
			{
				editedBottle.resetData();
				FormPtr form = (FormPtr)FrmGetActiveForm();
				FrmDrawForm(form);
			}
			break;

		case ABOUT_MNU_ID:
			about();
			break;

		case HELP_MNU_ID:
			help();
			break;
		}
		handled = 1;
	}
	break;

	case nilEvent:
		handled = 1;
		break;
	}

	return handled;
}

