

#include "global.h"
#include "callback.h"
#include "cprotos.h"
#include "ids.h"

#include "pstring.h"
#include "PYearQuality.h"






void drawDrink(short x, short y, short h)
{
	//WinDrawChars("D", 1, x, y);

	WinDrawLine(x+1, y+4, x+1, y+9);
	WinDrawLine(x+2, y+3, x+2, y+5);WinDrawLine(x+2, y+9, x+2, y+9);
	WinDrawLine(x+3, y+1, x+3, y+5);WinDrawLine(x+3, y+9, x+3, y+9);
	WinDrawLine(x+4, y+3, x+4, y+5);WinDrawLine(x+4, y+9, x+4, y+9);
	WinDrawLine(x+5, y+4, x+5, y+9);

	return;
}

void drawDrinkOrWait(short x, short y, short h)
{
	//WinDrawChars("O", 1, x, y);

	WinDrawLine(x+7, y+2, x+8, y+2);
	WinDrawLine(x+4, y+3, x+8, y+3);
	WinDrawLine(x+3, y+4, x+7, y+4);
	WinDrawLine(x+2, y+5, x+3, y+5);WinDrawLine(x+5, y+5, x+7, y+5);
	WinDrawLine(x+1, y+6, x+2, y+6);WinDrawLine(x+6, y+6, x+7, y+6);
	WinDrawLine(x+2, y+7, x+3, y+7);WinDrawLine(x+5, y+7, x+6, y+7);
	WinDrawLine(x+3, y+8, x+5, y+8);
	WinDrawLine(x+4, y+9, x+4, y+9);

	return;
}

void drawWait(short x, short y, short h)
{
	//WinDrawChars("W", 1, x, y);

	WinDrawLine(x+1, y+5, x+6, y+5);
	WinDrawLine(x+1, y+6, x+1, y+6);WinDrawLine(x+5, y+6, x+7, y+6);
	WinDrawLine(x+1, y+7, x+1, y+7);WinDrawLine(x+5, y+7, x+9, y+7);
	WinDrawLine(x+1, y+8, x+1, y+8);WinDrawLine(x+5, y+8, x+7, y+8);
	WinDrawLine(x+1, y+9, x+6, y+9);

	return;
}

void WinDrawPoint(short x, short y)
{
	WinDrawLine(x, y, x, y);
}

void drawAvoid(short x, short y, short h)
{
	//WinDrawChars("A", 1, x, y);

	WinDrawLine(x+2, y+6, x+2, y+8);
	WinDrawPoint(x+3, y+1);WinDrawLine(x+3, y+5, x+3, y+9);
	WinDrawPoint(x+4, y+1);WinDrawLine(x+4, y+4, x+4, y+5);WinDrawPoint(x+4, y+9);
	WinDrawLine(x+5, y+1, x+5, y+4);WinDrawPoint(x+5, y+9);
	WinDrawPoint(x+6, y+1);WinDrawLine(x+6, y+4, x+6, y+5);WinDrawPoint(x+6, y+9);
	WinDrawPoint(x+7, y+1);WinDrawLine(x+7, y+5, x+7, y+9);
	WinDrawLine(x+8, y+6, x+8, y+8);

	return;
}

void drawStar(short x, short y, short h)
{
	//WinDrawChars("S", 1, x, y);

	//WinDrawPoint(x+2, y+3);
	WinDrawPoint(x+2, y+3);
	WinDrawPoint(x+3, y+2);
	WinDrawPoint(x+4, y+2);
	WinDrawPoint(x+5, y+2);
	WinDrawPoint(x+6, y+3);
	WinDrawPoint(x+6, y+4);
	WinDrawPoint(x+6, y+5);
	WinDrawPoint(x+5, y+6);
	WinDrawPoint(x+4, y+7);
	WinDrawPoint(x+4, y+9);

	return;
}





void drawSymbol(short x, short y, short h, char symbol)
{
	switch(symbol)
	{
	case DRINK:
		drawDrink(x, y, h);
		break;

	case DRINK_WAIT:
		drawDrinkOrWait(x, y, h);
		//drawDrink(x, y, h);
		//drawWait(x, y, h);
		break;

	case WAIT:
		drawWait(x, y, h);
		break;

	case AVOID:
		drawAvoid(x, y, h);
		break;

	case NO_TIP:
	default:
		drawStar(x, y, h);
		break;
	};

	return;
}







void drawQualityListItems(Word itemNum, RectanglePtr bounds, CharPtr *itemsText)
{
	CALLBACK_PROLOGUE

	FontID curFont = FntSetFont(stdFont);

	Regions* curRegion = (Regions*)itemsText;

	PString str;
	
	short x, y, height;
	y =			bounds->topLeft.y;
	height =	bounds->extent.y;

	short num = itemNum*2;
	if ( (num+1) > NbYears )
	{
		goto end_of_func;
	}





	
	// Draw year
	FntSetFont(stdFont);
	x = bounds->topLeft.x +2;
	str.print("%d", (short)LastYear-num);
	WinDrawChars(str.data(), str.Length(), x, y);

	// Draw first quality
	FntSetFont(boldFont);
	x += 30;
	str.print("%d", curRegion->year_[num].minQuality_);
	WinDrawChars(str.data(), str.Length(), x, y);
	
	// Draw second quality
	x += 14;
	str.print("%d", curRegion->year_[num].maxQuality_);
	WinDrawChars(str.data(), str.Length(), x, y);

	// Draw symbol
	x += 14;
	drawSymbol(x, y, height, curRegion->year_[num].tip_);




	x = bounds->topLeft.x + (bounds->extent.x-bounds->topLeft.x)/2;
	WinDrawLine(x, y, x, y+height);
	
	
	num++;
	if ( (num+1) > NbYears )
	{
		goto end_of_func;
	}




	// Draw year
	FntSetFont(stdFont);
	x = bounds->topLeft.x + (bounds->extent.x-bounds->topLeft.x)/2 +2;
	str.print("%d", (short)LastYear-num);
	WinDrawChars(str.data(), str.Length(), x, y);

	// Draw first quality
	FntSetFont(boldFont);
	x += 30;
	str.print("%d", curRegion->year_[num].minQuality_);
	WinDrawChars(str.data(), str.Length(), x, y);
	
	// Draw second quality
	x += 14;
	str.print("%d", curRegion->year_[num].maxQuality_);
	WinDrawChars(str.data(), str.Length(), x, y);

	// Draw symbol
	x += 14;
	drawSymbol(x, y, height, curRegion->year_[num].tip_);





end_of_func:
	FntSetFont(curFont);
	CALLBACK_EPILOGUE
	return;
}





void fillList()
{
	short sel = PYearQuality::getSelectedRegion();

	ControlPtr pop = (ControlPtr)GetObjectPtr(REGION_TRIGGER_ID);
	CtlSetLabel(pop, PYearQuality::getRegionName(sel));

	ListPtr list = (ListPtr)GetObjectPtr(WINE_LIST_ID);
	LstSetListChoices(list, (char**)PYearQuality::getRegionQuality(sel), PYearQuality::getNbLinesForYears() );
	LstSetDrawFunction(list, drawQualityListItems);

	FrmDrawForm(FrmGetActiveForm());
	return;
}

/*
	Regions* quality = PYearQuality::getRegionQuality();
	short nbYears = PYearQuality::getNbYears();

	PString str1, str2;
	PString* str;
	list.clearAndDestroy();
	for (short i=0;i<nbYears;i+=2)
	{
		str1 = "";
		str1->print("%d\t", PYearQuality::getFirstYear()+i, quality[i]);

		str2 = "";
		if (i+1<nbYears)
			str2->print("%d\t", PYearQuality::getFirstYear()+i+1, quality[i].minQuality_, quality[i].maxnQuality_);

		str = new PString;
		*str = str1 + str2;
		list.add(str);
	}



}
*/


Boolean wineQualityEventHandler(EventType* event)
{
	//static PCollection stringLists(removeString, 0, 0);

	int       handled = 0;
	FormPtr   form;

	switch (event->eType)
	{
	case frmOpenEvent:
		{
			FntSetFont(stdFont);

			form = FrmGetActiveForm();

			fillList();

			//FrmDrawForm(form);
			handled = 1;
		}
		break;

//------------------------------------------------------------
   	case keyDownEvent:		// P13.  Handle the physical scroll buttons
	   	if (event->data.keyDown.chr == pageUpChr)
        {
    		MESSAGE("keyDownEvent - UP");
			ListPtr list = (ListPtr)GetObjectPtr(WINE_LIST_ID);

            short sel = LstGetSelection(list);
            sel--;
            if (sel < 0)
            {
                sel = 0;
            }
            LstSetSelection(list, sel);

       		handled = true;
   		}
	   	else if (event->data.keyDown.chr == pageDownChr)
   		{
    		MESSAGE("keyDownEvent - DOWN");
			ListPtr list = (ListPtr)GetObjectPtr(WINE_LIST_ID);

            short sel = LstGetSelection(list);
            sel++;
            if ( sel >= LstGetNumberOfItems(list) )
                sel = LstGetNumberOfItems(list)-1;
            LstSetSelection(list, sel);

       		handled = true;
   		}
		break;

//------------------------------------------------------------
	case ctlSelectEvent:  // A control button was pressed and released.
		switch(event->data.ctlEnter.controlID)
		{
		case DONE_BT:
			{
				FrmSaveAllForms();
				FrmCloseAllForms();
				FrmGotoForm(MAIN_FORM_ID);
				handled = 1;
			}
			break;

		case REGION_TRIGGER_ID:
			{
				// Set the list
				ListPtr list = (ListPtr)GetObjectPtr(REGION_LIST_ID);
				LstSetListChoices(list, PYearQuality::getRegionList(), PYearQuality::getNbRegions() );
				LstSetHeight(list, 10);
				LstPopupList(list);

#ifdef DEMO_VERSION
                MessageBox(Autres_Dans_Version_Enreg);
#else
				short sel = LstGetSelection(list);

				PYearQuality::setSelectedRegion(sel);

				// Set the label
				ControlPtr pop = (ControlPtr)GetObjectPtr(REGION_TRIGGER_ID);
				CtlSetLabel(pop, LstGetSelectionText(list, sel));

				fillList();
#endif

			}
			break;
		}

		break;

//------------------------------------------------------------
	case menuEvent:
		switch (event->data.menu.itemID)
		{
    case 0:
    default:
      break;
		};
	};
	
	return handled;
}