/* find.c - Copyright Mitch Blevins <mblevin@debian.org>
**          Code taken from Ben Darnell and O'Reilly Palm Book
**          Distributed under the GNU GPL, v2 or later
*/

#include <Pilot.h>
#include "diddle.h"

void DiddleFind(FindParamsPtr pfindparams) {
    Boolean done=false;

    pfindparams->more=false;
    done=FindDrawHeader(pfindparams, "Diddle");
    if (done)
        pfindparams->more=true;
    else {
        Word index=pfindparams->recordNum;
        DmOpenRef db;
        UInt card;
        LocalID dbid;

        db=DmOpenDatabaseByTypeCreator(DBIType, AppType,
                                       pfindparams->dbAccesMode);
        if (!db)
            return;

        if (DmOpenDatabaseInfo(db, &dbid, NULL, NULL, &card, NULL))
            return;

        while (1) {
            VoidHand hrec;
            Ptr prec;
            Boolean match=false;
            Word pos;
            Word fieldnum=0;

            hrec=DmQueryRecord(db, index);
            if (!hrec)
                break;
            prec=MemHandleLock(hrec);


            if (FindStrInStr(prec+3200, pfindparams->strToFind, &pos)) {
                match = true;
                fieldnum = 0;
            } else if (FindStrInStr(prec+3232, pfindparams->strToFind, &pos)) {
                match = true;
                fieldnum = 1;
            }
            if (match) {
                RectangleType rect;

                done=FindSaveMatch(pfindparams, index, pos,
                                   fieldnum, 1, card, dbid);
                if (done) {
                    MemHandleUnlock(hrec);
                    break;
                };

                FindGetLineBounds(pfindparams, &rect);
                WinDrawChars(prec+3200, StrLen(prec+3200),
                             rect.topLeft.x, rect.topLeft.y);
                pfindparams->lineNumber++;
            };
            MemHandleUnlock(hrec);
            if (done)
                break;
            index++;
        };
        DmCloseDatabase(db);
    };
}



