/* linkaware.c
   This file released to the public domain by Ben Darnell.
   You may use this file however you wish to make
   LinkMaster-compatible applications.
   Modifications for Diddle application by Mitch Blevins
*/

#include <Pilot.h>
#include "linkaware.h"
#include "diddle.h"

LinkDiddlePtr LinkDiddleNew(DataPtr d, PrefPtr p) {
   LinkDiddlePtr linkinfo;
   int titlelen;
   VoidHand t;
   VoidPtr ptr;

   if (p->onscratch) ErrDisplay("Publish Link called on scratch buffer!");

   t = DmQueryRecord(d->dbRI, p->dbII);
   if (!t) ErrDisplay("LinkDiddleNew failed to Get");
   ptr = MemHandleLock(t);
   titlelen = StrLen(ptr+3200);
   if (titlelen) {
      linkinfo = MemPtrNew(65+titlelen);
	  ErrFatalDisplayIf(!linkinfo, "Not enough memory");
	  StrNCopy(((CharPtr)linkinfo)+64, ptr+3200, titlelen);
	  ((CharPtr)linkinfo)[64+titlelen] = 0;
   } else {
	  linkinfo = MemPtrNew(64);
	  ErrFatalDisplayIf(!linkinfo, "Not enough memory");
   }
   MemHandleUnlock(t);

   linkinfo->creator = AppType;

   DmRecordInfo(d->dbRI, p->dbII, NULL, &linkinfo->record_id, NULL);

   return linkinfo;
}

void LinkPublish(LinkDiddlePtr linkinfo)
{
   Err err;
   DmSearchStateType searchstate;
   UInt cardno;
   LocalID dbid;
   
   err=DmGetNextDatabaseByTypeCreator(true, &searchstate, 'appl', 'Link', true,
				      &cardno, &dbid);
   if (err) { FrmAlert(NoLinkMasterForm); return; }
   MemPtrSetOwner(linkinfo, 0);
   SysUIAppSwitch(cardno, dbid, linkAppLaunchReturnLink, (Ptr)linkinfo);
}

