/*
 *   $Id: pane.h,v 1.1.1.1 2000/10/27 17:15:56 ondrap Exp $
 * 
 *   Scientific Calculator for Palms and PilmPilots.
 *   Copyright (C) 2000 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _PANE_H_
#define _PANE_H_

#include "defuns.h"
#include "segment.h"

#define MAX_PANE_NAME 16
#define MAX_BUTTON_NAME 10
#define MAX_PANES 20
#define MAX_ACTIVE_PANES 5

#define PANE_TYPE 'pane'
#define PANE_CODE 'panc'

/* Button attributes */
#define NORMALFRAME   1
#define BOLDFRAME 2
/* Pane attributes */
#define PANE_INLIST 1

typedef enum {
	button_text=1,
	button_bitmap=2
}pane_item_display;

typedef struct {
	DmResID id; /* ID of a item resource */
	RectangleType bounds;
	pane_item_display type;
	Int8 pad_byte;
	UInt16 codeOffset;
	union {		
		struct {
			Int8 attr;
			FontID font;
			UInt16 textOffset;
		}buttonText;
		struct {
			Int8 attr;
			DmResID bitmap;
		}buttonBitmap;
	}d;
}Tpane_item;

typedef struct {
	char name[MAX_PANE_NAME];
	UInt32 paneid;
	Coord width,height;
	Int16 attr;
	UInt16 dataOffset;
	UInt16 codeOffset;
	UInt16 startupCode;
	UInt16 drawCode;
	Int16 itemCount;
	Tpane_item items[0];
}Tpane;

void pane_init_gadget(Int16 gadget) IFACE;
void pane_destroy_gadget(Int16 gadget) IFACE;
void pane_init(void) IFACE;
Boolean pane_goto_pane(Int32 paneid,Boolean base,Int16 gadget) IFACE;
Boolean pane_handle_pendown(Coord x,Coord y,Int16 gadget) IFACE;
Boolean pane_popup_pane(Int32 paneid,Coord x,Coord y,
						Boolean sticky,Int16 gadget) IFACE;
void pane_draw_pane(Int16 gadget) IFACE;
#endif
