/*
 *   $Id: panectrl.h,v 1.1.1.1 2000/10/27 17:15:57 ondrap Exp $
 * 
 *   Scientific Calculator for Palms and PilmPilots.
 *   Copyright (C) 2000 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _PANECTRL_H_
#define _PANECTRL_H_

typedef enum {
	cmd_stop = 0,
	cmd_insert = 1,
	cmd_exec_inp = 2,
	cmd_clear_inp = 3,
	cmd_popup_pane = 4,
	cmd_print = 5,
	cmd_text = 6,
	cmd_func = 7,
	cmd_expr = 8
}TcmdType;

typedef struct {
	TcmdType type;
	char pad1;
	UInt16 len;
	union {
		struct {
			unsigned 
			  oper :1,
			  func : 1,
			  nobrack : 1,
			  pad:5;
			char text[0];
		}insert;
		struct {
			UInt32 paneid;
			Coord x;
			Coord y;
			unsigned
			  sticky :1,
			  pad:7;
		}popup;
		struct {
			Coord x;
			Coord y;
			FontID font;
			char pad;
			char expr[0]; /* Should be Tcommand, unfortunately 
						   *  this is not allowed in C */
		}print;
		struct {
			char text[0];
		}data;
	}d;
}Tcommand;

void pnctl_exec(Tcommand *command);

#endif
