/* $Id: eightball.c,v 1.2 2000/10/15 08:16:40 jaq Exp $
 */

#include <Pilot.h>
#include "callback.h"
#include "eightball.h"
#include "phrases.h"

static FieldPtr shake()
{
    Handle hdl, oldhdl;
    FieldPtr fld;
    FormPtr frm;
    CharPtr s;

    s = phrases[SysRandom(0) % PHRASESIZE];

    hdl = (Handle) MemHandleNew(StrLen(s) + 1);
    if (!hdl)
	return NULL;
    StrCopy(MemHandleLock((VoidHand) hdl), s);
    MemHandleUnlock((VoidHand) hdl);
    frm = FrmGetActiveForm();
    fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, FILDAnswer));
    ErrNonFatalDisplayIf(!fld, "missing field");
    oldhdl = FldGetTextHandle(fld);
    FldSetTextHandle(fld, hdl);
    FldDrawField(fld);
    if (oldhdl)
	MemHandleFree((VoidHand) oldhdl);
    return fld;
}

static Boolean MainFormHandleEvent(EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;

#ifdef __GNUC__    
    CALLBACK_PROLOGUE;
#endif /* __GNUC__ */
    
    switch (e->eType) {
      case frmOpenEvent:
	frm = FrmGetActiveForm();
	FrmDrawForm(frm);
	handled = true;
	break;

      case menuEvent:
	MenuEraseStatus(NULL);

	switch (e->data.menu.itemID) {
	  case MENUAboot:
	    FrmAlert(ALRTAboot);
	    handled = true;
	    break;
	  case MENUShake:
	    shake();
	    handled = true;
	    break;
	}

	handled = true;
	break;

      case ctlSelectEvent:
	switch (e->data.ctlSelect.controlID) {
	}
	break;

      default:
	break;
    }

#ifdef __GNUC__
    CALLBACK_EPILOGUE;
#endif /* __GNUC__ */
    
    return handled;
}

static Boolean PreHandleEvent(EventPtr e)
{
	Boolean handled = false;

#ifdef __GNUC__
	CALLBACK_PROLOGUE;
#endif /* __GNUC__ */

	if (e->eType == keyDownEvent) {
	  if (e->data.keyDown.chr > 12)
	    handled = false;
	  else
	    handled = true;
	} else if (e->eType == penUpEvent) {
	  if ((e->screenY > 168) && (e->screenX > 30) && (e->screenX < 130)) {
		  shake();
		  handled = true;
	  }
	}

	return false;

#ifdef __GNUC__
	CALLBACK_EPILOGUE;
#endif /* __GNUC__ */
}

static Boolean ApplicationHandleEvent(EventPtr e)
{
    FormPtr frm;
    Word formId;
    Boolean handled = false;

    if (e->eType == frmLoadEvent) {
	formId = e->data.frmLoad.formID;
	frm = FrmInitForm(formId);
	FrmSetActiveForm(frm);

	switch (formId) {
	  case FORMMain:
	    FrmSetEventHandler(frm, MainFormHandleEvent);
	    break;
	}
	handled = true;
    }

    return handled;
}

/* Get preferences, open (or create) app database */
static Word StartApplication(void)
{
    FrmGotoForm(FORMMain);
    return 0;
}

/* Save preferences, close forms, close app database */
static void StopApplication(void)
{
    FrmSaveAllForms();
    FrmCloseAllForms();
}

/* The main event loop */
static void EventLoop(void)
{
    Word err;
    EventType e;

    do {
	EvtGetEvent(&e, evtWaitForever);
	if (!PreHandleEvent(&e)) 
		if (!SysHandleEvent(&e))
	    	if (!MenuHandleEvent(NULL, &e, &err))
			if (!ApplicationHandleEvent(&e))
			    FrmDispatchEvent(&e);
    } while (e.eType != appStopEvent);
}

/* Main entry point; it is unlikely you will need to change this except to
   handle other launch command codes */
DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
    Word err;

    if (cmd == sysAppLaunchCmdNormalLaunch) {

	err = StartApplication();
	if (err)
	    return err;

	EventLoop();
	StopApplication();

    } else {
	return sysErrParamErr;
    }

    return 0;
}
