typedef struct {
	int caplen;
	char capability[120];
        char capkey[80];
        int  cap_ttl;       /*This may be useful someday, but is actually a */
	int  cap_policy;    /*placeholder from earlier design thoughts      */
        int  cap_directive;
	char directive_msg[20];
} Capability;    

typedef struct {       /*A Task Object describes a command on the main screen*/
	int TaskID;    /*The TaskID is used to identify each task on the main list                     */
 	int ChildID;   /*ChildID is the GUI Rsc ID of the dialog that pops up as a result of tapping on*/ 
	int ChildType; /*TaskID. ChildType is the kind of dialog that pops up                          */
	int taskxpos;  /*X position within the TaskList. Altered when the TaskList is scrolled	       */
	int taskypos;  /*Y "		"	"	 "	 "	  "	   "  "		       */
        UInt16 TaskTxtLen; /*Length of the text of the command				               */
	Char *TaskTxt;     /*pointer to the command text itself					       */
} TaskObject;

typedef struct {
	int BuildID; /*Similar to a TaskID, but used for commands on the Command Track of the Builder  */
	int LeftID;  /*ID of the Build command to the left of BuildID				       */
	int RightID; /*"  "      "	"	"     right of BuildID				       */
        int trackpos;/*position w/in the Command Track 						       */
	int track;   /*Track this command is on							       */
	int section; /*Section(Nav,Net,Admin or User) that this command is in 			       */
        UInt16 CmdTxtLen; /*Length of the text of the command					       */
	UInt16 FlagTxtLen;									       
	Char CmdText[10];    /*pointer to the command text itself				       */
        Char FlagText[50];  /*pointer to an array of flags(options) associated w/ this command	       */
} BuildCmdObject;

typedef struct {
       TaskObject to; 
       BuildCmdObject bo;
       UInt16 attribs; /*Universal attributes and permissions as a bitfield*/
       
} CmdObject;


typedef struct {
	FieldType *CLIPtr; 
        ControlType *BtnPtr;

}CLIObj;
typedef struct {
	Char user[9];
	Char pid[5];
	Char mem[5];
	Char cpu[5];
	Char cmd[40];
} psentry;

typedef struct {
	Char devname[25];
	UInt32 size;
	UInt32 used;
	UInt32 free;
	Char percent[5];
	Char mountpoint[25];
} dfentry;

typedef struct {
	int ActiveSection;
	int TopTrack;
	int MiddleTrack;
	int BottomTrack;
} CmdBuilderLayout;

typedef struct {
	Char user[16];
	Char fullname[35];
        Char homedir[30];
	Char shell[20];
} userentry;

#define TrkDBName "TrkDB"
#define TrkDBType 'DATA'
#define TrkDBCreatorID 'GEOR'
#define TrfDBName "TrfDB"
#define TrfDBType "DATA"
#define TrfDBCreatorID "GEOR"

#define CMDSTART 101
#define CMDSTOP	 102
#define CMDLINE 103
#define CMDSTAT 104
#define CMDPALLETTE 105
#define CMDNULL 106
#define CMDBUILD 107
