#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

extern void Init_dfTable(FormType *frm);
extern void Init_duTable(FormType *frm);
extern Int16 Geordi_DoDF();
extern void PopulateField(Char *NewFldText, Int16 FieldID);
extern Int16 Geordi_DoDU(Char *DuCmdStr,Int32 numlines);
extern UInt16 GS_SendCommand(Char *CmdStr);
extern void PalmOS_printf(char * pszFormat, ...);
extern void Geordi_DrawProgress(Char *msg);

Boolean DskFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    TableType *DskTable;
    int DskTblRow,DskTblCol=0;
    int results;
    extern int G_DskRow;
    extern Char DF_SelectedVolName[40];
    extern dfentry G_dftable[10];
    
  switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
	Init_dfTable(frm);
        results=Geordi_DoDF();	
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDskCan:
                FrmGotoForm(MainForm);
                handled = true;
                break;
	   case BtnDskMnt:
		FrmGotoForm(DskDetailsForm);
		handled = true;
		break;
        }
	break;
    case tblSelectEvent:
	DskTblRow = e->data.tblSelect.row;
	DskTblCol = e->data.tblSelect.column;
	G_DskRow = DskTblRow;
	frm=FrmGetActiveForm();	
	DskTable = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDfTable));

	switch(DskTblCol) {
	
		case 0:
			FrmGotoForm(DskDetailsForm);
			break;
		case 1:
		case 2:
			StrCopy(DF_SelectedVolName,G_dftable[G_DskRow].volname);
			FrmPopupForm(DskDuSelectForm);
			break;
		default:
			break;
	}
	break;

    default:
        break;
    }

    return handled;
}

Boolean DskDetailsFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    extern UInt16 G_DskRow;
    extern dfentry G_dftable[10];

    Char DtlCmd[80];

    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();

        	 PopulateField(G_dftable[G_DskRow].device,FldMntDev);
        	 
		 PopulateField(G_dftable[G_DskRow].volname,FldMntPt);
	
       		 PopulateField(G_dftable[G_DskRow].size,FldMntSize);

        	 PopulateField(G_dftable[G_DskRow].used,FldMntUsed);
	
		 PopulateField(G_dftable[G_DskRow].avail,FldMntAvail);
	
         	 PopulateField(G_dftable[G_DskRow].percent,FldMntPct);
 
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDtlCan:
                FrmGotoForm(DskForm);
                handled = true;
                break;
	   case BtnDtlEject:
		StrPrintF(DtlCmd,"%s %s\n","eject -v ",G_dftable[G_DskRow].device);
		GS_SendCommand(DtlCmd);
		break;
        }
	break;
    default:
        break;
    }

    return handled;
}

Boolean DskDuSelectFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    ListPtr LstDUSizePtr;
    ListPtr LstDUAdjPtr;
    ListPtr LstDUAorSPtr;
    FieldPtr FldDUPathPtr;
    Char*   LstCurSelPtr;
    Char*   DUPathPtr;
    Char    title[60]; 
    Word LstItem;
    Char *DtlCmd;

    extern Char DF_SelectedVolName[40];
    extern Char DU_VolTitle[60];

    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
	PopulateField(DF_SelectedVolName,FldDUPath);
        StrPrintF(title,"Disk Usage on %s",DF_SelectedVolName);
	FrmSetTitle(frm,title);
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDuSelCan:
                FrmReturnToForm(DskForm);
                handled = true;
                break;
	   case BtnDuSelOK:
		DtlCmd = MemPtrNew(80);
		StrCopy(DtlCmd, "sudo du -");
		frm = FrmGetActiveForm();
		LstDUAorSPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUas));
		LstItem = LstGetSelection(LstDUAorSPtr);
		LstCurSelPtr = LstGetSelectionText(LstDUAorSPtr,LstItem);
		if( (StrCompare(LstCurSelPtr,"all")) ==0 ) {
			StrCat(DtlCmd,"a");
		} else {
			StrCat(DtlCmd,"s");
		}
/*
		LstDUTypePtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUType));
		LstItem = LstGetSelection(LstDUTypePtr);
		LstCurSelPtr = LstGetSelectionText(LstDUTypePtr,LstItem);
		if ((StrCompare(LstCurSelPtr,"local")) == 0) {
			StrCat(DtlCmd,"l");
		}
*/
		StrCat(DtlCmd,"k "); 
	
		FldDUPathPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldDUPath));	
		DUPathPtr = FldGetTextPtr(FldDUPathPtr);
		StrCat(DtlCmd,DUPathPtr);	 			
	 	StrCat(DtlCmd,"|sort -n|");
	
		LstDUAdjPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDULgSm));
		LstItem = LstGetSelection(LstDUAdjPtr);
		LstCurSelPtr = LstGetSelectionText(LstDUAdjPtr,LstItem);
		if ((StrCompare(LstCurSelPtr,"largest")) == 0) {
			StrCat(DtlCmd,"tail -");
		} else {
			StrCat(DtlCmd,"head -");
		}
		
		LstDUSizePtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUSize));
		LstItem = LstGetSelection(LstDUSizePtr);
		LstCurSelPtr = LstGetSelectionText(LstDUSizePtr,LstItem);
		PalmOS_printf("%s",LstCurSelPtr);
		StrCat(DtlCmd,LstCurSelPtr);
		StrCat(DtlCmd,"\n");

		StrPrintF(DU_VolTitle,"%s %s files in %s",LstCurSelPtr,LstDUSizePtr,DUPathPtr);
		frm = FrmGetActiveForm();
	
		FrmReturnToForm(DskForm);
		PalmOS_printf("%s",DtlCmd);
		Geordi_DrawProgress("Looking...");
		Geordi_DoDU(DtlCmd,StrAToI(LstCurSelPtr));
	  	FrmGotoForm(DskDuForm);	
		MemPtrFree(DtlCmd);
		break;
	   default:
		break;
        }
	break;
    default:
        break;
    }

    return handled;
}

Boolean DskDuFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormType *frm;

    extern Char DU_VolTitle[60];
	    
    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
	Init_duTable(frm);
	Geordi_DuTableUpdate();
	FrmSetTitle(frm,DU_VolTitle);
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDuOK:
                FrmGotoForm(DskForm);
                handled = true;
                break;
	   default:
		break;
        }
	break;
    default:
        break;
    }

    return handled;
}
