#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

extern void Init_dfTable(FormType *frm);
extern void Init_duTable(FormType *frm);
extern Int16 Geordi_DoDF();
extern void PopulateField(Char *NewFldText, Int16 FieldID);
extern Int16 Geordi_DoDU(Char *DuCmdStr,Int32 numlines);
extern UInt16 GS_SendCommand(Char *CmdStr);
extern void PalmOS_printf(char * pszFormat, ...);
extern void Geordi_DrawProgress(Char *msg);
extern void Geordi_EraseProgress();
extern void Geordi_UpdateTimer();
extern void Geordi_DisableField(UInt16 DisFieldID);
extern Int Geordi_DoUmount(Char *FsPtr);
extern Int Geordi_DoMount();
extern void Geordi_DfTableUpdate();
extern void Geordi_DuTableUpdate();
extern Err SetListSelectionByName(FormType *frm,ListType *LstPtr,Char *LstTargetText);

Boolean DskFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    TableType *DskTable,*tbl;
    int DskTblRow,DskTblCol=0;
    int results,i;
    extern int G_DskRow;
    extern Char DF_SelectedVolName[40];
    extern dfentry G_dftable[10];
    extern Boolean G_DskNeedsRefresh;    
    extern Boolean IsMountRequest;
    extern Char G_StdOut[8192];

  switch (e->eType) {
    case frmOpenEvent:
	Geordi_UpdateTimer();
 frm= FrmGetActiveForm();
        tbl = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDfTable));
	for(i = 0; i < 10 ;i++) {
            TblSetRowUsable(tbl,i,false);
	}
        if (G_DskNeedsRefresh == true) {
		Init_dfTable(frm);
        	results=Geordi_DoDF();	
		G_DskNeedsRefresh = false;
	} else {
		Geordi_DfTableUpdate();
	       }
	
	DskTable = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDfTable));
	TblRedrawTable(DskTable);
        FrmDrawForm(frm);
	Geordi_UpdateTimer();
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDskCan:
                FrmGotoForm(MainForm);
                handled = true;
                break;
	   case BtnDskMnt:
		IsMountRequest = true;
		FrmGotoForm(DskDetailsForm);
		G_DskNeedsRefresh = true;
		handled = true;
		break;
	   case BtnDskRefresh:
		frm=FrmGetActiveForm();
		Init_dfTable(frm);
		results = Geordi_DoDF();
		handled = true;
		break;
        }
	break;
    case tblSelectEvent:
	DskTblRow = e->data.tblSelect.row;
	DskTblCol = e->data.tblSelect.column;
	G_DskRow = DskTblRow;
	frm=FrmGetActiveForm();	
	DskTable = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDfTable));

	switch(DskTblCol) {
	
		case 0:
			IsMountRequest = false;
			FrmGotoForm(DskDetailsForm);
			G_DskNeedsRefresh = true;
			break;
		case 1:
		case 2:
			StrCopy(DF_SelectedVolName,G_dftable[G_DskRow].volname);
			FrmPopupForm(DskDuSelectForm);
			break;
		default:
			break;
	}
	break;

    default:
        break;
    }

    return handled;
}

Boolean DskDetailsFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    Err err;
    extern UInt16 G_DskRow;
    extern dfentry G_dftable[10];
    extern Char G_StdOut[8192];
    extern Boolean G_DskNeedsRefresh;
    FieldType *FldDevPtr,*FldMntPtPtr;
    ListType  *LstFsType;
    Char DtlCmd[80];
    Char UmountArg[80];
    UInt16 numlines; 
    extern Boolean IsMountRequest;
    int devname_len,mntpt_len;
    int cmdresults;

    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
        	
	if (IsMountRequest == false) {
	    LstFsType = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstMntFsTypes));
			
        	 PopulateField(G_dftable[G_DskRow].device,FldMntDev);
        	 
		 PopulateField(G_dftable[G_DskRow].volname,FldMntPt);
	
       		 PopulateField(G_dftable[G_DskRow].size,FldMntSize);

        	 PopulateField(G_dftable[G_DskRow].used,FldMntUsed);
	
		 PopulateField(G_dftable[G_DskRow].avail,FldMntAvail);
	
         	 PopulateField(G_dftable[G_DskRow].percent,FldMntPct);
		 err=SetListSelectionByName(frm,LstFsType,G_dftable[G_DskRow].type);
		 if (err == noListSelection) {
			FrmCustomAlert(AlrtWarn,"File System type not recognized ","(This should not affect operations though)",""); 
		 }
		 
	} else {
		DisableField(FldMntSize);
		DisableField(FldMntUsed);
		DisableField(FldMntAvail);
		DisableField(FldMntPct);	
		}
 
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDtlCan:
                FrmGotoForm(DskForm);
                handled = true;
                break;
	   case BtnDtlEject:
		StrPrintF(DtlCmd,"%s %s\n","eject -v ",G_dftable[G_DskRow].device);
		GS_SendCommand(DtlCmd);
		break;
	   case BtnDtlUmnt:
		frm=FrmGetActiveForm();
		FldDevPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntDev));
		FldMntPtPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntPt));
		devname_len = FldGetTextLength(FldDevPtr);
		mntpt_len = FldGetTextLength(FldMntPtPtr);
		if ((devname_len > 1) && (mntpt_len > 1) ){
	
			StrCopy(UmountArg,FldGetTextPtr(FldDevPtr));
			cmdresults = Geordi_DoUmount(UmountArg);
			if (cmdresults !=0) {
			   FrmCustomAlert(AlrtCrit,"umount(1) failed ","Could not umount because:",G_StdOut);
			} else {
			        FrmCustomAlert(AlrtInfo,"umount(1) succeeded ",UmountArg," Unmounted");
			G_DskNeedsRefresh = true;
			FrmGotoForm(DskForm);
			}
			
		} else {
			FrmCustomAlert(AlrtEmptyField,"Missing device name and/or mountpoint","","");
		}
StrCopy(G_StdOut,"                                                                             ");
		handled = true;
		break;

	   case BtnDtlMnt:
/* They want to mount something. Check to see if at least the device and  */
/* mountpoint fields are filled in. Complain if they're not.		  */
	
		if (IsMountRequest == false) {
			FrmCustomAlert(AlrtWarn,"Filesystem already mounted.","Unmount first,then try again",""); 
			handled = true;
			break;
		}
	
		frm = FrmGetActiveForm();
		FldDevPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntDev));
		FldMntPtPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntPt));

		if ((FldGetTextLength(FldDevPtr) > 1) && (FldGetTextLength(FldMntPtPtr) > 1) ){
			cmdresults = Geordi_DoMount();
			if (cmdresults !=0) {
				FrmCustomAlert(AlrtCrit,"mount(1) request failed ","because ",G_StdOut);
			} else {
				FrmCustomAlert(AlrtInfo,"mount(1) request succeeded ",G_StdOut,"");
			G_DskNeedsRefresh = true;
			FrmGotoForm(DskForm);
			}
StrCopy(G_StdOut,"                                                                             ");
		} else {
			FrmCustomAlert(AlrtEmptyField,"Missing device name and/or mountpoint","","");
		}
		handled = true;
		break;
        }
	break;
    default:
        break;
    }
    return handled;
}

Boolean DskDuSelectFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    ListPtr LstDUSizePtr;
    ListPtr LstDUAdjPtr;
    ListPtr LstDUAorSPtr;
    FieldPtr FldDUPathPtr;
    Char*   CurSelPtr;
    Char*   DUPathPtr;
    Char    title[60]; 
    Word LstItem;
    Char *DtlCmd;

    extern Char DF_SelectedVolName[40];
    extern Char DU_VolTitle[60];
    extern Int32 DU_Depth;

    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
	PopulateField(DF_SelectedVolName,FldDUPath);
        StrPrintF(title,"Disk Usage on %s",DF_SelectedVolName);
	FrmSetTitle(frm,title);
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDuSelCan:
                FrmReturnToForm(DskForm);
                handled = true;
                break;
	   case BtnDuSelOK:
		DtlCmd = MemPtrNew(80);
		StrCopy(DtlCmd, "sudo du -");
		frm = FrmGetActiveForm();
		LstDUAorSPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUas));
		LstItem = LstGetSelection(LstDUAorSPtr);
		CurSelPtr = LstGetSelectionText(LstDUAorSPtr,LstItem);
		if( (StrCompare(CurSelPtr,"all")) ==0 ) {
			StrCat(DtlCmd,"a");
		} else {
			StrCat(DtlCmd,"s");
		}
/*
		LstDUTypePtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUType));
		LstItem = LstGetSelection(LstDUTypePtr);
		CurSelPtr = LstGetSelectionText(LstDUTypePtr,LstItem);
		if ((StrCompare(CurSelPtr,"local")) == 0) {
			StrCat(DtlCmd,"l");
		}
*/
		StrCat(DtlCmd,"k "); 
	
		FldDUPathPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldDUPath));	
		DUPathPtr = FldGetTextPtr(FldDUPathPtr);
		StrCat(DtlCmd,DUPathPtr);	 			
	 	StrCat(DtlCmd," |sort -n -r|");
	
		LstDUAdjPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDULgSm));
		LstItem = LstGetSelection(LstDUAdjPtr);
		CurSelPtr = LstGetSelectionText(LstDUAdjPtr,LstItem);
		if ((StrCompare(CurSelPtr,"largest")) == 0) {
			StrCat(DtlCmd,"head -");
		} else {
			StrCat(DtlCmd,"tail -");
		}
		
		LstDUSizePtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUSize));
		LstItem = LstGetSelection(LstDUSizePtr);
		CurSelPtr = LstGetSelectionText(LstDUSizePtr,LstItem);
		DU_Depth = StrAToI(CurSelPtr);
		StrCat(DtlCmd,CurSelPtr);
		StrCat(DtlCmd,"\n");

		StrPrintF(DU_VolTitle,"%s %s files in %s",CurSelPtr,LstDUSizePtr,DUPathPtr);
		frm = FrmGetActiveForm();
	
		FrmReturnToForm(DskForm);
		Geordi_DoDU(DtlCmd,StrAToI(CurSelPtr));
		Geordi_EraseProgress();
	  	FrmGotoForm(DskDuForm);	
		MemPtrFree(DtlCmd); 
		break;
	   default:
		break;
        }
	break;
    default:
        break;
    }

    return handled;
}

Boolean DskDuFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormType *frm;

    extern Char DU_VolTitle[60];
	    
    switch (e->eType) {
    case frmOpenEvent:
	PalmOS_printf("Made it to DskDuForm");
	SysTaskDelay(SysTicksPerSecond()*3);
        frm = FrmGetActiveForm();
	Init_duTable(frm);
	Geordi_DuTableUpdate();
	FrmSetTitle(frm,DU_VolTitle);
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDuOK:
                FrmGotoForm(DskForm);
                handled = true;
                break;
	   default:
		break;
        }
	break;
    default:
        break;
    }

    return handled;
}
