#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

extern UInt16 GS_SendCommand(Char *CmdStr);
extern void PalmOS_printf(char * pszFormat, ...); 
extern UInt16 GS_GetResults(int Type, Char *Keyword,Char *Keyword2, UInt16 KeywordLen,int RLL_Threshhold,int maxresults);
extern void Geordi_DrawProgress(Char *msg);

Boolean LogFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormType *frm; 
    FieldType *FldPtr;
    Char *LogTxtPtr;
    extern Char G_StdOut[8192];
    
    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
        FrmDrawForm(frm);
        frm = FrmGetActiveForm();
	FldPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldLogText));
        FldSetTextPtr(FldPtr,G_StdOut);
        FldRecalculateField(FldPtr,true);
        FldDrawField(FldPtr);
        handled = true;
        break;
 
   case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

	   case BtnLogOk:
		FrmGotoForm(MainForm);
		handled = true;
		break;
        }
	break;

    default:
        break;
    }

    return handled;
}


 
Boolean LogSelectFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormType *frm;
    ListType *LogListHTPtr;
    ListType *LogListNumPtr;
    FieldType *FldPtr;
    Char *LogHTTextPtr;
    Char *LogNumLinesTextPtr;
    Char *LogGrepPtr;
    Char *LogPathPtr;

    Word HTSelection;
    Word NumSelection;
    Char LogCmdLine[80];
    Int32 numresults;
    Int32  numloglines = 0;


    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnLogCan:
                FrmGotoForm(MainForm);
                handled = true;
                break;

	   case BtnLogOk:
		frm = FrmGetActiveForm();
		StrCopy(LogCmdLine,"sudo ");
		LogListHTPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstLogHeadTail));
		HTSelection = LstGetSelection(LogListHTPtr);
		LogHTTextPtr = LstGetSelectionText(LogListHTPtr,HTSelection);
		PalmOS_printf("HTText=%s",LogHTTextPtr);
	
		LogListNumPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstLogNumLines));
		NumSelection = LstGetSelection(LogListNumPtr);
		LogNumLinesTextPtr = LstGetSelectionText(LogListNumPtr,NumSelection);
		PalmOS_printf("NumLinesText=%s",LogNumLinesTextPtr);
		SysTaskDelay(SysTicksPerSecond()*3);	
		
		if (StrCompare(LogHTTextPtr,"the last") == 0 ) {
			PalmOS_printf("the last");
			StrCat(LogCmdLine," tail -");
			StrCat(LogCmdLine,LogNumLinesTextPtr);
			numloglines = StrAToI(LogNumLinesTextPtr);
		}
		if (StrCompare(LogHTTextPtr,"the first") == 0) {
			PalmOS_printf("the first");
			StrCat(LogCmdLine," head -");
			StrCat(LogCmdLine,LogNumLinesTextPtr);
			numloglines = StrAToI(LogNumLinesTextPtr);
		}
		if (StrCompare(LogHTTextPtr,"all") == 0 ) {
			StrCat(LogCmdLine," cat ");
			numloglines = 100;
		}
		FldPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldLogPath));
		LogPathPtr = FldGetTextPtr(FldPtr);
		StrCat(LogCmdLine," ");
		StrCat(LogCmdLine,LogPathPtr);
		
		FldPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldLogGrep));
		if ( (LogGrepPtr = FldGetTextPtr(FldPtr)) == NULL) {
			StrCat(LogCmdLine,"\n");
		} 
		else {
			StrCat(LogCmdLine,"|grep ");
			StrCat(LogCmdLine,LogGrepPtr);
			StrCat(LogCmdLine,"\n");
		}
		
		Geordi_DrawProgress("Looking...");
		GS_SendCommand(LogCmdLine);
	 	numresults = GS_GetResults(CMD_TD,"None","None",4,1,numloglines);  
		FrmReturnToForm(MainForm);
		FrmGotoForm(LogForm);  
		handled = true;
		break;



        }
	break;

    default:
        break;
    }

    return handled;
}
