#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

extern void IncrementActiveSelector(ControlType *ActiveCtl, int Ctlx,int Ctly,int ctrfloor,int ctrceil);
extern void DecrementActiveSelector(ControlType *ActiveCtl, int Ctlx,int Ctly,int ctrfloor,int ctrceil);
extern UInt16 GS_SendCommand(Char *CmdStr);
extern UInt16 GS_GetResults(int Type, Char *kw,Char *kw2, Char *cmdFormStr,UInt16 KeywordLen, int RLL_Threshhold,int maxresults);
extern Int16 Geordi_DoPSCmd();

Boolean SignalFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormType *frm;
    FieldType *FldUserPtr;
    FieldType *FldCmdPtr;
    ControlType *sigctl1;
    ControlType *sigctl2;
    ControlType *signctl;
    Char SigStr[80];
    Char SigTitle[20];
    Char SigNotice[40]; 
    Char numprocstr[4];
    Char *NiceLabel;
    Char SigVal[2];
    Int16 results;
    int sigdex1=0;
    int sigdex2=0;
    int sigsign=1;	
    extern ControlType *ActiveSigCounter;
    extern Char PT_SelectedPID[5];
    extern Char PT_SelectedUname[9];
    extern Char PT_SelectedCMD[40];
    extern int NiceSign; 
    extern Char G_killuser[80];

    frm = FrmGetActiveForm();
    switch (e->eType) {
    case frmOpenEvent:

        frm = FrmGetActiveForm();
        FrmSetControlGroupSelection(frm,(UInt8)GrpSigSelect,PBtnSig1);
        ActiveSigCounter = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig1));
	FldUserPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldSigUser));
	FldCmdPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldSigCmd));
        StrCopy(SigTitle,"Process ");
        StrCat(SigTitle,PT_SelectedPID);
	FldSetTextPtr(FldUserPtr,PT_SelectedUname);
	FldSetTextPtr(FldCmdPtr,PT_SelectedCMD);
        FrmSetTitle(frm,SigTitle);
	
        FrmDrawForm(frm);
        handled = true;
        break;
  
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

                case BtnNiceToggle:
                     signctl = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,BtnNiceToggle));
                     NiceLabel = (Char *) CtlGetLabel(signctl);
                     if (NiceSign == 1) {
                         NiceSign = 0;
                        StrCopy(NiceLabel,"-");
                        CtlSetLabel(signctl,NiceLabel);
                     } else {
                        NiceSign = 1;
                        StrCopy(NiceLabel,"+");
                        CtlSetLabel(signctl,NiceLabel);
                     }
		     handled = true;
                     break;

                case PBtnSig1:
                   ActiveSigCounter = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig1));
                   FrmSetControlGroupSelection(frm,(UInt8)GrpSigSelect,PBtnSig1);
                   break;
 		case PBtnSig2:
                   ActiveSigCounter = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig2));
                   FrmSetControlGroupSelection(frm,(UInt8)GrpSigSelect,PBtnSig2);
		     handled = true;
                   break;

                case BtnSigUp:
                     IncrementActiveSelector(ActiveSigCounter,2,140,0,9);
		     handled = true;
                     break;

                case BtnSigDown:
                     DecrementActiveSelector(ActiveSigCounter,2,140,0,9);
		     handled = true;
                     break;

                case BtnCycleProc:
		     handled = true;
                     break;

                case BtnSigCan:
                     FrmReturnToForm(MainForm);
		     handled = true;
                     break;

                case BtnNiceProc:
                     frm=FrmGetActiveForm();
                     sigdex1= FrmGetObjectIndex(frm,PBtnSig1);
                     sigdex2= FrmGetObjectIndex(frm,PBtnSig2);
                     sigctl1 = FrmGetObjectPtr(frm,sigdex1);
                     sigctl2 = FrmGetObjectPtr(frm,sigdex2);

                     sigsign= FrmGetObjectIndex(frm,BtnNiceToggle);
                     signctl = FrmGetObjectPtr(frm,sigsign);
		      /*
                     StrCopy(SigStr, "renice ");
	  	     StrCat(SigStr,CtlGetLabel(sigsign));
                     StrCat(SigStr,CtlGetLabel(sigctl1));
                     StrCat(SigStr,CtlGetLabel(sigctl2));
		      */
		     StrPrintF(SigStr,"renice %c%c%c %s -v\n",CtlGetLabel(signctl),CtlGetLabel(sigctl1),CtlGetLabel(sigctl2),PT_SelectedPID);
		     GS_SendCommand(SigStr);
		     results=GS_GetResults(CMD_TD,"None","None","None",4,32,2);
		     handled = true;
                     break;    

                case BtnSignalProc:
                     frm=FrmGetActiveForm();
                     sigctl1 = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig1));
                     sigctl2 = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig2));

                     StrCopy(SigVal,CtlGetLabel(sigctl1));
                     StrCat(SigVal,CtlGetLabel(sigctl2));
		     
                     if ((StrAToI(SigVal)) > 15) {
                        FrmCustomAlert(AlrtBadSignal,"Valid signals are 1-15","","");
			break;
                     }
		     StrPrintF(SigStr,"sudo kill -%s %s\n",SigVal,PT_SelectedPID);
		     GS_SendCommand(SigStr);
		
		     FrmReturnToForm(MainForm);
		     StrPrintF(SigNotice,"Sent Signal %s to Process %s",SigVal,PT_SelectedPID); 
                     FrmCustomAlert(AlrtInfo,SigNotice,"","");	
		     Geordi_DoPSCmd();
		     handled = true;
                     break;

		case BtnKallGrp:
		case BtnKallUser:

		     frm=FrmGetActiveForm();
                     sigctl1 = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig1));
                     sigctl2 = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig2));

                     StrCopy(SigVal,CtlGetLabel(sigctl1));
                     StrCat(SigVal,CtlGetLabel(sigctl2));

                     if ((StrAToI(SigVal)) > 15) {
                        FrmCustomAlert(AlrtBadSignal,"Valid signals are 1-15","","");
                        break;
                     }
		     if (e->data.ctlSelect.controlID == BtnKallGrp) {

			StrPrintF(SigStr,"sudo killall -v -%s %s\n",SigVal,PT_SelectedCMD);
		     } else {
				StrPrintF(SigStr,"sudo skill -%s -v %s\n",SigVal,FldUserPtr);
		     }    
			GS_SendCommand(SigStr);
		     	FrmReturnToForm(MainForm);
			results = GS_GetResults(CMD_TD,"None","None","None",4,1,100);
			StrIToA(numprocstr,results);
			FrmCustomAlert(AlrtInfo,numprocstr," processes were killed","");
		        Geordi_DoPSCmd();
		     	handled = true;
			break;
        }
        break;
    
    default:
        break;
    }

    return handled;
}
