#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

extern void IncrementActiveSelector(ControlType *ActiveCtl, int Ctlx,int Ctly,int ctrfloor,int ctrceil);
extern void DecrementActiveSelector(ControlType *ActiveCtl, int Ctlx,int Ctly,int ctrfloor,int ctrceil);
extern UInt16 GS_SendCommand(Char *CmdStr);
extern UInt16 GS_GetResults(int Type, Char *kw,Char *kw2, UInt16 KeywordLen, int RLL_Threshhold,int maxresults);
extern Int16 Geordi_DoPSCmd();

Boolean SignalFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    ControlType *sigctl1;
    ControlType *sigctl2;
    ControlType *signctl;
    Char SigStr[25];
    Char SigTitle[20];
 /*   Char SigNotice[25]; */
    Char *NiceLabel;
    Char SigVal[2];
    Int16 results;
    int sigdex1=0;
    int sigdex2=0;
    int sigsign=1;	
    extern ControlType *ActiveSigCounter;
    extern Char PT_SelectedPID[5];
    extern int NiceSign; 
    frm = FrmGetActiveForm();
    switch (e->eType) {
    case frmOpenEvent:

        frm = FrmGetActiveForm();
        FrmSetControlGroupSelection(frm,(UInt8)GrpSigSelect,PBtnSig1);
        ActiveSigCounter = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig1));
        StrCopy(SigTitle,"Process ");
        StrCat(SigTitle,PT_SelectedPID);
        FrmSetTitle(frm,SigTitle);
        FrmDrawForm(frm);
        handled = true;
        break;
  
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

                case BtnNiceToggle:
                     signctl = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,BtnNiceToggle));
                     NiceLabel = (Char *) CtlGetLabel(signctl);
                     if (NiceSign == 1) {
                         NiceSign = 0;
                        StrCopy(NiceLabel,"-");
                        CtlSetLabel(signctl,NiceLabel);
                     } else {
                        NiceSign = 1;
                        StrCopy(NiceLabel,"+");
                        CtlSetLabel(signctl,NiceLabel);
                     }
                     break;

                case PBtnSig1:
                   ActiveSigCounter = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig1));
                   FrmSetControlGroupSelection(frm,(UInt8)GrpSigSelect,PBtnSig1);
                   break;
 		case PBtnSig2:
                   ActiveSigCounter = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig2));
                   FrmSetControlGroupSelection(frm,(UInt8)GrpSigSelect,PBtnSig2);
                   break;

                case BtnSigUp:
                     IncrementActiveSelector(ActiveSigCounter,2,140,0,9);
                     break;

                case BtnSigDown:
                     DecrementActiveSelector(ActiveSigCounter,2,140,0,9);
                     break;

                case BtnCycleProc:
                     break;

                case BtnSigCan:
                     FrmReturnToForm(MainForm);
                     break;

                case BtnNiceProc:
                     frm=FrmGetActiveForm();
                     sigdex1= FrmGetObjectIndex(frm,PBtnSig1);
                     sigdex2= FrmGetObjectIndex(frm,PBtnSig2);
                     sigctl1 = FrmGetObjectPtr(frm,sigdex1);
                     sigctl2 = FrmGetObjectPtr(frm,sigdex2);

                     sigsign= FrmGetObjectIndex(frm,BtnNiceToggle);
                     signctl = FrmGetObjectPtr(frm,sigsign);
		      /*
                     StrCopy(SigStr, "renice ");
	  	     StrCat(SigStr,CtlGetLabel(sigsign));
                     StrCat(SigStr,CtlGetLabel(sigctl1));
                     StrCat(SigStr,CtlGetLabel(sigctl2));
		      */
		     StrPrintF(SigStr,"renice %c%c%c %s -v\n",CtlGetLabel(sigsign),CtlGetLabel(sigctl1),CtlGetLabel(sigctl2),PT_SelectedPID);
		     GS_SendCommand(SigStr);
		     results=GS_GetResults(CMD_TD,"None","None",4,32,2);
                     break;    

                case BtnSignalProc:
                     frm=FrmGetActiveForm();
                     sigctl1 = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig1));
                     sigctl2 = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,PBtnSig2));

                     StrCopy(SigVal,CtlGetLabel(sigctl1));
                     StrCat(SigVal,CtlGetLabel(sigctl2));
		     
                     if ((StrAToI(SigVal)) > 15) {
                        FrmCustomAlert(AlrtBadSignal,"Valid signals are 1-15","","");
			break;
                     }
		     StrPrintF(SigStr,"sudo kill -%s %s\n",SigVal,PT_SelectedPID);
		     GS_SendCommand(SigStr);
		/*
		     StrPrintF(SigNotice,"Sent Signal %s to Process %s",SigVal,PT_SelectedPID); 
                     FrmCustomAlert(AlrtInfo,SigNotice,"","");
		 */	
		     FrmReturnToForm(MainForm);
		     Geordi_DoPSCmd();
                     break;
        }
        break;
    
    default:
        break;
    }

    return handled;
}
