#define GEORDI_MAIN 1  
#include <PalmOS.h>
#include <PalmCompatibility.h>
#include <SysEvtMgr.h>
#include <NetMgr.h>
#include <StringMgr.h>
#include <AlarmMgr.h>
#include <DataMgr.h>
#include <DateTime.h>
#include <System/DLServer.h>
#include <stdarg.h>
#include "geordi.h"
#include "geordi_ui.h"
#include <sys/socket.h> 
/*#include <rand.h> */

int  G_sockd;
int  G_AlarmSockRef;
int  G_numappts = 0;
int  NiceSign = 1;
int  authround = 1;
int  authlimit = 3;
int  tablemax = 8;
int  G_MaxCmdBtn;
int  G_TrackPos;
int  G_RotorPos = 0;

Char *G_CtlLabel[10];

char G_NetServAddrStr[15];
Char G_NetIF_name[32];
NetSocketRef G_sockref;
NetSocketAddrINType G_socketAddr;
UInt32 G_NetServPortnum;
UInt16   G_NetIF_index;
UInt32   G_NetIF_creator;
UInt16   G_NetIF_instance;
UInt16   G_NetIF_bufLenP;
UInt32 G_ScreenWidth = 160;
UInt32 G_ScreenHeight = 160;
UInt32 G_ScreenDepth = 8;
UInt16   AppNetRefnum;
UInt16   G_ScrollCeil;
UInt16   G_ScrollFloor;
UInt16	 G_DskRow;
UInt16	 G_PrevForm;
Int	 G_TimerGraphLength = 160;

Word   autoID = 9000;
Boolean IsConnected = false;
Boolean IsFirst = true;
Boolean IsColorDevice;
Boolean IsMountRequest = true;
Boolean LibOpened = false;
Boolean G_CanBuild = true;
Boolean G_UseFilter = false;
Boolean G_DskNeedsRefresh = true;
ControlType *ActiveSigCounter;
ControlType *ActiveNS_ptr;
DmOpenRef TrkDB;
DmOpenRef TrfDB; 
WinHandle G_DPnewWin,G_DPcurWin,G_DPsavedWin;
FontID G_prevfnt;
RectangleType G_ProgRect,G_SaveRect;

Char CBCmds[25][10];
Char OptBuf[5];
Char G_promptchar;
Char G_prompt[10];
Char G_pscmd[30]="top -b -n 1|head -19|tail -11";
Char G_filterline[40];
Char G_StdOut[8192];
Char G_ProgRotor[6]="|-|-|-";

MemHandle ProcTableHandles[5][10];
MemHandle DiskTableHandles[5][10];
MemHandle DuTableHandles[2][10];

psentry G_pstable[10] = 
{
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "},
{"         ","     ","     ","     ","                                      "}
};

dfentry G_dftable[10] = 
{
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "},
{"                                       ","                         ","       ","          ","          ","          ","    "}
};

duentry G_dutable[10] = 
{
{"          ","                                                                              "},
{"          ","                                                                              "},
{"          ","                                                                              "},
{"          ","                                                                              "},
{"          ","                                                                              "},
{"          ","                                                                              "},
{"          ","                                                                              "},
{"          ","                                                                              "},
{"          ","                                                                              "},
{"          ","                                                                              "}
};

Char regex[28] = "-/.,|;:?*^~@$#+=([{}])<>'`&%";
Char PT_SelectedPID[5];
Char PT_SelectedCMD[40];
Char PT_SelectedUname[9];
Char DF_SelectedVolName[40];
Char DU_VolTitle[60];
Char OptStr[50];
Char *OptBtnLabel;
Char *HostTxt, *UnameTxt, *PassTxt;
UInt16 OptStrPos;
Int32 DU_Depth;

NetSocketAddrINType* G_socketAddrP; 

/*Used for debugging and flow tracing */

void PalmOS_printf(char * pszFormat, ...)
{
   static int iOffset = 5;
   const int iDelta = 10;
   char szBuf[200];
   char *szBlanks = "                                                                             ";
   va_list args;

   va_start(args,pszFormat);
   StrVPrintF(szBuf,pszFormat,args);
   va_end(args);

   WinDrawChars(szBlanks,StrLen(szBlanks),0,iOffset);
   WinDrawChars(szBuf,StrLen(szBuf),0,iOffset);


   iOffset += iDelta;

   if (iOffset > 135) {
      iOffset = 5;
   }

}

/* This works like StrNCopy,but it's designed to be used at an arbitrary position */
/* in the string rather than at the start					  */

Char* get_substr(Char* wholestr, int startpos, int length) 
{
 int i = 0;	
 int wholelen = 0;
 Char fullstr[80];
 Char* substr;


     
    wholelen = StrLen(wholestr); 

    if (wholelen >0) {
	StrCopy(fullstr,wholestr);
    }  
 
    if ((startpos+length) > wholelen) {
         length = wholelen-startpos;
    }
   
    if (startpos > wholelen) {
	 return -1;
    }
 
    substr = MemPtrNew(length); 
    substr[length] = '\0'; 
    
 
 	for (i = 0; i < length;i++) {
		substr[i] = fullstr[startpos+i];
 	} 
   return substr;
}
 
/*An awk/Perl-like field extractor.Send it a string,seperator character */
/*and a field # and it sends you back a pointer to the field head	*/
 
Char* get_field(Char* wholestr, Char sep, int fieldpos) 
{
 int i,j = 0;	
 int wholelen = 0;
 int curfield = 0;
 Char *fullstr;
 Char fieldstr[80];
 Char *substr;
 Boolean infield = false;

 
  wholelen = StrLen(wholestr); 
  if (wholelen >0) {
	fullstr = MemPtrNew(wholelen);
	StrCopy(fullstr,wholestr);

    for(i=0;i < wholelen;i++) {
	if ((isnumeric(fullstr[i])) || (isalpha(fullstr[i])) || (fullstr[i] != sep) )
        {
	        if(infield == false) {
		infield = true;
		curfield++;
		}
		if((curfield == fieldpos) && (infield == true)) {
	   		fieldstr[j] = fullstr[i];
	   		j++;
		}
	} else {
		 if (infield == true) {
			infield = false;
		 }
		 infield = false;
	  }
     }

      if (j >0 ) {
	fieldstr[j] = '\0';
	substr = MemPtrNew(j);
	StrCopy(substr,fieldstr);
      } else {
	      substr = MemPtrNew(wholelen);
	      StrCopy(substr,wholestr);
      }
    } else {
	     substr = "";
    }
  MemPtrFree(fullstr);
  return substr;
}

static Boolean isnumeric(Char c)
 
{
	if ((c >= '0') && (c <= '9')) {
 
		return true;
 
	}
	return false;
 
}

static Boolean isalpha(Char c)
 
{
	if ((c >= 'A') && (c <= 'z')) {
 
		return true;
 
	}
	return false;
 
}

void Geordi_DrawProgress(Char *msg) 
{
 Char spacemsg[30];
 UInt16 err;
 
 G_ProgRect.topLeft.x = 2;
 G_ProgRect.topLeft.y = 70;
 G_ProgRect.extent.x = 140;
 G_ProgRect.extent.y = 30;

         G_prevfnt = FntSetFont(boldFont);

         StrCopy(spacemsg,"                             ");
         
         G_DPnewWin = WinCreateWindow(&G_ProgRect,boldRoundFrame, false, false,&
err);
         WinGetWindowFrameRect(G_DPnewWin,&G_SaveRect);
         G_DPsavedWin = WinSaveBits(&G_SaveRect,&err);
         G_DPcurWin = WinSetDrawWindow(G_DPnewWin);
         WinEraseWindow();
         WinDrawWindowFrame();
         WinSetDrawWindow(G_DPcurWin); 

         WinEraseRectangle(&G_ProgRect,2);
         WinDrawRectangleFrame(boldRoundFrame,&G_ProgRect);
         WinDrawChars(spacemsg,StrLen(spacemsg),5,75);
         WinDrawChars(msg,StrLen(msg),5,75);

}

void Geordi_EraseProgress()
{
 	 FntSetFont(G_prevfnt);
	 WinDeleteWindow(G_DPnewWin,true); 
	 WinRestoreBits(G_DPsavedWin,G_SaveRect.topLeft.x,G_SaveRect.topLeft.y);
	 G_DPnewWin = NULL;
}

void Geordi_UpdateProgress()
{
   G_prevfnt = FntSetFont(boldFont);
  if(G_RotorPos <=6 ) {
	WinDrawChars(G_ProgRotor[G_RotorPos],1,135,75);
	G_RotorPos++;
  } else {
	   G_RotorPos = 0;
 }
   FntSetFont(G_prevfnt);

}

void Geordi_UpdateTimer()
{
  RectangleType TimerRect;
  RectangleType EraseRect;
  IndexedColorType TimerColor = 0xd3; 

  WinPushDrawState();
 
  TimerRect.topLeft.x = 0;
  TimerRect.topLeft.y = 155;
  TimerRect.extent.x = G_TimerGraphLength;
  TimerRect.extent.y= 5;

  EraseRect.topLeft.x = 0;
  EraseRect.topLeft.y = 155;
  EraseRect.extent.x = 160;
  EraseRect.extent.y= 5;


  WinDrawLine(0,155,0,160);
  WinDrawLine(40,155,40,160);
  WinDrawLine(80,155,80,160);
  WinDrawLine(120,155,120,160);
  WinDrawLine(160,155,160,160);

  if (IsColorDevice == true) {

        if (G_TimerGraphLength >= 120) {
		TimerColor = 0xd3;
	} 
        
	if (G_TimerGraphLength <= 96) {
		TimerColor = 0x78;
	}
        
	if (G_TimerGraphLength <= 64) {
		TimerColor = 0x7d;
	}

	WinSetForeColor(TimerColor);
  }	
  WinEraseRectangle(&EraseRect,0);

  WinDrawRectangle(&TimerRect,0);
	
  WinPopDrawState();

}

void Geordi_ModemCtrl(int state) {

  Err err;
  UInt32 errcode;
  UInt32 portID, baud;
  UInt16 openPort;
  UInt16 *numportsPtr;
  UInt16 numports =0;
  Char *modemcmd;
    
  numportsPtr = &numports;
    modemcmd = MemPtrNew(7);
      if (state == 0) { 
           StrCopy(modemcmd,"ATH4\r");
      }
       else {
	      StrCopy(modemcmd,"ATMD0\r");
            }

    baud = 19200;
    err = FtrGet(sysFileCSerialMgr, sysFtrNewSerialPresent, &errcode);

    if (errcode >0) {
        err = CncGetProfileInfo("Minstrel",&portID,&baud,0,0,0,0,0,0);
        if(!err) {
                  baud = 19200;
                  SrmOpen(portID,baud,&openPort);
                  SrmSend(openPort,(void*)modemcmd,StrLen(modemcmd),&err);
		  SrmSendWait(openPort);
		  SrmReceiveFlush(openPort,1);
		  SrmClose(openPort);
        }

    }


  MemPtrFree(modemcmd);
}

Char* Geordi_AppendArgToCmdStr(Char *basestr, Char *param)
{
	MemPtrResize(basestr,StrLen(param)+1);
	StrCat(basestr,param);
	StrCat(basestr," ");
	return basestr;
}

/*This decodes the error code returned by the various calls which return */
/*reason codes in addition to the fact that they didn't succeed		 */
/*This is actually cheaper than going throught the appropriate PalmOS    */
/*Manager functions plus lets us introduce our own error codes 		 */

void Err_Decode(UInt16 AlertID, Err errcode,Char* msg)
{
 Char decoded_msg[40];

 switch (errcode) {

         case netErrTimeout:
                StrCopy(decoded_msg,"netErrTimeOut");
                break;

         case netErrNotOpen:
                StrCopy(decoded_msg,"Net Library not open");
                break;

         case netErrParamErr:
                StrCopy(decoded_msg,"Parameter error on call");
                break;

         case netErrNoMoreSockets:
                StrCopy(decoded_msg,"No more sockets");
                break;

         case netErrSocketNotOpen:
                StrCopy(decoded_msg,"Socket not open");
                break;

         case netErrUnimplemented:
                StrCopy(decoded_msg,"Socket Option not implemented");
                break;

         case netErrWrongSocketType:
                StrCopy(decoded_msg,"Wrong SocketType for operation");
                break;

         case netErrSocketBusy:
                StrCopy(decoded_msg,"Socket Busy");
                break;

         case netErrNoInterfaces:
                StrCopy(decoded_msg,"No interfaces for Connect");
                break;

         case netErrPortInUse:
                StrCopy(decoded_msg,"Port already in use");
                break;

         case netErrQuietTimeNotElapsed:
                StrCopy(decoded_msg,"Waiting for port to recycle");
                break;

         case netErrSocketAlreadyConnected:
                StrCopy(decoded_msg,"Already connected to port");
                break;

         case netErrSocketClosedByRemote:
                StrCopy(decoded_msg,"Port closed by remote host");
                break;

/*       case netErrWouldBlock:
                StrCopy(decoded_msg,"Blocking read on non-blocking socket");
                break;  */
         default:
                StrCopy(decoded_msg,"Unknown error");
                break;
         }
        FrmCustomAlert(AlertID,msg,"",decoded_msg);
}

UInt16 RandomNum(UInt n) {
        return SysRandom(0) / (1 + sysRandomMax / n );
}

/*Copy the text on a button into the Command Builder command line */
/*This is used for all Tracks					  */

void AppendBtnTxtToBuildField(ControlType *CmdBtn, FieldType *CmdFld)
{
 MemHandle curfieldH;
 Char *BtnText;
 Char *curfieldptr;
 UInt32 curfieldlen=0;
 UInt32 curbtnlen=0;
 UInt32 newlen=1;
 Err err;

 BtnText = (Char *) CtlGetLabel(CmdBtn);
  
  curfieldlen = FldGetTextLength(CmdFld);
  curbtnlen = sizeof(BtnText);
 
  newlen = newlen+curfieldlen+curbtnlen; 
  
 if (FldGetTextLength(CmdFld) >0 ) {
    curfieldH=FldGetTextHandle(CmdFld);
    FldSetTextHandle(CmdFld,NULL);
    err = MemHandleResize(curfieldH,newlen);
    if(err == 0) {
   	curfieldptr = MemHandleLock(curfieldH);
    	StrCat(curfieldptr," ");
    	StrCat(curfieldptr,BtnText);
    	MemHandleUnlock(curfieldH);
    	FldSetTextHandle(CmdFld,curfieldH);
    	FldDrawField(CmdFld);
   }
 }	
  
}

/*Copy text from TrkDB onto buttons in Command Builder	*/
/*We use this for all buttons				*/

int PopulateBtn(UInt16 BtnID,int TrkIndex)
{
 ControlType *CmdBtn; 
 int cmdlen = 0;
 int newbtnsize = 0;
 RectangleType btnbounds ;
 FormType *frm; 


            btnbounds.topLeft.x = 0;
	    btnbounds.topLeft.y = 0;
	    btnbounds.extent.x = 0;
	    btnbounds.extent.y = 0;
                
	       	cmdlen = StrLen(CBCmds[TrkIndex]);
	        frm = FrmGetActiveForm();  
               	CmdBtn= (ControlPtr)FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,BtnID));
                G_CtlLabel[TrkIndex] = (Char*)CtlGetLabel(CmdBtn); 
		FrmGetObjectBounds(frm,FrmGetObjectIndex(frm,BtnID),&btnbounds); 

	        newbtnsize = 7*cmdlen;
		btnbounds.extent.x = newbtnsize;
		FrmSetObjectBounds(frm,FrmGetObjectIndex(frm,BtnID),&btnbounds);
		StrCopy(G_CtlLabel[TrkIndex],CBCmds[TrkIndex]);
/*		PalmOS_printf("newbtnsize=%d",newbtnsize);
		PalmOS_printf("G_CtlLabel[%d] = %s",TrkIndex,G_CtlLabel[TrkIndex]); 
*/
		CtlSetLabel(CmdBtn,G_CtlLabel[TrkIndex]);
/*		FrmShowObject(frm,FrmGetObjectIndex(frm,BtnID)); */
		return newbtnsize;
}

int PopulateBtnTrack(FormType *frm,UInt16 PBtnBaseId, UInt16 TrkDBOffset)
{
    int btnlength = 0;
    int start_btnlength = 0;
    int BtnIndex = 0;
    int TrkDBIndex =0;
    int TrkLength = 34;
    int i = 0;
    Boolean shrunk = false;

	BtnIndex = PBtnBaseId;
 	TrkDBIndex=TrkDBOffset;
	start_btnlength = StrLen(CBCmds[TrkDBOffset]);
	
	while( TrkLength < 144) {
               /* PalmOS_printf("TrkLength=%d",TrkLength); */
                btnlength = PopulateBtn(BtnIndex,TrkDBIndex);
		if(btnlength+TrkLength >=144) {
		     if (shrunk == true) {
			break;
		     } else {
			btnlength = btnlength - start_btnlength;
			FrmHideObject(frm,FrmGetObjectIndex(frm,PBtnBaseId));
			
			shrunk = true;
		     }
				
		} else {
                	if (BtnIndex >PBtnCBCmd1 ) {
                                        NudgeObject(frm,BtnIndex-1,BtnIndex);
                        }
			FrmShowObject(frm,FrmGetObjectIndex(frm,BtnIndex));
                	TrkLength += btnlength;
                	BtnIndex++;
                	TrkDBIndex++;
			i++;
		}
        }
    FrmUpdateForm(PaletteForm,frmRedrawUpdateCode);
    return (TrkDBIndex-1);
}

/*This is used to populate the buttons on the Option track. We copy the */
/*FlagText field in a TrkDB record onto buttons sent into here. This    */
/*happens when you tap on a command button				*/

void PopulateBtnRowByCmd(int CmdBtnIndex,int OptBtnIndex,Char *CmdBtnText)
{
 int i=0;
 int OptLen=0;
 FormType *frm;
 ControlType *OptBtn; 
 BuildCmdObject *BtnRecPtr;
 MemHandle BtnRecH;
 
/*This is ugly, but I don't understand Unique IDs quite yet, so.... */

  TrkDB=DmOpenDatabaseByTypeCreator(TrkDBType,TrkDBCreatorID,dmModeReadWrite|dmModeExclusive);
  if (!TrkDB) {
	        FrmCustomAlert(AlrtCrit,"Can't Populate Option Track","","");
		frm=FrmInitForm(MainForm);
 		FrmSetActiveForm(frm);
		FrmGotoForm(MainForm);
  }

  while(i < 5 )
	{
		BtnRecH = DmQueryRecord(TrkDB,i);
	        BtnRecPtr = MemHandleLock(BtnRecH);	
		if (StrCompare(CmdBtnText,BtnRecPtr->CmdText) == 0) {
		    StrCopy(OptStr,BtnRecPtr->FlagText);
		    OptLen = BtnRecPtr->FlagTxtLen;
		    MemHandleUnlock(BtnRecH);
		    break;
		} else {
			MemHandleUnlock(BtnRecH);
		}
		i++;
	}

	   for(i = 0; i < 9;i++) {
		if (i <= OptLen) {
                        frm = FrmGetActiveForm();			
	                OptBtn = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,OptBtnIndex+i));
			OptBtnLabel = (Char*)CtlGetLabel(OptBtn);
			StrCopy(OptBtnLabel,OptStr[i]);
			CtlSetLabel(OptBtn,OptBtnLabel);
			CtlShowControl(OptBtn);
	 	} else {
                        frm = FrmGetActiveForm();			
	                OptBtn = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,OptBtnIndex+i));
			CtlHideControl(OptBtn);
		       }
	   }
	DmCloseDatabase(TrkDB);
}

void PopulateField(Char *NewFldText, Int16 FieldID)
{
    MemHandle FieldH;
    MemHandle oldH;
    MemPtr FldMemPtr; 
    FieldType *FieldPtr; 
    FormPtr frm;
 
        frm = FrmGetActiveForm();
 	FieldPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FieldID));
	FieldH = MemHandleNew((StrLen(NewFldText)));
	FldMemPtr = MemHandleLock(FieldH);
	StrCopy(FldMemPtr,NewFldText);
	MemHandleUnlock(FieldH);
	
	oldH = FldGetTextHandle(FieldPtr);
		FldSetTextHandle(FieldPtr,FieldH);
		FldDrawField(FieldPtr);
	if(oldH) {
			MemHandleFree(oldH);
	} 
	
}

void DisableField(UInt16 DisFieldID) 
{
 
 FieldAttrType attr;
 FieldType *FldPtr;
 FormType *frm;

	frm = FrmGetActiveForm();

 	FldPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,DisFieldID));
	FldGetAttributes(frm,&attr);
	attr.underlined=noUnderline;
	FldDrawField(FldPtr);
}


/*Given a string and a pointer to a ListType, find the item in the List and set the */
/*current selection that matches the string.					    */

Err SetListSelectionByName(FormType *frm,ListType *LstPtr,Char *LstTargetText)
{
 Err err;
 Int16 numchoices;
 int i = 0;
 Char *curtext;
 Boolean foundit = false;

  numchoices=LstGetNumberOfItems(LstPtr);
  
  while ( i < numchoices) {
	curtext = LstGetSelectionText(LstPtr,i);	
	if (StrCompare(curtext,LstTargetText) == 0 ) {
		LstSetSelection(LstPtr,i);
		foundit = true;
		err = i;
		break;
	} 
	i++;
  }
  
  if (foundit == false) {
	err = noListSelection;
  } 
  
  return err;

}

/*Closes up ranks between buttons of different sizes.We look at our neighbors*/
/*to see how much we should be moved and in which direction		     */
void NudgeObject(FormType *frm,int refObjID,int nudgeObjID) 
{
	
 ControlType *refCtl,*nudgeCtl;
 Coord nudgeX,nudgeY=0;
 RectangleType refRT;
 UInt16 refObjIndex,nudgeObjIndex;

 frm = FrmGetActiveForm();

 refObjIndex = FrmGetObjectIndex(frm,refObjID);
 nudgeObjIndex = FrmGetObjectIndex(frm,nudgeObjID);
 refCtl = FrmGetObjectPtr(frm,refObjIndex);
 nudgeCtl = FrmGetObjectPtr(frm,nudgeObjIndex);
 FrmGetObjectBounds(frm,refObjIndex,&refRT);
 nudgeX = refRT.topLeft.x+refRT.extent.x;
 nudgeY = refRT.topLeft.y;
 FrmSetObjectPosition(frm,nudgeObjIndex,nudgeX,nudgeY);
  
}

/* IncrementActiveSelector						*/
/* This is used by SignalFormHandleEvent. When the up-arrow is clicked  */
/* to increment the signal number, this handles the actual twiddling of */
/* the counter(s)							*/


void IncrementActiveSelector(ControlType *ActiveCtl, int Ctlx,int Ctly,int ctrfloor,int ctrceil) 
{
 Char *ActiveCtlStr;
 int ActiveCtlNum;

 ActiveCtlStr = (Char *) CtlGetLabel(ActiveCtl);
                     WinDrawChars(ActiveCtlStr,StrLen(ActiveCtlStr),Ctlx,Ctly);
                     ActiveCtlNum=StrAToI(ActiveCtlStr);
                     if(ActiveCtlNum ==ctrceil) {
                        ActiveCtlNum=ctrfloor;
                     } else {
                             ActiveCtlNum++;
                     }
                     StrIToA(ActiveCtlStr,ActiveCtlNum);
                     WinDrawChars(ActiveCtlStr,StrLen(ActiveCtlStr),Ctlx,Ctly);
                     CtlSetLabel(ActiveCtl,ActiveCtlStr);

}

/* DecrementActiveSelector						  */
/* This is used by SignalFormHandleEvent. When the down-arrow is clicked  */
/* to decrement the signal number, this handles the actual twiddling of   */
/* the counter(s)							  */


void DecrementActiveSelector(ControlType *ActiveCtl, int Ctlx,int Ctly,int ctrfloor,int ctrceil)
{
 
 Char *ActiveCtlStr;
 int ActiveCtlNum;

 ActiveCtlStr = (Char *)CtlGetLabel(ActiveCtl);
                     ActiveCtlNum=StrAToI(ActiveCtlStr);
                     if(ActiveCtlNum ==ctrfloor) {
                        ActiveCtlNum=ctrceil;
                     } else {
                             ActiveCtlNum--;
                     }
                     StrIToA(ActiveCtlStr,ActiveCtlNum);
                     WinDrawChars(ActiveCtlStr,StrLen(ActiveCtlStr),2,140);
                     CtlSetLabel(ActiveCtl,ActiveCtlStr);
}

void ScrollTrackRight(int TrkGroup, UInt16 TrkIndex, int TrkBase)
{

 FormType *frm; 
 UInt16 ActiveCtlNum;
 UInt16 SelectedCtl;

	frm = FrmGetActiveForm();
	ActiveCtlNum = FrmGetControlGroupSelection(frm,TrkGroup);
/* 	PalmOS_printf("Got CtlGroup as %d",TrkGroup);*/
	if (ActiveCtlNum != frmNoSelectedControl) {
		SelectedCtl = FrmGetObjectId(frm,ActiveCtlNum);
/*		PalmOS_printf("SelectedCtl=%d",SelectedCtl); */
		if (SelectedCtl <G_MaxCmdBtn) {
		SelectedCtl++;
		}
		else { 
			SelectedCtl = G_MaxCmdBtn;
			PopulateBtnTrack(frm,PBtnCBCmd1,1);			
	 	}
			FrmSetControlGroupSelection(frm,TrkGroup,SelectedCtl);
	}		
}

void ScrollTrackLeft(int TrkGroup, UInt16 TrkIndex, int TrkBase)
{
 
 FormType *frm; 
 UInt16 ActiveCtlNum;
 UInt16 SelectedCtl;

	frm = FrmGetActiveForm();
	ActiveCtlNum = FrmGetControlGroupSelection(frm,TrkGroup);
	if (ActiveCtlNum != frmNoSelectedControl) {
		SelectedCtl = FrmGetObjectId(frm,ActiveCtlNum);
		if (SelectedCtl >TrkBase) {
			SelectedCtl--;
		} else {
			SelectedCtl = TrkBase;
		}
		FrmSetControlGroupSelection(frm,TrkGroup,SelectedCtl);
	}
}

/*Geordi_Connect							    */
/*Establish connection to remote host and log in. GS_TelOptChat carries out */
/*OOB protocol-specific negotiations and setup, and calls GS_UnameChat      */
/* to complete login. After that, we jump to MainForm			    */

Err Geordi_Connect(Word librefnum,DWord creator_id,Word iface) 
{
 Err conn_err; 
 Err conn_eptr; 
 NetIPAddr G_NetServAddrN;

 Int32 G_timeout; 
 Err conn_result;
 Err chat_result;
 Err prompt_result;

     /*G_timeout = 100 * SysTicksPerSecond(); */
    
     /*bzero((char*)&G_socketAddrP,sizeof(G_socketAddrP)); */
     G_NetServAddrN=NetLibAddrAToIN(AppNetRefnum,HostTxt);

     G_socketAddr.family = netSocketAddrINET;
     G_socketAddr.port = NetHToNL(G_NetServPortnum);
     G_socketAddr.addr = G_NetServAddrN;
   
     G_socketAddrP = &G_socketAddr; 
    
        Geordi_DrawProgress("Contacting Host..."); 
	G_sockref= NetLibSocketOpen(librefnum,netSocketAddrINET,netSocketTypeStream,0,10,(Err*)&conn_eptr);
        if (conn_eptr != 0) {
	    Geordi_EraseProgress();
            Err_Decode(AlrtNetFail,conn_eptr,"Error on Socket Acquisition");
            conn_result = -1;
          }
          else {
                conn_err = NetLibSocketConnect(librefnum,G_sockref,(NetSocketAddrType*) &G_socketAddr,sizeof(G_socketAddr),(30* SysTicksPerSecond()),(Err*)&conn_eptr);
	       if (conn_eptr != 0) { 
	    	 Geordi_EraseProgress();
            	 Err_Decode(AlrtNetFail,conn_eptr,"Error Connecting to Host!");
             	 conn_result = -1;
                }
                else {
                      	conn_result = G_sockref;
                      	IsConnected = true;
			Geordi_EraseProgress();
                      	Geordi_DrawProgress("Negotiating...");
		      	chat_result = GS_TelOptChat(G_sockref,G_socketAddr);
			if (chat_result < 0)
			{
        		  FrmCustomAlert(AlrtCrit, "Login Failure!", "","");
				return 0;
			} else {
				prompt_result = GS_LearnHostPrompt(G_sockref,G_socketAddr);
				if (prompt_result !=0 ) {
					conn_result = -1;
				}
			}
                }
         }
     return conn_result;

}

/* Geordi_DoPSCmd							 */
/*									 */
/* This runs the top command at startup and whenever the "Refresh" button */
/* is tapped. If a filter has been applied, we construct it before 	 */
/* issuing the ps command. We can filter on anything since this is a 	 */
/* simple grep on the full process table			 	 */
/* We know we've reached the end of our returned results when we get	 */
/* NetLibReceive timeouts.						 */

Int16 Geordi_DoPSCmd() 
{
 Char* clibuf;
 Char* filtercmd;
 int linenum = 0;
 int clibuf_len = 0;
 Int32 maxlines = 0;
 Int32 cmdtimeout = 10;
 
      Geordi_PsTableFlush();

      if (G_UseFilter == false) {	 
        GS_SendBytes(G_sockref,G_socketAddr,30,G_pscmd);
	GS_SendBytes(G_sockref,G_socketAddr,1,"\n");
	maxlines = 10;
      } else {
		filtercmd = MemPtrNew(51+(StrLen(G_filterline)));
		StrPrintF(filtercmd,"top -b -n 1|grep %s|sort +10 -n -r|head -10\n",G_filterline);
		GS_SendBytes(G_sockref,G_socketAddr,(StrLen(filtercmd)),filtercmd);
		MemPtrFree(filtercmd);
      }
	  clibuf = GS_GetLine(cmdtimeout);	
      Geordi_DrawProgress("Refreshing Process List"); 
      while ( (StrStr(clibuf,"EOI")) == NULL) { 
	  clibuf = GS_GetLine(cmdtimeout);	
	  clibuf_len = StrLen(clibuf);
	  if((clibuf_len > 60) && ((StrStr(clibuf,"PID"))==NULL) && \
	    ((StrStr(clibuf,"head")) ==NULL ) ) {
	    	Geordi_ParseResults(clibuf,NULL,CMD_PS,linenum,clibuf_len);
        	MemPtrFree(clibuf);
		linenum++;
	  }
	  if(linenum >9 ) {
		break;
	  }
	}

   Geordi_EraseProgress();
   if ( linenum == 0) {
	FrmCustomAlert(AlrtWarn,"No processes found","","");
   } else {
		 Geordi_PsTableUpdate();
     }
 return linenum;		
}

/* Geordi_DoDF								    */
/* This is the main entry point into DskForm				    */
/* It runs a df -k and then displays the results in DskForm		    */

Int16 Geordi_DoDF()
{
Char* clibuf;
 int linenum = 0;
 int clibuf_len = 0;
 Int32 timeout = 5;
	
Geordi_DfTableFlush();
	Geordi_DrawProgress("Refreshing mountlist...");
	GS_SendBytes(G_sockref,G_socketAddr,7,"df -Tk\n");
	 clibuf = GS_GetLine(timeout);	
        while ( (StrStr(clibuf,"EOI")) == NULL) { 
	  clibuf = GS_GetLine(timeout);	
	  clibuf_len = StrLen(clibuf);
	  if((clibuf_len > 50) && ((StrStr(clibuf,"Filesystem"))==NULL) && \
	    ((StrStr(clibuf,"df")) ==NULL )) {
	    	Geordi_ParseResults(clibuf,NULL,CMD_DF,linenum,clibuf_len);
        	MemPtrFree(clibuf);
		linenum++;
	  }
	  if(linenum >9 ) {
		break;
	  }
	}
  Geordi_EraseProgress();
  Geordi_DfTableUpdate(linenum);
 return linenum;

}

/* Geordi_DoDU								    */
/* This runs a du(1) and then displays the results in DskDUForm		    */
/* options for the du are set in the DskDuSelectForm			    */

Int16 Geordi_DoDU(Char *DuCmdStr,Int32 numlines)
{
 UInt16 numresults;
 Char *DUCmdBasePtr;
	PalmOS_printf("Entered DoDU");
	DUCmdBasePtr= get_field(DuCmdStr,' ',4);
	PalmOS_printf("Basename=%s",DUCmdBasePtr);
	GS_SendCommand(DuCmdStr);
	PalmOS_printf("Doing GS_GetResults");
	numresults = GS_GetResults(CMD_DU,"denied","cannot",DUCmdBasePtr,6,1,numlines);
	PalmOS_printf("Completed GetResults");
  	MemPtrFree(DUCmdBasePtr); 
	PalmOS_printf("Exiting DoDU");
  	return numresults;		
}

int Geordi_DoMount() 
{

 Char MntCmd[80];
 Char CheckCmd[80]; 
 Char *OptText,*FsTypeText,*DevName,*MntPt;
 FieldType *FldDevPtr,*FldMntPtPtr,*FldOptPtr;
 ListType *LstFsTypePtr;
 FormType *frm;
 UInt16 numlines=0;
 Word FsSelection;
 int results=0;


	frm = FrmGetActiveForm();

	LstFsTypePtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstMntFsTypes));
        FsSelection = LstGetSelection(LstFsTypePtr);
        FsTypeText = LstGetSelectionText(LstFsTypePtr,FsSelection);

 	StrPrintF(MntCmd,"sudo mount -t %s ",FsTypeText);

	FldOptPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntOpt));
	if(FldGetTextLength(FldOptPtr) > 1) {
       		OptText = FldGetTextPtr(FldOptPtr);
       		StrCat(MntCmd,"-o ");
       		StrCat(MntCmd,OptText);
       		StrCat(MntCmd," ");
 	}
	FldDevPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntDev));
 	DevName = FldGetTextPtr(FldDevPtr);

        FldMntPtPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntPt));
        MntPt = FldGetTextPtr(FldMntPtPtr);

       StrCat(MntCmd,DevName);
       StrCat(MntCmd," ");
       StrCat(MntCmd,MntPt);
       StrCat(MntCmd,"\n");
       PalmOS_printf("MntCmd:%s",MntCmd);
       GS_SendCommand(MntCmd);
       numlines = GS_GetResults(CMD_TD,"None","None","None",4,1,5);
        
       if (StrStr(G_StdOut,"mount:")!=NULL)  {
		results = -1;
	} else {
		results = 0;
	}
		
 return results;
}

int Geordi_DoUmount(Char *FsPtr) {

Char UmntCmd[80];
int numlines;
int results;


	StrPrintF(UmntCmd,"sudo umount -v %s \n",FsPtr);
	GS_SendCommand(UmntCmd);
	
 	numlines = GS_GetResults(CMD_TD,"None","None","None",4,1,5);
	
	if (StrStr(G_StdOut,"umount:") !=NULL) {
		results = -1;
	} else {
		results = 0;
	}
	
 return results;
}


/* GS_GetResults							    */
/* Retrieves command output from the remote host. This is used by functions */
/* whose results are not deterministic, like du, df, filtered top, etc.     */
/* 									    */
/* Parameters:								    */
/* Type: Command type. Acceptable values are:CMD_PS,CMD_DF,CMD_DU,CMD_IF or */
/* CMD_TD. CMD_TD does not get parsed, but dumped into a global variable    */
/* G_StdOut. The caller then processes this according to taste.	This is     */
/* so that Geordi_ParseResults knows what to do with the output	    	    */
/* 									    */
/* kw,kw2:Pass a keyword to filter out lines containing kw or kw2.	    */
/* Pass "None" to get all output returned. Typically, a keyword is preamble */
/* or other header data in output a form wants to skip. 		    */
/* 									    */
/* KeywordLen: Length of the keyword(s)					    */
/* 									    */
/* RLL_Threshhold: Result Line Length to start paying attention to output at*/
/* The result output of some commands is deterministic in line length.	    */
/* If the length of a particular line of output exceeds RLL_Threshhold	    */
/* it's something we want to pay attention to. If it's less, it gets flushed*/
/* 									    */
/* maxresults: The maximum lines of output we're interested in getting back.*/
/* If the output from a command exceeds maxresults, it's flushed	    */
/* 									    */
/* By themselves, these each are a pretty cheesy way of figuring out what   */
/* part of a netstat or df or whatever we're interested in. Combined 	    */
/* together, they work quite well.  			 		    */
/* 									    */
/* cmdFormStr: A string from the originating form. It's possible that the   */
/* results may need to reference some data from the form that resulted in   */
/* us being here in the first place. A good example of this is when we do a */
/* du(1) using DoDU. In order to properly display the results, we need to   */
/* basename the starting path. 	We can either do something like we do in    */
/* SyncToPrompt(much heavier and overkill) or we can just grab it from the  */
/* command string that DoDU ships out(*much* easier). 			    */
/* 									    */

 UInt16 GS_GetResults(int Type, Char *kw,Char *kw2, Char *cmdFormStr,UInt16 KeywordLen, int RLL_Threshhold,int maxresults) 
{ 
  int linenum = 1;	
  int resultbuf_len = 0;
  int StdOutSize = 0;
  Int32 gstimeout = 20;
  Char *resultbuf;
  Char *Keyword;
  Char *Keyword2;
  Char *FormParm;
  Char  LineNumStr[4] = "....";

	Keyword = MemPtrNew((StrLen(kw)));
	Keyword2= MemPtrNew((StrLen(kw2)));
        FormParm = MemPtrNew((StrLen(cmdFormStr))); 
	StrCopy(Keyword,kw);
	StrCopy(Keyword2,kw2); 
	StrCopy(FormParm,cmdFormStr);
	
 	Geordi_DrawProgress("Getting Results ....");

	/*resultbuf = GS_GetLine(gstimeout);	*/
        while ( linenum < maxresults ) { 
        /*	MemPtrFree(resultbuf);  */
	  resultbuf = GS_GetLine(gstimeout);	
	  if((StrStr(resultbuf,"EOI")) != NULL) {
			break;
	  }
	  resultbuf_len = StrLen(resultbuf);
	  StdOutSize += resultbuf_len; 
	  if (StdOutSize > 8192 ) {
		FrmCustomAlert(AlrtInternal,"GetResults:Output Overflow","Truncating at:",StdOutSize);
		break;
	  }

	  if((resultbuf_len > RLL_Threshhold) && \
		((StrStr(resultbuf,Keyword))==NULL) && \
	    	((StrStr(resultbuf,Keyword2))==NULL )) 
	    {
		if (Type !=CMD_TD) {
	    		Geordi_ParseResults(resultbuf,FormParm,Type,linenum,resultbuf_len);
			linenum++;
			PalmOS_printf("linenum=%d",linenum);
		} else {
			StrCat(G_StdOut,resultbuf);
				linenum++;

			}
		}
	  if(linenum >=maxresults ) {
		break;
	  }
	  StrPrintF(LineNumStr,"%d",linenum);
	  WinDrawChars(LineNumStr,4,95,75);		
          MemPtrFree(resultbuf); 
	}
 MemPtrFree(Keyword);
 MemPtrFree(Keyword2);
 MemPtrFree(FormParm);
 Geordi_EraseProgress();
 return linenum;

}

/* Geordi_ParseResults							    */
/* 									    */
/* This parses the output from commands that have a given command type	    */
/* attached to them, either by a caller function or GS_GetResults	    */
/* Valid command types are found in geordi.h. 				    */
/* 									    */
/* Parameters:								    */
/* parsebuf: pointer to a Char buffer that has the output to be parsed	    */
/* cmdtype: command type. This determines how the output is to be parsed and*/
/*processed for display in a form.					    */
/* 									    */
/*linenum: output line number. 						    */
/*buflen: length of buffer						    */
/*formstr: See CmdFormStr in GS_GetResults				    */ 


void Geordi_ParseResults(Char *parsebuf,Char *formstr,int cmdtype,int linenum,int buflen) {
	
int parsebuf_len = 0;
int sizelen,basename_len,pathname_len,basename_extent = 0;
Char *substr;
Char *pathname;
	parsebuf_len = buflen;

	switch(cmdtype) {
		case CMD_PS:
	        	StrNCopy(G_pstable[linenum].pid,parsebuf,5);   

			substr = get_substr(parsebuf,6,9);
			StrCopy(G_pstable[linenum].user,substr);
			MemPtrFree(substr);
			
			substr = get_substr(parsebuf,44,5);
			StrCopy(G_pstable[linenum].cpu,substr);
			MemPtrFree(substr);

			substr = get_substr(parsebuf,50,5);
			StrCopy(G_pstable[linenum].mem,substr);
			MemPtrFree(substr);

			substr = get_substr(parsebuf,62,(parsebuf_len-62));
			StrNCopy(G_pstable[linenum].cmd,substr,(StrLen(substr))-1);
			MemPtrFree(substr);
			break;
		case CMD_IF:
			break;
		case CMD_DF:
		
			substr = get_field(parsebuf,' ',1);
			StrCopy(G_dftable[linenum].device,substr); 
			MemPtrFree(substr);
	
			substr = get_field(parsebuf,' ',2);
			StrCopy(G_dftable[linenum].type,substr);
		 	MemPtrFree(substr);
			
			substr = get_field(parsebuf,' ',3);
			StrCopy(G_dftable[linenum].size,substr);
		 	MemPtrFree(substr);
			    
			substr = get_field(parsebuf,' ',4);
			StrCopy(G_dftable[linenum].used,substr);
		 	MemPtrFree(substr);
			    
			substr = get_field(parsebuf,' ',5);
			StrCopy(G_dftable[linenum].avail,substr);
		 	MemPtrFree(substr);
			
			substr = get_field(parsebuf,' ',6);
			StrCopy(G_dftable[linenum].percent,substr);
			MemPtrFree(substr);	
		        
			substr = get_field(parsebuf,' ',7);
			StrNCopy(G_dftable[linenum].volname,substr,(StrLen(substr))-1);
			MemPtrFree(substr);
			break;
		case CMD_DU:
			PalmOS_printf("Entered CMD_DU");
			substr = get_field(parsebuf,'	',1);
			sizelen = StrLen(substr);
			StrCopy(G_dutable[linenum].size,substr);
			MemPtrFree(substr);

			substr = get_field(parsebuf,'	',2); 
			basename_len = StrLen(formstr)+1;
			pathname_len = StrLen(substr);
			basename_extent = pathname_len - basename_len;
			
			if(basename_extent >0) {
			pathname = get_substr(substr,basename_len,basename_extent);	
			} else {
				pathname = MemPtrNew(StrLen("Directory Total"));
				StrCopy (pathname,"Directory Total");
				pathname_len = StrLen(pathname);
			}
			PalmOS_printf("basename=%s",formstr);	
			PalmOS_printf("substr=%s",substr);
 			SysTaskDelay(SysTicksPerSecond()*3);		
			PalmOS_printf("blen=%d plen=%d extent=%d",basename_len,pathname_len,basename_extent);
			PalmOS_printf("pathname=%s",pathname);	
 			SysTaskDelay(SysTicksPerSecond()*3);		
	
			StrCopy(G_dutable[linenum].path,pathname);
			MemPtrFree(substr);
			MemPtrFree(pathname);
			break;

		default:
		break; 	
	}
       
}                    		

/*GS_LearnHostPrompt							     */
/*Different sites will have different prompts 				     */
/*We have to learn to recognize the one used by this login 	    	     */

Err GS_LearnHostPrompt(NetSocketRef sockd,NetSocketAddrINType sockaddr) 
{
 Err prompt_err;
 Char* promptbuf;
 Char learnbuf[90];
 int learned = 0;
 int tries = 0;
 int promptlen = 0;
 int promptend = 0;
 int lastlen = 0; 
 int i = 0;
 
  Geordi_DrawProgress("Learning Prompt");
	
  while ( learned < 3) { 
       
      if (tries > 10 ) {
        break;
      }
       GS_SendBytes(sockd,sockaddr,1,"\n");
       promptbuf = GS_GetBytes(sockd);
       promptlen = StrLen(promptbuf);
       if (promptlen == lastlen) {
		learned++;
       }
       tries++;
       lastlen = promptlen;
  }
       if (tries > 10 && learned < 3) {
	Geordi_Disconnect();
	Geordi_EraseProgress();
        FrmCustomAlert(AlrtCrit, "Could not sync to prompt!", "","");
	prompt_err = -1;
       }else {
		StrCopy(learnbuf,promptbuf);
		G_promptchar = learnbuf[promptlen-1];
	        promptend = promptlen - 1; 
		for (i =0;i < 10; i++) {
			G_prompt[i] = learnbuf[(promptlen-11)+i];
		}
		Geordi_EraseProgress();
		Geordi_DrawProgress("Synced to prompt");
		promptbuf = GS_GetBytes(sockd);
		MemPtrFree(promptbuf);
		prompt_err = 0;
       }
  return prompt_err;
}		

void GS_SyncToPrompt() 
{
 Char* SyncPtr;

  	 SyncPtr = GS_GetLine(G_sockref);
 while( (StrStr(SyncPtr,G_prompt))== NULL && (StrLen(SyncPtr)) > 1) {
	 SyncPtr = GS_GetLine(G_sockref);
	}
}


Err GS_TelOptChat(NetSocketRef sockd,NetSocketAddrINType sockaddr) {

 unsigned char OptBuf[11];
  UInt8 HostOptByte;
  Err success = 0;
 
  OptBuf[0] = IAC;
  OptBuf[1] = WILL;
  OptBuf[2] = TELOPT_ECHO;
	GS_SendBytes(sockd,sockaddr,3,OptBuf); 
  while ((HostOptByte = GS_GetTelOptByte(sockd))) {
	if(HostOptByte == 'g') {
                  if((HostOptByte = GS_GetTelOptByte(sockd)) == 'i') {
                       if((HostOptByte = GS_GetTelOptByte(sockd)) == 'n') {
                          if((HostOptByte = GS_GetTelOptByte(sockd)) == ':') {
			
				OptBuf[0] = IAC;
				OptBuf[1] = WILL;
				OptBuf[2] = TELOPT_ECHO;
				GS_SendBytes(sockd,sockaddr,3,OptBuf); 
				
				OptBuf[0] = IAC;
				OptBuf[1] = DONT;
				OptBuf[2] = TELOPT_SGA;
				GS_SendBytes(sockd,sockaddr,3,OptBuf); 
			         
				success = GS_UnameChat(sockd,sockaddr);
			  }
		       }
		break;
		  }
	}
    switch(HostOptByte) {
      case IAC: 
           HostOptByte = GS_GetTelOptByte(sockd); 
	  switch (HostOptByte) {
		  case DO:
         		HostOptByte = GS_GetTelOptByte(sockd); 
			switch(HostOptByte) {
				case TELOPT_TTYPE:
					OptBuf[0] = IAC;
					OptBuf[1] = WILL;
					OptBuf[2] = TELOPT_TTYPE;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
				 
					break;
				case TELOPT_TSPEED:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_TSPEED;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					break;
				case TELOPT_XDISPLOC:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_XDISPLOC;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					break;
				case TELOPT_NEW_ENVIRON:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_NEW_ENVIRON;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					break;
				case TELOPT_ECHO:
					OptBuf[0] = IAC;
					OptBuf[1] = WILL;
					OptBuf[2] = TELOPT_ECHO;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					break;
				case TELOPT_SGA:
					OptBuf[0] = IAC;
					OptBuf[1] = DONT;
					OptBuf[2] = TELOPT_SGA;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					break; 
				case TELOPT_LFLOW:
					OptBuf[0] = IAC;
					OptBuf[1] = DO;
					OptBuf[2] = TELOPT_LFLOW;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					break;
				case TELOPT_NAWS:
					OptBuf[0] = IAC;
					OptBuf[1] = WILL;
					OptBuf[2] = TELOPT_NAWS;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					OptBuf[0] = IAC;
					OptBuf[1] = SB;
					OptBuf[2] = TELOPT_NAWS;
					OptBuf[3] = TELQUAL_IS;
					OptBuf[4] = 'P';
					OptBuf[5] = IAC;
					OptBuf[6] = SE;
					GS_SendBytes(sockd,sockaddr,7,OptBuf); 
				 	break; 
				default:
					break;
			}
			break;
		   case DONT:
         		   HostOptByte = GS_GetTelOptByte(sockd); 
			   switch(HostOptByte) {
				case TELOPT_TTYPE:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_TTYPE;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                        break;
                                case TELOPT_TSPEED:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_TSPEED;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                        break;
                                case TELOPT_XDISPLOC:   
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_XDISPLOC;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					
                                        break;
                                case TELOPT_NEW_ENVIRON:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;	
					OptBuf[2] = TELOPT_NEW_ENVIRON;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                        break;
                                case TELOPT_ECHO:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_ECHO;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                        break;
				case TELOPT_SGA:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_SGA;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					break;
                                case TELOPT_LFLOW:
					OptBuf[0] = IAC;
					OptBuf[1] = DO;
					OptBuf[2] = TELOPT_LFLOW;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                default:
                                        break;
			   }
			break;
		   case WILL: 
         		   HostOptByte = GS_GetTelOptByte(sockd); 
			   switch(HostOptByte) {
				case TELOPT_TTYPE:
                                        break;
                                case TELOPT_TSPEED:
					OptBuf[0] = SB;
					OptBuf[1] = TELOPT_TSPEED;
					OptBuf[2] = TELQUAL_SEND;
					OptBuf[3] = SE; 
					GS_SendBytes(sockd,sockaddr,4,OptBuf); 
                                        break;
                                case TELOPT_XDISPLOC:   
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_XDISPLOC;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                        break;
                                case TELOPT_NEW_ENVIRON:
					OptBuf[0] = IAC;
					OptBuf[1] = DONT;
					OptBuf[2] = TELOPT_NEW_ENVIRON;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                        break;
                                case TELOPT_ECHO:
					OptBuf[0] = IAC;
					OptBuf[1] = WONT;
					OptBuf[2] = TELOPT_ECHO;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                        break;
				case TELOPT_SGA:
					OptBuf[0] = IAC;
					OptBuf[1] = DONT;
					OptBuf[2] = TELOPT_SGA;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
					break;
                                case TELOPT_LFLOW:
					OptBuf[0] = IAC;
					OptBuf[1] = DO;
					OptBuf[2] = TELOPT_ECHO;
					GS_SendBytes(sockd,sockaddr,3,OptBuf); 
                                default:
					break;
			   }
			break;
		   case WONT:
         		   HostOptByte = GS_GetTelOptByte(sockd); 
			   switch(HostOptByte) {
				case TELOPT_TTYPE:
                                case TELOPT_TSPEED:
                                case TELOPT_XDISPLOC:   
                                case TELOPT_NEW_ENVIRON:
                                case TELOPT_ECHO:
					break;
				case TELOPT_SGA:
					OptBuf[0] = IAC;
					OptBuf[1] = DO;
					OptBuf[2] = TELOPT_SGA;
					break;
                                case TELOPT_LFLOW:
					OptBuf[0] = IAC;
					OptBuf[1] = DO;
					OptBuf[2] = TELOPT_LFLOW;
					break;
                                default:
					break;
			   }
			break;

		    case SB:
         		   HostOptByte = GS_GetTelOptByte(sockd); 
			   switch(HostOptByte) {
				  case TELOPT_TTYPE:
					OptBuf[0] = IAC;
					OptBuf[1] = SB;
					OptBuf[2] = TELOPT_TTYPE;
					OptBuf[3] = TELQUAL_IS;
					OptBuf[4] = 'v';
					OptBuf[5] = 't';
					OptBuf[6] = '1';
					OptBuf[7] = '0';
					OptBuf[8] = '0';
					OptBuf[9] = IAC;
					OptBuf[10] = SE;
					GS_SendBytes(sockd,sockaddr,11,OptBuf); 
					break;
				   case TELOPT_NAWS:
					OptBuf[0] = IAC;
					OptBuf[1] = SB;
					OptBuf[2] = TELOPT_NAWS;
					OptBuf[3] = TELQUAL_IS;
					OptBuf[4] = 'P';
					OptBuf[5] = IAC;
					OptBuf[6] = SE;
					GS_SendBytes(sockd,sockaddr,7,OptBuf); 
					break;
				   default:
					break;
					
			   }
			break;
			}
			break;
	    default:
		   break;
      }
   }
   return success;
} 

Int16 GS_UnameChat() 
{
 Char* init_buf;
 int success;
	Geordi_EraseProgress(); 
 	Geordi_DrawProgress("Logging in...");	
 	GS_SendBytes(G_sockref,G_socketAddr,StrLen(UnameTxt),UnameTxt);
 	GS_SendBytes(G_sockref,G_socketAddr,1,"\n");
 	SysTaskDelay(SysTicksPerSecond()*2);			
 	GS_SendBytes(G_sockref,G_socketAddr,StrLen(PassTxt),PassTxt);
 	GS_SendBytes(G_sockref,G_socketAddr,1,"\n");
	init_buf = GS_GetLine(G_sockref);

	if((StrStr(init_buf,"Last")) == NULL) {
		success = -1;

 	} else {
		MemPtrFree(init_buf);
		success = 1;
	}	
	Geordi_EraseProgress();
    return success; 
}

Err Geordi_Disconnect() {

Err err;
        Geordi_DrawProgress("Disconnecting...");
	err = NetLibSocketClose(AppNetRefnum,G_AlarmSockRef,true,&err);
	err = NetLibClose(AppNetRefnum,true);
        IsConnected = false;
        IsFirst = true;
	G_UseFilter = false;
	AlmSetProcAlarm(AuthRenewalHandler,0,0);
	Geordi_EraseProgress();
	return err;
}

Char* GS_GetBytes(int sockd)
{
 Err result,rcv_err;
 UInt16 G_RASize = sizeof(NetSocketAddrType);
 UInt16* G_RASizePtr; 
 Char* gsbuf;
 Char* gsbufptr;
 Char tmp[80];

  Int32 gstimeout = -1;  
  void* G_RcvAddrPtr = MemPtrNew(sizeof(NetSocketAddrType)); 
  G_RASizePtr = &G_RASize;

    result = NetLibReceive(AppNetRefnum,sockd,&tmp,80,0,G_RcvAddrPtr,G_RASizePtr,gstimeout,(Err*)&rcv_err);
    
    if (result < 80 ) {
	    tmp[result+1] = '\0';
    } else {
	    tmp[80] = '\0'; 
    }
    if (result > 0) {

  	gsbuf= MemPtrNew(result+1); 
  	MemPtrFree(G_RcvAddrPtr);
  	StrCopy(gsbuf,tmp);
  	gsbufptr = gsbuf;
  	return gsbufptr;
    } else {
		return 0;
	}
	
	
}

/*Get lines of output from a GS_SendBytes or GS_SendCommand call */
/* Int32 gst says how long we should wait on completion  	 */
/* before assuming end-of-input. Some commands take longer than  */
/* others to complete so we let the callers decide how long to   */
/* wait before assuming EOI.					 */

Char* GS_GetLine(Int32 gst)
{
 Err result,rcv_err;
 UInt16 G_RASize = sizeof(NetSocketAddrType);
 UInt16* G_RASizePtr;
 Char* glbuf;
 int i =0;
 Int32 gstimeout =0;
 Char tmp[80];
 Char input;
   
  void* G_RcvAddrPtr = MemPtrNew(sizeof(NetSocketAddrType));
  G_RASizePtr = &G_RASize;

  gstimeout = gst * 100;

  result = NetLibReceive(AppNetRefnum,G_sockref,&input,sizeof(Char),0,G_RcvAddrPtr,G_RASizePtr,gstimeout,(Err*)&rcv_err);
  while ( (input != '\n') && (rcv_err == 0)) {
    tmp[i] = input;
    i++;
    result = NetLibReceive(AppNetRefnum,G_sockref,&input,sizeof(Char),0,G_RcvAddrPtr ,G_RASizePtr,gstimeout,(Err*)&rcv_err) ;
/*	if (rcv_err == netErrTimeout) {
	    Err_Decode(AlrtNetFail,rcv_err,"GS_GetLine:");
		break;
	}
*/
  }
   if (rcv_err == 0) {
  	tmp[i] = '\0';
  	glbuf= MemPtrNew(sizeof(Char) * (i + 1));
  	StrCopy(glbuf, tmp);
 	 MemPtrFree(G_RcvAddrPtr);
	  return glbuf;
   } else {
	    glbuf = MemPtrNew(3);
	    StrCopy(glbuf,"EOI");
	    return glbuf;
          }

}

UInt8 GS_GetTelOptByte(int sockd)
{
 Err result,rcv_err;
 UInt16 G_RASize = sizeof(NetSocketAddrType);
 UInt16* G_RASizePtr; 
 UInt8 input = 0;
 UInt8 gsbyte = 0; 
 Int32 gstimeout = -1;  
  void* G_RcvAddrPtr = MemPtrNew(sizeof(NetSocketAddrType)); 
  G_RASizePtr = &G_RASize;
  
  result = NetLibReceive(AppNetRefnum,sockd,&input,sizeof(Char),0,G_RcvAddrPtr,G_RASizePtr,gstimeout,(Err*)&rcv_err);
    gsbyte = input;
  MemPtrFree(G_RcvAddrPtr);
  return gsbyte; 
}

Char* GS_GetNBytes(int sockd,int numbytes)
{

 Err result,rcv_err;
 Byte* gsbufptr;
 Byte RcvBufPtr[512]; 
 UInt16 G_RASize = sizeof(NetSocketAddrType);
 UInt16* G_RASizePtr; 
 Int32 gstimeout; 
 
  void* G_RcvAddrPtr = MemPtrNew(sizeof(NetSocketAddrType)); 
  G_RASizePtr = &G_RASize;
    
  gstimeout = (SysTicksPerSecond())*100; 
     if(numbytes <= 512) { 
     result = NetLibReceive(AppNetRefnum,sockd,&RcvBufPtr,numbytes,0,G_RcvAddrPtr,G_RASizePtr,gstimeout,(Err*)&rcv_err);
     gsbufptr = RcvBufPtr;
     MemPtrFree(G_RcvAddrPtr);
     return gsbufptr; 
     } else {
		return -1;
       }
}

Int16 GS_SendBytes(int sockd,NetSocketAddrINType sockaddr,int buflen, unsigned char* GS_buf) 
{

 int results; 
 Err send_err;
  
 results=NetLibSend(AppNetRefnum,sockd,GS_buf,buflen,0,(NetSocketAddrType *)&sockaddr,sizeof(NetSocketAddrType),1000,(Err*)&send_err);
 
  if (results < 0) {
	 Err_Decode(AlrtNetFail,send_err,"Error sending data");
  } 
  return results;
}

UInt16 GS_SendCommand(Char *CmdStr)
{
 Err err;
 if ( (err = GS_SendBytes(G_sockd,G_socketAddr,(StrLen(CmdStr)),CmdStr)) < 0 ) {
       FrmCustomAlert(AlrtCrit,"Error Sending Command:",CmdStr,"");
	}
      
 return 0;
}

/*We need to find out where the PPP interface lives on this device */
/*This should be standard, but we're smart enough to: 		   */
/*A. Not trust firmware to stay the same across models 		   */
/*B. Not trust our userbase to even know(or care) how to make it   */
/*   consistent. 					 	   */

UInt16 Geordi_GetNetIF(Word libRefnum)
{
 Err max_if;
 Err if_err;

 G_NetIF_index = 0;
 
 
      while((max_if = NetLibIFGet(libRefnum,G_NetIF_index,&G_NetIF_creator,&G_NetIF_instance)) == 0 ){
 	 if_err = NetLibIFSettingGet(libRefnum,G_NetIF_creator,G_NetIF_instance,netIFSettingName,G_NetIF_name,&G_NetIF_bufLenP);
		 if(StrCompare(G_NetIF_name,"PPP0") == 0 ) {
		        break;
                 }
                  else {
		     G_NetIF_index++;
		  }
      }
	 return G_NetIF_index;
}

/*This is the kick-off point for (re-)establishing a network connection */
        
int Geordi_ConnectMgr()
{
 Err err,netlib_err,netif_err = 0;

         if(IsConnected == false) {
	 	err = SysLibFind("Net.lib", &AppNetRefnum);
 	 	err = NetLibOpen(AppNetRefnum,&netlib_err);
	 }

         if ((err == 0) || (err == netErrAlreadyOpen)) {
	 LibOpened=true;
    	 G_NetIF_index = Geordi_GetNetIF(AppNetRefnum);
 	 netif_err = NetLibIFUp(AppNetRefnum,G_NetIF_creator,G_NetIF_instance);
		if (netif_err != 0) {
			Err_Decode(AlrtNetFail,netif_err," Error bringing up Interface");
	        	G_sockd = -1;
			} else {

	  		      	if ( (G_sockd = Geordi_Connect(AppNetRefnum,G_NetIF_creator,G_NetIF_instance)) < 0) {
	        		 	  G_sockd = -1;
         			}
         			G_AlarmSockRef = G_sockd;
	 		}
   	 } else {
		Err_Decode(AlrtNetFail,err,"Failed to get NetLib reference");
	        G_sockd = -1;
	 }
 	return G_sockd;
}

void Geordi_PsTableUpdate() 
{
    int numRows,i=0;
    FormType *frm;
    TableType *tbl;

    Char* userstr;
    Char* pidstr;
    Char* cpustr;
    Char* memstr;
    Char* cmdstr;


       frm= FrmGetActiveForm();
	tbl = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblProcTable));
      numRows = TblGetNumberOfRows(tbl);
      TblMarkTableInvalid(tbl);

      for(i = 0; i < numRows ;i++) {
	   
	    ProcTableHandles[0][i] = MemHandleNew(10);
            userstr = MemHandleLock(ProcTableHandles[0][i]);
            StrCopy(userstr,G_pstable[i].user);
            MemHandleUnlock(ProcTableHandles[0][i]);

            ProcTableHandles[1][i] = MemHandleNew(6);
            pidstr = MemHandleLock(ProcTableHandles[1][i]);
            StrCopy(pidstr,G_pstable[i].pid);
            MemHandleUnlock(ProcTableHandles[1][i]);
            
	    ProcTableHandles[2][i] = MemHandleNew(6);
            cpustr = MemHandleLock(ProcTableHandles[2][i]);
            StrCopy(cpustr,G_pstable[i].cpu);
            MemHandleUnlock(ProcTableHandles[2][i]);
            
	    ProcTableHandles[3][i] = MemHandleNew(6);
            memstr = MemHandleLock(ProcTableHandles[3][i]);
            StrCopy(memstr,G_pstable[i].mem);
            MemHandleUnlock(ProcTableHandles[3][i]);

	    ProcTableHandles[4][i] = MemHandleNew(41);
            cmdstr = MemHandleLock(ProcTableHandles[4][i]);
            StrCopy(cmdstr,G_pstable[i].cmd);
            MemHandleUnlock(ProcTableHandles[4][i]);

      }
	TblRedrawTable(tbl);
}

void Geordi_PsTableFlush() {


  int i;
     for(i=0; i < 10;i++) {
        StrCopy(G_pstable[i].user,"         ");
        StrCopy(G_pstable[i].pid,"     ");
        StrCopy(G_pstable[i].mem,"     ");
        StrCopy(G_pstable[i].cpu,"     ");
        StrCopy(G_pstable[i].cmd,"                                 ");
      }
}

void Geordi_DfTableUpdate(int numvols)
{
    int numRows,i=0;
    FormType *frm;
    TableType *tbl;

    Char* volnamestr;
    Char* sizestr;
    Char* percentstr;


       frm= FrmGetActiveForm();
	tbl = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDfTable));
      numRows = TblGetNumberOfRows(tbl);
      TblMarkTableInvalid(tbl);

      for(i = 0; i < numvols ;i++) {
	    
 	    TblSetRowUsable(tbl,i,true);

	    DiskTableHandles[0][i] = MemHandleNew(40);
            volnamestr = MemHandleLock(DiskTableHandles[0][i]);
            StrCopy(volnamestr,G_dftable[i].volname);
            MemHandleUnlock(DiskTableHandles[0][i]);

            DiskTableHandles[1][i] = MemHandleNew(10);
            sizestr = MemHandleLock(DiskTableHandles[1][i]);
            StrCopy(sizestr,G_dftable[i].size);
            MemHandleUnlock(DiskTableHandles[1][i]);
            
	    DiskTableHandles[2][i] = MemHandleNew(5);
            percentstr = MemHandleLock(DiskTableHandles[2][i]);
            StrCopy(percentstr,G_dftable[i].percent);
            MemHandleUnlock(DiskTableHandles[2][i]);
            
      }

      if (numvols < numRows) {
	
	 for (i =numvols; i< numRows;i++) {
		TblSetRowUsable(tbl,i,false);
	 }
      }

	TblRedrawTable(tbl);

}

void Geordi_DfTableFlush() {


  int i;
     for(i=0; i < 10;i++) {
        StrCopy(G_dftable[i].volname,"                                  ");
        StrCopy(G_dftable[i].size,"      ");
        StrCopy(G_dftable[i].percent,"    ");
      }
}

void Geordi_DuTableUpdate()
{
    int numRows,i=0;
    FormType *frm;
    TableType *tbl;

    Char* sizestr;
    Char* pathstr;

       PalmOS_printf("Reached DuTableUpdate");  

       frm = FrmGetActiveForm();
	tbl = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDuTable));
      numRows = TblGetNumberOfRows(tbl);
      TblMarkTableInvalid(tbl);
       PalmOS_printf("Finished Table setup");  
      for(i = 0; i < DU_Depth ;i++) {
         
	    TblSetRowUsable(tbl,i,true);
	    DuTableHandles[0][i] = MemHandleNew(StrLen(G_dutable[i].size));
            sizestr = MemHandleLock(DuTableHandles[0][i]);
            StrCopy(sizestr,G_dutable[i].size);
            MemHandleUnlock(DuTableHandles[0][i]);

            DuTableHandles[1][i] = MemHandleNew(StrLen(G_dutable[i].path));
            pathstr = MemHandleLock(DuTableHandles[1][i]);
            StrCopy(pathstr,G_dutable[i].path);
            MemHandleUnlock(DuTableHandles[1][i]);

      }
      if (DU_Depth < numRows) {
      		for(i = DU_Depth; i < numRows;i++) {
			TblSetRowUsable(tbl,i,false);
		}
      }
      
	TblRedrawTable(tbl);

}

void AuthRenewalHandler(Word AlmProcCmd,SysAlarmTriggeredParamType *paramP)
{
 

 FormType *frm;
 int authtime;
 UInt32 alarmtime,curtime;

 if ((AlmProcCmd == almProcCmdTriggered) && (authround == 5)) {
 
	GS_SendBytes(G_sockref,G_socketAddr,5,"exit\n");
	Geordi_Disconnect();
        FrmCustomAlert(AlrtAuth,"Authentication Expired ","","");
        authround = 1;
	frm=FrmInitForm(LoginForm);
 	FrmSetActiveForm(frm);
	FrmGotoForm(LoginForm);
 } else {
         authtime = authlimit - authround;
	 authround++;
	 curtime = TimGetSeconds();
	alarmtime = curtime+60;
        G_TimerGraphLength -= 32;
  	Geordi_UpdateTimer();	
	AlmSetProcAlarm(AuthRenewalHandler,0,alarmtime);
   }	 
         	

}

static Boolean MainFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    int ProcTblRow,ProcTblCol=0; 
    int results = 0;
    UInt32 curtime,authtime=0;
    TableType *ProcTable;
    


    switch (e->eType) {
    case frmOpenEvent:
   
  	Geordi_UpdateTimer();	
	frm = FrmGetActiveForm();
        Init_psTable(frm);	
	curtime = TimGetSeconds();
	authtime = curtime+60;
	AlmSetProcAlarm(AuthRenewalHandler,0,authtime);
	results = Geordi_DoPSCmd();
	FrmDrawForm(frm);
  	Geordi_UpdateTimer();	
	handled = true;
	break;
  
    case ctlSelectEvent:
	switch(e->data.ctlSelect.controlID) {
         
	   case PBtnBuild:
		FrmGotoForm(PaletteForm);
		handled = true;
		break;
	   case PBtnDsk:
		G_DskNeedsRefresh = true;
		FrmGotoForm(DskForm);
		handled = true;
		break;	
	   case PBtnLog:
		FrmPopupForm(LogSelectForm);
		handled = true;
		break;
	   case PBtnCli:
		FrmPopupForm(CliForm);
		handled = true;
		break;
	   case PBtnFind:
		FrmGotoForm(FindForm);
		handled = true;
		break; 
	   case BtnRefresh:
		/*GS_SendCommand("\n"); */
		results = Geordi_DoPSCmd();
		break;
	   case BtnFilter:
		FrmPopupForm(FilterForm);
		handled = true;
		break;
	   case BtnDone:
		Geordi_Disconnect();
		frm=FrmInitForm(LoginForm);
        	FrmSetActiveForm(frm);
        	FrmGotoForm(LoginForm);
		break;

	}
	break;
     
    case popSelectEvent:
		FrmPopupForm(CocktailActForm);
		handled = true;
		break; 

    case tblSelectEvent:
	ProcTblRow = e->data.tblSelect.row;
	ProcTblCol = e->data.tblSelect.column;
        frm=FrmGetActiveForm();
	ProcTable = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblProcTable));
	
	if (ProcTblCol == 0) {
		StrCopy(PT_SelectedUname,G_pstable[ProcTblRow].user);
		FrmPopupForm(UIDForm);
	}
        if (ProcTblCol == 1) {
		StrCopy(PT_SelectedPID,G_pstable[ProcTblRow].pid);
		StrCopy(PT_SelectedUname,G_pstable[ProcTblRow].user);
		StrCopy(PT_SelectedCMD,G_pstable[ProcTblRow].cmd);
		FrmPopupForm(SignalForm);
        }

        if (ProcTblCol == 4) {
		StrCopy(PT_SelectedPID,G_pstable[ProcTblRow].pid);
		StrCopy(PT_SelectedCMD,G_pstable[ProcTblRow].cmd);
                FrmPopupForm(CommandForm); 
	}
	break;    
    
    default:
        break;
    }

    return handled;
}

static Boolean ApplicationHandleEvent(EventPtr e)
{
    FormPtr frm;
    Word    formId;
    Boolean handled = false;

    if (e->eType == frmLoadEvent) {
	formId = e->data.frmLoad.formID;
	frm = FrmInitForm(formId);
	FrmSetActiveForm(frm);
       	
	switch(formId) {
	case LoginForm:
	    FrmSetEventHandler(frm,LoginFormHandleEvent);
	    FrmSetTitle(frm,"Geordi:Login");
	    break;
	case MainForm:
	    FrmSetEventHandler(frm, MainFormHandleEvent);
	    break;
        case SignalForm:
	    FrmSetEventHandler(frm,SignalFormHandleEvent);
            FrmSetTitle(frm,"Process Control");
            break;
        case PaletteForm:
	    FrmSetEventHandler(frm,PaletteFormHandleEvent);
            FrmSetTitle(frm,"Geordi:Command Builder");
            break;

	case CommandForm:
	    FrmSetEventHandler(frm,CommandFormHandleEvent);
	    FrmSetTitle(frm,"Command Text");
	    break;	
	case CocktailActForm: 
	    FrmSetEventHandler(frm,CocktailActFormHandleEvent);
	    FrmSetTitle(frm,"Choose and Perish");
	    break;
	case DskForm:
	    FrmSetEventHandler(frm,DskFormHandleEvent);
	    FrmSetTitle(frm,"Geordi:Mounted Volumes");
	    break;
	case DskDetailsForm:
	    FrmSetEventHandler(frm,DskDetailsFormHandleEvent);
	    FrmSetTitle(frm,"Volume Details");
	    break;
	case DskDuForm:
	    FrmSetEventHandler(frm,DskDuFormHandleEvent);
	    FrmSetTitle(frm,"Disk Usage");
	    break;
	case DskDuSelectForm:
	    FrmSetEventHandler(frm,DskDuSelectFormHandleEvent);
	    FrmSetTitle(frm,"Set du(1) Parameters");
	    break;
	case FilterForm:
	    FrmSetEventHandler(frm,FilterFormHandleEvent);
	    FrmSetTitle(frm,"Process Table Filters");
	    break;
	case LogForm:
	    FrmSetEventHandler(frm,LogFormHandleEvent);
	    FrmSetTitle(frm,"Log Contents               ");
	    break;
	case LogSelectForm:
	    FrmSetEventHandler(frm,LogSelectFormHandleEvent);
	    FrmSetTitle(frm,"Select Log To View         ");
	    break;
	case CliForm:
	    FrmSetEventHandler(frm,CliFormHandleEvent);
	    FrmSetTitle(frm,"Enter command to execute");
	    break;
	case UIDForm:
	    FrmSetEventHandler(frm,UIDFormHandleEvent);
	    FrmSetTitle(frm,"User Details");
	    break;
	case BuilderSaveForm:
	    FrmSetEventHandler(frm,BuilderSaveFormHandleEvent);
	    FrmSetTitle(frm,"Save Builder Contents");
	    break;
	case FindForm:
	    FrmSetEventHandler(frm,FindFormHandleEvent);
	    FrmSetTitle(frm,"Find File");
	    break;


	}
	handled = true;
    }

    return handled;
}

/* Get preferences, open (or create) app database */
static Word StartApplication(void)
{
    int i;    
    Char uidtxt[10];
    Char pidtxt[6];
    Char memtxt[6];
    Char cputxt[6];
    Char cmdtxt[41]; 

  

   StrCopy(G_NetServAddrStr,"192.168.1.20");
   G_NetServPortnum=23;
    /*Geordi_ModemCtrl(1); */
 
   G_promptchar = '$';


     for(i=0; i < 10;i++) {
		 
	Char *UIDstr;
	Char *PIDstr;
	Char *Memstr;
	Char *CPUstr;
	Char *Cmdstr;
     
        Char *volstr;
	Char *sizestr;
	Char *pctstr;
	
	Char *du_sizestr;
	Char *du_pathstr;

 	StrPrintF(uidtxt,"%s",G_pstable[i].user);
        StrPrintF(pidtxt,"%s",G_pstable[i].pid);
        StrPrintF(memtxt,"%s",G_pstable[i].mem);
        StrPrintF(cputxt,"%s",G_pstable[i].cpu);
        StrPrintF(cmdtxt,"%s",G_pstable[i].cmd);
 
        ProcTableHandles[0][i] = MemHandleNew(StrLen(G_pstable[i].user)+1);
	UIDstr = MemHandleLock(ProcTableHandles[0][i]);
	StrCopy(UIDstr,G_pstable[i].user);
	MemHandleUnlock(ProcTableHandles[0][i]);

        ProcTableHandles[1][i] = MemHandleNew(StrLen(G_pstable[i].pid)+1);
	PIDstr = MemHandleLock(ProcTableHandles[1][i]);
	StrCopy(PIDstr,G_pstable[i].pid);
	MemHandleUnlock(ProcTableHandles[1][i]);

        ProcTableHandles[2][i] = MemHandleNew(StrLen(G_pstable[i].mem)+1);
	Memstr = MemHandleLock(ProcTableHandles[2][i]);
	StrCopy(Memstr,G_pstable[i].mem);
	MemHandleUnlock(ProcTableHandles[2][i]);

        ProcTableHandles[3][i] = MemHandleNew(StrLen(G_pstable[i].cpu)+1);
	CPUstr = MemHandleLock(ProcTableHandles[3][i]);
	StrCopy(CPUstr,G_pstable[i].cpu);
	MemHandleUnlock(ProcTableHandles[3][i]);

        ProcTableHandles[4][i] = MemHandleNew(StrLen(G_pstable[i].cmd)+1);
	Cmdstr = MemHandleLock(ProcTableHandles[4][i]);
	StrCopy(Cmdstr,G_pstable[i].cmd);
	MemHandleUnlock(ProcTableHandles[4][i]);
 
        DiskTableHandles[0][i] = MemHandleNew(StrLen(G_dftable[i].volname)+1);
	volstr = MemHandleLock(DiskTableHandles[0][i]);
	StrCopy(volstr,G_dftable[i].volname);
	MemHandleUnlock(DiskTableHandles[0][i]);

        DiskTableHandles[1][i] = MemHandleNew(StrLen(G_dftable[i].size)+1);
	sizestr = MemHandleLock(DiskTableHandles[1][i]);
	StrCopy(sizestr,G_dftable[i].size);
	MemHandleUnlock(DiskTableHandles[1][i]);

        DiskTableHandles[2][i] = MemHandleNew(StrLen(G_dftable[i].percent)+1);
	pctstr = MemHandleLock(DiskTableHandles[2][i]);
	StrCopy(pctstr,G_dftable[i].percent);
	MemHandleUnlock(DiskTableHandles[2][i]);

	DuTableHandles[0][i] = MemHandleNew(StrLen(G_dutable[i].size)+1);
	du_sizestr = MemHandleLock(DuTableHandles[0][i]);
	StrCopy(du_sizestr,G_dutable[i].size);
	MemHandleUnlock(DuTableHandles[0][i]);
	
	DuTableHandles[1][i] = MemHandleNew(StrLen(G_dutable[i].path)+1);
	du_pathstr = MemHandleLock(DuTableHandles[1][i]);
	StrCopy(du_pathstr,G_dutable[i].size);
	MemHandleUnlock(DuTableHandles[1][i]);
 
      }
 
      WinScreenMode(winScreenModeGetSupportsColor,NULL,NULL,NULL,&IsColorDevice);
       if (IsColorDevice == true) {
		WinScreenMode(winScreenModeSet,NULL,NULL,G_ScreenDepth,NULL);
       }
	else {
		G_ScreenDepth = 1;
		WinScreenMode(winScreenModeSet,NULL,NULL,G_ScreenDepth,NULL);
	}

    return 0;
}

/* Save preferences, close forms, close app database */
static void StopApplication(void)
{
 Err err;

	AlmSetProcAlarm(AuthRenewalHandler,0,0);
	err = NetLibClose(AppNetRefnum,true);

    FrmSaveAllForms();
    FrmCloseAllForms();
}

/* The main event loop */
static void EventLoop(void)
{
    Word err;
    EventType e;

    do {
	EvtGetEvent(&e, evtWaitForever);
	if (! SysHandleEvent (&e))
	    if (! MenuHandleEvent (NULL, &e, &err))
		if (! ApplicationHandleEvent (&e))
		    FrmDispatchEvent (&e);
    } while (e.eType != appStopEvent);
}

/* Main entry point; it is unlikely you will need to change this except to
   handle other launch command codes */
UInt32 PilotMain(UInt16 launchCode, MemPtr cmdPBP, UInt16 launchFlags)
{
    Err err;
 if (launchCode == sysAppLaunchCmdNormalLaunch) {

        err = StartApplication();
        if (err) return err;

        FrmGotoForm(LoginForm);
        EventLoop();
        StopApplication();

    } else {
        return sysErrParamErr;
    }

    return 0;
	
}

