#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

extern void PalmOS_printf(char * pszFormat, ...);
extern int PopulateBtn(UInt16 BtnID,int TrkIndex);
extern int PopulateBtnTrack(FormType *frm,UInt16 PBtnIndex, UInt16 TrkDBIndex);

Boolean PaletteFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormType *frm;
    DmOpenRef TrkDB;
    BuildCmdObject *bcoptr;
    bcoDB_hdr	   *hdrptr;
    int TrkDBIndex = 0;
    int PBtnIndex = 2411;
    int numtracks = 0;
    int totalrecs = 0;
    int navtrk_numrecs = 0;
    int admtrk_numrecs = 0;
    int nettrk_numrecs = 0;

    MemHandle cmdtrackH;
    MemHandle db_hdrH;
    extern Char CBCmds[30][10];  
    extern int G_MaxCmdBtn;
    extern int G_TrackPos;
    extern UInt16 G_PrevForm;
 
    switch (e->eType) {
    case frmOpenEvent:

        frm = FrmGetActiveForm();

    TrkDB=DmOpenDatabaseByTypeCreator(TrkDBType,TrkDBCreatorID,dmModeReadWrite|dmModeExclusive);
     if(!TrkDB) {
              FrmCustomAlert(AlrtCrit,"Unable to create scratch DB! Quit GEORDI and
restart","","");
              return DmGetLastErr();
     } else {
        
             db_hdrH = DmQueryRecord(TrkDB,TrkDBIndex);
	     hdrptr = MemHandleLock(db_hdrH);
	     numtracks = hdrptr->numtracks;
	     totalrecs = hdrptr->db_numrecs;
	     navtrk_numrecs = hdrptr->track_numrecs[0];
	     admtrk_numrecs = hdrptr->track_numrecs[1];
	     nettrk_numrecs = hdrptr->track_numrecs[2];
	     MemHandleUnlock(db_hdrH);
 
       for (TrkDBIndex =0; TrkDBIndex < 29;TrkDBIndex++) {
        cmdtrackH = DmQueryRecord(TrkDB,TrkDBIndex);
        bcoptr = MemHandleLock(cmdtrackH);
        StrCopy(CBCmds[TrkDBIndex],bcoptr->CmdText);
	
        MemHandleUnlock(cmdtrackH);
       }
        DmCloseDatabase(TrkDB);
        TrkDBIndex = 0;

	G_MaxCmdBtn=(PopulateBtnTrack(frm,PBtnIndex,1))+GrpCMDPush;
        PalmOS_printf("G_MaxCmdBtn=%d", G_MaxCmdBtn); 
        FrmSetControlGroupSelection(frm,GrpCMDPush,PBtnCBCmd1);
        FrmSetControlGroupSelection(frm,GrpSYMPush,PBtnCBSym1);
        FrmSetControlGroupSelection(frm,GrpOPTPush,PBtnCBOpt9);
        FrmDrawForm(frm);

      }  
        handled = true;
        break;
    case menuEvent:
        MenuEraseStatus(NULL);

        switch(e->data.menu.itemID) {
        }

        handled = true;
        break;
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

        case BtnCBCan:
	         FrmGotoForm(G_PrevForm);
       		 handled = true;
       		 break;
	
	case BtnCBSave:
		FrmPopupForm(BuilderSaveForm);
		handled = true;
		break;

	case LeftCBCmdArr:
		PopulateBtnTrack(frm,PBtnIndex,G_TrackPos--);
		handled = true;
		break;
	case RightCBCmdArr:
		PopulateBtnTrack(frm,PBtnIndex,G_TrackPos++);
		handled = true; 
		break;
        }

        handled = true;
        break;
    case tblSelectEvent:
	handled = true;
	break;
    default:
        break;
    }

    return handled;
}

Boolean BuilderSaveFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormType *frm;
    DmOpenRef TrkDB;
    
    extern UInt16 G_PrevForm;
 
    switch (e->eType) {
    case frmOpenEvent:

        frm = FrmGetActiveForm();
	FrmDrawForm(frm);
        handled = true;
        break;
    case menuEvent:
        MenuEraseStatus(NULL);

        switch(e->data.menu.itemID) {
        }

        handled = true;
        break;
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

        case BtnCBSaveCan:
	         FrmReturnToForm(PaletteForm);
       		 handled = true;
       		 break;
	
	case BtnCBSaveOk:
		handled = true;
		break;
	
	default:
		handled = true;
		break; 
        }

        handled = true;
        break;
    default:
        break;
    }

    return handled;
}
