#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

extern void Init_dfTable(FormType *frm);
extern void Init_duTable(FormType *frm);
extern Int16 Geordi_DoDF();
extern void PopulateField(Char *NewFldText, Int16 FieldID);
extern Int16 Geordi_DoDU(Char *DuCmdStr,Int32 numlines);
extern UInt16 GS_SendCommand(Char *CmdStr);
extern void PalmOS_printf(char * pszFormat, ...);
extern void Geordi_DrawProgress(Char *msg);
extern void Geordi_EraseProgress();
extern void Geordi_UpdateTimer();

Boolean DskFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    TableType *DskTable;
    int DskTblRow,DskTblCol=0;
    int results;
    extern int G_DskRow;
    extern Char DF_SelectedVolName[40];
    extern dfentry G_dftable[10];
    extern Boolean G_DskNeedsRefresh;    

  switch (e->eType) {
    case frmOpenEvent:
	Geordi_UpdateTimer();
        frm = FrmGetActiveForm();
        if (G_DskNeedsRefresh == true) {
		Init_dfTable(frm);
        	results=Geordi_DoDF();	
		G_DskNeedsRefresh = false;
	} else {
		Geordi_DfTableUpdate();
	       }
	
	DskTable = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDfTable));
	TblRedrawTable(DskTable);
        FrmDrawForm(frm);
	Geordi_UpdateTimer();
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDskCan:
                FrmGotoForm(MainForm);
                handled = true;
                break;
	   case BtnDskMnt:
		IsMountRequest = true;
		FrmGotoForm(DskDetailsForm);
		G_DskNeedsRefresh = true;
		handled = true;
		break;
	   case BtnDskRefresh:
		Init_dfTable(frm);
		results = Geordi_DoDF();
		Geordi_DfTableUpdate();
		handled = true;
		break;
        }
	break;
    case tblSelectEvent:
	DskTblRow = e->data.tblSelect.row;
	DskTblCol = e->data.tblSelect.column;
	G_DskRow = DskTblRow;
	frm=FrmGetActiveForm();	
	DskTable = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDfTable));

	switch(DskTblCol) {
	
		case 0:
			IsMountRequest = false;
			FrmGotoForm(DskDetailsForm);
			G_DskNeedsRefresh = true;
			break;
		case 1:
		case 2:
			StrCopy(DF_SelectedVolName,G_dftable[G_DskRow].volname);
			FrmPopupForm(DskDuSelectForm);
			break;
		default:
			break;
	}
	break;

    default:
        break;
    }

    return handled;
}

Boolean DskDetailsFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    extern UInt16 G_DskRow;
    extern dfentry G_dftable[10];
    FieldType *DevFldPtr,*MntPtFldPtr;
    ListType *LstFsTypePtr;
    ControlType *CtlOptPtr;
    Char DtlCmd[80];
    Char *DevText;
    Char *MntPtText;
    Char *FSTypeText;
    Char MntOpt1[2];
    Char MntOpt2[2];
    Char MntOpt3[2];
    UInt16 SelectedOptCtl;
    UInt16 SelectedOptIndex;
    
    int optcount= 0;    

    Word FSSelection;

    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
	if (IsMountRequest == false) {
        	 PopulateField(G_dftable[G_DskRow].device,FldMntDev);
        	 
		 PopulateField(G_dftable[G_DskRow].volname,FldMntPt);
	
       		 PopulateField(G_dftable[G_DskRow].size,FldMntSize);

        	 PopulateField(G_dftable[G_DskRow].used,FldMntUsed);
	
		 PopulateField(G_dftable[G_DskRow].avail,FldMntAvail);
	
         	 PopulateField(G_dftable[G_DskRow].percent,FldMntPct);
	}
 
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDtlCan:
                FrmGotoForm(DskForm);
                handled = true;
                break;
	   case BtnDtlEject:
		StrPrintF(DtlCmd,"%s %s\n","eject -v ",G_dftable[G_DskRow].device);
		GS_SendCommand(DtlCmd);
		break;
	   case BtnDtlMnt:
/*They want to mount something. Collect info from the various UI objects  */
/*Check to see if at least the device and mountpoint fields are filled in */

		frm = FrmGetActiveForm();
		DevFldPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntDev));
		MntPtFldPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntPt));

		if ((FldGetTextLength(DevFldPtr) > 1) && (FldGetTextLength(MntPtFldPtr) > 1) ){
	 		LstFSTypePtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldMntDev));
			FSSelection = LstGetSelection(LstFSTypePtr);
			FSTypeText = LstGetSelectionText(LstFSTypePtr,FSSelection);
		
			OptGrp1 = FrmGetControlGroupSelection(frm,0);
			OptGrp2 = FrmGetControlGroupSelection(frm,1);
			OptGrp3 = FrmGetControlGroupSelection(frm,2);
			
 			StrPrintF(DtlCmd,"mount -t %s ",FSTypeText);
			if (OptGrp1 != frmNoSelectedControl) {
				CtlOptPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,OptGrp1);
				StrCopy(MntOpt1,(CtlGetLabel(CtlOptPtr));
				optcount++;
				StrCat(DtlCmd,"-o ");
				StrCat(DtlCmd,MntOpt1);
			}
			if (OptGrp2 != frmNoSelectedControl) {
				CtlOptPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,OptGrp2);
				StrCopy(MntOpt2,(CtlGetLabel(CtlOptPtr));
				optcount++;
				StrCat(DtlCmd,MntOpt2);
				if(optcount > 1) {
					StrCat(DtlCmd,",");
				}
				StrCat(DtlCmd,MntOpt2);
			}
			if (OptGrp3 != frmNoSelectedControl) {
				CtlOptPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,OptGrp3);
				StrCopy(MntOpt3,(CtlGetLabel(CtlOptPtr));
				optcount++;
				if(optcount > 1) {
					StrCat(DtlCmd,",");
				}
				StrCat(DtlCmd,MntOpt3);
			}
			
			if ((StrCompare(FSTypeText,"nfs")==NULL) && (optcount >1)) {
				FrmCustomAlert(AlrtBadEntry,"Can't apply NFS options to a non-NFS file system");
			handled= true;
			break;
			}
			StrCat(DtlCmd,DevFldPtr);
			StrCat(DtlCmd," ");
			StrCat(DtlCmd,MntPtFldPtr);
			StrCat(DtlCmd,"\n");

		} else {
			FrmCustomAlert(AlrtMissingField,"Missing device name and/or mountpoint","","");
			handled = true;
			break;
		}
		GS_SendCommand(DtlCmd);
		handled = true;
		break;
        }
	break;
    default:
        break;
    }
    return handled;
 }

Boolean DskDuSelectFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    ListPtr LstDUSizePtr;
    ListPtr LstDUAdjPtr;
    ListPtr LstDUAorSPtr;
    FieldPtr FldDUPathPtr;
    Char*   CurSelPtr;
    Char*   DUPathPtr;
    Char    title[60]; 
    Word LstItem;
    Char *DtlCmd;

    extern Char DF_SelectedVolName[40];
    extern Char DU_VolTitle[60];
    extern Int32 DU_Depth;

    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
	PopulateField(DF_SelectedVolName,FldDUPath);
        StrPrintF(title,"Disk Usage on %s",DF_SelectedVolName);
	FrmSetTitle(frm,title);
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDuSelCan:
                FrmReturnToForm(DskForm);
                handled = true;
                break;
	   case BtnDuSelOK:
		DtlCmd = MemPtrNew(80);
		StrCopy(DtlCmd, "sudo du -");
		frm = FrmGetActiveForm();
		LstDUAorSPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUas));
		LstItem = LstGetSelection(LstDUAorSPtr);
		CurSelPtr = LstGetSelectionText(LstDUAorSPtr,LstItem);
		if( (StrCompare(CurSelPtr,"all")) ==0 ) {
			StrCat(DtlCmd,"a");
		} else {
			StrCat(DtlCmd,"s");
		}
/*
		LstDUTypePtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUType));
		LstItem = LstGetSelection(LstDUTypePtr);
		CurSelPtr = LstGetSelectionText(LstDUTypePtr,LstItem);
		if ((StrCompare(CurSelPtr,"local")) == 0) {
			StrCat(DtlCmd,"l");
		}
*/
		StrCat(DtlCmd,"k "); 
	
		FldDUPathPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldDUPath));	
		DUPathPtr = FldGetTextPtr(FldDUPathPtr);
		StrCat(DtlCmd,DUPathPtr);	 			
	 	StrCat(DtlCmd," |sort -n -r|");
	
		LstDUAdjPtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDULgSm));
		LstItem = LstGetSelection(LstDUAdjPtr);
		CurSelPtr = LstGetSelectionText(LstDUAdjPtr,LstItem);
		if ((StrCompare(CurSelPtr,"largest")) == 0) {
			StrCat(DtlCmd,"head -");
		} else {
			StrCat(DtlCmd,"tail -");
		}
		
		LstDUSizePtr = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,LstDUSize));
		LstItem = LstGetSelection(LstDUSizePtr);
		CurSelPtr = LstGetSelectionText(LstDUSizePtr,LstItem);
		DU_Depth = StrAToI(CurSelPtr);
		StrCat(DtlCmd,CurSelPtr);
		StrCat(DtlCmd,"\n");

		StrPrintF(DU_VolTitle,"%s %s files in %s",CurSelPtr,LstDUSizePtr,DUPathPtr);
		frm = FrmGetActiveForm();
	
		FrmReturnToForm(DskForm);
		Geordi_DrawProgress("Looking...");
		Geordi_DoDU(DtlCmd,StrAToI(CurSelPtr));
		Geordi_EraseProgress();
	  	FrmGotoForm(DskDuForm);	
		MemPtrFree(DtlCmd);
		break;
	   default:
		break;
        }
	break;
    default:
        break;
    }

    return handled;
}

Boolean DskDuFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormType *frm;

    extern Char DU_VolTitle[60];
	    
    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
	Init_duTable(frm);
	Geordi_DuTableUpdate();
	FrmSetTitle(frm,DU_VolTitle);
        FrmDrawForm(frm);
        handled = true;
        break;
 
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnDuOK:
                FrmGotoForm(DskForm);
                handled = true;
                break;
	   default:
		break;
        }
	break;
    default:
        break;
    }

    return handled;
}
