#include <PalmOS.h> 
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

int Geordi_Login(ssh_prefs sess_prefs); 
extern int Geordi_ConnectMgr(ssh_prefs sess_prefs);
extern void Geordi_DrawProgress(Char *msg);


void SetLoginLabel(Char *LogLabel)
{
 FormType *frm;
 ControlPtr LogBtn;
 Char *LogBtnLabel;

	 frm = FrmGetActiveForm(); 
	 LogBtn = (ControlPtr)FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,BtnLog));
         LogBtnLabel = CtlGetLabel(LogBtn);
         StrCopy(LogBtnLabel,LogLabel);
         CtlSetLabel(LogBtn,LogBtnLabel);
}


Boolean LoginFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    Boolean stoppable = false;
    FormPtr frm;
    FieldType *hostP;
    FieldType *userP;
    FieldType *passP;
    ControlType *CtlFuzz;
    extern Char *HostTxt;
    extern Char *UnameTxt; 
    extern Char *PassTxt;
    extern ssh_prefs G_sshprefs;
    extern UInt16 G_PrevForm;

    
    switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
        passP=FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldPass));
        FldSetFont(passP,5);

        FrmDrawForm(frm);
        handled = true;
        break;
  
    case menuEvent:
        MenuEraseStatus(NULL);

	FrmGotoForm(AboutForm);
	handled = true;
	break;

    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {

           case BtnLog:
		if (stoppable == true) {
			Geordi_DrawProgress("Cancelling...");
			Geordi_Disconnect();
			stoppable = false;
			SetLoginLabel("Login");
		}
		if (stoppable == false) {
			stoppable = true;
			frm = FrmGetActiveForm();
			SetLoginLabel("Cancel");
		}
		
                frm = FrmGetActiveForm();
                hostP= FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldHost));
                userP= FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldUname));
                passP= FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldPass));
           if((HostTxt=FldGetTextPtr(hostP))==NULL ) {
              FrmCustomAlert(AlrtLogin,"No Hostname","","");
			SetLoginLabel("Login");
              break;
           }
           if((UnameTxt=FldGetTextPtr(userP))==NULL ) {
              FrmCustomAlert(AlrtLogin,"No Username","","");
			SetLoginLabel("Login");
              break;
           }
           if((PassTxt=FldGetTextPtr(passP))==NULL ) {
              FrmCustomAlert(AlrtLogin,"Empty Passphrase","","");
			SetLoginLabel("Login");
              break;
           }
           else {
		 G_sshprefs.host = MemPtrNew(StrLen(HostTxt));
		 G_sshprefs.username = MemPtrNew(StrLen(UnameTxt));
		 G_sshprefs.password = MemPtrNew(StrLen(PassTxt));
		 		  		 		 
 		 if(Geordi_Login(G_sshprefs) != -1) {
			 FrmGotoForm(MainForm);
		 } else {
              		 FrmCustomAlert(AlrtLogin,"Login Failure","","");
			 Geordi_Disconnect();
			 SetLoginLabel("Login");
		 }

           }
                handled = true;
               break;
	case BtnLogBld:
		G_PrevForm = LoginForm;
		FrmGotoForm(PaletteForm);
		handled = true;
	       break;

    case CBxFuzzPass:
                frm = FrmGetActiveForm();
                CtlFuzz = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,CBxFuzzPass));
                passP=FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,FldPass));
                if(CtlGetValue(CtlFuzz) != 0 ) {
                   FldSetFont(passP,5);
		   FrmDrawForm(frm); 
                } else {
                   FldSetFont(passP,0);
		   FrmDrawForm(frm); 
                }
                break;
 
	}
        break;
    
    default:
        break;
    }

    return handled;
}

int Geordi_Login(ssh_prefs sess_prefs) 
{
 extern Boolean IsConnected; 
 int result = 0;
	
	if(!IsConnected) {
		result=Geordi_ConnectMgr(sess_prefs);
	}
	
  return result;
}
