#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "geordi.h"
#include "geordi_ui.h"

extern MemHandle ProcTableHandles[5][10];
extern MemHandle DiskTableHandles[5][10];
extern MemHandle DuTableHandles[2][10];

static Err LoadUID(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset, Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = ProcTableHandles[0][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;

}

static Err LoadPID(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset, Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = ProcTableHandles[1][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

static Err LoadMem(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset, Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = ProcTableHandles[2][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

static Err LoadCPU(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset, Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = ProcTableHandles[3][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

static Err LoadCmd(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset, Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = ProcTableHandles[4][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

static Err LoadVol(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset, Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = DiskTableHandles[0][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

static Err LoadSize(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset, Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = DiskTableHandles[1][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

static Err LoadPct(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset, Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = DiskTableHandles[2][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

static Err LoadDuSize(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset,Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = DuTableHandles[0][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

static Err LoadDuPath(void *table,Int16 row,Int16 column, Boolean editable,MemHandle *dataH,Int16 *dataOffset,Int16 *dataSize, FieldType *field)
{
   editable = false;
   *dataH = DuTableHandles[1][row];
   *dataOffset = 0;
   *dataSize = MemHandleSize(*dataH);
   return 0;
}

void Init_psTable(FormType *frm) {
Int16 numRows;
        Int16 i,j;
        TableType *ps_Table;

        ps_Table = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblProcTable));
        numRows = TblGetNumberOfRows(ps_Table);

        for (i = 0; i < 10; i++) {
           for(j = 0; j < 5;j++) {
            TblSetItemStyle(ps_Table,i,j,textTableItem);
            TblSetColumnEditIndicator(ps_Table,j,false);
           }
        }

        for (i=0;i < numRows;i++) {
            TblSetColumnUsable(ps_Table,i,true);
            TblSetColumnSpacing(ps_Table,i,2);
          for(j=0;j < 5;j++) {
            TblSetItemFont(ps_Table,i,j,0);
          }
            TblSetRowSelectable(ps_Table,i,true);
            TblSetRowUsable(ps_Table,i,true);
        }
            TblSetLoadDataProcedure(ps_Table,0,LoadUID);
            TblSetLoadDataProcedure(ps_Table,1,LoadPID);
            TblSetLoadDataProcedure(ps_Table,2,LoadMem);
            TblSetLoadDataProcedure(ps_Table,3,LoadCPU);
            TblSetLoadDataProcedure(ps_Table,4,LoadCmd);

        FrmDrawForm(frm);
}

void Init_dfTable(FormType *frm) {
Int16 numRows;
        Int16 i,j;
        TableType *df_Table;

        df_Table = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDfTable));
        numRows = TblGetNumberOfRows(df_Table);

        for (i = 0; i < 10; i++) {
           for(j = 0; j < 3;j++) {
            TblSetItemStyle(df_Table,i,j,textTableItem);
            TblSetColumnEditIndicator(df_Table,j,false);
           }
        }

        for (i=0;i < numRows;i++) {
            TblSetColumnUsable(df_Table,i,true);
            TblSetColumnSpacing(df_Table,i,2);
          for(j=0;j < 3;j++) {
            TblSetItemFont(df_Table,i,j,0);
          }
            TblSetRowSelectable(df_Table,i,true);
            TblSetRowUsable(df_Table,i,true);
        }
            TblSetLoadDataProcedure(df_Table,0,LoadVol);
            TblSetLoadDataProcedure(df_Table,1,LoadSize);
            TblSetLoadDataProcedure(df_Table,2,LoadPct);

        FrmDrawForm(frm);
}

void Init_duTable(FormType *frm) {
Int16 numRows;
        Int16 i,j;
        TableType *du_Table;

        du_Table = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,TblDuTable));
        numRows = TblGetNumberOfRows(du_Table);

        for (i = 0; i < 10; i++) {
           for(j = 0; j < 3;j++) {
            TblSetItemStyle(du_Table,i,j,textTableItem);
            TblSetColumnEditIndicator(du_Table,j,false);
           }
        }

        for (i=0;i < numRows;i++) {
            TblSetColumnUsable(du_Table,i,true);
            TblSetColumnSpacing(du_Table,i,2);
          for(j=0;j < 3;j++) {
            TblSetItemFont(du_Table,i,j,0);
          }
            TblSetRowSelectable(du_Table,i,true);
            TblSetRowUsable(du_Table,i,true);
        }
            TblSetLoadDataProcedure(du_Table,0,LoadDuSize);
            TblSetLoadDataProcedure(du_Table,1,LoadDuPath);

        FrmDrawForm(frm);
}
