/*
 * Structures to hold the various preferences and saved state for GutenPalm
 */

#ifndef GUTENPALM_BOOKMARKS_H
#define GUTENPALM_BOOKMARKS_H

#include <PalmOS.h>
#include <PalmTypes.h>


/* Bookmark grouping.  Stores a sequential list of user bookmarks.
 * It also stores the current location in a doc, if that option is set */
/* This is pref collection #2 */
typedef struct GPlmMarkType {
  UInt32      offset;
  Char        title[MAX_BMRK_LENGTH];
} GPlmMark;


/* Name of the bookmark used for resuming last location */
#define BMRK_RESUME     "__CURRENT_POS__"


/* Functions for using/manipulating bookmarks */
extern void     bmrkAdd(Char *, UInt32);
extern void     bmrkDeleteMark(Char *);


#endif
