/*
 * Structures to hold and manage the document cache
 */

#ifndef GUTENPALM_CACHE_H
#define GUTENPALM_CACHE_H

#include <PalmOS.h>
#include <PalmTypes.h>


/* zTXT uncompressed cache DB listing */
/* This is pref collection #1         */
typedef struct GPlmCacheStateType {
  Char          cache[dmDBNameLength];  /* Uncompressed text database      */
  Char          zTxtDB[dmDBNameLength]; /* If these two match then         */
} GPlmCacheState;


/* number of the cache preferences */
#define PREFS_CACHE     1

/* Functions to work with the cache list */
extern Boolean  cacheExists(Char *);
extern Char *   cacheGet(Char *);
extern void     cacheAdd(Char *, Char *);
extern void     cacheDelete(Char *);
extern void     cacheClear(void);


/* Global cache variable */
extern GPlmCacheState   *gCache;


#endif
