/*
 * Structures to hold the various preferences and saved state for GutenPalm
 */

#ifndef GUTENPALM_PREFS_H
#define GUTENPALM_PREFS_H

#include <PalmOS.h>
#include <PalmTypes.h>


/* Preferences for GutenPalm  */
/* This is pref collection #0 */
typedef struct GPlmPrefsType {
  Boolean       skipLicense;
  Boolean       keepCache;
  Boolean       alwaysRememberPos;
  UInt16        numCachedDBs;
  UInt16        numBMGroups;
  UInt16        bookmarkBytes;
  /* These two entries are for resuming the last read doc */
  Boolean       resume;
  Char          resumeDBName[dmDBNameLength];
} GPlmPrefs;


/* number of the main preferences */
#define PREFS_MAIN      0

/* Global preferences variable */
extern GPlmPrefs        gPrefs;


#endif
