#include <Pilot.h>
#include "iLarnRsc.h"
#include "Globals.h"

/***********************************************************************
 * This form is the "display entire dungeon level, really tiny" form.
 * You tap anywhere on the map form to return to the main form.
 ***********************************************************************/

static void show_dungeon() SEC_4;
Boolean Map_Form_HandleEvent(EventPtr e)
{
  Boolean handled = false;
  FormPtr frm;

  switch (e->eType) {

  case frmOpenEvent:
    frm = FrmGetActiveForm();
    FrmDrawForm(frm);
    /* this must be AFTER draw form */
    show_dungeon();
    handled = true;
    break;

  case penDownEvent:
    LeaveForm(); // LeaveForm(true);
    //    i_used_too_much_heap();
    handled = true;
    break;

  default:
    break;
  }

  return handled;
}



/**********************************************************************
                       SHOW_DUNGEON
 IN:
 sotu = various globals (dungeon, rooms, wizard, cur_level, rogue)
 OUT:
 nothing
 PURPOSE:
 The "real" dungeon is 24 wide x 80 high, and doesn't all fit on the
            ... now:   17,       67. 
 (156^2 pixel) screen at once when it's "full size".  So I have a
 form to display a tiny version of the map (just rooms/mazes/tunnels,
 the rogue, and the stairs), where each square is 2 x 3 pixels.
 Maybe I could put flyspecks for monsters/objects too.  Maybe.
 **********************************************************************/
// Cool, this actually works (code reuse is good)
// I just need to fix it to be centered since it's a different size now.
// (Sadly can't make it any larger unless I try for fractional pixels :)
//static CustomPatternType yourPattern = { 0xaaaa, 0x5555, 0xaaaa, 0x5555 };
// The passage pattern got messed up so I moved it inside.
static void show_dungeon()
{
  RectangleType r;
  //  Word col, row, i, w, h;
  Word col, row;
  Short fudge, fudgetot = 0, x;
  //  UShort mask;
  //  Char c;
  CustomPatternType origPattern;
  CustomPatternType yourPattern = { 0xaaaa, 0x5555, 0xaaaa, 0x5555 };
  //  CustomPatternType myPattern = { 0xffff, 0x0000, 0xffff, 0x0000 };

  RctSetRectangle(&r, 0,0, 160, 160);
  WinDrawRectangle(&r, 6);

  /* This is just some fluff to put in the extra space above and below. 
     I could probably think of some more-useful fluff to put there. */
  WinDrawInvertedChars("You Can't Get There From Here", 29, 15, 1);
  WinDrawInvertedChars("(Tap  Anywhere  When  Done)", 27, 22, 147);
  /* This is just some decoration. */
  WinEraseLine(8, 34, 148, 34);
  WinEraseLine(6, 36, 150, 36);
  WinEraseLine(4, 38, 152, 38);
  /* Each tile gets 2 pixels/col and 3 pixels/row. */
  RctSetRectangle(&r, 0,42, 160,72); /* left,top, width,height */
  //  WinEraseRectangle(&r, 0);
  WinDrawRectangleFrame(simpleFrame, &r); /* simple,round,popup,boldRound */

  /* Draw each cell in the dungeon.  Could perhaps be more clever */
  WinGetPattern(origPattern);
  for (col = 0; col < MAXX; col++) {
    fudge = (col % 3) ? 2 : 3; // this factor was always 2 for iRogue
    for (row = 0; row < MAXY; row++) {
      //      RctSetRectangle(&r, fudgetot, row*3 + 42, fudge, 3);
      RctSetRectangle(&r, fudgetot, row*3 + 42, fudge, 3);
      //      if (wizard_p || env->know[col][row]) {
      if (env->know[col][row]) {
	switch (env->item[col][row]) {
	case OWALL:
	  //	  WinGetPattern(origPattern);
	  //	  WinSetPattern(yourPattern);
	  //	  WinFillRectangle(&r, 0);
	  //	  WinSetPattern(origPattern);
	  //	WinFillRectangle(&r, 0);
	  if (col == env->playerx && row == env->playery)
	    WinEraseRectangle(&r, 0); // in case you're wall walking
	  // Does that actually work?  I haven't been paying attention.
	  break;
	case OSTAIRSUP:
	case OVOLUP:
	case OSTAIRSDOWN:
	  x = fudgetot-2;
	  x = max(0,min(x,160-2));
	  if (env->item[col][row] == OSTAIRSDOWN)
	    WinDrawInvertedChars("d", 1, x, 101);
	  else 
	    WinDrawInvertedChars("u", 1, x, 93);
	  WinSetPattern(yourPattern);
	  WinFillRectangle(&r, 0);
	  break;
	default:
	  WinEraseRectangle(&r, 0);
	  break;
	}
	if (col == env->playerx && row == env->playery) {
	  WinSetPattern(yourPattern);
	  //	    WinSetPattern(myPattern);
	  WinFillRectangle(&r, 0);
	  //	    WinDrawRectangleFrame(simpleFrame, &r);
	  // This is what draws the arrow:
	  RctSetRectangle(&r, fudgetot, 114, 3, 20);
	  WinEraseRectangle(&r,0);
	  RctSetRectangle(&r, fudgetot-1, 117, 5, 3);
	  WinEraseRectangle(&r,0);
	  RctSetRectangle(&r, fudgetot+1, 111, 1, 3);
	  WinEraseRectangle(&r,0);
	}
      } else {
	WinSetPattern(origPattern);
	WinFillRectangle(&r, 0);
      }
    } // end for row
    fudgetot += fudge;
  }
  WinSetPattern(origPattern);
  /* don't forget to put the player somewhere */

  // hm, maybe I could use GRAYSCALE.
  return;
}
