#include "h:\projects\c\pilotdb\pilotdb.h"

//---------------------------------------------------------------------------
// Reverse byte orders on longs (32 bits)
long htonl (long motorola)
{
  char *cp1;
  char *cp2;
  long lv;

  cp1 = (char *)&motorola;
  cp2 = (char *)&lv;

  cp2[0] = cp1[3];
  cp2[1] = cp1[2];
  cp2[2] = cp1[1];
  cp2[3] = cp1[0];

  return lv;
}

//---------------------------------------------------------------------------
// Reverse byte orders on ints (16 bits)
int htons (int motorola)
{
  char *cp1;
  char *cp2;
  int iv;

  cp1 = (char *)&motorola;
  cp2 = (char *)&iv;

  cp2[0] = cp1[1];
  cp2[1] = cp1[0];

  return iv;
}

//---------------------------------------------------------------------------
int pdb_Create (pdb *db, char *creator, char *type, char *name, char *title)
{
  char temp[256];

  // Save info for later
  strcpy (db->name, name);
  strcpy (db->creator, creator);
  strcpy (db->type, type);
  strcpy (db->title, title);
  db->records = 0;

  // Open data block
  strcpy (temp, db->name);
  strcat (temp, ".pd1");
  db->data = fopen (temp, "wb");
  if (db->data == NULL)
    return 0;

  return 1;
}

//---------------------------------------------------------------------------
int pdb_Close (pdb *db)
{
  int b;
  int c;
  char temp[256];
  FILE *outfile;
  unsigned char buff[32];
  unsigned long w, w2;
  unsigned long flags = 0xAE44D106;
  unsigned int  z, z2;
  unsigned char head[4];

  // Get vars ready
  memset (buff, 0, 23);

  // Close temp file
  fclose (db->data);

  // Re-open data block
  strcpy (temp, db->name);
  strcat (temp, ".pd1");
  db->data = fopen (temp, "rb");
  if (db->data == NULL)
    return 0;

  // Create PDB file
  strcpy (temp, db->name);
  strcat (temp, ".pdb");
  outfile = fopen (temp, "wb");
  if (outfile == NULL)
  {
    fclose (db->data);
    return 0;
  }

  // --- Create Header ---

  fwrite (db->title, 32, 1, outfile); // DB Name
  fwrite (buff, 2, 1, outfile);  // Flags
  fwrite (buff, 2, 1, outfile);  // Version

  flags = htonl (flags);
  fwrite (&flags, 4, 1, outfile); // Creation Time
  fwrite (&flags, 4, 1, outfile); // Modificaton Time

  fwrite (buff, 4, 1, outfile); // Backup Time
  fwrite (buff, 4, 1, outfile); // Modification Number
  fwrite (buff, 4, 1, outfile); // App Info Offset
  fwrite (buff, 4, 1, outfile); // Sort Info Offset

  fwrite (db->type, 4, 1, outfile); // Type
  fwrite (db->creator, 4, 1, outfile); // Creator

  fwrite (buff, 4, 1, outfile); // unique ID seed
  fwrite (buff, 4, 1, outfile); // next record list id

  z = db->records;
  z2 = htons (z);
  fwrite (&z2, 2, 1, outfile); // Number of records for this header

  // --- Record Entry Header (8 bytes) ---

  w = 0x50L + (long)z * 8;

  head[0] = 0x40;  // (Record Attributes)
  head[1] = 0x6f;  // (Unique ID)
  head[2] = 0x80;  // (Unique ID)
  head[3] = 0;     // (Unique ID)

  // Write out index for records
  c = 0;
  while (z--)
  {
    w2 = htonl (w);
    fwrite (&w2, 4, 1, outfile);  // Offset
    fwrite (head, 4, 1, outfile); // Record attributes (1) & unique ID (3)
    w += db->sizes[c];
    c++;
    head[3]++;
  }

  // --- End of Headers ---

  head[0] = 0;
  head[1] = 0;
  fwrite (head, 2, 1, outfile); // Unknown

  // Copy data
  while (!feof (db->data))
  {
    b = fgetc (db->data);
    if (!feof (db->data))
      fputc (b, outfile);
  }

  fclose (outfile);

  strcpy (temp, db->name);
  strcat (temp, ".pd1");
  unlink (temp);

  return 1;
}

//---------------------------------------------------------------------------

int pdb_AddRecord (pdb *db, char *buffer, int length)
{
  db->sizes[db->records] = length;
  db->records++;

  fwrite (buffer, length, 1, db->data);

  return 1;
}

//---------------------------------------------------------------------------

int pdb_AddFileAsRecord (pdb *db, char *filename)
{
  int size;
  int r;
  char *buffer;
  FILE *infile;

  infile = fopen (filename, "rb");
  if (infile == NULL)
    return 0;

  fseek (infile, 0, SEEK_END);
  size = (int)ftell (infile);
  fseek (infile, 0, SEEK_SET);

  buffer = (char *)malloc (size);
  if (buffer == NULL)
  {
    fclose (infile);
    return 0;
  }

  fread (buffer, size, 1, infile);

  r = pdb_AddRecord (db, buffer, size);

  free (buffer);
  fclose (infile);

  return r;
}

//---------------------------------------------------------------------------
