/*********************************************************************
 * kMoria - Moria adapted for the PalmPilot.                         *
 * Copyright (C) 2000 Bridget Spitznagel                             *
 *                                                                   *
 * This program is derived from Umoria 5.5.2.  Moria is              *
 *   Copyright (c) 1989-94 James E. Wilson, Robert A. Koeneke        *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License       *
 * as published by the Free Software Foundation; either version 2    *
 * of the License, or (at your option) any later version.            *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along with this program; if not, write to                         *
 * The Free Software Foundation, Inc.,                               *
 * 59 Temple Place - Suite 330,                                      *
 * Boston, MA  02111-1307, USA.                                      *
 *********************************************************************/
#include <Pilot.h>
#include "kMoria.h"
#include "lock-externs.h"
#include "kMoriaRsc.h"

/***********************************************************************
 * This form allows the player to select a letter to genocide...
 *   abcdefghijklmnopqrstuvwxyz   no u, v, x.
 *   ....................  . ..
 *   ABCDEFGHIJKLMNOPQRSTUVWXYZ,$   no I, N, Z.
 *   ........ .... ........... ..
 *
 * abcdefghijklmnopqrstwyz,$ABCDEFGHJKLMOPQRSTUVWXY
 *
 ***********************************************************************/
extern MoriaPreferenceType my_prefs;
static void dalek_init() SEC_6;
static Char dalek_c[48] = "abcdefghijklmnopqrstwyz,ABCDEFGHJKLMOPQRSTUVWXY$";
Boolean Dalek_Form_HandleEvent(EventPtr e)
{
  Boolean handled = false;
  FormPtr frm;
  Short x, y, k;
    
  switch (e->eType) {

  case frmOpenEvent:
    frm = FrmGetActiveForm();
    FrmDrawForm(frm);
    dalek_init();
    handled = true;
    break;

  case penDownEvent:
    x = e->screenX / 20;
    y = (e->screenY - 15) / 20;
    LeaveForm();
    if (x >= 0 && y >= 0 && x < 8 && y < 6) {
      // Translate the cell into dalek_c index.
      k = y * 8 + x;
      // call genocide with appropriate character.
      genocide(dalek_c[k]);
    }
    take_a_turn(true);
    handled = true;
    break;

  default:
    break;
  }
  return handled;
}

static void dalek_init()
{
  Short k, x, y;

  for (y = 15, k = 0 ; y < 15+120 ; y += 20) {
    WinDrawLine(0, y, 160, y);
    for (x = 0 ; x < 160 ; x += 20, k++)
      WinDrawChars(dalek_c+k, 1, x+10-4, y+10-5);
  }
  for (x = 20 ; x < 160 ; x += 20)
    WinDrawLine(x, 15, x, 15+120);

  WinDrawLine(0, 15+120, 160, 15+120);
  WinDrawChars("None", 4, 69, 15+120+10);

}

/*

abcdefgh
ijklmnop
qrstwyz,
ABCDEFGH
JKLMOPQR
STUVWXY$
 -None-
*/
