/*********************************************************************
 * kMoria - Moria adapted for the PalmPilot.                         *
 * Copyright (C) 2000 Bridget Spitznagel                             *
 *                                                                   *
 * This program is derived from Umoria 5.5.2.  Moria is              *
 *   Copyright (c) 1989-94 James E. Wilson, Robert A. Koeneke        *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License       *
 * as published by the Free Software Foundation; either version 2    *
 * of the License, or (at your option) any later version.            *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along with this program; if not, write to                         *
 * The Free Software Foundation, Inc.,                               *
 * 59 Temple Place - Suite 330,                                      *
 * Boston, MA  02111-1307, USA.                                      *
 *********************************************************************/
#include <Pilot.h>
#include "kMoria.h"
#include "lock-externs.h"
#include "kMoriaRsc.h"

/***********************************************************************
 * This form allows the player to bind/unbind actions to hardware buttons
 * It is full of popup lists and stuff.
 * and an ok and a cancel button, as you might expect.
 ***********************************************************************/
extern MoriaPreferenceType my_prefs;
Boolean HwButtons_Form_HandleEvent(EventPtr e)
{
  Boolean handled = false;
  FormPtr frm;
  ListPtr lst;    // popup list
  ControlPtr ctl; // popup trigger
  CharPtr label;
  Short i;
    
  switch (e->eType) {

  case frmOpenEvent:
    frm = FrmGetActiveForm();
    // my stuff
    ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, check_hwb));
    CtlSetValue(ctl, (my_prefs.use_hardware ? 1 : 0));
    //    ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, check_hwb_keyb));
    //    CtlSetValue(ctl, (my_prefs.use_keyboard ? 1 : 0));
    for (i = 0 ; i < 8 ; i++) {
      lst = FrmGetObjectPtr (frm, FrmGetObjectIndex(frm, list_hwb_1 + i));
      ctl = FrmGetObjectPtr (frm, FrmGetObjectIndex(frm, popup_hwb_1 + i));
      LstSetSelection(lst, my_prefs.hardware[i]);
      label = LstGetSelectionText(lst, my_prefs.hardware[i]);
      CtlSetLabel(ctl, label);
    }
    // end my stuff
    FrmDrawForm(frm);
    handled = true;
    break;

    // XXX - I need it to redraw stuff.
  case ctlSelectEvent:
    switch(e->data.ctlSelect.controlID) {
    case btn_hwb_ok:
      frm = FrmGetActiveForm();
      ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, check_hwb));
      my_prefs.use_hardware = (CtlGetValue(ctl) != 0);	
      //   ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, check_hwb_keyb));
      //   my_prefs.use_keyboard = (CtlGetValue(ctl) != 0);	
      for (i = 0 ; i < 8 ; i++) {
	lst = FrmGetObjectPtr (frm, FrmGetObjectIndex(frm, list_hwb_1 + i));
	my_prefs.hardware[i] = LstGetSelection(lst);
      }
      writeMoriaPrefs();
      LeaveForm(); // LeaveForm(true);
      handled = true;
      break;
    case btn_hwb_cancel:
      LeaveForm(); // LeaveForm(true);
      handled = true;
      break;
    }
    break;
  default:
    break;
  }

  return handled;
}
