/*********************************************************************
 * kMoria - Moria adapted for the PalmPilot.                         *
 * Copyright (C) 2000 Bridget Spitznagel                             *
 *                                                                   *
 * This program is derived from Umoria 5.5.2.  Moria is              *
 *   Copyright (c) 1989-94 James E. Wilson, Robert A. Koeneke        *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License       *
 * as published by the Free Software Foundation; either version 2    *
 * of the License, or (at your option) any later version.            *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along with this program; if not, write to                         *
 * The Free Software Foundation, Inc.,                               *
 * 59 Temple Place - Suite 330,                                      *
 * Boston, MA  02111-1307, USA.                                      *
 *********************************************************************/
#include <Pilot.h>
#include "kMoria.h"
#include "lock-externs.h"
#include "kMoriaRsc.h"

extern Short snowcrash;
static void explain_error();

Boolean SnowCrash_Form_HandleEvent(EventPtr e)
{
  Boolean handled = false;
  FormPtr frm;

  switch (e->eType) {

  case frmOpenEvent:
    frm = FrmGetActiveForm();
    FrmDrawForm(frm);
    /* this must be AFTER draw form */
    explain_error();
    handled = true;
    break;

  default:
    break;
  }

  return handled;
}

static void explain_error()
{
  Char buf[80];
  Short y = 12;
  switch(snowcrash) { // see main.c StartApplication
  case 1:    // compiled for OS2, running on OS3
  case 2:    // compiled for OS3, running on OS2
    StrPrintF(buf, "This PRC was compiled for OS %d.x", snowcrash+1);
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    StrPrintF(buf, "It will not work on your %d.x handheld.", 4-snowcrash);
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 14;
    StrPrintF(buf, "You need a different PRC:", snowcrash+1);
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    StrPrintF(buf, "Download kMoria ZIP file from");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    StrPrintF(buf, "http://roguelike-palm.sourceforge.net");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 14;
    StrPrintF(buf, "Unzip, then install \"kMoria%sprc\"",
	      ((snowcrash==1)?"OS2.":"."));
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    StrPrintF(buf, "and \"kMoriaDB.pdb\" only.");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    y += 11;
    StrPrintF(buf, "yes, I know, it is a pain.  sorry.");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    y += 11;
    StrPrintF(buf, " -- i0lanthe@yahoo.com");
    WinDrawChars(buf, StrLen(buf), 0, y);
    break;
  case 3:  // missing database
    StrPrintF(buf, "kMoria needs its database.");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    StrPrintF(buf, "Please install \"kMoriaDB.pdb\"");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 14;
    StrPrintF(buf, "If you don't have this file,");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    StrPrintF(buf, "download kMoria ZIP file from");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    StrPrintF(buf, "http://roguelike-palm.sourceforge.net");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 14;
    StrPrintF(buf, "Unzip, and install the .pdb file.");
    WinDrawChars(buf, StrLen(buf), 0, y);
    y += 11;
    y += 11;
    StrPrintF(buf, " -- i0lanthe@yahoo.com");
    WinDrawChars(buf, StrLen(buf), 0, y);
    break;
  }

}
