/*********************************************************************
 * kMoria - Moria adapted for the PalmPilot.                         *
 * Copyright (C) 2000 Bridget Spitznagel                             *
 *                                                                   *
 * This program is derived from Umoria 5.5.2.  Moria is              *
 *   Copyright (c) 1989-94 James E. Wilson, Robert A. Koeneke        *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License       *
 * as published by the Free Software Foundation; either version 2    *
 * of the License, or (at your option) any later version.            *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along with this program; if not, write to                         *
 * The Free Software Foundation, Inc.,                               *
 * 59 Temple Place - Suite 330,                                      *
 * Boston, MA  02111-1307, USA.                                      *
 *********************************************************************/
#include <Pilot.h>
#include <Graffiti.h> /* just for GrfGetState */
#include <CharAttr.h> /* for IsDigit */ // why is this not working for 3.1??
#include <System/Globals.h> // for font foo

#include "kMoriaRsc.h"
#include "kMoria.h"
#include "lock-externs.h"

DmOpenRef MoriaDB = NULL;
DmOpenRef MoriaSaveDB = NULL;


MoriaPreferenceType my_prefs = {
  6, // run_walk_border
  2, // walk_center_border
  // I may eliminate some of these.
  true,  // big font
  false, // rel move
  false, // circles
  true,  // sound
  true,  // run
  true,  // cut
  true,  // examine
  true, // sector
  false, // doors
  false, // prompt
  false, // weights
  false, // minerals
  false, // stats at top
  // menu thingies
  false, // inv is compact
  false, // inv shows individual weights
  false, // store is compact
  true, // store is haggling
  // Hardware buttons
  false,
  false,
  { 0,0,0,0,0,0,0,0 },
  // Default character name
  "my name"
};

/*****************************************************************************
 *                                                                           *
 *                  thrilling event handlers                                 *
 *                                                                           *
 *****************************************************************************/
Boolean do_pickup = true;
Boolean found_my_character = false;
extern Char last_command;
extern Boolean just_throwing;
//Short command_count = 0;
static void game_init()
{

  //#if (COST_ADJ != 100)
  //  price_adjust();
  //#endif

  /* Grab a random seed from the clock		*/
  //  init_seeds(seed);

  /* Init monster and treasure levels for allocate */
  //  init_m_level();
  //  init_t_level();

  /* Init the store inventories			*/
  // No!  Only if you are a new character!
  //  store_init();

  // do this if the old character dies, too.
  last_command = -1;
}

//Boolean stats_toggler = true;
//Short ctr; // this is for testing foo_list
//static Boolean do_command(Char c);
extern Boolean came_from_generation;
Boolean Main_Form_HandleEvent(EventPtr e)
{
  Boolean handled = false;
  FormPtr frm;
  Short tmp_x, tmp_y, dir;
  //Char buf[40]; // for testing

  free_turn_flag = false;// let's try this shall we

  switch (e->eType) {

  case frmOpenEvent:
    frm = FrmGetActiveForm();
    /** place any form-initialization stuff here **/
    FrmDrawForm(frm);
    // Make new level if needed, display level, display stats, yadda.
    if (came_from_generation) { // was (!found_my_character)
      came_from_generation = false;
      generate_cave();
      enter_new_level();
    }
    start_of_turn();
    // just to be really sure:
    get_panel(char_row, char_col, true);
    recalc_and_refresh(); //    recalc_screen();   refresh(true);
    print_stats(STATS_STR_ETC);
    show_messages(); // in case you can learn a spell.
    command_count = 0;
    return true;

  case menuEvent:
    //    message_clear();
    MenuEraseStatus(NULL); /* clear menu status from display */
    switch(e->data.menu.itemID) {
    case menu_mainScores:
      FrmPopupForm(ScoresForm);
      free_turn_flag = true;
      break;
    case menu_mainWiz:
      pymisc.exp=MAX_EXP;
      prt_experience();
      detect_inv2(10000);
      free_turn_flag = true;
      break;
    case menu_mainWiz2:
      {
	Short x = char_col+7, y = char_row;
	summon_monster(&y, &x, false);
	refresh(false);
	free_turn_flag = false;
      }
      break;
    case menu_mainMap:
      FrmPopupForm(MapForm);
      free_turn_flag = true;
      break;
    case menu_mainSettings:
      FrmPopupForm(PrefsForm);
      free_turn_flag = true;
      break;
    case menu_mainButtons:
      FrmPopupForm(HwButtonsForm);
      free_turn_flag = true;
      break;
    case menu_mainMsgs:
      FrmPopupForm(MsgLogForm);
      free_turn_flag = true;
      break;
    case menu_mainFont:
      toggle_itsy();
      get_panel(char_row, char_col, true); // FORCE recalculation of panel
      recalc_and_refresh(); //    recalc_screen();   refresh(true);
      free_turn_flag = true;
      break;
    case menu_mainAbout:
      FrmPopupForm(AboutForm);
      //      detect_inv2(randint(24)+24); // test
      free_turn_flag = true;
      break;
    case menu_mainStats:
      came_from_generation = false;
      FrmPopupForm(CharSummaryForm);
      free_turn_flag = true;
      break;
    case menu_mainRecall:
      // this should be same as '/' what-is-this- character
      do_command('/');
      free_turn_flag = true;
      break;
    case menu_cmd_quit:
      if (0 == FrmAlert(QuitP)) {
	if (false) {
	  antisave_char(); // delete the save file
	  re_init();
	  LeaveForm();
	  came_from_generation = true;
	  FrmGotoForm(CharRaceForm);
	} else {
	  death = true;
	  total_winner = false;
	  StrCopy(died_from, "Quitting");
	  LeaveForm();
	  FrmGotoForm(DeathForm);
	  //	  FrmGotoForm(ScoresForm);
	}
	return true;
      }
      // also need to leave the application... hm.
      free_turn_flag = true;
      break;
    default:
      // MAGIC & MORE MAGIC..
      tmp_x = e->data.menu.itemID - MAGIC_MENU_NUMBER;
      if (tmp_x > 0 && tmp_x < 128)
	handled = do_command((Char) tmp_x);
      if (handled && !free_turn_flag) command_count = 0; // XXX
      break;
    }
    handled = true;
    break;

    // let's have some fun...
  case keyDownEvent:
    // hardware button -- or else graffiti.
    if (true) {
      // under some circ.s you don't want to do this.
      // like casting a directional spell?  maybe?
      if (message_clear()) {
	show_messages();
	command_count = 0;
	return true;
      }
    }
    //      message_clear();
    handled = do_command(e->data.keyDown.chr); // XXXX This needs fixed!
    if (handled && !free_turn_flag) command_count = 0; // XXX
    else {
      Char buf[16];
      free_turn_flag = true;
      // allow numbers for 'command_count'
      if ('0' <= e->data.keyDown.chr
	  && e->data.keyDown.chr <= '9') {
	if (command_count <= 0) {
	  command_count = e->data.keyDown.chr - '0';
	} else if (command_count <= 9) {
	  command_count = command_count * 10 + e->data.keyDown.chr - '0';
	} else {
	  command_count = 99; /* maxed-out */
	} // xxx Hey, I need to make "backspace" work too.
	handled = true;
	StrPrintF(buf, "count: %d", command_count);
	count_message(buf);
      } else if (8 == e->data.keyDown.chr ||   // backspace (BS)
		 127 == e->data.keyDown.chr) {   // delete (DEL)
	command_count = command_count / 10;
	if (command_count) {
	  StrPrintF(buf, "count: %d", command_count);
	  count_message(buf);
	}
	handled = true;
      }
    }
    break;

  case penDownEvent:
    if (true) {
      // under some circ.s you don't want to do this.
      // like casting a directional spell?  maybe?
      if (message_clear()) {
	show_messages();
	command_count = 0;
	if (last_command == 'I') {
	  last_command = -1;
	  creatures(false); // undo a 'detect <foo>' spell/scroll/prayer
	  refresh(false);
	}
	return true;
      }
    }
    tmp_x = e->screenX - 80;
    tmp_y = e->screenY - 80;
    /*
      1. Map the direction to 1,2,3,4,6,7,8,9.
      2. Decide whether last_command != -1
      3. Either do_dir_command(dir, NULL),
      4. Or move_char(dir, do_pickup)
      5. last_command = -1;do_pickup = true; count = 0; free_turn_flag = false;
     */
    if (last_command == -1) { // Move!...
      Boolean do_run = my_prefs.run;
      Short dist;
      if (my_prefs.relative_move) {
	// translate tap coordinates so that rogue's screen location = 0,0.
	relativize_move(&tmp_x, &tmp_y);
      }
      dist = tmp_x * tmp_x + tmp_y * tmp_y;
      if (dist < my_prefs.walk_center_border * 10
	          * my_prefs.walk_center_border * 10) {
	; // could do search or something
      } else {
	dir = convert_to_dir(tmp_x, tmp_y, 10);
	// /* search or something */ }
	//if ((abs(tmp_x) < my_prefs.run_walk_border*10) &&
	//  (abs(tmp_y) < my_prefs.run_walk_border*10))
	//	if ((abs(tmp_x) < 6 * 10) && (abs(tmp_y) < 6 * 10))
	if (dist < my_prefs.run_walk_border * 10
	           * my_prefs.run_walk_border * 10)
	  do_run = false;
	do_feep(200,9);	// make a tap sound
	if (!do_run || hit_dont_run(dir))
	  move_char(dir, do_pickup);	// WALK  .. or attack
	else {
	  find_init(dir);	                // RUN
	  if (find_flag) find_run();
	}
      }
      do_pickup = true;
      command_count = 0; // not that it's, like, currently working or anything
    } else { // Last turn we got asked to do a directional command
      if (last_command == '/') {
	Short x, y;
	where_in_dungeon(e->screenX, e->screenY, &x, &y); // convert to cell
	do_xy_command(x, y);
      } else if (last_command == 'I') {
	// this is a fake command which sorta stands for 'invisible'.
	// it un-lights any creatures that last turn's magic had lit up.
	// hm, monsters get to take their turn BEFORE this is done....
	// will that be bad?  may need to fix parts of spell.c
	last_command = -1;
	creatures(false); // undo a 'detect <foo>' spell/scroll/prayer
	free_turn_flag = true;
      } else {
	undraw_directional();
	//	message_clear(); // in case some of these forget to clear it
	dir = convert_to_dir(tmp_x, tmp_y, 10);
	if (dir == 5 && last_command != '?') // 'aborted' unless 'look'
	  free_turn_flag = true;
	else
	  do_dir_command(dir, 0);
      }
      last_command = -1;
    }
    command_count = 0;
    handled = true;
    break;

  default:
    return true;
  } // end switch event type!
  // for anyone who has not returned,
  // call something to move the monsters.
  if (!free_turn_flag) {
    // so, like there's a fatal error in one of these puppies.
    end_of_turn();   // this is what moves the creatures and makes new levels
                     // (should I check for death here?  I wonder..)  xyzzy
    start_of_turn(); // this is what makes your own clock tick.
  }
  show_messages();
  refresh(false);
  // how about "if (death) FrmGotoForm..."?
  if (death) {
    LeaveForm();
    FrmGotoForm(DeathForm);
  }
  return handled;
}

/*****************************************************************************/
/*
// if free_turn_flag needs to be set, do the setting here.
// caller will zero command_count, and deal with numeric input and '-'
static Boolean do_command(Char c)
{
  // decide whether to clear the message....
  switch(c) {
  case 'a':
    //message("aim()"); // xxx needs direction argument
    needed_direction_for = DIR_AIM; // also needs an object
    free_turn_flag = true;
    draw_directional();
    return true;
  case 'z':
    //use();
    return true;
  case 'c':
    needed_direction_for = DIR_CLOSE;
    free_turn_flag = true;
    draw_directional();
    return true;
  case 't':
    needed_direction_for = DIR_THROW; // also needs an object
    //throw_object(need item_val); // shouldn't this be an Inventory command??
    free_turn_flag = true;
    draw_directional();
    return true;
  case 'm':
    //cast()
    return true;
  case 'o':
    needed_direction_for = DIR_OPEN;
    free_turn_flag = true;
    draw_directional();
    return true;
  case 'p':
    //pray();
    return true;
  case 's':
    //search();
    return true;
  case 'x':
    // exchange weapons
    return true;
  case 'f':
    needed_direction_for = DIR_BASH;
    free_turn_flag = true;
    draw_directional();
    return true;
  case '.':
    //rest();
    return true;
  case 'd':
    needed_direction_for = DIR_TUNNEL;
    free_turn_flag = true;
    draw_directional();
    return true;
  case '^':
    needed_direction_for = DIR_DISARM;
    free_turn_flag = true;
    draw_directional();
    return true;
  case '<':
  case pageUpChr:
    //go_up();
    return true;
  case '>':
  case pageDownChr:
    //go_down();
    return true;
  case 'i':
    // go to the inventory form
    return true;
  case 'e':
    // go to the equipment form
    return true;
  case 'S':
    // toggle search mode
    free_turn_flag = true;
    return true;
  case 'w':
    needed_direction_for = DIR_WEDGE;
    free_turn_flag = true;
    draw_directional();
    return true;
  case '?':
    needed_direction_for = DIR_LOOK;
    free_turn_flag = true;
    draw_directional();
    return true;
  case 'g':
    //gain_spells();
    return true;
  }
  return false;
}
*/
/*****************************************************************************/

static Char hwb_commands[14] = {  0 , 'k', 'j', 'l', 'h',
				 'M', '?', 'i', 'm', 's',
				 '#', 'R', 'd', 'f' };
static Boolean buttonsHandleEvent(EventPtr e)
{
  Boolean handled = false;
  //  Boolean took_time = true;
  Short dispatch_type = 0;
  Word which_form;
  Char command;

  if (!(ChrIsHardKey(e->data.keyDown.chr))
      && (e->data.keyDown.chr != findChr)
      && (e->data.keyDown.chr != pageUpChr)
      && (e->data.keyDown.chr != pageDownChr))
    return false; // it's NOT a hardware button.. probably graffiti.

  which_form = FrmGetActiveFormID();
  if (which_form != MainForm) {
    switch (which_form) {
    case LookForm: case MapForm:
      return true; // basically, disable buttons in these two forms
    default:
      return false; // else if not main form, buttons go to 'datebook' etc.
    }
  }

  // <incs>/UI/Chars.h is useful....   ChrIsHardKey(c)
  // hard[1-4]Chr, calcChr, findChr.
  switch (e->data.keyDown.chr) {
  case hard1Chr:      // datebook
    dispatch_type = my_prefs.hardware[0];
    break;
  case hard2Chr:      // address
    dispatch_type = my_prefs.hardware[1];
    break;
  case hard3Chr:      // todo
    dispatch_type = my_prefs.hardware[2];
    break;
  case hard4Chr:      // memos
    dispatch_type = my_prefs.hardware[3];
    break;
  case pageUpChr:
    dispatch_type = my_prefs.hardware[4];
    break;
  case pageDownChr:
    dispatch_type = my_prefs.hardware[5];
    break;
  case calcChr:
    dispatch_type = my_prefs.hardware[6];
    break;
  case findChr: // hello, why is this not working in xcopilot? works on Visor!!
    dispatch_type = my_prefs.hardware[7];
    break;
  default:
    return false;
  }
  if (dispatch_type < 1 || dispatch_type > 13)
    return false;

  command = hwb_commands[dispatch_type];
  if (command == 'm' && class[pymisc.pclass].spell == PRIEST) command = 'p';
  // This is the same as in Main_Form_HandleEvent
  handled = do_command(command);
  if (handled && !free_turn_flag) command_count = 0; // XXX

  // This is just the same as the end of Main_Form_HandleEvent
  if (!free_turn_flag) {
    end_of_turn();
    start_of_turn();
  }
  show_messages();
  refresh(false);
  if (death) {
    LeaveForm();
    FrmGotoForm(DeathForm);
  }
  return handled;
  // Well, let's see if this works.
}


/*****************************************************************************
 *                                                                           *
 *                      OpenDatabase                                         *
 *                                                                           *
 *****************************************************************************/
static Boolean OpenDatabase(void)
{
  // The '0' arguments are all 'card number'.
  // Note I have two databases of the same type now, so
  //  DmOpenDatabaseByTypeCreator is not going to work.
  LocalID dbID;
  Boolean created = false;

  // We cannot run if we cannot find the MoriaDB, so return error
  if (0 == (dbID = DmFindDatabase(0, MoriaDBName))) return 1;
  if (0 == (MoriaDB = DmOpenDatabase(0, dbID, dmModeReadWrite))) return 1;

  // We can run if we cannot find the MoriaSaveDB.  Just create it.
  if (0 == (dbID = DmFindDatabase(0, MoriaSaveDBName))) {
    if (DmCreateDatabase(0, MoriaSaveDBName, MoriaAppID, MoriaSaveDBType,
			 false))
      return 1;
    created = true;
    if (0 == (dbID = DmFindDatabase(0, MoriaSaveDBName))) return 1;
  }
  if (0 == (MoriaSaveDB = DmOpenDatabase(0, dbID, dmModeReadWrite))) return 1;

  if (DmNumRecords(MoriaSaveDB) < 1) {
    data_record_create();
  }

  return 0;
}

/*****************************************************************************
 *                      ApplicationHandleEvent                               *
 *****************************************************************************/
static Boolean ApplicationHandleEvent(EventPtr e)
{
    FormPtr frm;
    Word    formId;
    Boolean handled = false;

    if (e->eType == frmLoadEvent) {
	formId = e->data.frmLoad.formID;
	frm = FrmInitForm(formId);
	FrmSetActiveForm(frm);

	switch(formId) {
	case MainForm:
	    FrmSetEventHandler(frm, Main_Form_HandleEvent);
	    break;
	case SnowCrashForm:
	    FrmSetEventHandler(frm, SnowCrash_Form_HandleEvent);
	    break;
	case AboutForm:
	    FrmSetEventHandler(frm, About_Form_HandleEvent);
	    break;
	case MapForm:
	    FrmSetEventHandler(frm, Map_Form_HandleEvent);
	    break;
	case PrefsForm:
	    FrmSetEventHandler(frm, Prefs_Form_HandleEvent);
	    break;
	case HwButtonsForm:
	    FrmSetEventHandler(frm, HwButtons_Form_HandleEvent);
	    break;
	case MsgLogForm:
	    FrmSetEventHandler(frm, MsgLog_Form_HandleEvent);
	    break;
	case InvForm:
	    FrmSetEventHandler(frm, Inv_Form_HandleEvent);
	    break;
	case EquForm:
	    FrmSetEventHandler(frm, Equ_Form_HandleEvent);
	    break;
	case InvSelectForm:
	    FrmSetEventHandler(frm, InvS_Form_HandleEvent);
	    break;
	case ScribeForm:
	    FrmSetEventHandler(frm, Scribe_Form_HandleEvent);
	    break;
	case RecallForm:
	    FrmSetEventHandler(frm, Recall_Form_HandleEvent);
	    break;
	case LookForm:
	    FrmSetEventHandler(frm, Look_Form_HandleEvent);
	    break;
	case StoreForm:
	    FrmSetEventHandler(frm, Store_Form_HandleEvent);
	    break;
	case HaggleForm:
	    FrmSetEventHandler(frm, Haggle_Form_HandleEvent);
	    break;
	case BookForm:
	    FrmSetEventHandler(frm, Book_Form_HandleEvent);
	    break;
	case SpellForm:
	    FrmSetEventHandler(frm, Spell_Form_HandleEvent);
	    break;
	case DalekForm:
	    FrmSetEventHandler(frm, Dalek_Form_HandleEvent);
	    break;
	case GainSpForm:
	    FrmSetEventHandler(frm, GainSp_Form_HandleEvent);
	    break;
	case DeathForm:
	    FrmSetEventHandler(frm, Death_Form_HandleEvent);
	    break;
	case ScoresForm:
	    FrmSetEventHandler(frm, Scores_Form_HandleEvent);
	    break;
       // Generation stuff:
	case CharRaceForm:
	    FrmSetEventHandler(frm, CharRace_Form_HandleEvent);
	    break;
	case CharGenderForm:
	    FrmSetEventHandler(frm, CharGender_Form_HandleEvent);
	    break;
	case CharClassForm:
	    FrmSetEventHandler(frm, CharClass_Form_HandleEvent);
	    break;
	case CharSummaryForm:
	    FrmSetEventHandler(frm, CharSummary_Form_HandleEvent);
	    break;
	}
	handled = true;
    }

    return handled;
}

/*****************************************************************************
 *                      Preferences                                          *
 *****************************************************************************/

static void readMoriaPrefs()
{
  Word prefsSize;
  SWord prefsVersion;

  prefsSize = sizeof(MoriaPreferenceType);
  prefsVersion = PrefGetAppPreferences(MoriaAppID, MoriaAppPrefID, &my_prefs,
				       &prefsSize, true);
  if (!my_prefs.big_font)
    toggle_itsy();
}
void useMoriaPrefs()
{
  find_cut = my_prefs.run_cut_corners;
  find_examine = my_prefs.run_examine_corners;
  find_prself = true;
  find_bound = my_prefs.run_stop_sector;
  find_ignore_doors = my_prefs.run_thru_doors;
  prompt_carry_flag = my_prefs.prompt_pickup; // might wire this to false
  //  rogue_like_commands = true; // this is not used and also only quasitrue
  //  show_weight_flag = my_prefs.show_weights; // this is not used I guess
  highlight_seams = my_prefs.highlight_minerals;
  //  sound_beep_flag = false;
  //  display_counts = false;
  set_statsbar_loc();
}
void writeMoriaPrefs()
{
  Word prefsSize;

  prefsSize = sizeof(MoriaPreferenceType);
  PrefSetAppPreferences(MoriaAppID, MoriaAppPrefID, MoriaAppPrefVersion,
			&my_prefs, prefsSize, true);
}




/*****************************************************************************
 *                      StartApplication                                     *
 *****************************************************************************/
Boolean evil = false;
Short snowcrash = 0;
#ifdef I_AM_OS_2
FontPtr oldFontSix = 0;
#endif
static Word StartApplication(void)
{
  Word error = 0;
  DWord version;
#ifdef I_AM_OS_2
  void *font128 = 0;
#else
  VoidHand fontHandle;
  FontType *fontPtr;
#endif

  // Deal with the font.
  FtrGet(sysFtrCreator, sysFtrNumROMVersion, &version);
#ifdef I_AM_OS_2
  // evil font kludges!
  font128 = MemHandleLock(DmGetResource('NFNT', ItsyFont));
  if (version < 0x03000000L) {
    oldFontSix = ((UIGlobalsPtr)GUIGlobalsP)->uiFontTable[6];
    ((UIGlobalsPtr)GUIGlobalsP)->uiFontTable[6] = font128;
  } else {
    snowcrash = 1;
    evil = true;
  }
#else
  if (version >= 0x03000000L) {
    fontHandle = DmGetResource('NFNT',ItsyFont);
    fontPtr = MemHandleLock(fontHandle);
    // "user defined fonts start from 129"
    FntDefineFont(129,fontPtr);
    // the custom font is uninstalled automatically when we leave the app;
    // however, fontHandle must remain locked until then.
  } else {
    snowcrash = 2;
    evil = true;
  }
#endif

  // Return error if we don't have MoriaDB.  Open or create MoriaSaveDB.
  error = OpenDatabase();
  if (error && !evil) {
    snowcrash = 3;
    evil = true;
  }

  if (evil) {
    FrmGotoForm(SnowCrashForm);
    return 0;
  }

  // Lock the various database records; also take care of random seed.
  data_record_lock(true);

  // Read user preferences.
  readMoriaPrefs();
  useMoriaPrefs();
  
  
  //found_my_character = false;
  found_my_character = load_char();

  game_init(); // so, hm, currently that only initializes the store inv?
  came_from_generation = !found_my_character;
  if (found_my_character)
    FrmGotoForm(MainForm);
  else
    FrmGotoForm(CharRaceForm);
  
  return 0;
}


/*****************************************************************************
 *                      StopApplication                                      *
 *****************************************************************************/
#define free_me(a)  h = MemPtrRecoverHandle((a)); if (h) MemHandleFree(h);
static void StopApplication(void)
{
  //  VoidHand h;
  DWord version;
#ifdef I_AM_OS_2
  //void *font128 = 0;
#else
  VoidHand fontHandle;
#endif

  if (evil) return;

  FtrGet(sysFtrCreator, sysFtrNumROMVersion, &version);
#ifdef I_AM_OS_2
  if (version < 0x03000000L) {
    if (oldFontSix) {
      ((UIGlobalsPtr)GUIGlobalsP)->uiFontTable[6] = oldFontSix;
      oldFontSix = 0;
      //      if ((font128 = ((UIGlobalsPtr)GUIGlobalsP)->uiFontTable[6]))
      //	MemHandleUnlock(font128);
    }
  }
#else
  if (version >= 0x03000000L) {
    fontHandle = DmGetResource('NFNT',ItsyFont);
    MemHandleUnlock(fontHandle);
  }  
#endif

  // try to save!  woohoo.  but I should only do this if you're not dead...
  if (!death) save_char(); // returns false on failure; ignored for now.
  else        antisave_char(); // delete old save file, if any

  data_record_lock(false);
  // possibly I should free some things too.

  FrmSaveAllForms();
  FrmCloseAllForms();

  if (MoriaDB!=NULL) {
    DmCloseDatabase(MoriaDB);
    MoriaDB = NULL;
  }
  if (MoriaSaveDB!=NULL) {
    DmCloseDatabase(MoriaSaveDB);
    MoriaSaveDB = NULL;
  }
  // free stuff

}


/*****************************************************************************
 *                      EventLoop                                            *
 *****************************************************************************/

/* The main event loop */


static void EventLoop(void)
{
    Word err;
    EventType e;
     
    do {
	EvtGetEvent(&e, evtWaitForever);
	// first see if it's a hardware button thing!!!
	// don't ask me what the poweredOnKeyMask is, though; cargo cult.
	// Do special hardware button things only if:
	// it's a hardware button event, [you're alive,] and in the main form.
	if ( (e.eType != keyDownEvent)
	     || !my_prefs.use_hardware 
	     || (e.data.keyDown.modifiers & poweredOnKeyMask)
	     || (FrmGetActiveFormID() != MainForm)
	     || !buttonsHandleEvent(&e) )
	  // now proceed with usual handling
	  if (! SysHandleEvent (&e))
	    if (! MenuHandleEvent (NULL, &e, &err))
	      if (! ApplicationHandleEvent (&e))
		FrmDispatchEvent (&e);
    } while (e.eType != appStopEvent);
}


/* Main entry point; it is unlikely you will need to change this except to
   handle other launch command codes */
/*****************************************************************************
 *                      PilotMain                                            *
 *****************************************************************************/
DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
    Word err;

    if (cmd == sysAppLaunchCmdNormalLaunch) {

      err = StartApplication();
      if (err) return err;

      EventLoop();
      StopApplication();

    } else {
      return sysErrParamErr;
    }

    return 0;
}
