#ifndef _kalk_h_
#define _kalk_h_

/*
 * File:   kalk.h
 * Author: Holger Klawitter
 * Date:   14.07.1997
 *
 * Changes:
 * 23.09.1999 Adding "%" und "!"
 * 05.10.1999 Adding Buttons for Base Conversion
 */

/***********************************************************************
 * Definition of all ResourceIDs
 ***********************************************************************/

#define KALKTYPE 'hk01'
#define KALKVERSION 1002
#define MEMSIZE 10 /* number of registers */

extern float angleConvert;
extern double lastx;

#define MainForm 1000
#define MathForm 1250
#define StatForm 1200
#define OptForm 1300
#define AboutForm 1400

#define MenuAbout   1050
#define MenuOptions 1051
#define MenuClear   1052
#define MenuCopy    1053
#define MenuPaste   1054

#define AboutMsg 1900

#define NotEnoughArgs 1400
#define AreYouSure 1402

/* MainForm buttons */

#define BtMath 1001
#define BtDiv  1005
#define BtStat 1006
#define BtMult 1010
#define BtSwp  1011
#define BtSub  1015
#define BtE    1016
#define BtDot  1018
#define BtChs  1019
#define BtAdd  1020
#define BtEnt  1021
#define BtDel  1022

#define BtLastX 1023

#define BtRez  1040
#define BtPow  1041
#define BtSqr  1042
#define BtSqrt 1043

#define BtSto  1044
#define BtRcl  1045

#define Bt0    1030
#define Bt1    1031
#define Bt2    1032
#define Bt3    1033
#define Bt4    1034
#define Bt5    1035
#define Bt6    1036
#define Bt7    1037
#define Bt8    1038
#define Bt9    1039

/* Buttons for Mathform */

#define MtRez  1201
#define MtPow  1202
#define MtSqr  1203
#define MtSqrt 1204
#define MtLog  1205
#define Mt10pw 1206
#define MtLn   1207
#define MtExp  1208
#define MtSin  1209
#define MtCos  1210
#define MtTan  1211
#define MtPi   1212
#define MtASin 1213
#define MtACos 1214
#define MtATan 1215
#define MtBack 1216
#define MtSinH 1217
#define MtCosH 1218
#define MtTanH 1219
#define MtASinH 1220
#define MtACosH 1221
#define MtATanH 1222
#define MtProz  1223
#define MtFak  1224

/* Buttons for Statistics form */

#define StAdd  1251
#define StDel  1252
#define StXAv  1253
#define StXVa  1254
#define StYAv  1255
#define StYVa  1256
#define StR    1257
#define StBYX  1258
#define StBXY  1259
#define Stn    1260
#define StToX  1261
#define StToY  1262
#define StBack 1263
#define StClear 1264

/* Buttons for Options form */

#define OptDisplayGroup 1
#define OptAngleGroup   2
#define OptBaseGroup    3

#define OptAll 1302
#define OptFixed 1303
#define OptSci 1304
#define OptEng 1305

#define OptPrec 1306
#define OptPrecLabel 1307

#define OptRad 1311
#define OptDeg 1312

#define OptDec 1320
#define OptBin 1321
#define OptOct 1322
#define OptHex 1323

#define OptOk 1330
#define OptCancel 1331
#define OptDefault 1332

/* Buttons for About form */

#define AboutOk 1400

/* Buttons for Memory form */

#define MemForm 1500
#define MemButton 1500
#define MemExit 1599
#define MemClear 1598

void LiftButton( UInt16 id );

#endif /* _kalk_h_ */
