#ifndef _ops_h_
#define _ops_h_

/*
 * File: ops.h
 * Author: Holger Klawitter
 * Date: 14.07.1997
 *
 * Handler for no nary and unary functions which can go into the
 * shared library this way.
 *
 * Beware! Bugs inside!
 */

#include <PalmOS.h>
#include <mathf.h>

/**********************************************************************
 * Public variables and DS
 **********************************************************************/

typedef struct {
  float X, Y, XY, X2, Y2;
  Int16 N;
} Statistics;

/**********************************************************************
 * Public functions
 **********************************************************************/

double DoNonaryOp( Int16 id );
/* Computes constants (partly from the values of S. */

double DoUnaryOp( Int16 id, double arg1 );
/* Computes all unary functions */

/* As many of the binary functions do different things with the stack,
 * I try to avoid putting them into the library right now.
 */

#endif /* _ops_h_ */
