#ifndef _view_h_
/*
 * File: view.h
 * Author: Holger Klawitter
 * Date: 22.04.1997
 *
 * Handling of the visual part of the stack on screen.
 */

#include <PalmOS.h>
#include "util.h"

/**********************************************************************
 * Public data structures
 **********************************************************************/

typedef enum { freeMode, fixedMode, sciMode, engMode } ViewMode;
/* The differnet display modes. */

/**********************************************************************
 * Public variables
 **********************************************************************/

extern Boolean ViewUScore;
/* if true, an underscore will be shown */

extern Int16 places;
extern ViewMode displayMode;

extern Int8 baseMode;

/**********************************************************************
 * Public functions
 **********************************************************************/

void ViewUp();
/* Scrolls the display upward (meaning towards the tos).
 * Does nothing if this is not possible.
 */

void ViewDown();
/* Scrolls the display downward (meaning away from the tos).
 * Does nothing if this is not possible.
 */

void ViewLine();
/* Redisplays the tos line. Scrolls down if neccessary. */

void ViewUpdateAll();
/* Redisplays the screen but does not scroll. */

void ViewFltToStr( double f, CharPtr s );
/* Transforms the floating point number into a character string.
 * Obeys the current display settings.
 * The caller has to supply 's' with LINESIZE (see stk.h) characters.
 */

#endif /* _view_h_ */
