#pragma pack(2)
#include <Common.h>
#include <System/SysAll.h>
#include <System/NetMgr.h>
#include <UI/UIAll.h>

#include "linkdirect.h"
#define HelloAppID    'HElo'   

static int StartApplication(void);
static Boolean OpenDatabase(void);
static void EventLoop(void);
static void StopApplication(void);
static Boolean MainEventHandler(EventPtr event);
static void DoQuickConnect(void);

int err;
ListPtr SpeedListPtr;
Word AppNetRefnum;

DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
	{
	int error;

	if ( cmd == sysAppLaunchCmdNormalLaunch )
		{

		error = StartApplication();  // Application start code
		if ( error ) return error;

		EventLoop();  // Event loop

		StopApplication (); // Application stop code
		}
	return 0;
	}


static int StartApplication(void)
	{

	FrmGotoForm(formID_main);

	}

static void StopApplication(void)
	{

	while ( 0 );

	}

static void EventLoop(void)
	{
	short err;
	int formID;
	FormPtr form;
	EventType event;
	Word fish;

	do
		{

		EvtGetEvent(&event, 200);

		if ( SysHandleEvent(&event) )	continue;

		if ( event.eType == frmLoadEvent )
			{
			formID = event.data.frmLoad.formID;
			form = FrmInitForm(formID);
			FrmSetActiveForm(form);
			fish=FrmGetObjectIndex(form, listID_speeds);
			SpeedListPtr=FrmGetObjectPtr(form, fish);
			switch ( formID )
				{
				case formID_main:
					FrmSetEventHandler(form, (FormEventHandlerPtr) MainEventHandler);
					break;
				}
			}
		FrmDispatchEvent(&event);
		}while ( event.eType != appStopEvent );
	}

static Boolean MainEventHandler(EventPtr event)
	{
	FormPtr   form;
	int       handled = 0;

	switch ( event->eType )
		{
		case frmOpenEvent:
			form = FrmGetActiveForm();
			FrmDrawForm(form);
			handled = 1;
			break;

		case ctlSelectEvent:	 // A control button was pressed and released.
			if ( event->data.ctlEnter.controlID== buttonID_connect )
				{
				DoQuickConnect();
				handled = 1;
				}
			break;

		case nilEvent:
			handled = 1;
			break;
		}
	return handled;
}

static void DoQuickConnect()
{

	int count;
	Word index=0;
	DWord ifcreator, baudrate;
	Word ifinstance, bufsize, selectedspeed;
	Char *selectionp, fish[5];

	err = SysLibFind("Net.lib", &AppNetRefnum);
	if (err) 
	{
		return;
	}

	err=NetLibIFGet(AppNetRefnum, index, &ifcreator, &ifinstance);

	while ((ifcreator!=netIFCreatorPPP) & (err!=netErrInvalidInterface))
	{
		index++;
		err=NetLibIFGet(AppNetRefnum, index, &ifcreator, &ifinstance);
	}
	bufsize=sizeof(baudrate);
	
	selectedspeed=LstGetSelection(SpeedListPtr);

	selectionp=LstGetSelectionText(SpeedListPtr, selectedspeed);
	baudrate=StrAToI(selectionp);

	err=NetLibIFSettingSet(AppNetRefnum, ifcreator, ifinstance, netIFSettingBaudRate, &baudrate, bufsize);

	if (err!=0)
	{
		return;
	}

	bufsize=0;

	err=NetLibOpen(AppNetRefnum, &bufsize);
	if ((err!=0) && (err!=netErrAlreadyOpen))
	{
		return;
	}

	if (bufsize!=0)
	{
		return;
	}

	err=NetLibIFUp(AppNetRefnum, ifcreator, ifinstance);
	if (err!=0)
	{
		return;
	}
	err=NetLibClose(AppNetRefnum, false);

}
