/*
 * MCalc.c
 * Copyright (C) 2000, James Caple
 *
 * Mortgage Calculator for Palm
 *
 * Currently using sdk-3.5.
 * This code is distributed under the terms of GNU Public License.  You may re-use any of this
 * code you want as long as the original copyright remains in tact, please.  See http://www.fsf.org
 * for the terms of this license.
 *
 * 2/11/2001 - Removed old Callback code; learned that this is no longer required for PRC-Tools 2.0 or greater.
 * Still need to clean up Makefile and make it pretty, like me.
 *
 * Yes, this is ugly code, but it works!
 */


#include <PalmOS.h>
#include <PalmCompatibility.h>
#include "MCalc.h"

// for definition of IsDigit
#include <CharAttr.h>
#include <SysEvtMgr.h>
#include <stdlib.h>
#include <FloatMgr.h>
#include <StringMgr.h>
/** #include "../mathlib/src/MathLib.h" **/

/** Prototypes **/
static FieldType* SetFieldTextFromStr( UInt16 fieldID, CharPtr strP );
static FieldType* SetFieldTextFromHandle( UInt16 fieldID, Handle txtH );
static void ClearFieldText(Word fieldID);
void ClearFields();
Boolean CalcForm();
float calc_monthly_mortgage(int amount, int percent_down, float rate, int num_years, int taxes, int insurance );
float cvt_atof(char *,short *);
void format_number(float,short,char *);
float pow( double f, int n );

static Err StartApplication(void)
{
  FrmGotoForm(MainForm);
  
  return 0;
}


static void StopApplication(void)
{
  FrmCloseAllForms();
}


static Boolean MyFormHandleEvent(EventPtr event)
{
  Boolean handled = false;
    
    switch (event->eType)
    {
    case ctlSelectEvent:  // A control button was pressed and released.
      if (event->data.ctlSelect.controlID == CalcButton) {
	if ( CalcForm() ) {				
	  handled = true;
	}
      }
      
      if ( event->data.ctlSelect.controlID == ClearButton ) {
	ClearFields();
	handled = true;
      }
      
      break;
    case frmOpenEvent:	
      FrmDrawForm(FrmGetActiveForm());
      handled = true;
      break;
      
    case menuEvent:		
      // Load About Box
      if (event->data.menu.itemID == About)
	FrmAlert( AboutAlert );
    }
    return handled;
}


static Boolean ApplicationHandleEvent(EventPtr event)
{
  FormPtr frm;
  Int formId;
  Boolean handled = false;
  
  if (event->eType == frmLoadEvent)
  {
    // Load the form resource specified in the event then activate the form.
    formId = event->data.frmLoad.formID;
    frm = FrmInitForm(formId);
    FrmSetActiveForm(frm);
    
    // Set the event handler for the form.  The handler of the currently 
    // active form is called by FrmDispatchEvent each time it receives an event.
    switch (formId)
      {
      case MainForm:
	FrmSetEventHandler(frm, MyFormHandleEvent);
	break;
      }
    handled = true;
  }
  
  return handled;
}


static void EventLoop(void)
{
  EventType event;
  Word error;
  
  do
  {
    EvtGetEvent(&event, evtWaitForever);
    if (! SysHandleEvent(&event))
      if (! MenuHandleEvent(0, &event, &error))
	if (! ApplicationHandleEvent(&event))
	  FrmDispatchEvent(&event);
  }
  while (event.eType != appStopEvent);
}


DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
  Err err = 0;
  
  /***
      err = SysLibFind(MathLibName, &MathLibRef);
      if ( err )
      err = SysLibLoad(LibType, MathLibCreator, &MathLibRef);
      // DISPLAY ERROR!
      err = MathLibOpen(MathLibRef, MathLibVersion);
  ***/
  
  // DISPLAY ERROR!
  if (cmd == sysAppLaunchCmdNormalLaunch)
  {
    if ((err = StartApplication()) == 0)
      {
	EventLoop();
	
	StopApplication();
      }
  }
  
  return err;
}

static FieldType* SetFieldTextFromStr( UInt16 fieldID, CharPtr strP )
{
  Handle txtH;
  txtH = MemHandleNew( StrLen(strP) + 1);
  if (!txtH)
    return NULL;
  
  // copy the string to the locked handle
  StrCopy(MemHandleLock(txtH), strP);
  
  // unlock the string handle.
  MemHandleUnlock(txtH);
  
  // set the field to the handle
  return SetFieldTextFromHandle( fieldID, txtH );	
  
}

/**
 * Clear all the fields to normal state.
 */
void ClearFields() {
  ClearFieldText( ListPriceText );
  ClearFieldText( PcntDownText );
  ClearFieldText( RateText );
  ClearFieldText( TermText );
  ClearFieldText( TaxesText );
  ClearFieldText( InsuranceText );
  ClearFieldText( PayText );
}

static FieldType* SetFieldTextFromHandle( UInt16 fieldID, Handle txtH ) {
  Handle oldTxtH;
  FormPtr frm = FrmGetActiveForm();
  FieldType* fldP;
  
  fldP = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, fieldID));
  oldTxtH = FldGetTextHandle(fldP);
  
  FldSetTextHandle(fldP, txtH);
  FldDrawField(fldP);
  
  //if (oldTxtH)
  //	MemHandleFree(oldTxtH);
  
  return fldP;
}

static void ClearFieldText(Word fieldID) {
  SetFieldTextFromHandle( fieldID, NULL );
}

/*
 * Calculate monthly mortgage rate.
 */
Boolean CalcForm() { 
  Char* s;
  Char* a;
  Char* result;
  short decimal = 2;
  FlpCompDouble CompFloat;
  float f_price, f_pcnt_down, f_pay;
  //FlpFloat f_result;
  //float f_rate = 0.0;
  UInt16 i_pcnt_down = 0;
  //UInt32 i_price = 0;
  int i_price = 0;
  UInt32 i_rate = 0;
  int i_term = 0;
  int i_taxes = 0;
  int i_insurance = 0;
  float i_result = 0;
  float f_rate;
  
  FlpDouble fd;
  
  Handle h_price, h_pay, h_pcntdown, h_term, h_taxes, h_insurance, h_rate;
  
  FormPtr frm = FrmGetActiveForm();
  FieldType* price;
  FieldType* pcntdown;
  FieldType* pay;
  FieldType* rate;
  FieldType* term;
  FieldType* taxes;
  FieldType* insurance;
  
  price = (FieldType*) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, ListPriceText ) );
  pcntdown = (FieldType*) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, PcntDownText ) );
  term = (FieldType*) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, TermText ) );
  taxes = (FieldType*) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, TaxesText ) );
  insurance = (FieldType*) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, InsuranceText ) );
  rate = (FieldType*) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, RateText ) );
  pay = (FieldType*) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, PayText ) );
  
  h_price = FldGetTextHandle( price );
  h_pcntdown = FldGetTextHandle( pcntdown );
  h_term = FldGetTextHandle( term );
  h_taxes = FldGetTextHandle( taxes );
  h_insurance = FldGetTextHandle( insurance );
  h_rate = FldGetTextHandle( rate );
  h_pay = FldGetTextHandle( pay );
  
  if ( h_price ) {
    FldSetTextHandle( price, NULL );
    s = MemHandleLock( h_price );
    i_price = StrAToI( s );
    MemHandleUnlock( h_price );
  }
  if ( h_pcntdown ) {
    FldSetTextHandle( pcntdown, NULL );
    s = MemHandleLock( h_pcntdown );
    i_pcnt_down = StrAToI( s );
    MemHandleUnlock( h_pcntdown );
  }
  
  if ( h_rate ) {
    FldSetTextHandle( rate, NULL );
    s = MemHandleLock(h_rate);
    //CompFloat.fd = FlpAToF( s );
    //f_rate = CompFloat.d;
    f_rate = cvt_atof( s, &decimal ); 
    MemHandleUnlock( h_rate );
  }
  
  if ( h_term ) {
    FldSetTextHandle( term, NULL );
    s = MemHandleLock(h_term);
    i_term = StrAToI( s );
    MemHandleUnlock(h_term);
  }
  
  if ( h_taxes ) {
    FldSetTextHandle( taxes, NULL );
    s = MemHandleLock(h_taxes);
    i_taxes = StrAToI( s );
    MemHandleUnlock(h_taxes);
  }
  
  if ( h_insurance ) {
    FldSetTextHandle( insurance, NULL );
    s = MemHandleLock(h_insurance);
    i_insurance = StrAToI( s );
    MemHandleUnlock(h_insurance);
  }
  
  //StrIToA( a, i_price );
  //StrIToA( b, i_pcnt_down );
  //FrmCustomAlert( DebugAlert, "Results:", a, NULL );
  
  i_result = calc_monthly_mortgage( i_price, i_pcnt_down, f_rate, i_term, i_taxes, i_insurance );  	

  format_number( i_result, 2, result);
  
  if ( h_pay ) {
    //FldSetTextHandle( pay, NULL );
    //s = MemHandleLock(h_pay);
    //CompFloat.d = f_result;
    //FlpFToA( CompFloat.fd, s ); 
    //MemHandleUnlock( h_pay );
    //SetFieldTextFromHandle( PayText, h_pay );
  } else {
    SetFieldTextFromStr( PayText, result );
  }
  
  return true;
}


/*
 * Calculate the the monthly payments, as nearly as possible, based on the provided
 * input parameters.  Note: the algorithm used to calulate Principle and Interest payments
 * over a period, n, was taken from pass.maths.org (Plus Magazine).  P.S. I had alot of fun
 * working with Palm's Floating Point routines...Not!
 */
float calc_monthly_mortgage(int amount, int percent_down, float f_rate, int num_years, int taxes, int insurance ) {
  
  float f_tmnt;
  int new_amount;
  float f_amount;
  float f_pcnt_down;
  float rate;
  int months;
  double monthly_rate;
  double da, db;
  float mth_i;
  float monthly_pay = 0;

  if ( ( amount <= 0 ) || ( percent_down < 0 ) ) {
    return (float) 0.0;
  }

  f_pcnt_down = percent_down / 100.0;
  rate = f_rate / 100.0;
  
  f_tmnt = amount * f_pcnt_down;
  new_amount = amount - f_tmnt;
  
  months = num_years * 12;
  
  monthly_rate = 1 + ( rate / 12.0 );
  mth_i = rate / 12.0;
  
  da = pow( monthly_rate, months );
  db = pow( 1+mth_i, months);
  
  monthly_pay = ( ( ( new_amount * mth_i * da ) / ( da - 1 ) ) * 1000 ) + taxes + insurance;

  return monthly_pay;
  
}

/**
 * My own hack exponent calculator.
 */
float pow( double d, int n ) {
  int i;
  double p = 1;
  for (i=1;i<=n;++i) 
    p = p * d;	
  
  return (float)p;
}

