/*
 PalGar - use a PALm to up-, download, edit waypoints from a GARmin GPS
 Copyright (C) 2000 Ralf Meyer

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//  GarminDef.h
//  Garmin protocol specific defines

// L000 - packet ID`s    basic

#define 	Pid_Ack_Byte		  6
#define		Pid_Nak_Byte		 21
#define		Pid_Protocol_Array	253
#define		Pid_Product_Rqst	254
#define		Pid_Product_Data	255

// L001 -

#define 	Pid_Command_Data	 10
#define		Pid_Xfer_Cmplt		 12
#define		Pid_Date_Time_Data	 14
#define		Pid_Position_Data	 17
#define		Pid_Prx_Wpt_Data	 19
#define 	Pid_Records			 27
#define 	Pid_Rte_Hdr			 29
#define 	Pid_Rte_Wpt_Data	 30
#define 	Pid_Almanac_Data	 31
#define 	Pid_Trk_Data		 34
#define 	Pid_Wpt_Data		 35
#define 	Pid_Pvt_Data		 51

#define 	Pid_Rte_Link_Data	 98
#define 	Pid_Trk_Header		 99

// L002 -

// A000 - product data protocol
typedef struct
{
	UInt16	product_ID;
	UInt16	software_version;
	char	product_description[50 +1];
	char	product_additional[50 +1];
	/* 12XL sends Version of city database */
	/* zero or more null-terminated strings*/
} 	Product_Data_Type;

// A001 - protocol capability protocol

typedef struct
{
	char	tag;
	UInt16	data;
}	Protocol_Data_Type;

typedef Protocol_Data_Type Protocol_Array_Type[20];

// A010 - device command protocol 1

#define		Cmnd_Abort_Transfer		0
#define		Cmnd_Transfer_Alm		1
#define		Cmnd_Transfer_Posn		2
#define		Cmnd_Transfer_Prx		3
#define		Cmnd_Transfer_Rte		4
#define		Cmnd_Transfer_Time		5
#define		Cmnd_Transfer_Trk		6
#define		Cmnd_Transfer_Wpt		7
#define		Cmnd_Turn_Off_Pwr		8
#define		Cmnd_Start_Pvt_Data		49
#define		Cmnd_Stop_Pvt_Data		50

// A100 - waypoint transfer protocol
// A200 - route transfer protocol
// A201 - route transfer protocol
// A300 - track log transfer protocol
// A301 - track log transfer protocol
// A400 - proximity waypoint transfer protocol
// A500 - almanac transfer protocol
// A600 - date and time initialization protocol
// A700 - position initialization protocol
// A800 - PVT data protocol



extern Product_Data_Type	A000;
//extern Protocol_Array_Type	A001;

