/*
 * endian_convert
 * Little Endian to Big Endian and vice versa
 */
/*
 PalGar - use a PALm to up-, download, edit waypoints from a GARmin GPS
 Copyright (C) 2000 Ralf Meyer <ranf@users.sourceforge.net>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include <PalmOS.h>

// static char *rcs_id = "$Id: endian.c,v 1.1 2000/11/26 15:07:11 ranf Exp $";

void endian_convert( void * data, int len )
{
	char	d[8];
	int	i;
	char 	*	p;

	p = (char *) data;
	p += len -1;

	for ( i = 0; i < len; i ++ ) {
		d[i] = * p --;
	}

	MemMove( data, &d, len );
}

