#!/bin/sh
#
#	Create a strings with compile date, RCS ID's,
#	etc.
#

#	$Header: /cvs/PalGar/make_versions.sh,v 1.8 2000/11/26 15:07:11 ranf Exp $
#
#	$Log: make_versions.sh,v $
#	Revision 1.8  2000/11/26 15:07:11  ranf
#	Modified Files:
#		gps.rcp make_versions.sh
#	Added Files:
#		endian.c
#	
#	Revision 1.7  2000/11/07 19:42:42  ranf
#	- eTrex WPT download at least works
#	
#	Revision 1.1.1.1  2000/04/24 20:54:18  ranf
#	
#	
#	Revision 1.2  2000/03/27 00:08:27  giga
#	ISO Date in make_versions.sh
#	
#	Revision 1.1.1.1  2000/03/23 18:18:40  giga
#	Initial import
#	
#	Revision 1.7  1999/05/12 08:48:05  paul
#	Ready for release as Gypsy 1.4.  Major changes include:
#	*  Rudimentary track/route buffer to transfer data between GPS
#	   and PC (a'la gps2p2pc)
#	*  Protocol fix for DLE escaping bug
#	*  Code changes from <andre@drfmc.ceng.cea.fr> to be able to
#	   compile a PalmOS2 version
#	*  Garmin protocol tries a bit harder to recover from comms
#	   errors (but is still *very* dumb)
#
#

/bin/echo "// automatically generated by $0" > versions.c
/bin/echo >> versions.c

# I prefer ISO dates
date=`date "+%Y-%m-%d\\\\t%H:%M:%S"`
/bin/echo "char *compile_date = \"$date\";" >> versions.c

/bin/echo -n "char *version_info = \"" >> versions.c

for f in gps.c garmin.c file.c host.c endian.c; do
   rcs=`grep -i 'static char \*rcs_id' $f | \
	sed -e 's/.*\.c,v //' -e 's/ .*//'`
   if [ `echo $f | wc -c` -lt 8 ]; then
      /bin/echo -n "$f\\t\\t$rcs\\n" >> versions.c
   else
      /bin/echo -n "$f\\t$rcs\\n" >> versions.c
   fi
done
/bin/echo "\";" >> versions.c
