#!/usr/bin/perl


# Create a directory for the upgraded code:

mkdir("os35",0777);


# Read the current directory's file list:

opendir(DIR,".");
@filelist = readdir(DIR);
closedir(DIR);


# Cut the list down to just .c and .h files:

@filelist = grep(/\.(c|h|cpp)$/,@filelist);

print "Upgrading files to Palm OS 3.5...\n";

foreach $file (@filelist)
{
	print "Upgrading $file to os35/$file: ";

	open (IN,"$file");
	read (IN,$code,999999);
	close (IN);

	$code = upgrade($code);

	open (OUT,">os35/$file");
	print OUT $code;
	close (OUT);

	print "done.\n";
}

print "Upgrade complete.\n";

sub upgrade
{
	my ($code) = @_;

	$_ = $code;

	s/\bSDWordPtr\b/Int32 */g;
	s/\bDWordPtr\b/UInt32 */g;
	s/\bSWordPtr\b/Int16 */g;
	s/\bWordPtr\b/UInt16 */g;
	s/\bSBytePtr\b/Int8 */g;
	s/\bBytePtr\b/UInt8 */g;
    s/\bCharPtr\b/char */g;
    s/\bSCharPtr\b/Int8 */g;
	s/\bUCharPtr\b/UInt8 */g;
	s/\bUShortPtr\b/UInt16 */g;
	s/\bShortPtr\b/Int16 */g;
	s/\bUIntPtr\b/UInt16 */g;
	s/\bIntPtr\b/Int16 */g;
	s/\bULongPtr\b/UInt32 */g;
	s/\bLongPtr\b/Int32 */g;

	s/\bSDWord\b/Int32/g;
	s/\bDWord\b/UInt32/g;
	s/\bSWord\b/Int16/g;
	s/\bWord\b/UInt16/g;
	s/\bSByte\b/Int8/g;
	s/\bByte\b/UInt8/g;
	s/\bSChar\b/Int8/g;
	s/\bUChar\b/UInt8/g;
	s/\bUShort\b/UInt16/g;
	s/\bShort\b/Int16/g;
	s/\bUInt\b/UInt16/g;
	s/\bInt\b/Int16/g;
	s/\bULong\b/UInt32/g;
	s/\bLong\b/Int32/g;

	s/\bVoidPtr\b/MemPtr/g;
	s/\bVoidHand\b/MemHandle/g;
	s/\bPtr\b/MemPtr/g;
	s/\bHandle\b/MemHandle/g;

	s/\bscrCopy\b/winPaint/g;
	s/\bscrAND\b/winErase/g;
	s/\bscrANDNOT\b/winMask/g;
	s/\bscrXOR\b/winInvert/g;
	s/\bscrOR\b/winOverlay/g;
	s/\bscrCopyNOT\b/winPaintInverse/g;
	s/\bScrOperation\b/WinDrawOperation/g;

	s/\bScrDisplayMode/WinScreenMode/g;
	s/\bScrInit/WinScreenInit/g;

	s/\bscrDisplayMode/winScreenMode/g;
	$_;
}

__END__

