;-----------------------------------------------------------------------------
; pilotadd.inc
;
;   include file for pila
;
;   processed from USR Pilot include files
;
;-----------------------------------------------------------------------------
; missing definitions, added by Bodo Wenzel

; system/chars.h, but only some needed with old names

backlightChr		equ	$0113
autoOffChr		equ	$0114
powerOffChr		equ	$011E
vchrLateWakeup		equ	$0120
vchrBrightness		equ	$0122
vchrContrast		equ	$0123
hardCradle2Chr		equ	$020A
hardContrastChr		equ	$020B
hardAntennaChr		equ	$020C
hardBrightnessChr	equ	$020D

; system/keymgr.h

keyBitPower		equ	$0001
keyBitPageUp		equ	$0002
keyBitPageDown		equ	$0004
keyBitHard1		equ	$0008
keyBitHard2		equ	$0010
keyBitHard3		equ	$0020
keyBitHard4		equ	$0040
keyBitCradle		equ	$0080
keyBitAntenna		equ	$0100
keyBitContrast		equ	$0200
keyBitsAll		equ	$FFFFFFFF
slowestKeyDelayRate	equ	$ff
slowestKeyPeriodRate	equ	$ff

; system/systemmgr.h

struct SysDBListItemType
    name.32	;dmDBNameLength
    creator.l
    type.l
    version.w
    dbID.l
    cardNo.w
    iconP.l
endstruct

; system/preferences.h

prefVersion			equ	0
prefCountry			equ	1
prefDateFormat			equ	2
prefLongDateFormat		equ	3
prefWeekStartDay		equ	4
prefTimeFormat			equ	5
prefNumberFormat		equ	6
prefAutoOffDuration		equ	7
prefSysSoundLevelV20		equ	8
prefGameSoundLevelV20		equ	9
prefAlarmSoundLevelV20		equ	10
prefHidePrivateRecordsV33	equ	11
prefDeviceLocked		equ	12
prefLocalSyncRequiresPassword	equ	13
prefRemoteSyncRequiresPassword	equ	14
prefSysBatteryKind		equ	15
prefAllowEasterEggs		equ	16
prefMinutesWestOfGMT		equ	17
prefDaylightSavings		equ	18
prefRonamaticChar		equ	19
prefHard1CharAppCreator		equ	20
prefHard2CharAppCreator		equ	21
prefHard3CharAppCreator		equ	22
prefHard4CharAppCreator		equ	23
prefCalcCharAppCreator		equ	24
prefHardCradleCharAppCreator	equ	25
prefLauncherAppCreator		equ	26
prefSysPrefFlags		equ	27
prefHardCradle2CharAppCreator	equ	28
prefAnimationLevel		equ	29
; Additions for PalmOS 3.0:
prefSysSoundVolume		equ	30
prefGameSoundVolume		equ	31
prefAlarmSoundVolume		equ	32
prefBeamReceive			equ	33
prefCalibrateDigitizerAtReset	equ	34
prefSystemKeyboardID		equ	35
prefDefSerialPlugIn		equ	36
; Additions for PalmOS 3.1:
prefStayOnWhenPluggedIn		equ	37
prefStayLitWhenPluggedIn	equ	38
; Additions for PalmOS 3.2:
prefAntennaCharAppCreator	equ	39
; Additions for PalmOS 3.3:
prefMeasurementSystem		equ	40
; Additions for PalmOS 3.5:
prefShowPrivateRecords		equ	41
prefAutoOffDurationSecs		equ	42

; ui/Event.h

frmTitleEnterEvent	equ	29
frmTitleSelectEvent	equ	30
tblExitEvent		equ	31
sclEnterEvent		equ	32
sclExitEvent		equ	33
sclRepeatEvent		equ	34

appEvtHookKeyMask	equ	$0200
libEvtHookKeyMask	equ	$0400

struct frmTitleEnter
    formID.w
endstruct

struct frmTitleSelect
    formID.w
endstruct

struct sclEnter
    scrollBarID.w
    pScrollBar.l
endstruct

struct sclExit
    scrollBarID.w
    pScrollBar.l
    value.w
    newValue.w
endstruct

struct sclRepeat
    scrollBarID.w
    pScrollBar.l
    value.w
    newValue.w
    time.l
endstruct

; ui/Progress.h

progressMaxMessage	equ	128
progressMaxTitle	equ	20

struct PrgCallbackData
    stage.w
    textP.l
    textLen.w
    message.l
    error.w
    bitmapId.w
    flags.w	;for pila
    timeout.l
    barMaxValue.l
    barCurValue.l
    barMessage.l
    barFlags.w
endstruct

PrgCallbackData_Flag_canceled_shift	equ	0
PrgCallbackData_Flag_canceled_count	equ	1
PrgCallbackData_Flag_canceled_mask	equ	$0001
PrgCallbackData_Flag_showDetails_shift	equ	1
PrgCallbackData_Flag_showDetails_count	equ	1
PrgCallbackData_Flag_showDetails_mask	equ	$0002
PrgCallbackData_Flag_textChanged_shift	equ	2
PrgCallbackData_Flag_textChanged_count	equ	1
PrgCallbackData_Flag_textChanged_mask	equ	$0004
PrgCallbackData_Flag_timedOut_shift	equ	3
PrgCallbackData_Flag_timedOut_count	equ	1
PrgCallbackData_Flag_timedOut_mask	equ	$0008

struct ProgressType
    frmP.l
    timeout.l
    flags.w
    error.w
    stage.w
    message.130		;129
    lastBitmapID.w
    ctlLabel.8
    serviceNameP.l
    lastBarMaxValue.l
    lastBarCurValue.l
    oldDrawWinH.l
    oldActiveWinH.l
    oldFrmP.l
    oldInsPtState.w	;.b ?
    oldInsPtPos.PointType
    textCallback.l
    title.22		;21
endstruct

ProgressType_Flag_needUpdate_shift	equ	0
ProgressType_Flag_needUpdate_count	equ	1
ProgressType_Flag_needUpdate_mask	equ	$0001
ProgressType_Flag_cancel_shift		equ	1
ProgressType_Flag_cancel_count		equ	1
ProgressType_Flag_cancel_mask		equ	$0002
ProgressType_Flag_waitingForOK_shift	equ	2
ProgressType_Flag_waitingForOK_count	equ	1
ProgressType_Flag_waitingForOK_mask	equ	$0004
ProgressType_Flag_showDetails_shift	equ	3
ProgressType_Flag_showDetails_count	equ	1
ProgressType_Flag_showDetails_mask	equ	$0008
ProgressType_Flag_messageChanged_shift	equ	4
ProgressType_Flag_messageChanged_count	equ	1
ProgressType_Flag_messageChanged_mask	equ	$0010

; ui/ScrollBar.h

sclUpArrow	equ	0
sclDownArrow	equ	1
sclUpPage	equ	2
sclDownPage	equ	3
sclCar		equ	4

ScrollBarAttrType_usable_shift		equ	0
ScrollBarAttrType_usable_count		equ	1
ScrollBarAttrType_usable_mask		equ	$0001
ScrollBarAttrType_visible_shift		equ	1
ScrollBarAttrType_visible_count		equ	1
ScrollBarAttrType_visible_mask		equ	$0002
ScrollBarAttrType_hilighted_shift	equ	2
ScrollBarAttrType_hilighted_count	equ	1
ScrollBarAttrType_hilighted_mask	equ	$0004
ScrollBarAttrType_shown_shift		equ	3
ScrollBarAttrType_shown_count		equ	1
ScrollBarAttrType_shown_mask		equ	$0008
ScrollBarAttrType_activeRegion_shift	equ	4
ScrollBarAttrType_activeRegion_count	equ	4
ScrollBarAttrType_activeRegion_mask	equ	$00F0
ScrollBarAttrType_sizeof		equ	1

struct ScrollBarType
    bounds.RectangleType
    id.w
    attr.w
    value.w
    minValue.w
    maxValue.w
    pageSize.w
    penPosInCar.w
    savePos.w
endstruct

; ui/scrdrive.h (OS 3.x)

scrDisplayModeGetDefaults		equ	0
scrDisplayModeGet			equ	1
scrDisplayModeSetToDefaults		equ	2
scrDisplayModeSet			equ	3
scrDisplayModeGetSupportedDepths	equ	4
scrDisplayModeGetSupportsColor		equ	5

; system/window.h (OS 3.5)

winScreenModeGetDefaults		equ	0
winScreenModeGet			equ	1
winScreenModeSetToDefaults		equ	2
winScreenModeSet			equ	3
winScreenModeGetSupportedDepths		equ	4
winScreenModeGetSupportsColor		equ	5

; system/systemmgr.rh

sysFileCSystem			equ	'psys'
sysFileCGraffiti		equ	'graf'
sysFileCSystemPatch		equ	'ptch'

sysFileCCalculator		equ	'calc'
sysFileCSecurity		equ	'secr'
sysFileCPreferences		equ	'pref'
sysFileCAddress			equ	'addr'
sysFileCToDo			equ	'todo'
sysFileCDatebook		equ	'date'
sysFileCMemo			equ	'memo'
sysFileCSync			equ	'sync'
sysFileCMemory			equ	'memr'
sysFileCMail			equ	'mail'
sysFileCExpense			equ	'exps'
sysFileCLauncher		equ	'lnch'

sysFileCGraffitiDemo		equ	'gdem'
sysFileCMailDemo		equ	'mdem'

sysFileCFirstApp		equ	sysFileCPreferences
sysFileCDefaultApp		equ	sysFileCPreferences
sysFileCDefaultButton1App	equ	sysFileCDatebook
sysFileCDefaultButton2App	equ	sysFileCAddress
sysFileCDefaultButton3App	equ	sysFileCToDo
sysFileCDefaultButton4App	equ	sysFileCMemo
sysFileCDefaultCalcButtonApp	equ	sysFileCCalculator
sysFileCDefaultCradleApp	equ	sysFileCSync
sysFileCDefaultModemApp		equ	sysFileCSync
sysFileCNullApp			equ	'0000'

sysFileCDigitizer		equ	'digi'
sysFileCGeneral			equ	'gnrl'
sysFileCFormats			equ	'frmt'
sysFileCShortCuts		equ	'shct'
sysFileCButtons			equ	'bttn'
sysFileCOwner			equ	'ownr'
sysFileCModemPanel		equ	'modm'
sysFileCDialPanel		equ	'dial'
sysFileCNetworkPanel		equ	'netw'
sysFileCPADHtal			equ	'hpad'
sysFileCTCPHtal			equ	'htcp'
sysFileCMineHunt		equ	'mine'
sysFileCPuzzle15		equ	'puzl'
sysFileCOpenLibInfo		equ	'olbi'

sysFileTLibrary			equ	'libr'

sysFileCNet			equ	'netl'
sysFileCIrLib 			equ	'irda'

sysFileCSerialHwrMgr		equ	'shwm'
sysFileCSerialWrapper		equ	'swrp'
sysFileCIrSerialWrapper		equ	'iwrp'

sysFileTUartPlugIn		equ	'sdrv'
sysFileCUart328 		equ	'u328'
sysFileCUart650 		equ	'u650'

sysFileTSystem			equ	'rsrc'
sysFileTSystemPatch		equ	'ptch'
sysFileTKernel			equ	'krnl'
sysFileTUIAppShell		equ	'uish'
sysFileTExtension		equ	'extn'
sysFileTApplication		equ	'appl'
sysFileTPanel			equ	'panl'
sysFileTSavedPreferences	equ	'sprf'
sysFileTPreferences		equ	'pref'
sysFileTMidi			equ	'smfr'
sysFileTGraffitiMacros		equ	'macr'
sysFileTHtalLib			equ	'htal'
sysFileTExgLib			equ	'exgl'
sysFileTFileStream		equ	'strm'
sysFileTTemp			equ	'temp'

; system/systemmgr.h

sysFtrCreator			equ	sysFileCSystem
sysFtrNumProcessorID		equ	2
sysFtrNumProcessorMask		equ	$FFFF0000
sysFtrNumProcessor328		equ	$00010000
sysFtrNumProcessorEZ		equ	$00020000
sysFtrNumBacklight		equ	3
sysFtrNumEncryption		equ	4
sysFtrNumEncryptionMaskDES	equ	$00000001
sysFtrNumCountry		equ	5
sysFtrNumLanguage		equ	6
sysFtrNumDisplayDepth		equ	7

sysErrDelayWakened		equ	$0000050b
sysErrRomIncompatible		equ	$0000050c

; system/systraps.h

; PalmOS 2.X traps
sysTrapSclSetScrollBar			equ	41654
sysTrapSclDrawScrollBar			equ	41655
sysTrapSclHandleEvent			equ	41656
sysTrapSysMailboxCreate			equ	41657
sysTrapSysMailboxDelete			equ	41658
sysTrapSysMailboxFlush			equ	41659
sysTrapSysMailboxSend			equ	41660
sysTrapSysMailboxWait			equ	41661
sysTrapSysTaskWait			equ	41662
sysTrapSysTaskWake			equ	41663
sysTrapSysTaskWaitClr			equ	41664
sysTrapSysTaskSuspend			equ	41665
sysTrapSysTaskResume			equ	41666
sysTrapCategoryCreateList		equ	41667
sysTrapCategoryFreeList			equ	41668
sysTrapCategoryEditV20			equ	41669
sysTrapCategorySelect			equ	41670
sysTrapDmDeleteCategory			equ	41671
sysTrapSysEvGroupCreate			equ	41672
sysTrapSysEvGroupSignal			equ	41673
sysTrapSysEvGroupRead			equ	41674
sysTrapSysEvGroupWait			equ	41675
sysTrapEvtEventAvail			equ	41676
sysTrapEvtSysEventAvail			equ	41677
sysTrapStrNCopy				equ	41678
sysTrapKeySetMask			equ	41679
sysTrapSelectDay			equ	41680
sysTrapPrefGetPreference		equ	41681
sysTrapPrefSetPreference		equ	41682
sysTrapPrefGetAppPreferences		equ	41683
sysTrapPrefSetAppPreferences		equ	41684
sysTrapFrmPointInTitle			equ	41685
sysTrapStrNCat				equ	41686
sysTrapMemCmp				equ	41687
sysTrapTblSetColumnEditIndicator	equ	41688
sysTrapFntWordWrap			equ	41689
sysTrapFldGetScrollValues		equ	41690
sysTrapSysCreateDataBaseList		equ	41691
sysTrapSysCreatePanelList		equ	41692
sysTrapDlkDispatchRequest		equ	41693
sysTrapStrPrintF			equ	41694
sysTrapStrVPrintF			equ	41695
sysTrapPrefOpenPreferenceDB		equ	41696
sysTrapSysGraffitiReferenceDialog	equ	41697
sysTrapSysKeyboardDialog		equ	41698
sysTrapFntWordWrapReverseNLines		equ	41699
sysTrapFntGetScrollValues		equ	41700
sysTrapTblSetRowStaticHeight		equ	41701
sysTrapTblHasScrollBar			equ	41702
sysTrapSclGetScrollBar			equ	41703
sysTrapFldGetNumberOfBlankLines		equ	41704
sysTrapSysTicksPerSecond		equ	41705
sysTrapHwrBacklight			equ	41706
sysTrapDmDatabaseProtect		equ	41707
sysTrapTblSetBounds			equ	41708
sysTrapStrNCompare			equ	41709
sysTrapStrNCaselessCompare		equ	41710
sysTrapPhoneNumberLookup		equ	41711
sysTrapFrmSetMenu			equ	41712
sysTrapEncDigestMD5			equ	41713
sysTrapDmFindSortPosition		equ	41714
sysTrapSysBinarySearch			equ	41715
sysTrapSysErrString			equ	41716
sysTrapSysStringByIndex			equ	41717
sysTrapEvtAddUniqueEventToQueue		equ	41718
sysTrapStrLocalizeNumber		equ	41719
sysTrapStrDelocalizeNumber		equ	41720
sysTrapLocGetNumberSeparators		equ	41721
sysTrapMenuSetActiveMenuRscID		equ	41722
sysTrapLstScrollList			equ	41723
sysTrapCategoryInitialize		equ	41724
sysTrapEncDigestMD4			equ	41725
sysTrapEncDES				equ	41726
sysTrapLstGetVisibleItems		equ	41727
sysTrapWinSetWindowBounds		equ	41728
sysTrapCategorySetName			equ	41729
sysTrapFldSetInsertionPoint		equ	41730
sysTrapFrmSetObjectBounds		equ	41731
sysTrapWinSetColors			equ	41732
sysTrapFlpDispatch			equ	41733
sysTrapFlpEmDispatch			equ	41734
; PalmOS 3.0 traps
sysTrapExgInit				equ	41735
sysTrapExgConnect			equ	41736
sysTrapExgPut				equ	41737
sysTrapExgGet				equ	41738
sysTrapExgAccept			equ	41739
sysTrapExgDisconnect			equ	41740
sysTrapExgSend				equ	41741
sysTrapExgReceive			equ	41742
sysTrapExgRegisterData			equ	41743
sysTrapExgNotifyReceive			equ	41744
sysTrapExgControl			equ	41745
;sysTrapPrgStartDialog			equ	41746
sysTrapPrgStartDialogV31		equ	41746
sysTrapPrgStopDialog			equ	41747
sysTrapPrgUpdateDialog			equ	41748
sysTrapPrgHandleEvent			equ	41749
sysTrapImcReadFieldNoSemicolon		equ	41750
sysTrapImcReadFieldQuotablePrintable	equ	41751
sysTrapImcReadPropertyParameter		equ	41752
sysTrapImcSkipAllPropertyParameters	equ	41753
sysTrapImcReadWhiteSpace		equ	41754
sysTrapImcWritequotedPrintable		equ	41755
sysTrapImcWriteNoSemicolon		equ	41756
sysTrapImcStringIsAscii			equ	41757
sysTrapTblGetItemFont			equ	41758
sysTrapTblSetItemFont			equ	41759
sysTrapFontSelect			equ	41760
sysTrapFntDefineFont			equ	41761
sysTrapCategoryEdit			equ	41762
sysTrapSysGetOSVersionString		equ	41763
sysTrapSysBatteryInfo			equ	41764
sysTrapSysUIBusy			equ	41765
sysTrapWinValidateHandle		equ	41766
sysTrapFrmValidatePtr			equ	41767
sysTrapCtlValidatePointer		equ	41768
sysTrapWinMoveWindowAddr		equ	41769
sysTrapFrmAddSpaceForObject		equ	41770
sysTrapFrmNewForm			equ	41771
sysTrapCtlNewControl			equ	41772
sysTrapFldNewField			equ	41773
sysTrapLstNewList			equ	41774
sysTrapFrmNewLabel			equ	41775
sysTrapFrmNewBitmap			equ	41776
sysTrapFrmNewGadget			equ	41777
sysTrapFileOpen				equ	41778
sysTrapFileClose			equ	41779
sysTrapFileDelete			equ	41780
sysTrapFileReadLow			equ	41781
sysTrapFileWrite			equ	41782
sysTrapFileSeek				equ	41783
sysTrapFileTell				equ	41784
sysTrapFileTruncate			equ	41785
sysTrapFileControl			equ	41786
sysTrapFrmActiveState			equ	41787
sysTrapSysGetAppInfo			equ	41788
sysTrapSysGetStackInfo			equ	41789
sysTrapScrDisplayMode			equ	41790
sysTrapHwrLCDGetDepth			equ	41791
sysTrapHwrGetROMToken			equ	41792
sysTrapDbgControl			equ	41793
sysTrapExgDBRead			equ	41794
sysTrapExgDBWrite			equ	41795
sysTrapSysGremlins			equ	41796
sysTrapFrmRemoveObject			equ	41797
sysTrapSysReserved1			equ	$A346
sysTrapSysReserved2			equ	$A347
sysTrapSysReserved3			equ	$A348
sysTrapOEMDispatch			equ	$A349
; Palm OS 3.1 traps
sysTrapHwrLCDContrastV33		equ	$A34A
sysTrapSysLCDContrast			equ	$A34B
sysTrapUIContrastAdjust			equ	$A34C
sysTrapHwrDockStatus			equ	$A34D
sysTrapFntWidthToOffset			equ	$A34E
sysTrapSelectOneTime			equ	$A34F
sysTrapWinDrawChar			equ	$A350
sysTrapWinDrawTruncChars		equ	$A351
sysTrapSysNotifyInit			equ	$A352
sysTrapSysNotifyRegister		equ	$A353
sysTrapSysNotifyUnregister		equ	$A354
sysTrapSysNotifyBroadcast		equ	$A355
sysTrapSysNotifyBroadcastDeferred	equ	$A356
sysTrapSysNotifyDatabaseAdded		equ	$A357
sysTrapSysNotifyDatabaseRemoved		equ	$A358
sysTrapSysWantEvent			equ	$A359
sysTrapFtrPtrNew			equ	$A35A
sysTrapFtrPtrFree			equ	$A35B
sysTrapFtrPtrResize			equ	$A35C
sysTrapSysReserved5			equ	$A35D
; Palm OS 3.2 & 3.3 traps
sysTrapHwrNVPrefSet			equ	$A35E
sysTrapHwrNVPrefGet			equ	$A35F
sysTrapFlashInit			equ	$A360
sysTrapFlashCompress			equ	$A361
sysTrapFlashErase			equ	$A362
sysTrapFlashProgram			equ	$A363
sysTrapAlmTimeChange			equ	$A364
sysTrapErrAlertCustom			equ	$A365
sysTrapPrgStartDialog			equ	$A366
sysTrapSerialDispatch			equ	$A367
sysTrapHwrBattery			equ	$A368
sysTrapDmGetDatabaseLockState		equ	$A369
sysTrapCncGetProfileList		equ	$A36A
sysTrapCncGetProfileInfo		equ	$A36B
sysTrapCncAddProfile			equ	$A36C
sysTrapCncDeleteProfile			equ	$A36D
sysTrapSndPlaySmfResource		equ	$A36E
sysTrapMemPtrDataStorage		equ	$A36F
sysTrapClipboardAppendItem		equ	$A370
sysTrapWiCmdV32				equ	$A371
; TRAPS ABOVE THIS POINT CAN NOT CHANGE BECAUSE THEY HAVE
; BEEN RELEASED TO CUSTOMERS IN SHIPPING ROMS AND SDKS.
; (MOVE THIS COMMENT DOWN WHENEVER THE "NEXT" RELEASE OCCURS.)
; Palm OS 3.5
sysTrapWinScreenInit			equ	sysTrapScrInit
sysTrapWinScreenMode			equ	sysTrapScrDisplayMode
sysTrapHwrDisplayAttributes		equ	$A372
sysTrapHwrDisplayDoze			equ	$A373
sysTrapHwrDisplayPalette		equ	$A374
sysTrapBltFindIndexes			equ	$A375
sysTrapBmpGetBits			equ	$A376
sysTrapBltCopyRectangle			equ	$A377
sysTrapBltDrawChars			equ	$A378
sysTrapBltLineRoutine			equ	$A379
sysTrapBltRectangleRoutine		equ	$A37A
sysTrapScrCompress			equ	$A37B
sysTrapScrDecompress			equ	$A37C
sysTrapSysLCDBrightness			equ	$A37D
sysTrapWinPaintChar			equ	$A37E
sysTrapWinPaintChars			equ	$A37F
sysTrapWinPaintBitmap			equ	$A380
sysTrapWinGetPixel			equ	$A381
sysTrapWinPaintPixel			equ	$A382
sysTrapWinDrawPixel			equ	$A383
sysTrapWinErasePixel			equ	$A384
sysTrapWinInvertPixel			equ	$A385
sysTrapWinPaintPixels			equ	$A386
sysTrapWinPaintLines			equ	$A387
sysTrapWinPaintLine			equ	$A388
sysTrapWinPaintRectangle		equ	$A389
sysTrapWinPaintRectangleFrame		equ	$A38A
sysTrapWinPaintPolygon			equ	$A38B
sysTrapWinDrawPolygon			equ	$A38C
sysTrapWinErasePolygon			equ	$A38D
sysTrapWinInvertPolygon			equ	$A38E
sysTrapWinFillPolygon			equ	$A38F
sysTrapWinPaintArc			equ	$A390
sysTrapWinDrawArc			equ	$A391
sysTrapWinEraseArc			equ	$A392
sysTrapWinInvertArc			equ	$A393
sysTrapWinFillArc			equ	$A394
sysTrapWinPushDrawState			equ	$A395
sysTrapWinPopDrawState			equ	$A396
sysTrapWinSetDrawMode			equ	$A397
sysTrapWinSetForeColor			equ	$A398
sysTrapWinSetBackColor			equ	$A399
sysTrapWinSetTextColor			equ	$A39A
sysTrapWinGetPatternType		equ	$A39B
sysTrapWinSetPatternType		equ	$A39C
sysTrapWinPalette			equ	$A39D
sysTrapWinRGBToIndex			equ	$A39E
sysTrapWinIndexToRGB			equ	$A39F
sysTrapWinScreenLock			equ	$A3A0
sysTrapWinScreenUnlock			equ	$A3A1
sysTrapWinGetBitmap			equ	$A3A2
sysTrapUIColorInit			equ	$A3A3
sysTrapUIColorGetTableEntryIndex	equ	$A3A4
sysTrapUIColorGetTableEntryRGB		equ	$A3A5
sysTrapUIColorSetTableEntry		equ	$A3A6
sysTrapUIColorPushTable			equ	$A3A7
sysTrapUIColorPopTable			equ	$A3A8
sysTrapCtlNewGraphicControl		equ	$A3A9
sysTrapTblGetItemPtr			equ	$A3AA
sysTrapUIBrightnessAdjust		equ	$A3AB
sysTrapUIPickColor			equ	$A3AC
sysTrapEvtSetAutoOffTimer		equ	$A3AD
sysTrapTsmDispatch			equ	$A3AE
sysTrapOmDispatch			equ	$A3AF
sysTrapDmOpenDBNoOverlay		equ	$A3B0
sysTrapDmOpenDBWithLocale		equ	$A3B1
sysTrapResLoadConstant			equ	$A3B2
sysTrapHwrPreDebugInit			equ	$A3B3
sysTrapHwrResetNMI			equ	$A3B4
sysTrapHwrResetPWM			equ	$A3B5
sysTrapKeyBootKeys			equ	$A3B6
sysTrapDbgSerDrvOpen			equ	$A3B7
sysTrapDbgSerDrvClose			equ	$A3B8
sysTrapDbgSerDrvControl			equ	$A3B9
sysTrapDbgSerDrvStatus			equ	$A3BA
sysTrapDbgSerDrvWriteChar		equ	$A3BB
sysTrapDbgSerDrvReadChar		equ	$A3BC
sysTrapHwrPostDebugInit			equ	$A3BD
sysTrapHwrIdentifyFeatures		equ	$A3BE
sysTrapHwrModelSpecificInit		equ	$A3BF
sysTrapHwrModelInitStage2		equ	$A3C0
sysTrapHwrInterruptsInit		equ	$A3C1
sysTrapHwrSoundOn			equ	$A3C2
sysTrapHwrSoundOff			equ	$A3C3
sysTrapSysKernelClockTick		equ	$A3C4
sysTrapMenuEraseMenu			equ	$A3C5
sysTrapSelectTime			equ	$A3C6
sysTrapMenuCmdBarAddButton		equ	$A3C7
sysTrapMenuCmdBarGetButtonData		equ	$A3C8
sysTrapMenuCmdBarDisplay		equ	$A3C9
sysTrapHwrGetSilkscreenID		equ	$A3CA
sysTrapEvtGetSilkscreenAreaList		equ	$A3CB
sysTrapSysFatalAlertInit		equ	$A3CC
sysTrapDateTemplateToAscii		equ	$A3CD
sysTrapSecVerifyPW			equ	$A3CE
sysTrapSecSelectViewStatus		equ	$A3CF
sysTrapTblSetColumnMasked		equ	$A3D0
sysTrapTblSetRowMasked			equ	$A3D1
sysTrapTblRowMasked			equ	$A3D2
sysTrapFrmCustomResponseAlert		equ	$A3D3
sysTrapFrmNewGsi			equ	$A3D4
sysTrapMenuShowItem			equ	$A3D5
sysTrapMenuHideItem			equ	$A3D6
sysTrapMenuAddItem			equ	$A3D7
sysTrapFrmSetGadgetHandler		equ	$A3D8
sysTrapCtlSetGraphics			equ	$A3D9
sysTrapCtlGetSliderValues		equ	$A3DA
sysTrapCtlSetSliderValues		equ	$A3DB
sysTrapCtlNewSliderControl		equ	$A3DC
sysTrapBmpCreate			equ	$A3DD
sysTrapBmpDelete			equ	$A3DE
sysTrapBmpCompress			equ	$A3DF
sysTrapBmpGetColortable			equ	$A3E0
sysTrapBmpSize				equ	$A3E1
sysTrapBmpBitsSize			equ	$A3E2
sysTrapBmpColortableSize		equ	$A3E3
sysTrapWinCreateBitmapWindow		equ	$A3E4
sysTrapEvtSetNullEventTick		equ	$A3E5
sysTrapExgDoDialog			equ	$A3E6
sysTrapSysUICleanup			equ	$A3E7
; WARNING!! LEAVE THIS AT THE END AND ALWAYS ADD NEW TRAPS TO
; THE END OF THE TRAP TABLE BUT RIGHT BEFORE THIS TRAP, AND THEN
; RENUMBER THIS ONE TO ONE MORE THAN THE ONE RIGHT BEFORE IT!!!!!!!!!
sysTrapLastTrapNumber			set	$A3E8

; system/ErrorBase.h

errNone			equ	$0000
memErrorClass		equ	$0100
dmErrorClass		equ	$0200
serErrorClass		equ	$0300
slkErrorClass		equ	$0400
sysErrorClass		equ	$0500
fplErrorClass		equ	$0600
flpErrorClass		equ	$0680
evtErrorClass		equ	$0700
sndErrorClass		equ	$0800
almErrorClass		equ	$0900
timErrorClass		equ	$0A00
penErrorClass		equ	$0B00
ftrErrorClass		equ	$0C00
cmpErrorClass		equ	$0D00
dlkErrorClass		equ	$0E00
padErrorClass		equ	$0F00
grfErrorClass		equ	$1000
mdmErrorClass		equ	$1100
netErrorClass		equ	$1200
htalErrorClass		equ	$1300
inetErrorClass		equ	$1400
exgErrorClass		equ	$1500
fileErrorClass		equ	$1600
rfutErrorClass		equ	$1700
txtErrorClass		equ	$1800
tsmErrorClass		equ	$1900
webErrorClass		equ	$1A00
secErrorClass		equ	$1B00
emuErrorClass		equ	$1C00
flshErrorClass		equ	$1D00
pwrErrorClass		equ	$1E00
cncErrorClass		equ	$1F00
actvErrorClass		equ	$2000
radioErrorClass		equ	$2100
dispErrorClass		equ	$2200
bltErrorClass		equ	$2300
winErrorClass		equ	$2400
omErrorClass		equ	$2500
menuErrorClass		equ	$2600
oemErrorClass		equ	$7000
errInfoClass		equ	$7F00
appErrorClass		equ	$8000

; system/SerialMgrOld.h

serErrBadParam		equ	serErrorClass|1
serErrBadPort		equ	serErrorClass|2
serErrNoMem		equ	serErrorClass|3
serErrBadConnID		equ	serErrorClass|4
serErrTimeOut		equ	serErrorClass|5
serErrLineErr		equ	serErrorClass|6
serErrAlreadyOpen	equ	serErrorClass|7
serErrStillOpen		equ	serErrorClass|8
serErrNotOpen		equ	serErrorClass|9
serErrNotSupported	equ	serErrorClass|10

serPortDefault		equ	$0000
serPortLocalHotSync	equ	$8000
serPortMaskLocal	equ	$7FFF

struct SerSettingsType
    baudRate.l
    flags.l
    ctsTimeout.l
endstruct											// before transmitting; used only when

serSettingsFlagStopBitsM	equ	$00000001
serSettingsFlagStopBits1	equ	$00000000
serSettingsFlagStopBits2	equ	$00000001
serSettingsFlagParityOnM	equ	$00000002
serSettingsFlagParityEvenM	equ	$00000004
serSettingsFlagXonXoffM		equ	$00000008
serSettingsFlagRTSAutoM		equ	$00000010
serSettingsFlagCTSAutoM		equ	$00000020
serSettingsFlagBitsPerCharM	equ	$000000C0
serSettingsFlagBitsPerChar5	equ	$00000000
serSettingsFlagBitsPerChar6	equ	$00000040
serSettingsFlagBitsPerChar7	equ	$00000080
serSettingsFlagBitsPerChar8	equ	$000000C0

serDefaultSettings		equ	serSettingsFlagBitsPerChar8|serSettingsFlagStopBits1|serSettingsFlagRTSAutoM

serDefaultCTSTimeout		equ	5*sysTicksPerSecond

serLineErrorParity		equ	$0001
serLineErrorHWOverrun		equ	$0002
serLineErrorFraming		equ	$0004
serLineErrorBreak		equ	$0008
serLineErrorHShake		equ	$0010
serLineErrorSWOverrun		equ	$0020
serLineErrorCarrierLost		equ	$0040

struct SerCallbackEntryType
    funcP.l
    userRef.l
endstruct

serCtlFirstReserved		equ	0
serCtlStartBreak		equ	1
serCtlStopBreak			equ	2
serCtlBreakStatus		equ	3
serCtlStartLocalLoopback	equ	4
serCtlStopLocalLoopback		equ	5
serCtlMaxBaud			equ	6
serCtlHandshakeThreshold	equ	7
serCtlEmuSetBlockingHook	equ	8
serCtlIrDAEnable		equ	9
serCtlIrDADisable		equ	10
serCtlIrScanningOn		equ	11
serCtlIrScanningOff		equ	12
serCtlRxEnable			equ	13
serCtlRxDisable			equ	14
serCtlLAST			equ	15

serCtlFirstCustomEntry		equ	$A800

SerOpen			equ	sysLibTrapOpen
	;Err SerOpen(UInt16 refNum, UInt16 port, UInt32 baud)
SerClose		equ	sysLibTrapClose
	;Err SerClose(UInt16 refNum)
SerSleep		equ	sysLibTrapSleep
	;Err SerSleep(UInt16 refNum)
SerWake			equ	sysLibTrapWake
	;Err SerWake(UInt16 refNum)
SerGetSettings		equ	sysLibTrapCustom
	;Err SerGetSettings(UInt16 refNum, SerSettingsPtr settingsP)
SerSetSettings		equ	sysLibTrapCustom+1
	;Err SerSetSettings(UInt16 refNum, SerSettingsPtr settingsP)
SerGetStatus		equ	sysLibTrapCustom+2
	;UInt16 SerGetStatus(UInt16 refNum, Boolean * ctsOnP, Boolean * dsrOnP)
SerClearErr		equ	sysLibTrapCustom+3
	;Err SerClearErr(UInt16 refNum)
SerSend10		equ	sysLibTrapCustom+4
	;Err SerSend10(UInt16 refNum, void * bufP, UInt32 size)
SerSendWait		equ	sysLibTrapCustom+5
	;Err SerSendWait(UInt16 refNum, Int32 timeout)
SerSendCheck		equ	sysLibTrapCustom+6
	;Err SerSendCheck(UInt16 refNum, UInt32 * numBytesP)
SerSendFlush		equ	sysLibTrapCustom+7
	;Err SerSendFlush(UInt16 refNum)
SerReceive10		equ	sysLibTrapCustom+8
	;Err SerReceive10(UInt16 refNum, void * bufP, UInt32 bytes, Int32 timeout)
SerReceiveWait		equ	sysLibTrapCustom+9
	;Err SerReceiveWait(UInt16 refNum, UInt32 bytes, Int32 timeout)
SerReceiveCheck		equ	sysLibTrapCustom+10
	;Err SerReceiveCheck(UInt16 refNum, UInt32 * numBytesP)
SerReceiveFlush		equ	sysLibTrapCustom+11
	;void SerReceiveFlush(UInt16 refNum, Int32 timeout)
SerSetReceiveBuffer	equ	sysLibTrapCustom+12
	;Err SerSetReceiveBuffer(UInt16 refNum, void * bufP, UInt16 bufSize)
SerReceiveISP		equ	sysTrapSerReceiveISP
	;Boolean SerReceiveISP(void)
SerReceiveWindowOpen	equ	sysLibTrapCustom+13
	;Err	SerReceiveWindowOpen(UInt16 refNum, UInt8 ** bufPP, UInt32 * sizeP)
SerReceiveWindowClose	equ	sysLibTrapCustom+14
	;Err	SerReceiveWindowClose(UInt16 refNum, UInt32 bytesPulled)
SerSetWakeupHandler	equ	sysLibTrapCustom+15
	;Err	SerSetWakeupHandler(UInt16 refNum, SerWakeupHandler procP, UInt32 refCon)
SerPrimeWakeupHandler	equ	sysLibTrapCustom+16
	;Err	SerPrimeWakeupHandler(UInt16 refNum, UInt16 minBytes)
SerControl		equ	sysLibTrapCustom+17
	;Err	SerControl(UInt16 refNum, UInt16 op, void * valueP, UInt16 * valueLenP)
SerSend			equ	sysLibTrapCustom+18
	;UInt32 SerSend(UInt16 refNum, void * bufP, UInt32 count, Err* errP)
SerReceive		equ	sysLibTrapCustom+19
	;UInt32 SerReceive(UInt16 refNum, void * bufP, UInt32 count, Int32 timeout, Err* errP)

; system/SerialMgr.h

sysFileCSerialMgr	equ	'smgr'	;system/Resources.h
sysFtrNewSerialPresent	equ	1

serErrNoDevicesAvail	equ	serErrorClass|11

serPortCradlePort	equ	$8000
serPortIrPort		equ	$8001

srmSettingsFlagStopBitsM	equ	$00000001
srmSettingsFlagStopBits1	equ	$00000000
srmSettingsFlagStopBits2	equ	$00000001
srmSettingsFlagParityOnM	equ	$00000002
srmSettingsFlagParityEvenM	equ	$00000004
srmSettingsFlagXonXoffM		equ	$00000008
srmSettingsFlagRTSAutoM		equ	$00000010
srmSettingsFlagCTSAutoM		equ	$00000020
srmSettingsFlagBitsPerCharM	equ	$000000C0
srmSettingsFlagBitsPerChar5	equ	$00000000
srmSettingsFlagBitsPerChar6	equ	$00000040
srmSettingsFlagBitsPerChar7	equ	$00000080
srmSettingsFlagBitsPerChar8	equ	$000000C0
srmSettingsFlagFlowControl	equ	$00000100

srmDefaultSettings		equ	srmSettingsFlagBitsPerChar8|srmSettingsFlagStopBits1|srmSettingsFlagRTSAutoM

srmDefaultCTSTimeout		equ	5*sysTicksPerSecond

srmStatusCtsOn			equ	$00000001
srmStatusRtsOn			equ	$00000002
srmStatusDsrOn			equ	$00000004
srmStatusBreakSigOn		equ	$00000008

serDevCradlePort		equ	$00000001
serDevRS232Serial		equ	$00000002
serDevIRDACapable		equ	$00000004
serDevModemPort			equ	$00000008
serDevCncMgrVisible		equ	$00000010

struct DeviceInfoType
    serDevCreator.l
    serDevFtrInfo.l
    serDevMaxBaudRate.l
    serDevHandshakeBaud.l
    serDevPortInfoStr.l
    reserved.8
endstruct

struct SrmCallbackEntryType
    BlockingHookProcPtr.l
    userRef.l
endstruct

srmCtlFirstReserved		equ	0
srmCtlSetBaudRate		equ	1
srmCtlGetBaudRate		equ	2
srmCtlSetFlags			equ	3
srmCtlGetFlags			equ	4
srmCtlSetCtsTimeout		equ	5
srmCtlGetCtsTimeout		equ	6
srmCtlStartBreak		equ	7
srmCtlStopBreak			equ	8
srmCtlStartLocalLoopback	equ	9
srmCtlStopLocalLoopback		equ	10
srmCtlIrDAEnable		equ	11
srmCtlIrDADisable		equ	12
srmCtlRxEnable			equ	13
srmCtlRxDisable			equ	14
srmCtlEmuSetBlockingHook	equ	15
srmCtlUserDef			equ	16
srmCtlGetOptimalTransmitSize	equ	17
srmCtlSetDTRAsserted		equ	18
srmCtlGetDTRAsserted		equ	19
srmCtlLAST			equ	20

sysSerialInstall		equ	0
sysSerialOpen			equ	1
sysSerialOpenBkgnd		equ	2
sysSerialClose			equ	3
sysSerialSleep			equ	4
sysSerialWake			equ	5
sysSerialGetDeviceCount		equ	6
sysSerialGetDeviceInfo		equ	7
sysSerialGetStatus		equ	8
sysSerialClearErr		equ	9
sysSerialControl		equ	10
sysSerialSend			equ	11
sysSerialSendWait		equ	12
sysSerialSendCheck		equ	13
sysSerialSendFlush		equ	14
sysSerialReceive		equ	15
sysSerialReceiveWait		equ	16
sysSerialReceiveCheck		equ	17
sysSerialReceiveFlush		equ	18
sysSerialSetRcvBuffer		equ	19
sysSerialRcvWindowOpen		equ	20
sysSerialRcvWindowClose		equ	21
sysSerialSetWakeupHandler	equ	22
sysSerialPrimeWakeupHandler	equ	23
