/*
 Copyright 1999 Palm Drop Power Games Assoc.  

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

#include <Pilot.h>		

#define AboutDialog 3000
#define FatalDialog 4000
#define RunButton 1005
#define DebugButton 1006
#define BugPicture 2001
#define FatalPicture 2002
#define Fatal2Picture 2003

static Boolean	endApp = false;
static Boolean	waitAns = false;
static short	prog = 1;
static short	limit = 0;
static short	score = 0;

static char 	prog1[] = "
#include<palmbug.h>

main()
{
    if (isWindowsCE()){
        Exit();
    }
    Crash();
}";

static char 	prog2[] = "
#include<palmbug.h>

main()
{
    while (isPalmOS()){
        doEventLoop();
    }
    Crash();
}";

void waitAmoment()
{
        int     i;
        int     j;

        for(i = 0; i < 300; i++)
                for(j = 0; j < 100; j++);

}

void waitTime(int interval)
{
	long  t;

        t = TimGetSeconds();
        for(;;){
		if(TimGetSeconds() >= t + interval) break;
	}
}

void drawBitmap(Int x, Int y, Int id)
{
        VoidHand h;
        VoidPtr p;

        h = DmGet1Resource('Tbmp', id);
        if(h != NULL){
                p = MemHandleLock(h);
                WinDrawBitmap((BitmapPtr)p, x, y);
                MemHandleUnlock(h);
                DmReleaseResource(h);
        }
}

void drawBug(Int bug)
{
	short	i;
        RectangleType r;

        r.topLeft.x = 104;
        r.topLeft.y = 138;
        r.extent.x = 80;
        r.extent.y = 16;
        WinEraseRectangle(&r, 0);

	for(i = 0; i < bug; i++){
		drawBitmap(i * 14 + 104, 138, BugPicture);
	}
	if(bug > 4){
        	WinDrawChars("RUN!", 4, 124, 108);
		waitTime(1);
	}
}

void drawScore()
{
        char temp[20];
        char temp2[10];
        RectangleType r;

        r.topLeft.x = 65;
        r.topLeft.y = 0;
        r.extent.x = 60;
        r.extent.y = 12;
        WinEraseRectangle(&r, 0);
	StrCopy(temp, "SCORE: ");
        StrIToA(temp2, score);
        StrCat(temp, temp2);
        WinDrawChars(temp, StrLen(temp), 65, 0);
}

void drawText(Int x, Int y, char * text)
{
	char *	p;
	Int	px;
	Int	py;
        RectangleType r;

        r.topLeft.x = 2;
        r.topLeft.y = 18;
        r.extent.x = 158;
        r.extent.y = 108;
        WinEraseRectangle(&r, 0);

	p = text;
	px = x;
	py = y;
	for(;;){
		if(p >= text + StrLen(text)) break;
		if(*p == '\n'){
			py += FntCharHeight();
			px = x;
			SndPlaySystemSound(sndClick);
		}
		else if(*p == '\r'){
		}
		else
			WinDrawChars(p, 1, px, py);
		px += FntCharsWidth(p, 1);
		p++;
		waitAmoment();
	}
}

void fatalErr()
{
	FormPtr	frm;
        RectangleType r;

	SndPlaySystemSound(sndError);
       	frm = FrmInitForm(FatalDialog);
        FrmDoDialog(frm);
        FrmDeleteForm(frm);
	drawBitmap(0, 0, FatalPicture);	
	waitTime(1);

        r.topLeft.x = 1;
        r.topLeft.y = 1;
        r.extent.x = 158;
        r.extent.y = 158;
	WinInvertRectangle(&r, 0);
	waitTime(1);
	WinInvertRectangle(&r, 0);
	waitTime(1);
	WinInvertRectangle(&r, 0);
	waitTime(1);
	endApp = true;
}

void checkAns(Boolean run)
{
	if(prog == 0){
		if(!run){
			waitAns = false;
			limit = 0;
			score += 10;
			SndPlaySystemSound(sndClick);
		}
		else
			fatalErr();
	}
	else if(prog == 1){
		if(run){
			waitAns = false;
			limit = 0;
			score += 10;
			SndPlaySystemSound(sndClick);
		}
		else{
			waitAns = false;
			limit = 0;
			score -= 5;
			SndPlaySystemSound(sndError);
		}
	}
}

void StartApplication(void)
{
	FormPtr	frm;

	frm = FrmInitForm(1000);	
	FrmSetActiveForm(frm);
	FrmDrawForm(frm);

	drawScore();
}

Boolean MainFormHandleEvent(EventPtr event)
{
	Boolean		handled = false;
	FormPtr		frm;

	if(event->eType == frmTitleSelectEvent){
	        frm = FrmInitForm(AboutDialog);
                FrmDoDialog(frm);
                FrmDeleteForm(frm);
	}
	else if(event->eType == ctlSelectEvent){
		switch(event->data.ctlEnter.controlID){
		case RunButton:
			checkAns(true);
			break;
		case DebugButton:
			checkAns(false);
			break;
		default:
			break;
		}
	}
	else if(event->eType == keyDownEvent){
		switch(event->data.keyDown.chr){
		case pageDownChr:
			checkAns(false);
			break;
		case pageUpChr:
			checkAns(true);
			break;
		default:
			break;
		}
	}
	else if(event->eType == nilEvent){
		drawBug(limit);
		drawScore();
		if(!waitAns){
			prog = SysRandom(0) % 2;
			switch(prog){
			case 0:
				drawText(10, 15, prog1);
				break;
			case 1:
				drawText(10, 15, prog2);
				break;
			}
			waitAns = true;
		}
		else{
			limit++;
			if(limit > 5){
				score -= 20;
				checkAns(true);
			}
		}
	}
	return handled;
}

void EventLoop(void)
{
	EventType	event;

	do{
		EvtGetEvent(&event, 50); 
		if(!SysHandleEvent(&event))
                        if(!MainFormHandleEvent(&event))
                                FrmHandleEvent(FrmGetActiveForm(), &event);
		if(endApp) return;
	} 
	while (event.eType != appStopEvent);
}

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
	if(cmd != sysAppLaunchCmdNormalLaunch) return 0;
	StartApplication();
	EventLoop();
	return 0;
}
