/**	
	$Author: dizzy $
	$Revision: 1.9 $
	Last updated: $Date: 2000/11/15 18:58:42 $
	
	$Log: CoinsPref.h,v $
	Revision 1.9  2000/11/15 18:58:42  dizzy
	New balance adjust option in transaction form menu.
	Help updated in Transaction form and Accounts form.
	Merged ShowScrollArrows functions.
	Updated a few variable and function names.
	
	Revision 1.8  2000/10/12 17:17:24  dizzy
	Email address update; lots of bugfixes
	
	Revision 1.7  2000/10/08 15:40:46  dizzy
	Fixed a load of bugs related to transaction support.
	Displaying i/e accounts in all view is optional.
	

	Copyright (C) 2000 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
*/

#ifndef __COINS_PREFERENCES__
#define __COINS_PREFERENCES__

#include <PalmOS.h>
#include <Preferences.h>
#include <DateTime.h>

//for creator
#include "MiscFunc.h"
#include "AccountsDB.h"

///structure containing the program preferences
typedef struct {
	///when the scheduled transactions were last updated
	DateType	last_update;	
	///toogle for displaying the expected column in the account view
	Boolean		disp_expected_col;
	///toogle for displaying the income/expense accounts in the all view
	Boolean		disp_ie_acc;
	///the category in which we start
	UInt16		opening_category;
	///true if the payee is displayed in transaction list, false otherwise
	Boolean		disp_payee;
} palmCoinsPrefType;

#ifndef __COINS_PREF_C__
	///the structure holds the app's preferences
	extern palmCoinsPrefType 	coins_pref;	
#endif


///retrieve the preferences into gCoinsPref
void Prefs_Get();

///save the preferences from gCoinsPref
void Prefs_Save();


///assigns default values to gCoinsPrefs
void Prefs_SetDefault();
#endif
