/**	
	$Author: chaese $
	$Revision: 1.1 $
	Last updated: $Date: 2000/11/16 02:38:32 $
	
	Copyright (C) 2000 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Log: EditTransactionForm.h,v $
	Revision 1.1  2000/11/16 02:38:32  chaese
	Merged New Transaction and Transaction Details forms
	
		
*/

#ifndef __EDIT_TRANSACTION_FORM__
#define __EDIT_TRANSACTION_FORM__

#include <PalmOS.h>

#include "AccountsDB.h"
#include "TransactionsDB.h"
#include "MiscFunc.h"
#include "PalmCoinsRsc.h"

///saves the transaction data and updates all the accounts involved
Boolean EditTrans_Save();

/**
	initialises the account list
	@param use_acc_name if true when the static var p_acc is set to a specific account name, that name will be 
	selected by default in the list and displayed by the trigger
*/
void EditTrans_InitAccList(Boolean use_acc_name);

///set the values for some of the fields in the form (from the transaction record)
void EditTrans_SetDefaults();

///initialises the payment methods list
void EditTrans_InitMethods();

///updates the date field from the month/day/year globals
void EditTrans_UpdateDateField();

///sets the default date to the date in the record 
void EditTrans_InitDate();
 
///call the system form to choose a new date
void EditTrans_ChooseDate();

/// event handler for the form
Boolean EditTrans_HandleEvent(EventPtr event);

#endif
