/**	
	$Author: dizzy $
	$Revision: 1.6 $
	Last updated: $Date: 2000/11/18 15:12:49 $
	
	$Log: PreferencesForm.c,v $
	Revision 1.6  2000/11/18 15:12:49  dizzy
	Fixed yet another scrolling bug.
	
	Revision 1.5  2000/11/15 18:58:42  dizzy
	New balance adjust option in transaction form menu.
	Help updated in Transaction form and Accounts form.
	Merged ShowScrollArrows functions.
	Updated a few variable and function names.
	
	Revision 1.4  2000/10/12 17:17:24  dizzy
	Email address update; lots of bugfixes
	
	Revision 1.3  2000/10/08 15:40:46  dizzy
	Fixed a load of bugs related to transaction support.
	Displaying i/e accounts in all view is optional.
	
	Revision 1.2  2000/09/15 10:10:48  dizzy
	First useful version
	
	Revision 1.1  2000/09/08 10:42:54  dizzy
	Initial commit.
	
	Copyright (C) 2000 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
*/

#include "PreferencesForm.h"

// module globals - placed here to avoid naming conflicy with Accdetails form

static FormPtr	frm;

Boolean PrefForm_HandleEvent(EventPtr event)
{
	Boolean 	handled = true;

	// Get the form pointer
	frm = FrmGetActiveForm();

	// Key Events
	switch(event->eType) {

	// Form Open
	case frmOpenEvent:		
		//draw form
		FrmSetControlValue(frm,FrmGetObjectIndex(frm,PREF_EXPECTED_COL_CBX),coins_pref.disp_expected_col);
		FrmSetControlValue(frm,FrmGetObjectIndex(frm,PREF_DISP_IE_CBX),coins_pref.disp_ie_acc);
		FrmDrawForm(frm);
		break;
	
	// Controls
	case ctlSelectEvent:
		switch( event->data.ctlSelect.controlID ) {
			case PREF_OK:
				handled = true;
				coins_pref.disp_expected_col=FrmGetControlValue(frm,FrmGetObjectIndex(frm,PREF_EXPECTED_COL_CBX));
				coins_pref.disp_ie_acc=FrmGetControlValue(frm,FrmGetObjectIndex(frm,PREF_DISP_IE_CBX));
				//save the new preferences
				Prefs_Save();
				AccountsTable_top_visible_item=0;
				//update the main form
				FrmUpdateForm(ACCOUNTS_MAIN_FORM,0);				
				FrmReturnToForm(ACCOUNTS_MAIN_FORM);
				break;
			
			case PREF_CANCEL:
				//cancel button was pressed;
				//simply return to the main form
				handled = true;
				FrmReturnToForm(ACCOUNTS_MAIN_FORM);
				break;
				
			default:
				handled = false;
		};
		break;	
	// Everything else...
	default:
		handled = false;
	}	
	return handled;
}
