/**	
	$Author: dizzy $
	$Revision: 1.5 $
	Last updated: $Date: 2000/11/19 19:19:44 $
	
	$Log: TransactionsTable.h,v $
	Revision 1.5  2000/11/19 19:19:44  dizzy
	The way the tables are loaded was re-written. The account table works perfectly now
	but the transaction table still has a few problems.
	
	Revision 1.4  2000/11/15 18:58:42  dizzy
	New balance adjust option in transaction form menu.
	Help updated in Transaction form and Accounts form.
	Merged ShowScrollArrows functions.
	Updated a few variable and function names.
	
	Revision 1.3  2000/10/12 17:17:24  dizzy
	Email address update; lots of bugfixes
	
	Revision 1.2  2000/09/15 10:10:49  dizzy
	First useful version
	
	Revision 1.1  2000/09/13 11:50:27  dizzy
	The transaction module is fully functional

	Copyright (C) 2000 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
*/


#ifndef __TRANSACTIONS_TABLE__
#define __TRANSACTIONS_TABLE__

#include <PalmOS.h>

#include "TransactionsDB.h"
#include "MiscFunc.h"
#include "PalmCoinsRsc.h"
#include "CoinsPref.h"

#ifndef __TRANSACTIONS_TABLE_C__
	/// the uniqueid for top visible items
	extern UInt16		TransactionsTable_top_visible_item;
	/// the max no of rows that can be displayed
	extern UInt16		TransactionsTable_rows;
	/// no of elements that could be loaded in the table
	extern UInt16		TransactionsTable_total_items;

	///name all the columns
	extern UInt16		TransactionsTable_name_col;
	extern UInt16		TransactionsTable_expected_balance_col;
	extern UInt16		TransactionsTable_balance_col;
#endif

/// initialises the table
void TransactionsTable_Init();

///loads datea into the accounts table
void TransactionsTable_LoadData();

///draws a sum of money
void TransactionsTable_DrawCurrency(void* table, Int16 row, Int16 column, RectangleType* bounds);

///draws a date
void TransactionsTable_DrawDate(void* table, Int16 row, Int16 column, RectangleType* bounds);

///draw the account name (source or dest; the one which is different from the present account)
void TransactionsTable_DrawAcc(void* table, Int16 row, Int16 column, RectangleType* bounds);

/**
	set part of the table rows to unusable
	@param start row from which all other rows will be unusable
*/
void TransactionsTable_SetRowsUnusable(UInt16 start);


///unhilights the curent selection
void TransactionsTable_Unhilight();
#endif
