/*
 *  $Id: Account.h,v 1.1 2000/08/20 15:33:21 jmanning Exp $
 * Copyright (C) 2000 by Jackie Manning <jackie@linuxfan.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <PalmOS.h>

#ifndef __ACCOUNT_H

#include "DBUtils.h"

typedef struct {
    double      beginningBalance;
    UInt16      lastCheckNo;
    char        name[1];
} PackedAccount;

typedef struct {
    double      beginningBalance;
    UInt16      lastCheckNo;
    const char  *name;
} Account;

UInt16 InsertAccount( Account *acct, DmOpenRef db );
UInt16 getAccountSize( Account *acct );
PackedAccount *PackAccount( Account *acct, MemHandle acctDBEntry );
void UnpackAccount( Account *acct, PackedAccount *packedAccount );
Err ReadAccount( DmOpenRef db, UInt16 recNo, Account *acct );
Err UpdateAccount( Account *acct, UInt16 recNo, DmOpenRef db );
extern DmOpenRef gAccountDB;

#define __ACCOUNT_H 1
#endif
