/*
 * $Id: AcctGridModel.c,v 1.2 2000/11/21 03:04:19 jmanning Exp $
 *
 * Copyright (C) 2000 by Jackie Manning (jackie@linuxfan.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <PalmOS.h>
#include <stdarg.h>

#include "grid.h"
#include "PCashRsc.h"
#include "Account.h"

#define GetObjectPtr(f,i) FrmGetObjectPtr((f),FrmGetObjectIndex((f),(i)))

//void UpdatePostedBalance( void );
//void ModelGetCellID(void * __unused, UInt16 index, UInt32 * idP);

static UInt16 column_widths[2] = { 120, 40 };
static UInt16 num_rows = 0;
extern DmOpenRef gAccountDB;

UInt16 AcctModelGetColumnCount(void * __unused) {

    return 1;
}

static void AcctModelGetColumnName(void * __unused, UInt16 col,
			       Char * name, UInt32 len) {
                               
    switch (col) {
    case 0:
	StrNCopy(name, "Account", len);
	break;
    case 1:
	StrNCopy(name, "Bal", len);
	break;
    }
}

UInt16 AcctModelGetColumnWidth(void * __unused, UInt16 col) {
    return column_widths[col];
}

void AcctModelSetColumnWidth(void * __unused, UInt16 col, UInt16 width) {
    column_widths[col] = width;
}

void * AcctModelLockIndex(void * gridModelData, UInt16 index, Boolean writable) {

    static Account acct;
    UInt16 idx = 0;
//    UInt32 id;
    
//    ModelGetCellID( gridModelData, index, &id );
//    DmFindRecordByID( gAccountDB, id, &idx );
    ReadAccount( gAccountDB, index, &acct );
    return &acct;
}

void AcctModelUnlockIndex(void * GridModelData, UInt16 index, Boolean writable,
		      void * row_data ) {
                      
}

GridCellType AcctModelGetCellType(void * __unused, UInt16 index, UInt16 col) {

    char buff[80];

    if( col == 1 )     
	return gridCellTypeRString;
    return gridCellTypeString;
}

void AcctModelGetCellString(void * __unused, UInt16 index, UInt16 col,
			Char * data, UInt32 len, void * row_data)
{

    Err err;
    Account *acct;
    Char format[10];

    acct = row_data;
    switch( col ) {
    
    case 0:
        StrPrintF( data, "%s", acct->name );
        break;
        
    case 1:
//        doubleToStr( data, acct->beginningBalance, 2 );
        break;
        
    default:
        StrPrintF(data, "%u,%u", index, col);
    }
}

Boolean AcctModelGetCellBoolean(void * __unused, UInt16 index, UInt16 col,
			    void * row_data) {

    return false;
}

void AcctModelSetCellBoolean(void * __unused, UInt16 index, UInt16 col, Boolean b,
			 void * row_data) {
}

void AcctModelGetCellID(void * __unused, UInt16 index, UInt32 * idP) {

    UInt32 *indexes;
    
    *idP = (UInt32) index;
}

Boolean AcctModelSeek(void * __unused, UInt16 * indexP, Int16 offset,
		  Int16 direction) {
                  
    UInt16 i = *indexP;
    
    num_rows = DmNumRecords( gAccountDB );
    switch (direction) {
    case dmSeekForward:
	if (i + offset >= num_rows)
	    return false;
	i += offset;
	break;

    case dmSeekBackward:
	if (i >= num_rows)
	    i = num_rows - 1; /* move to valid index number */
	if (offset > i)
	    return false;
	i -= offset;
	break;
    }

    *indexP = i;
    return true;
}

GridModelType acctModel = {
    GetColumnCount:     AcctModelGetColumnCount,
    GetColumnName:      AcctModelGetColumnName,
    GetColumnWidth:     AcctModelGetColumnWidth,
    SetColumnWidth:     AcctModelSetColumnWidth,
    LockIndex:          AcctModelLockIndex,
    UnlockIndex:        AcctModelUnlockIndex,
    GetCellType:        AcctModelGetCellType,
    GetCellString:      AcctModelGetCellString,
    GetCellBoolean:     AcctModelGetCellBoolean,
    SetCellBoolean:     AcctModelSetCellBoolean,
    GetCellID:          AcctModelGetCellID,
    Seek:               AcctModelSeek,
};

