/*
 * $Id: DBUtils.c,v 1.4 2000/08/23 12:52:17 jmanning Exp $
 *
 * Copyright (C) 2000 by Jackie Manning (jackie@linuxfan.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <PalmOS.h>
#include "DBUtils.h"
//#include "PCashRsc.h"

Err OpenByName(DmOpenRef *dbP, UInt32 type, UInt32 creator,
                   UInt32 mode, UInt16 cardNo, char *name ) {
                   
    Err   err;
    DmSearchStateType searchState;
    LocalID     locID;
    char dbName[32];

    err = DmGetNextDatabaseByTypeCreator( true, &searchState,
            type, creator, false, &cardNo, &locID );
    while( err != dmErrCantFind ) {
        DmDatabaseInfo( cardNo, locID, dbName, NULL, NULL, NULL, 
                NULL, NULL, NULL, NULL, NULL, NULL, NULL );
        if( StrCompare( dbName, name ) == 0 ) {
            *dbP = DmOpenDatabase( cardNo, locID, mode );
            err = DmGetLastErr();
            break;
        }
        err = DmGetNextDatabaseByTypeCreator( false, &searchState,
                type, creator, false, &cardNo, &locID );
    }
    return err;
}

// open a database. If it doesn't exist, create it.
Err OpenOrCreateDB(DmOpenRef *dbP, UInt32 type, UInt32 creator,
                   UInt32 mode, UInt16 cardNo, char *name, Boolean *created) {
                   
    Err   err;
    DmSearchStateType searchState;
    LocalID     locID;
    char dbName[32];

    *created = false;

    err = OpenByName( dbP, type, creator, mode, cardNo, name );
    if (! *dbP) {
        err = DmCreateDatabase(0, name, creator, type, false);
        if (err) {
            return err;
        }
        *created = true;

        err = OpenByName( dbP, type, creator, mode, cardNo, name );
    }
    return err;
}
/*
Err FilterQueryNext( DmOpenRef db, UInt16 *curIndex, QueryFilter *filter ) {

    Err err = 0;
    UInt16 index = *curIndex;
    MemHandle handle;
    
    index++;
    handle = DmQueryRecord( db, index );
    while( handle != NULL && !filter( handle ) ) {
        index++;
        handle = DmQueryRecord( db, index );
    }
    if( handle == NULL ) {
        err = DmGetLastErr();
    }
    else {
        *curIndex == index;
    }
    return err;
}
*/
void WriteObject( void *s, UInt32 *offset, const void *srcP, UInt32 length ) {

    DmWrite( s, *offset, srcP, length );
    *offset += length;
}



