/*
 *  $Id: Trans.h,v 1.4 2000/10/21 01:49:53 jmanning Exp $
 * Copyright (C) 2000 by Jackie Manning <jackie@linuxfan.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <PalmOS.h>

#ifndef __TRANS_H

#define CHECK_TRANS 'C'
#define DEPOSIT_TRANS 'D'
#define WITHDRAWAL_TRANS 'W'
#define ACTUAL      0
#define ESTIMATED   1
#define PAYABLE     2
#include "DBUtils.h"

#define SORT_BY_DATE    0
#define SORT_BY_PARTY   1
#define SORT_BY_AMOUNT  2

typedef struct {
    UInt32      account;
    double      amount;
    DateType    date;
    char        transType;
    Boolean     posted;
//    Boolean     budget;
    unsigned char   budget;
    char        party[1];
} PackedTrans;

typedef struct {
    UInt32      account;
    double      amount;
    DateType    date;
    char        transType;
    Boolean     posted;
    unsigned char   budget;
//    Boolean     budget;
    const char  *party;
    const char  *ref;
    const char  *note;
} Trans;

//Boolean ActualTransFilter( MemHandle handle );
//Boolean AllTransFilter( MemHandle handle );
Int16 CompareTransByDate( 
        void *rec1, void *rec2, Int16 other, 
        SortRecordInfoPtr rec1SortInfo, 
        SortRecordInfoPtr rec2SortInfo, 
        MemHandle appInfoH );
Int16 CompareTransByParty( 
        void *rec1, void *rec2, Int16 other, 
        SortRecordInfoPtr rec1SortInfo, 
        SortRecordInfoPtr rec2SortInfo, 
        MemHandle appInfoH );
Int16 CompareTransByAmount( 
        void *rec1, void *rec2, Int16 other, 
        SortRecordInfoPtr rec1SortInfo, 
        SortRecordInfoPtr rec2SortInfo, 
        MemHandle appInfoH );
UInt16 InsertTrans( Trans *trans, DmOpenRef db );
UInt16 getTransSize( Trans *trans );
PackedTrans *PackTrans( Trans *trans, MemHandle transDBEntry );
void UnpackTrans( Trans *trans, PackedTrans *packedTrans );
Err ReadTrans( DmOpenRef db, UInt16 recNo, Trans *trans );
Err UpdateTrans( Trans *trans, UInt16 recNo, DmOpenRef db, UInt16 *newPos );
void SetTransSortOrder( UInt16 aSortOrder );
extern DmOpenRef gTransDB;
extern DmComparF *CompareTrans;
extern UInt16 sortOrder;

#define __TRANS_H 1
#endif
