/*
 * $Id: Utils.c,v 1.3 2000/11/21 03:04:19 jmanning Exp $
 *
 * Copyright (C) 2000 by Jackie Manning (jackie@linuxfan.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <PalmOS.h>
#include <FloatMgr.h>
#include "Utils.h"
#include "PCashRsc.h"

double strToDouble( char *str ) {
    double dbl = 0.0;
    StringToDouble( str, &dbl );
    return dbl;
}

void
StringToDouble( char *str, double *dbl ) {

    Char buff[40];
    Int16  i, start, length, punctPos;
    double  result, sign, fractPart;
    Int32 lResult;

    *dbl = 0.0;
    result = 0.0;
    lResult = 0;
    fractPart = 0.0;
    punctPos = StrLen(str);
    length = punctPos;
    start = 0;
    sign = 1.0;
    if (str[0] == '-') {
        sign = -1.0;
        start = 1;
    }
    
    for (i = start; i < length; i++)           // parse the string from left to right
    {
        if (str[i] != '.')                     //     converting the integer part
        {
//            if (TxtCharIsDigit(str[i])) {
            if ( str[i] >= '0' && str[i] <= '9' ) {
                result = result * 10.0 + (str[i] - 0x30);
            }
            else {
                return;
            }
        } else {
            punctPos = i;
            break;
        }
    }

    if (str[punctPos] == '.')                                     // parse the string from the end to the '.'
    {
        for (i = length-1; i > punctPos; i--)                     //     converting the fractional part
        {
            if ( str[i] >= '0' && str[i] <= '9' ) {
//            if (TxtCharIsDigit(str[i])) {
                fractPart = fractPart / 10.0 + (str[i] - 0x30);
            }
            else {
                return;
            }
        }
        result += fractPart / 10.0;
    }

    result *= sign;
    *dbl = result;
    
/*
    FlpCompDouble fdbl;
    fdbl.fd = FlpAToF( str );
    return fdbl.d;
*/
}

void doubleToStr( char *str, double flpNumber, UInt16 numFractDigits) {

    Int32  longNumber;
    double zeros, round;
    Int16 i, remainder, strLen;
    char sign = ' ';

    if (flpNumber < 0.000000 ) {
        flpNumber = -flpNumber;
        sign = '-';
    }
    zeros = 1.000000;
    for( i = 1;i<=numFractDigits; i++ ) {
        zeros *= 10.0;
    }
    round = 0.500000/zeros;
//    round = flpNumber * zeros + 0.500000;
//    round /= zeros;

    longNumber = flpNumber + round;
//    longNumber = round;
    if( sign == '-' ) {
        str[0] = sign;
        StrIToA(&str[1], longNumber );
    }
    else {
        StrIToA( str, longNumber );
    }
    strLen = StrLen(str);                                 // put in the decimal point and terminate the string
    str[strLen] = '.';
    str[numFractDigits+strLen+1] = '\0';

    longNumber = flpNumber * zeros;                       // fractional part

    for (i=numFractDigits+strLen; i>strLen; i--)          // convert the integer part
    {
        remainder = longNumber % 10;
        str[i] = remainder + 0x30;
        longNumber /= 10;
    }
}

