/*********************************************************************
 * Filename:      error.c
 * Description:
 * Author:      Thomas Roessler <roessler@guug.de>
 * Modified at:   Mon Feb 23 11:36:36 1998
 * Modified by:   Tage Stabell-Kuloe <tage@acm.org>
 *
 * 	Copyright (c) Thomas Roessler
 * 	See the file COPYING for details
 *
 * $Id: error.c,v 1.6 1999/03/08 19:58:46 perm Exp $
 *
 ********************************************************************/
/* All PalmOS code by Per Harald Myrvang <perm@pasta.cs.uit.no> */


#define _ERROR_C

#include <stdlib.h>
#include <stdio.h>
#ifdef __palmos__
# include <System/Unix/sys_errno.h>
#else	/* __palmos__ */
# include <errno.h>
#ifdef WIN32
# include <string.h>
#endif
#endif	/* __palmos__ */

#include "pgplib.h"

const char *pgplib_errlist[] = {
    "No error.",
    "Bad ctb length.",
    "Bad ctb.",
    "Invalid argument.",
    "Compressed packet.",
    "End of file.",
    "Impossible error condition.",
    "Bad packet length.",
    "Bad CRC.",
    "Bad algorithm.",
    "Zip error.",
    "Wrong pass phrase.",
    "Fatal db error.",
    "database not open.",
    NULL
};

int pgplib_errno;

const char *pgplib_strerror(int val)
{
#ifndef __palmos__
    if (val == PGPLIB_ERROR_SYSERR)
	return strerror(errno);
#endif	/* !__palmos__ */
    if (val < 0 || val > PGPLIB_ERROR_MAX)
	return NULL;

    return pgplib_errlist[val];
}
