/* Emace, this is really -*-C-*- */
/*********************************************************************
 * Filename:      flio.h
 * Description:   
 * Author:        Tage Stabell-Kulo <tage@acm.org>
 * Modified at:   Sat May 30 11:47:51 1998
 * Modified by:   Tage Stabell-Kulo <tage@acm.org>
 *
 * 	Copyright (c) University of Troms, Norway
 * 	See the file COPYING for details
 *
 * $Id: flio.h,v 1.4 1999/03/06 19:02:16 perm Exp $
 *
 *
 ********************************************************************/

#ifndef _FLIO_H_INCLUDED_
#define _FLIO_H_INCLUDED_

/* magic is (at lest) one of these */
#define	FLIO_FILE	0x01		/* FILE */
#define	FLIO_IS_FILE(x)	(x & FLIO_FILE)
#define FLIO_DESC	0x02		/* File descriptor */
#define FLIO_IS_DESC(x)	(x & FLIO_DESC)
#define FLIO_BUFF	0x04		/* Memory */
#define	FLIO_IS_BUFF(x)	(x & FLIO_BUFF)
#define	FLIO_EXTERN	0x08
#define FLIO_IS_EXTERN(x) (x & FLIO_EXTERN) 
#define FLIO_IS_SAME_TYPE(x,y)	((x|FLIO_EXTERN) == (y|FLIO_EXTERN))

typedef struct {
    int	magic;
    union {
	struct {
	    u_char *b;			/* The buffer */
	    u_long p;			/* Hos far are we into it */
	    u_long size;		/* The size */
	} buff;
#ifndef __palmos__
	FILE	*f;			/* FILE */
	int	fd;			/* File */
#else	/* __palmos__ */
	struct {
	    Word		libRef;
	    NetSocketRef	socket;
	} s;
#endif	/* __palmos__ */
    } d;
} flio_t;

typedef struct {
    int magic;
#ifndef __palmos__
    union {
	fpos_t	f;
	off_t	fd;
	long	p;
    } d;
#else	/* __palmos__ */
    struct {
	long	p;
    } d;
#endif	/* __palmos__ */
} flio_pos_t;

void flio_close(flio_t *p);
flio_t *flio_stdin(void);
flio_t *flio_stdout(void);
flio_t *flio_stderr(void);
flio_t *flio_fopen(const char *fname, const char *mode);
flio_t *flio_newbuff(void);
int flio_getpos(flio_t *p, flio_pos_t *pos);
int flio_setpos(flio_t *p, flio_pos_t *pos);
int flio_getc(flio_t *p, int *i);
char *flio_gets(char *b, u_long s, flio_t *p);
int flio_putc(int c, flio_t *p);
int flio_puts(const char *s, flio_t *p);
#ifndef __palmos__
flio_t * flio_fdreopen(int fd);
#else	/* __palmos__ */
flio_t * flio_fdreopen(Word libRef, NetSocketRef socket);
#endif /* __palmos__ */
flio_t * flio_freopen(FILE *f);
int flio_write(void *ptr, u_long s, u_long n, flio_t *p);

#endif /* _FLIO_H_INCLUDED_ */
