/* src/pgplib.h.  Generated automatically by configure.  */
/* Emace, this is really -*-C-*- */
/*********************************************************************
 * Filename:      pgplib.h.pre
 * Description:   
 * Author:        Tage Stabell-Kulo <tage@acm.org>
 * Modified at:   Sat May 30 11:47:51 1998
 * Modified by:   Tage Stabell-Kulo <tage@acm.org>
 *
 * 	Copyright (c) University of Troms, Norway
 * 	See the file COPYING for details
 *
 * $Id: pgplib.h.pre,v 1.5 1999/03/06 19:02:17 perm Exp $
 *
 *
 ********************************************************************/
/* All PalmOS code by Per Harald Myrvang <perm@pasta.cs.uit.no> */

#ifndef _PGPLIB_H_
#define _PGPLIB_H_

#ifndef __palmos__
# include <stdio.h>
# include <stdlib.h>
# include <errno.h>
# ifdef WIN32         
typedef unsigned char  u_char;
typedef unsigned short u_short;
typedef unsigned int   u_int;
typedef unsigned long  u_long;
# else	/* WIN32 */
#  include <sys/param.h>		/* includes sys/types */
# endif	/* WIN32 */
#else	/* indeed __palmos__ */
 #include <Pilot.h>
 #include <sys/types.h>
 #include <System/Unix/unix_stdlib.h>
 #include <System/Unix/unix_string.h>
 #include <System/Unix/sys_types.h>
 #include <System/Unix/sys_errno.h>
#endif	/* __palmos__ */

/* SSLeay */
#include <bn.h>

/* Flio */
#include "flio.h"

/* Configuration options (processed by the configure script) */

/* Define if you have the ANSI C header files.  */
#define STDC_HEADERS 1

/* Define to format for printing 64 bits hex numbers, ex. "llx" */
#define PRIx64 "llx"

/* Define if you want to use PGPKEYID as unsigned long long */
/* #undef USE_LONGLONG */

/* Define to unsigned long long if not provided by system. */
/* #undef u_quad_t */

/* Define if you have the daemon function.  */
#define HAVE_DAEMON 1

/* Define if you have the hstrerror function.  */
#define HAVE_HSTRERROR 1

/* Define if you have the strerror function.  */
#define HAVE_STRERROR 1

/* Define if you have the strsep function.  */
#define HAVE_STRSEP 1

/* Define if you have the strtouq function.  */
#define HAVE_STRTOUQ 1

/* Define if you have the <db.h> header file.  */
#define HAVE_DB_H 1

/* Define if you have the <errno.h> header file.  */
#define HAVE_ERRNO_H 1

/* Define if you have the <fcntl.h> header file.  */
#define HAVE_FCNTL_H 1

/* Define if you have the <limits.h> header file.  */
#define HAVE_LIMITS_H 1

/* Define if you have the <sys/errno.h> header file.  */
#define HAVE_SYS_ERRNO_H 1

/* Define if you have the <unistd.h> header file.  */
#define HAVE_UNISTD_H 1

/* Define if you have the db library (-ldb).  */
#define HAVE_LIBDB 1

/* Define if you have the nsl library (-lnsl).  */
#define HAVE_LIBNSL 1

/* Define if you have the socket library (-lsocket).  */
/* #undef HAVE_LIBSOCKET */

/* End of the configuration options */
/* -*-C-*- */
/*************************
  These things can (and possibly chould) be configured
  ************************/

/* 
 * armor.c
 */
#ifdef __palmos__
 /* We're short on stack-space on the pilot, so we'll use a tiny MAXLINE. In
  * fact, this could probably be pressed down to 70.   --Perm */
# define MAXLINE		100
#else	/* __palmos__ */
# define MAXLINE		1024
#endif	/* __palmos__ */
#define ARMORLINE	64
#define DATALEN	   	(ARMORLINE/4*3)

/* 
 * conventional.c
 */

/* We will not handle packets larger than this */
#ifdef __palmos__
    /* The pilot, with its epsilon amount of memory, cannot handle 1024**2.
     * Thus this - 128K - which still is rather alot.  --Perm */
# define	MAX_ENC_PACKET	((long)128*(long)1024)
#else	/* __palmos__ */
# define	MAX_ENC_PACKET	(1024*1024)
#endif	/* __palmos__ */

/*
 * keybase.c
 */
/* Tailor the database, see hash(3); */
#define CACHE_SIZE	(1024*1024)
#define NELEM		(40000)
#ifndef BSIZE
#  define BSIZE		(4096)
#endif

#ifdef __palmos__
    /* Key-database name */
# define DB_NAME "PGPLib KeyDB"
#endif /* __palmos__ */

/**************************
  End of configurable 
  *************************/
#ifdef __palmos__
 /* This is the posix epoch (1st Jan 1970) expressed in the PalmOS epoch (1st
  * Jan 1904). It's an unsigned long integer and it sucks, but we do what we
  * have to do. 1970 - 1904 = 66. In those 66 years there are (66/4) = 16.5 ->
  * 17 leap days. There are 86400 seconds in a day. Thus:
  *	(66 * 365 * 86400) + (17 * 86400) = 2'082'844'800 = 0x7c25b080
  * ...which is also what TimDateTimeToSeconds() tells us. Phew.   --Perm */
# define POSIX_EPOCH_KLUDGE	((unsigned long)0x7c25b080L)
#endif /* __palmos__ */

/* this is a portable view of a pgp key id rather than using 
 * any native type like long long which serious reduces the 
 * portability of the library --tjh
 */
#define PGPKEYID_SIZE 8
#ifndef USE_LONGLONG
typedef struct { 
    unsigned char data[PGPKEYID_SIZE]; 
} PGPKEYID;

typedef unsigned char xPGPKEYID[PGPKEYID_SIZE];

#define PGPKEYID_IsZero(X)	(memcmp(&(X),"\0\0\0\0\0\0\0\0",\
						sizeof(PGPKEYID))==0)
#define PGPKEYID_EQUAL(X,Y)	(memcmp(&(X),&(Y),sizeof(PGPKEYID))==0)
#define PGPKEYID_ZERO(X)	memset(&(X),0,sizeof(PGPKEYID));
#define PGPKEYID_COPY(DST,SRC)	memcpy(&(DST),&(SRC),sizeof(PGPKEYID));

#endif /* !USE_LONGLONG */

#ifdef USE_LONGLONG 
/* this is the "old" view of things ... which is handy to be able to
 * work with if the platform supports it I guess
 */
#ifdef WIN32
typedef unsigned __int64 PGPKEYID;
#else
typedef unsigned long long PGPKEYID;
#endif

#define PGPKEYID_IsZero(X)	((X)==0)
#define PGPKEYID_EQUAL(X,Y)	((X)==(Y))
#define PGPKEYID_ZERO(X)	((X)=0)
#define PGPKEYID_COPY(DST,SRC)	(DST)=(SRC)
#endif /* USE_LONGLONG */

extern char *LIB_VERSION;
extern char *PGP_VERSION;
extern char *PGP_COMMENT;


typedef struct {
    long	length;			/* of the original packet */
    u_char	version;
    u_long	created;
    u_short	valid;
    BIGNUM	*N;
    BIGNUM	*E;
    u_char	algorithm;
    u_char	iv[8];
    BIGNUM	*D;
    BIGNUM	*P;
    BIGNUM	*Q;
    BIGNUM	*U;
    u_short	cksum;			/* 16 bit */
    /* In the hope that this will increase the speed of the modular
     * exponentiation <plaintext> = <ciphertext>**D mod N, we provide these
     * extra fields, which are initialized when the secret key is first
     * decrypted (i.e. armed).
     *
     * "But how does it work", I hear you yelling. It works by enabling the
     * usage of a much faster mod_exp in SSLeay's RSA_* library.
     *
     * The price is [possibly much] slower decryption of the secret key, and
     * the memory requirements of 3 more BIGNUMs.
     *
     * The philosophy is that you arm your secret key once, then use it several
     * times to decrypt/sign various data.  Thus we win if we can reduce the
     * time used by secret key operations.  On a big, well-muscled machine
     * (e.g.  a 100MHz i486 or [much] better), this is not really such an
     * issue.  On a 16MHz M68K-based PDA, however, it is worth the bugger.
     * --Perm
     */
    BIGNUM *dmp1;
    BIGNUM *dmq1;
    BIGNUM *iqmp; /* PGP's U is the inverse of p mod q. See secencrypt.c. */
} PGPseckey_t;

typedef struct {
    long	length;			/* Of the original packet */
    u_char	version;
    u_long	created;
    u_short	valid;			/* in days */
    u_char	algorithm;
    BIGNUM	*N;
    BIGNUM	*E;
} PGPpubkey_t;
    
typedef struct {
    int		length;			/* of total packet  */
    u_char	version;
    u_char	included;
    u_char	classification;
    u_long	timestamp;
    PGPKEYID	key_id;
    u_char	pk_alg;
    u_char	hash_alg;
    u_char	ck[2];
    BIGNUM	*I;
} PGPsig_t;

/* We null-terminate the name, although PGP does not. */
typedef struct {
    char	*name;
} PGPuserid_t;

typedef struct {
    int		length;
    u_char	mode;
    char 	*filename;
    u_long	timestamp;
    int		datalen;
    u_char	*data;
} PGPliteral_t;

typedef struct {
    u_char	byte;
} PGPtrust_t;

typedef struct {
    int		length;
    u_char	version;
    PGPKEYID	key_id;
    u_char	algorithm;
    BIGNUM	*E;
} PGPpke_t;


/* What is returned from buffers containing keyrings ? */
typedef enum {NONE, SIG, PUBKEY, UID, SECKEY, TRUSTBYTE} res_t;

/* How to open a database */
typedef enum {NOMODE, READER, WRITER, NEWDB} openmode_t;

/* What to do with data in databases */
typedef enum {NOACTION, INSERT, REPLACE} repl_t;


/*
 * armor.c
 */

int
dearmor_buffer(char	*armor_buf, 
	       long	armor_len,
	       int	*used,
	       u_char	**buffer,
	       int	*buf_len);

#ifndef __palmos__
int
dearmor_file(FILE	*fin,
	     FILE	*fout);
#endif	/* __palmos__ */

int 
dearmor_flio(flio_t *, 	flio_t *);

int 
armor_flio (flio_t *, 	flio_t *);

#ifndef __palmos__
int 
armor_file(FILE *, 	FILE *);
#endif	/* __palmos__ */

int
armor_buffer(u_char	*buf,
	     int	buf_len,
	     int	*used,
	     char	**a_buf,
	     int	*a_len);
int 
pemDecode(char 		*inBuffer, 
	  u_char 	*outBuffer, 
	  int 		*outbuflen);
int
pemEncode(u_char 	*inBuffer,  
	  int		inbuflen,
	  char		*outBuffer,
	  int 		*outbuflen);

#ifndef __palmos__
int 
read_armored_package(FILE 	*fin, 
		     u_char 	**buffer, 
		     int 	*buf_len);
#endif	/* __palmos__ */

/*
 * conventional.c
 */

int
conventional_key_decrypt(u_char	*enc_p,
			 u_char	digest[16],
			 int	*outlen,
			 u_char	**data);

int
conventional_key_encrypt(u_char	*inbuf,
			 int	inbuflen,
			 u_char digest[16],
			 int	do_compress,
			 int	*outbuflen,
			 u_char	**outbuf);

/*
 * decompress.c
 */

int
decompress_buffer(u_char	*buf,
		  int		buf_len,
		  u_char	**data,
		  int		*data_len);

#ifndef __palmos__
int
decompress_file(FILE	*fin,
		FILE	*fout);
#endif	/* __palmos__ */

int
compress_buffer(u_char	*inbuf,
		int	inbuflen,
		u_char	**outbuf,
		int	*outbuflen);


/*
 * literal.c
 */
void
free_literal(PGPliteral_t *literal);

#ifndef __palmos__
int
file2literal(FILE		*fin,
	     PGPliteral_t	*lit);
#endif	/* __palmos__ */

int
buf2literal(u_char	*inbuf,
	    int  	inbuflen,
	    PGPliteral_t *literal);
int
literal2buf(PGPliteral_t	*literal,
	       u_char		**buf);
int
create_literal(char		*filename,
	       PGPliteral_t	*literal);

/*
 * keybase.c
 * Note: If target platform is PalmOS, then this really refers to
 * keybase_palmos.c    --Perm
 */

typedef struct {
    res_t		what;
    union {
	PGPpubkey_t	*key;
	PGPsig_t	*sig;
	PGPuserid_t	*uid;
	PGPtrust_t	*trust;
    } u;
} keyent_t;

#ifndef __palmos__

extern int dbase_open;

int
keydb_init(char		*caller_name,
	   openmode_t	caller_mode);
void
keydb_end(void);

void
keydb_sync(void);

int
keys_from_string(char	*string,
		 int	save_case,
		 int	*num_keys,
		 PGPKEYID  **keys);
int
find_shortid(char 	*short_id,
	     PGPKEYID	*keyid);

int	
store_pubkey(PGPpubkey_t 	*pubkey, 
	     repl_t 		replace);
int
key_exists(PGPKEYID	key_id);

int
get_pubkey_rec(PGPKEYID	key_id,
	       int	*len,
	       u_char 	**buf);

int
store_pubkey_rec(PGPKEYID 	key_id, 
		 repl_t 	replace, 
		 u_char 	*buf, 
		 int 	size);

int
store_uid(PGPuserid_t 	*user_id, 
	  PGPKEYID 		key_id);


/* higer level routines */
int
add_uid(PGPKEYID 	key_id,
	PGPuserid_t	*user_id);

int
add_sig(PGPKEYID	key_id,
	PGPuserid_t	*uid,
	PGPsig_t	*sig);

int
get_only_pubkey(PGPKEYID 	key_id,
		PGPpubkey_t 	**key);

int
get_keycontents(PGPKEYID	key_id,
		keyent_t	***arr);

int
get_keycontents_seq(keyent_t ***keyent, int where);

int
uids_from_keyid(PGPKEYID	key_id,
		PGPuserid_t	***uidpp);

int 
add_trust(PGPKEYID, PGPuserid_t *, PGPtrust_t *);

int
scan_pubring(FILE *fp);

#else	/* __palmos__ */

enum keyrecheadflags {
    KEY_PUBLIC, KEY_SECRET,
    KEY_MAX
};

int
lookup_keyid(DmOpenRef dref,
	PGPKEYID *keyid,
	unsigned long *uniqueid,
	unsigned long *shortkeyid,
	short shortid,
	unsigned short *size);

DmOpenRef
open_pubkey_db(char *dbname);

DmOpenRef
open_seckey_db(char *dbname);

int
close_db(DmOpenRef dbR);

int
add_pubkey(DmOpenRef dbR,
	PGPpubkey_t *key,
	PGPtrust_t *trust);

int
add_seckey(DmOpenRef dbR,
	PGPseckey_t *key,
	PGPtrust_t *trust);

int
remove_key(DmOpenRef dbR,
	PGPKEYID *key);

int
get_pubkey(DmOpenRef dbR,
	PGPKEYID *keyid,
	PGPpubkey_t *key);

int
get_seckey(DmOpenRef dbR,
	PGPKEYID *keyid,
	PGPseckey_t *key);

int
add_uid2key(DmOpenRef dbR,
	PGPKEYID *keyid,
	PGPuserid_t *userid,
	PGPtrust_t *trust);

int
add_sig2key(DmOpenRef dbR,
	PGPKEYID *keyid,
	PGPsig_t *sig,
	PGPtrust_t *trust);

int
get_keyidlist(DmOpenRef dbR,
	PGPKEYID **keyidlist,
	int *entries);

int
get_shortkeyidlist(DmOpenRef dbR,
	unsigned long **keyidlist,
	int *entries);

int
list_uids(DmOpenRef dbR,
	PGPKEYID *keyid,
	char ***uidlist,
	int *entries);

int
free_uid_list(char **list);

int
search4uid(DmOpenRef dbR,
	char *search,
	PGPKEYID *keyid,
	long *startindex);

int
list_signatures(DmOpenRef dbR,
	PGPKEYID *keyid);

int
free_signature_list(void);

#endif	/* __palmos__ */

/*
 * Keymgnt.c
 */


int
buf2seckey(u_char	*buf,
	   int		buflen,
	   PGPseckey_t	*key);

void
free_pubkey(PGPpubkey_t	*key);

int
copy_pubkey(PGPpubkey_t *in,
	    PGPpubkey_t *out);

void
free_keyrecords(keyent_t	**records);

int 
pub_fingerprint(PGPpubkey_t	*key,
		   char		*str);

#ifndef __palmos__
int
print_keyrec(u_char		*buffer, 
	     int 		buf_len, 
	     FILE 		*fd);
#endif	/* __palmos__ */

int
pubkey2buf(PGPpubkey_t	*key,
	   u_char 	**buf);

int
pubkey_length(PGPpubkey_t *key);

int
buf2pubkey(	u_char 		*buf, 
		int 		len, 
		PGPpubkey_t 	*key);
int
decrypt_seckey(	PGPseckey_t 	*old, 
		u_char 		*digest,
		PGPseckey_t	*new);

/* The encrypt_seckey() function formerly existed only in the PalmOS-version of
 * PGPlib --Perm */
int
encrypt_seckey(	PGPseckey_t 	*key,
		u_char 		*digest);

/* The seckey2buf() function formerly existed only in the PalmOS-version of
 * PGPlib --Perm */
int
seckey2buf(PGPseckey_t	*key,
	   u_char	**bufptr);

/* The generate_keypair() function formerly existed only in the PalmOS-version
 * of PGPlib --Perm */
int
generate_keypair(PGPseckey_t *sec,	/* secret key (empty struct) */
		 PGPpubkey_t *pub,	/* public key (ditto) */
		 int keysize,		/* keysize in bits (>=384) */
		 u_long e,		/* >2, e.g. 3, 11, 17 some small prime */
		 u_short valid,		/* # of days the keypair is valid */
		 u_char digest[16],	/* passphrase */
		 u_char *rndsrc,	/* random stir source (or NULL) */
		 u_long rndsrclen,	/* # of bytes in rndsrc */
		 u_short flags);	/* Various flags. Pass 0. */

/* Flag definitions for generate_keypair()'s <flags>-parameter. These can be
 * OR'ed together to produce interesting results. Some of them are Pilot/PDA
 * targeted, and most of them aren't implemented yet. --Perm
 */
#define GENKEY_BEEP_WHEN_DONE	    (1 <<  0)	/* Beep when done */
#define GENKEY_SCREEN_OFF	    (1 <<  1)	/* For saving power */
#define GENKEY_BEEP_UPDATE	    (1 <<  2)	/* Beep at updates */
#define GENKEY_NO_PROGRESSWINDOW    (1 << 14)	/* No progress window */
#define GENKEY_NO_CALLBACK	    (1 << 15)	/* Don't do callback at all */
#define GENKEY_DEFAULT	(GENKEY_BEEP_WHEN_DONE)
 
#ifndef __palmos__
void
print_seckey(int	verbose,
	     FILE 	*fd,
	     PGPseckey_t *key);
#endif	/* __palmos__ */

void
free_seckey(PGPseckey_t		*key);

void
clear_seckey(PGPseckey_t	*key);

/*
 * keyring.c
 */

int
get_keyentry_from_buf(u_char		*buf,
		      int		buf_len,
		      res_t		*what,
		      PGPsig_t		**sig,
		      PGPpubkey_t	**pubkey,
		      PGPuserid_t	**uid,
		      PGPseckey_t	**seckey,
		      PGPtrust_t	**trust,
		      int		*used);
int
get_seckey_from_buf(u_char		*buf, 
		    int 		buflen, 
		    PGPseckey_t 	**key);
#ifndef __palmos__
int
get_seckey_from_file(	FILE 		*keyring, 
			PGPseckey_t 	**key);

int
get_keyentry_from_file(	FILE		*fd,
			res_t		*what,
			PGPsig_t	**sig,
			PGPpubkey_t	**pubkey,
			PGPuserid_t	**uid,
			PGPseckey_t	**seckey,
			PGPtrust_t	**trust);
#endif	/* __palmos__ */


/*
 * misc.c
 */

#ifdef __palmos__
# ifdef memcpy
#  undef memcpy 	/* Why? Because we don't use memcpy's return value! */
#  define memcpy MemMove
# endif /* memcpy */
# ifdef realloc	/* We'll provide our own realloc, thank you! */
#  undef realloc
# endif	/* realloc */
# ifdef calloc	/* ditto for calloc */
#  undef calloc
# endif /* calloc */
/* Special PalmOS versions of realloc, calloc and pgplib_strtol/strtoul
 * --Perm */
void *
realloc(void *ptr, u_long size);
void *
calloc(u_long nmemb, u_long size);
long pgplib_strtol(const char *ptr, char **tail, int base);
# define strtoul (unsigned long)pgplib_strtol
#endif /* __palmos__ */

int
bufgets(u_char 	*line, 
	int 	linelen, 
	u_char 	*buf, 
	int buflen);

int
make_ctb(u_char		ctb_type, 
	 u_long 	length, 
	 int 		force, 
	 u_char 	*buf);


int
PGPKEYID_FromBytes(PGPKEYID 	*key_id, 
		   u_char 	*buf);

int
PGPKEYID_ToBytes(PGPKEYID *, 
		 u_char *);

int 
PGPKEYID_FromBN(PGPKEYID *key_id,
		BIGNUM *a);

u_short 
checksum(u_char	*, int);

int
mpi2bignum(u_char	*buf,
	   int		buflen,
	   int		*used,
	   BIGNUM	**N);

int 
ctb_llength(int ctb);


int 
PGPKEYID_ExtractShort(PGPKEYID *key_id,
		      unsigned long *short_id);
int 
PGPKEYID_FromAscii(char *str,
		   PGPKEYID *key_id);
int 
PGPKEYID_ToAscii(PGPKEYID *key_id,
		 char *buf,
		 int maxsize);
char *
PGPKEYID_ToStr(PGPKEYID *key_id);

/*
 * packet.c
 */

#ifndef __palmos__
int
read_packet(FILE	*fd,
	    u_char	**packet);
#endif	/* __palmos__ */

int
packet_length(u_char	*p);

int
find_packet_in_buffer(u_char	*buffer,
		      int	buf_len,
		      u_char	**packet);

/*
 * pke.c
 */

int
buf2pke (u_char		*buffer,
	 int		length,
	 PGPpke_t	*pke);

void
free_pke(PGPpke_t	*pke);


/*
 * pubencrypt.c
 */

int
pub_encrypt_buffer(PGPpubkey_t	*key,
		   u_char	*inbuf,
		   int		inbuflen,
		   int		do_compress,
		   u_char	digest[16],
		   int		*outbuflen,
		   u_char 	**outbuf);

int
pub_encrypt_session_key(PGPpubkey_t	*key,
                        u_char		*skey,
			int		*outbuflen,
			u_char		**outbuf);


/*
 * pubdecrypt.c
 */

int
sec_decrypt_packet(PGPseckey_t 	*key,
		   u_char 	*PKE_packet,
		   int 		pke_l,
		   u_char 	*conv_packet,
		   int 		conv_l,
		   u_char 	**outbuf,
		   int 		*outlen);

/*
 * secencrypt
 */

void
free_signature(PGPsig_t *sig);

int
signature_length(PGPsig_t *sig);

int
signature2buf(PGPsig_t	*sig, 
	      u_char	**buf);

int
buf2signature(u_char 	*buf, 
	      int 	len, 
	      PGPsig_t 	*sig);

int
add_sig_to_key(PGPKEYID	key_id, 
	       PGPsig_t *sig);

int
check_signature(u_char 	CBT, 
		u_char 	*file_ptr, 
		int 	*length, 
		u_char 	**data);

int
verify_sig(u_char	*data,
	   int		dlen,
	   PGPsig_t	*sig,
	   PGPpubkey_t	*signkey);

int
verify_keysig(	PGPpubkey_t	*pubkey,
		PGPuserid_t	*uid,
		PGPsig_t	*sig,
		PGPpubkey_t	*signkey);
int
sign_buffer(	u_char		*buffer, 
		int 		bufsize,
		PGPseckey_t	*key, 
		PGPsig_t 	*sig);
int
pub_encrypt_flio_buffer(PGPpubkey_t	*key, 
			flio_t		*flio,
			int		do_compress,
			u_char    	digest[16],
			int		*outbuflen,
			u_char		**outbuf);
int
sign_flio_buffer(flio_t 	*flio, 
		 PGPseckey_t 	*key, 
		 PGPsig_t *sig);
int
make_sig(u_char		*buffer, 
	 int 		bufsize,
	 u_char		class,
	 PGPseckey_t	*key, 
	 PGPsig_t 	*sig);

int is_compromised(PGPKEYID);

/*
 * trust.c
 */
int
trust2buf(PGPtrust_t	*trust,
	  u_char	**buf);
int
buf2trust(u_char 	*packet,
	  int 		p_len,
	  PGPtrust_t 	*trust);

int
purge_trust(u_char *, long, long *);

/*
 * userid.c
 */

void
free_uid(PGPuserid_t	*uid);

int
uid2buf(PGPuserid_t	*uid,
	u_char		**buf);

int
buf2uid(u_char 	*buf, 
	int		length, 
	PGPuserid_t	*uid);



/*
 * error reporting, written by Thomas Roessler <roessler@guug.de>
 */

#ifndef _ERROR_C
extern const char *pgplib_errlist[];
extern int pgplib_errno;
#endif

#define PGPLIB_ERROR_SYSERR -1
#define PGPLIB_ERROR_OK 0
#define PGPLIB_ERROR_BAD_CTB_LENGTH 1
#define PGPLIB_ERROR_BAD_CTB 2
#define PGPLIB_ERROR_EINVAL 3
#define PGPLIB_ERROR_COMPRESSED_CTB 4
#define PGPLIB_ERROR_EOF 5
#define PGPLIB_ERROR_IMPOSSIBLE 6
#define PGPLIB_ERROR_BAD_PACKET_LENGTH 7
#define PGPLIB_ERROR_BADCRC 8
#define PGPLIB_ERROR_BAD_ALGORITHM 9
#define PGPLIB_ERROR_ZIP 10
#define PGPLIB_ERROR_WRONG_PASS 11
#define PGPLIB_ERROR_DB_FATAL 12
#define PGPLIB_ERROR_DB_NOT_OPEN 13

#define PGPLIB_ERROR_MAX 13

const char *pgplib_strerror(int);
/* For compatibility */
#ifndef WIN32
char * strerror(int num);
#endif

/* --------- END OF PGPLIB ------- */

/**************************************************************************
 *
 * Pretty Good(tm) Privacy - RSA public key cryptography for the masses
 * Written by Philip Zimmermann, Phil's Pretty Good(tm) Software.
 * Version 1.0 - 5 Jun 91, last revised 6 Jul 91 by PRZ
 * 
 * This file defines the various formats, filenames, and general control
 * methods used by PGP, as well as a few global switches which control
 * the functioning of the driver code.
 *
 */


/* **************************************************************
 * Tage Stabell-Kul copied this file from the PGP sources.  Large parts
 * has been removed, the remaining contents is unaltered.
 * ************************************************************** */


#define KEYFRAGSIZE 8	/* # of bytes in key ID modulus fragment */
#define SIZEOF_TIMESTAMP 4 /* 32-bit timestamp */

/*
**********************************************************************
*/

/* Cipher Type Byte (CTB) definitions follow...*/
#define CTB_DESIGNATOR 0x80
#define is_ctb(c) (((c) & CTB_DESIGNATOR)==CTB_DESIGNATOR)
#define CTB_TYPE_MASK 0x7c
#define CTB_LLEN_MASK 0x03

#define is_ctb_type(ctb,type) (((ctb) & CTB_TYPE_MASK)==(4*type))
#define CTB_BYTE(type,llen) (CTB_DESIGNATOR + (4*type) + llen)

#define CTB_PKE_TYPE 1			/* packet encrypted with RSA public
					   key */
#define CTB_SKE_TYPE 2			/* packet signed with RSA secret key */
#define CTB_MD_TYPE 3			/* message digest packet */
#define CTB_CERT_SECKEY_TYPE 5  /* secret key certificate */
#define CTB_CERT_PUBKEY_TYPE 6  /* public key certificate */
#define CTB_COMPRESSED_TYPE 8	/* compressed data packet */
#define CTB_CKE_TYPE 9			/* conventional-key-encrypted data */
#define	CTB_LITERAL_TYPE 10		/* raw data with filename and mode */
#define CTB_LITERAL2_TYPE 11	/* Fixed literal packet */
#define CTB_KEYCTRL_TYPE 12		/* key control packet */
#define CTB_USERID_TYPE 13		/* user id packet */
#define CTB_COMMENT_TYPE 14		/* comment packet */

/* Unimplemented CTB packet types follow... */
/* #define CTB_EXTENDED_TYPE 15 */ /* 2-byte CTB, 256 extra CTB types */

#define CTB_PKE CTB_BYTE(CTB_PKE_TYPE,1)
	/* CTB_PKE len16 keyID mpi(RSA(CONKEYPKT)) */
	/*	  1		 2	 SIZE  countbytes()+2 */
#define CTB_SKE CTB_BYTE(CTB_SKE_TYPE,1)
	/* CTB_SKE len16 keyID mpi(RSA(MDPKT)) */
	/*	  1		 2	 SIZE  countbytes()+2 */
#define CTB_MD CTB_BYTE(CTB_MD_TYPE,0)
	/* CTB_MD len8 algorithm MD timestamp */
#define CTB_CERT_SECKEY CTB_BYTE(CTB_CERT_SECKEY_TYPE,1)
	/* CTB_CERT_SECKEY len16 timestamp userID mpi(n) mpi(e) mpi(d)
	   mpi(p) mpi(q) mpi(u) crc16 */
#define CTB_CERT_PUBKEY CTB_BYTE(CTB_CERT_PUBKEY_TYPE,1)
	/* CTB_CERT_PUBKEY len16 timestamp userID mpi(n) mpi(e) crc16 */

#define CTB_KEYCTRL CTB_BYTE(CTB_KEYCTRL_TYPE,0)
#define	CTB_USERID	CTB_BYTE(CTB_USERID_TYPE,0)

#define CTB_CKE CTB_BYTE(CTB_CKE_TYPE,3)
	/*	CTB_CKE ciphertext */

#define CTB_LITERAL CTB_BYTE(CTB_LITERAL_TYPE,3)
#define CTB_LITERAL2 CTB_BYTE(CTB_LITERAL_TYPE,3)
	/*	CTB_LITERAL data */

#define CTB_COMPRESSED CTB_BYTE(CTB_COMPRESSED_TYPE,3)
	/*	CTB_COMPRESSED compressedtext */

/*	Public key encryption algorithm selector bytes. */
#define RSA_ALGORITHM_BYTE	1	/*	use RSA	*/

/*	Conventional encryption algorithm selector bytes. */
#define IDEA_ALGORITHM_BYTE	1	/*	use the IDEA cipher */

/*	Message digest algorithm selector bytes. */
#define MD5_ALGORITHM_BYTE 1	/* MD5 message digest algorithm */

/*	Data compression algorithm selector bytes. */
#define ZIP2_ALGORITHM_BYTE  1	/* Zip-based deflate compression algorithm */

/* Signature classification bytes. */
#define SB_SIGNATURE_BYTE	0x00	/* Signature of a binary msg or doc */
#define SM_SIGNATURE_BYTE       0x01    /* Signature of canonical msg or doc */
#define K0_SIGNATURE_BYTE       0x10    /* Key certification, generic */
#define K1_SIGNATURE_BYTE       0x11    /* Key certification, persona */
#define K2_SIGNATURE_BYTE       0x12    /* Key certification, casual ID */
#define K3_SIGNATURE_BYTE       0x13    /* Key certification, positive ID */
#define KC_SIGNATURE_BYTE       0x20    /* Key compromise */
#define KR_SIGNATURE_BYTE       0x30    /* ID or Certification revocation */
#define TS_SIGNATURE_BYTE       0x40    /* Timestamp someone else's */

/* Public key encrypted data classification bytes. */
#define MD_ENCRYPTED_BYTE	1	/* Message digest is encrypted */
#define CK_ENCRYPTED_BYTE	2	/* Conventional key is encrypted */

/* Version byte for data structures created by this version of PGP */
#define	VERSION_BYTE_OLD	2	/* PGP2 */
#define	VERSION_BYTE_NEW	3

#define is_secret_key(ctb) is_ctb_type(ctb,CTB_CERT_SECKEY_TYPE)

/* Modes for CTB_LITERAL2 packet */
#define	MODE_BINARY	'b'
#define	MODE_TEXT	't'
#define MODE_LOCAL	'l'


#endif /* PGPLIB_H */

