/****************************************************************************
*																			*
*					SCEZ chipcard library - Proton routines					*
*						Copyright Matthias Bruestle 1999					*
*					For licensing, see the file COPYRIGHT					*
*																			*
****************************************************************************/

/* $Id: scproton.h,v 1.4 2000/09/01 15:31:27 zwiebeltu Exp $ */

#ifndef SC_PROTON_H
#define SC_PROTON_H

#ifndef SC_GENERAL_H
#error scgeneral.h needs to be included before this.
#endif

/* Usefull defines for command parameters */

#define SC_PROTON_EF_FAB		0x17FF
#define SC_PROTON_EF_PURSE		0x2901

#define	SC_PROTON_RECORD_ABS	0x00
#define	SC_PROTON_RECORD_FIRST	0x01
#define	SC_PROTON_RECORD_PREV	0x02
#define	SC_PROTON_RECORD_NEXT	0x03

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* Initialize card function pointer */
int scProtonInit( SC_CARD_INFO *ci );

/* Fill card data in ci */
int scProtonGetCardData( SC_CARD_INFO *ci );

/* Probably Ask Random/Get Challenge
 * The answer to Le==5 is 6A86, otherwise it is 6700.
 */
int scProtonCmdAskRandom( SC_READER_INFO *ri, SC_CARD_INFO *ci,
	BYTE *data, int *datalen );

int scProtonCmdLookupBalance( SC_READER_INFO *ri, SC_CARD_INFO *ci,
	BYTE *data, int *datalen );

int scProtonCmdReadBinary( SC_READER_INFO *ri, SC_CARD_INFO *ci,
	WORD offset, BYTE *data, int *datalen );

int scProtonCmdReadRecord( SC_READER_INFO *ri, SC_CARD_INFO *ci,
	BYTE recnum, BYTE mode, BYTE *data, int *datalen );

int scProtonCmdSelectFile( SC_READER_INFO *ri, SC_CARD_INFO *ci,
	WORD fid, BYTE *resp, int *resplen );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* SC_PROTON_H */


