/* 
 * datedb.c
 *
 * $Id: datedb.c,v 3.9 1998/05/15 16:20:15 ga58 Exp $
 *
 * $Log: datedb.c,v $
 * Revision 3.9  1998/05/15 16:20:15  ga58
 *  - no visible changes
 *
 * Revision 3.8  1998/05/04 16:25:40  ga58
 *  - changed the summary format to be CSV compatible.
 * CVS:
 * CVS:
 *
 * Revision 3.7  1998/05/03 12:18:30  ga58
 *  - i changed the text format for the summary log to a CSV format.
 * CVS:
 * CVS:
 *
 * Revision 3.6  1998/04/27 06:36:46  ga58
 *  - the width of the command popup window and the project list window are now
 *    calculated dynamically.
 * CVS:
 * CVS:
 *
 * Revision 3.5  1998/04/26 09:03:28  ga58
 *  - finished the conversion to a shared library version
 * CVS:
 * CVS:
 *
 * Revision 3.4  1998/04/19 15:44:26  ga58
 * This is the first branch of the 3.x series of titrax. Most of the new
 * features and code changes are described in the NEWS file.
 * CVS:
 * CVS:
 *
 * Revision 2.7  1998/04/13 09:22:33  ga58
 *  - added a new option: Clear note in datebook mode
 * CVS:
 * CVS:
 *
 * Revision 2.6  1998/04/12 09:31:08  ga58
 *  - a lot of minor changes in the UI
 *  - a lot of minor changes in the code
 *  - added new options
 * CVS:
 * CVS:
 *
 * Revision 2.5  1998/04/10 16:54:09  ga58
 * code cleanups in some modules
 * added the list-code to titraxDB
 * modularized mainForm
 * removed Elapsed and StartedAt from titraxDB and integrated them into
 * titraxPref
 * reworked TextIsEmpty and NoteIsEmpty in titraxDB
 * tried to make the code faster
 * CVS:
 * CVS:
 *
 * Revision 2.4  1998/04/04 15:26:32  ga58
 * version 2.4
 * CVS:
 * CVS:
 *
 * Revision 1.1  1998/04/04 15:24:32  ga58
 * first version in CVS
 * CVS:
 *
 * Revision 1.1.1.1  1998/04/04 15:04:07  ga58
 * first version
 *
 * Revision 2.0  1998/03/24 08:55:56  ga58
 * *** empty log message ***
 *
 * Revision 1.2  1998/03/24 07:50:50  ga58
 * *** empty log message ***
 *
 * Revision 1.1  1998/03/21 16:06:31  ga58
 * Initial revision
 *
 */

#pragma pack(2)

#include "titraxAll.h"

void AddAppointment(Int no, ULong sTime, ULong eTime);

static UInt ApptFindSortPosition(DmOpenRef dbP, ApptPackedDBRecordPtr newRecord);
Err ApptNewRecord(DmOpenRef dbP, ApptDBRecordPtr r, UInt *index);
static void ApptPack(ApptDBRecordPtr s, ApptPackedDBRecordPtr d);
static UInt ApptPackedSize (ApptDBRecordPtr r);
static Int ApptComparePackedRecords (ApptPackedDBRecordPtr r1, 
												 ApptPackedDBRecordPtr r2, Int extra, 
												 SortRecordInfoPtr info1, 
												 SortRecordInfoPtr info2, 
												 VoidHand appInfoH);

static Int TimeCompare (TimeType t1, TimeType t2);
static Int DateCompare (DateType d1, DateType d2);


#define DateBookDBType  'DATA'
#define DateBookAppType 'date'
#define DateBookDBName  "DateBookDB"

void
AddAppointment(Int no, ULong sTime, ULong eTime)
{
  static DmOpenRef DateBookDB;
  UInt mode, cardNo,version,attr;
  LocalID dbID, appInfoID;
  Err error;
  ApptDBRecordType newAppt;
  ApptDateTimeType when;
  DateType date;
  DateTimeType temptime, temptime2;
  Char desc[MAXTEXT+1];
  Word recordNum;
  VoidPtr noteP = NULL;
  VoidHand noteH = NULL;

  mode = dmModeReadWrite;
  DateBookDB = DmOpenDatabaseByTypeCreator(DateBookDBType, DateBookAppType, mode);
  if (! DateBookDB)
	 (void)FrmAlert(titraxDateBookAlert);
  else {
	 error = DmOpenDatabaseInfo(DateBookDB, &dbID, NULL, NULL, &cardNo, NULL);
	 ErrFatalDisplayIf(error, "Could not get open Appointment database info.");
	 
	 error = DmDatabaseInfo(0, dbID, NULL, NULL, &version, NULL, NULL, NULL, 
									NULL, &appInfoID, NULL, NULL, NULL);
	 ErrFatalDisplayIf(error, "Could not get Appointment database info.");
	 
	 TimSecondsToDateTime(eTime, &temptime);
	 TimSecondsToDateTime(sTime, &temptime2);
	 DateSecondsToDate(sTime,&date);

	 while ((temptime.day != temptime2.day) || (temptime.month != temptime2.month) || (temptime.year != temptime2.year)) {
		/* We're crossing over a day boundary, make 2 appointments, one on either
			side of the midnight bondary */
		when.endTime.hours = 23;
		when.endTime.minutes = 59;  
		when.startTime.hours = temptime2.hour;
		when.startTime.minutes = temptime2.minute;  
		when.date = date;
		GetText(no,desc);
		MemSet (&newAppt, sizeof(newAppt), 0);
		newAppt.when = &when;
		newAppt.description = desc;

		if (!NoteIsEmpty(no)) {
		  noteH = GetNote(no);
		  noteP = MemHandleLock(noteH);
		  newAppt.note = noteP;
		}

		error = ApptNewRecord(DateBookDB, &newAppt, &recordNum);
		ErrFatalDisplayIf(error, "Could not create new appointment.");
		/* Mark the record Dirty */
		DmRecordInfo (DateBookDB, recordNum, &attr, NULL, NULL);
		attr |= dmRecAttrDirty;
		DmSetRecordInfo (DateBookDB, recordNum, &attr, NULL);
		sTime = ((sTime/daysInSeconds) + 1)*daysInSeconds;
		TimSecondsToDateTime(sTime, &temptime2);
		DateSecondsToDate(sTime,&date);

		if (!NoteIsEmpty(no)) {
		  MemHandleUnlock(noteH);
		  MemHandleFree(noteH);
		}
	 }
	 when.endTime.hours = temptime.hour;
	 when.endTime.minutes = temptime.minute;  
	 when.startTime.hours = temptime2.hour;
	 when.startTime.minutes = temptime2.minute;  
	 when.date = date;
	 GetText(no,desc);
	 MemSet (&newAppt, sizeof(newAppt), 0);
	 newAppt.when = &when;
	 newAppt.description = desc;

	 if (!NoteIsEmpty(no)) {
		noteH = GetNote(no);
		noteP = MemHandleLock(noteH);
		newAppt.note = noteP;
	 }
	 
	 error = ApptNewRecord(DateBookDB, &newAppt, &recordNum);
	 ErrFatalDisplayIf(error, "Could not create new appointment.");
	 
	 /* Mark the record Dirty */
	 DmRecordInfo (DateBookDB, recordNum, &attr, NULL, NULL);
	 attr |= dmRecAttrDirty;
	 DmSetRecordInfo (DateBookDB, recordNum, &attr, NULL);
	 sTime = ((sTime/daysInSeconds) + 1)*daysInSeconds;
	 TimSecondsToDateTime(sTime, &temptime2);
	 
	 if (!NoteIsEmpty(no)) {
		MemHandleUnlock(noteH);
		MemHandleFree(noteH);
	 }

	 /* Close the datebook database */
	 DmCloseDatabase(DateBookDB);

	 if (AlwaysNewNote() && !SaveMemopad())
		ClearNote(no);
  }
}

void
CreateDatebookSummary(ULong sTime)
{
  const Int maxLen = 4096-96; /* upper limit for memopad notes */

  VoidHand clip;
  CharPtr clipText;
  Char dateStr[longDateStrLength];
  DateTimeType dateTime;
  Char headerString[80];

  static DmOpenRef DateBookDB;
  UInt mode, cardNo,version,attr;
  LocalID dbID, appInfoID;
  Err error;
  ApptDBRecordType newAppt;
  ApptDateTimeType when;
  DateType date;
  DateTimeType temptime;
  Word recordNum;

  /* build the description */
  TimSecondsToDateTime(TimGetSeconds(), &dateTime);
  DateToAscii(dateTime.month, dateTime.day, dateTime.year, dfDMYLongWithDot, dateStr);
  StrCopy(headerString, "Titrax log ");
  StrNCat(headerString, dateStr, 80);

  /* build the note */
  clip = MemHandleNew(maxLen + 1);
  clipText = (CharPtr)MemHandleLock(clip);

  StrCopy(clipText, "");

  SaveTimeAndNoteInformation(clipText, maxLen);

  mode = dmModeReadWrite;
  DateBookDB = DmOpenDatabaseByTypeCreator(DateBookDBType, DateBookAppType, mode);
  if (! DateBookDB)
	 (void)FrmAlert(titraxDateBookAlert);
  else {
	 error = DmOpenDatabaseInfo(DateBookDB, &dbID, NULL, NULL, &cardNo, NULL);
	 ErrFatalDisplayIf(error, "Could not get open Appointment database info.");
	 
	 error = DmDatabaseInfo(0, dbID, NULL, NULL, &version, NULL, NULL, NULL, 
									NULL, &appInfoID, NULL, NULL, NULL);
	 ErrFatalDisplayIf(error, "Could not get Appointment database info.");
	 
	 TimSecondsToDateTime(sTime, &temptime);
	 DateSecondsToDate(sTime,&date);

	 when.startTime.hours = apptNoTime;
	 when.startTime.minutes = apptNoTime;  
	 when.date = date;

	 MemSet (&newAppt, sizeof(newAppt), 0);
	 newAppt.when = &when;
	 newAppt.description = headerString;

	 newAppt.note = clipText;
	 
	 error = ApptNewRecord(DateBookDB, &newAppt, &recordNum);
	 ErrFatalDisplayIf(error, "Could not create new appointment.");
	 
	 /* Mark the record Dirty */
	 DmRecordInfo (DateBookDB, recordNum, &attr, NULL, NULL);
	 attr |= dmRecAttrDirty;
	 DmSetRecordInfo (DateBookDB, recordNum, &attr, NULL);

	 /* Close the datebook database */
	 DmCloseDatabase(DateBookDB);
  }

  MemHandleUnlock(clip);
  MemHandleFree(clip);
}

Err 
ApptNewRecord(DmOpenRef dbP, ApptDBRecordPtr r, UInt *index)
{
  VoidHand recordH;
  ApptPackedDBRecordPtr recordP;
  UInt 					newIndex;
  Err err;

  // Make a new chunk with the correct size.
  recordH = DmNewHandle (dbP, (ULong) ApptPackedSize(r));
  if (recordH == NULL)
	 return dmErrMemError;

  recordP = MemHandleLock (recordH);
	
  // Copy the data from the unpacked record to the packed one.
  ApptPack (r, recordP);

  newIndex = ApptFindSortPosition(dbP, recordP);

  MemPtrUnlock (recordP);

  // 4) attach in place
  err = DmAttachRecord(dbP, &newIndex, (Handle) recordH, 0);
  if (err) 
	 MemHandleFree(recordH);
  else
	 *index = newIndex;
	
  return err;
}

/************************************************************
 *
 *  FUNCTION: ApptPackedSize
 *
 *  DESCRIPTION: Return the packed size of an ApptDBRecordType 
 *
 *  PARAMETERS: database record
 *
 *  RETURNS: the size in bytes
 *
 *  CREATED: 1/25/95 
 *
 *  BY: Roger Flores
 *
 *************************************************************/
static UInt 
ApptPackedSize (ApptDBRecordPtr r)
{
  UInt size;
	
  size = sizeof (ApptDateTimeType) + sizeof (ApptDBRecordFlags);
	
  if (r->alarm != NULL)
	 size += sizeof (AlarmInfoType);
	
  if (r->repeat != NULL)
	 size += sizeof (RepeatInfoType);
	
  if (r->exceptions != NULL)
	 size += sizeof (UInt) + 
		(r->exceptions->numExceptions * sizeof (DateType));
	
  if (r->description != NULL)
	 size += StrLen(r->description) + 1;
	
  if (r->note != NULL)
	 size += StrLen(r->note) + 1;

  return size;
}

/************************************************************
 *
 *  FUNCTION: ApptPack
 *
 *  DESCRIPTION: Pack an ApptDBRecordType
 *
 *  PARAMETERS: database record
 *
 *  RETURNS: the ApptPackedDBRecord is packed
 *
 *  CREATED: 1/25/95 
 *
 *  BY: Roger Flores
 *
 *************************************************************/
static void 
ApptPack(ApptDBRecordPtr s, ApptPackedDBRecordPtr d)
{
  ApptDBRecordFlags	flags;
  UInt 	size;
  ULong	offset = 0;
	
  *(unsigned char *)&flags = 0;			// clear the flags
	
  // copy the ApptDateTimeType
  //c = (char *) d;
  offset = 0;
  DmWrite(d, offset, s->when, sizeof(ApptDateTimeType));
  offset += sizeof (ApptDateTimeType) + sizeof (ApptDBRecordFlags);

  if (s->alarm != NULL)
	 {
		DmWrite(d, offset, s->alarm, sizeof(AlarmInfoType));
		offset += sizeof (AlarmInfoType);
		flags.alarm = 1;
	 }

  if (s->repeat != NULL)
	 {
		DmWrite(d, offset, s->repeat, sizeof(RepeatInfoType));
		offset += sizeof (RepeatInfoType);
		flags.repeat = 1;
	 }

  if (s->exceptions != NULL)
	 {
		size = sizeof (UInt) + 
		  (s->exceptions->numExceptions * sizeof (DateType));
		DmWrite(d, offset, s->exceptions, size);
		offset += size;
		flags.exceptions = 1;
	 }
	
  if (s->description != NULL)
	 {
		size = StrLen(s->description) + 1;
		DmWrite(d, offset, s->description, size);
		offset += size;
		flags.description = 1;
	 }

	
  if (s->note != NULL)
	 {
		size = StrLen(s->note) + 1;
		DmWrite(d, offset, s->note, size);
		offset += size;
		flags.note = 1;
	 }
	
  DmWrite(d, sizeof(ApptDateTimeType), &flags, sizeof(flags));
}

/************************************************************
 *
 *  FUNCTION: ApptFindSortPosition
 *
 *  DESCRIPTION: Return where a record is or should be
 *		Useful to find or find where to insert a record.
 *
 *  PARAMETERS: database record
 *
 *  RETURNS: position where a record should be
 *
 *  CREATED: 1/25/95 
 *
 *  BY: Roger Flores
 *
 *************************************************************/
static UInt 
ApptFindSortPosition(DmOpenRef dbP, ApptPackedDBRecordPtr newRecord)
{
  return (DmFindSortPosition (dbP, newRecord, NULL, (DmComparF *)ApptComparePackedRecords, 0));
}

/************************************************************
 *
 *  FUNCTION:    ApptComparePackedRecords
 *
 *  DESCRIPTION: Compare two packed records.
 *
 *  PARAMETERS:  r1    - database record 1
 *				     r2    - database record 2
 *               extra - extra data, not used in the function
 *
 *  RETURNS:    -1 if record one is less
 *		           1 if record two is less
 *
 *  CREATED: 1/14/95 
 *
 *  BY: Roger Flores
 *
 *	COMMENTS:	Compare the two records key by key until
 *	there is a difference.  Return -1 if r1 is less or 1 if r2
 *	is less.  A zero is never returned because if two records
 *	seem identical then their unique IDs are compared!
 *
 *************************************************************/ 
static Int 
ApptComparePackedRecords (ApptPackedDBRecordPtr r1, 
								  ApptPackedDBRecordPtr r2, Int extra, SortRecordInfoPtr info1, 
								  SortRecordInfoPtr info2, VoidHand appInfoH)
{
  Int result;

  CALLBACK_PROLOGUE

  if ((r1->flags.repeat) || (r2->flags.repeat))
	 {
		if ((r1->flags.repeat) && (r2->flags.repeat))
		  result = 0;
		else if (r1->flags.repeat)
		  result = -1;
		else
		  result = 1;
	 }

  else
	 {
		result = DateCompare (r1->when.date, r2->when.date);
		if (result == 0)
		  {
			 result = TimeCompare (r1->when.startTime, r2->when.startTime);
		  }
	 }
  
  CALLBACK_EPILOGUE
  
  return result;
}

/***********************************************************************
 *
 * FUNCTION:    DateCompare
 *
 * DESCRIPTION: This routine compares two dates.
 *
 * PARAMETERS:  d1 - a date 
 *              d2 - a date 
 *
 * RETURNED:    if d1 > d2  returns a positive int
 *              if d1 < d2  returns a negative int
 *              if d1 = d2  returns zero
 *
 * NOTE: This routine treats the DateType structure like an unsigned int,
 *       it depends on the fact the the members of the structure are ordered
 *       year, month, day form high bit to low low bit.
 *
 * REVISION HISTORY:
 *			Name	Date		Description
 *			----	----		-----------
 *			art	6/12/95		Initial Revision
 *
 ***********************************************************************/
static Int 
DateCompare (DateType d1, DateType d2)
{
  UInt int1, int2;
	
  int1 = DateToInt(d1);
  int2 = DateToInt(d2);
	
  if (int1 > int2)
	 return (1);
  else if (int1 < int2)
	 return (-1);
  return 0;
}


/***********************************************************************
 *
 * FUNCTION:    TimeCompare
 *
 * DESCRIPTION: This routine compares two times.  "No time" is represented
 *              by minus one, and is considered less than all times.
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    if t1 > t2  returns a positive int
 *              if t1 < t2  returns a negative int
 *              if t1 = t2  returns zero
 *
 * REVISION HISTORY:
 *			Name	Date		Description
 *			----	----		-----------
 *			art	6/12/95		Initial Revision
 *
 ***********************************************************************/
static Int 
TimeCompare (TimeType t1, TimeType t2)
{
  Int int1, int2;
	
  int1 = TimeToInt(t1);
  int2 = TimeToInt(t2);
	
  if (int1 > int2)
	 return (1);
  else if (int1 < int2)
	 return (-1);
  return 0;
}

/*
 * This routine appends the time information to the given string pointer.
 * The string must be initialized through the caller.
 */
void
SaveTimeAndNoteInformation(CharPtr text, Int len)
{
  const int minTime = 30; // seconds

  Int i;
  Char textStr[MAXTEXT+1];
  Char timeStr[10];
  ULong sum = SumElapsed();
  DateTimeType dateTime;
  Char dateStr[longDateStrLength];

  CharPtr noteP;
  VoidHand noteH;

  TimSecondsToDateTime(TimGetSeconds(), &dateTime);
  DateToAscii(dateTime.month, dateTime.day, dateTime.year, dfDMYLongWithDot, dateStr);

  StrNCat(text, "\"", len);
  StrNCat(text, dateStr, len);
  StrNCat(text, "\",\"", len);
  StrNCat(text, TimeToString(sum, timeStr), len);
  StrNCat(text, "\",\"", len);
  StrNCat(text, "days total elapsed time", len);
  StrNCat(text, "\"\n", len);

  for(i = 0; i < MAXSLOT; i++) {
	 if ((TextIsEmpty(i) == false) && (Elapsed(i) > minTime)) {
		GetText(i, textStr);
		StrNCat(text, "\"", len);
		StrNCat(text, textStr, len);
		StrNCat(text, "\",\"", len);
		StrNCat(text, TimeToString(Elapsed(i), timeStr), len);
		StrNCat(text, "\",\"", len);

		if (NoteIsEmpty(i)) 
		  StrNCat(text, "empty note", len);
		else {
		  noteH = GetNote(i);
		  noteP = MemHandleLock(noteH);
		  StrNCat(text, noteP, len);
		  MemHandleUnlock(noteH);
		  MemHandleFree(noteH);
		}
		StrNCat(text, "\"\n", len);
	 }
  }
}

/*
 * The Save button will stuff all time information as text into a
 * string of maximum length maxLen.
 */
void
CreateMemopadSummary(void)
{
  const Int maxLen = 4096-96; // upper limit for memopad notes

  UInt choice = 0;
  VoidHand clip;
  CharPtr clipText;

  Int idx = 0;
  UInt mode;
  DmOpenRef MemopadDB;
  VoidPtr recP;
  VoidHand recH;
  UInt attr;
  Word category;

  clip = MemHandleNew(maxLen + 1);
  clipText = (CharPtr)MemHandleLock(clip);

  StrCopy(clipText, "");

  SaveTimeAndNoteInformation(clipText, maxLen);

  if (StrLen(clipText) >= maxLen - 2)
	 choice = FrmAlert(titraxNoteSpaceAlert);

  if (choice == 0) {
	 mode = dmModeReadWrite;
	 MemopadDB = DmOpenDatabaseByTypeCreator('DATA', 'memo', mode);
	 
	 if (!MemopadDB)
		(void)FrmAlert(titraxNotepadAlert);
	 else {
		recH = DmNewRecord(MemopadDB, &idx, StrLen(clipText)+1);
		recP = MemHandleLock(recH);
		
		if (DmSet(recP, 0, StrLen(clipText)+1, 0) != 0) 
		  (void)FrmAlert(titraxNotepadAlert);
		else
		  DmWrite(recP, 0, clipText, StrLen(clipText));
		  
		MemHandleUnlock(recH);

		DmRecordInfo(MemopadDB, idx, &attr, NULL, NULL);
		attr &= ~dmRecAttrCategoryMask;

		category = CategoryFind(MemopadDB, "Titrax");

		if (category == dmAllCategories)
		  attr |= dmUnfiledCategory;
		else
		  attr |= category;

		DmSetRecordInfo(MemopadDB, idx, &attr, NULL);

		DmReleaseRecord(MemopadDB, idx, true);

		DmCloseDatabase(MemopadDB);
	 }
  }

  MemHandleUnlock(clip);
  MemHandleFree(clip);
}

void
AddTimeStamp(Int no, ULong start, ULong end)
{
  Int len;
  VoidPtr strP;
  VoidHand strH;
  VoidPtr noteP;
  VoidHand noteH;
  Char timStr[timeStringLength];
  const Int maxLen = 4095;

  len = NoteLen(no);
  TimeString(timStr, start);

  strH = MemHandleNew(len + 2 * timeStringLength + 4);
  strP = MemHandleLock(strH);

  noteH = GetNote(no);
  noteP = MemHandleLock(noteH);

  StrNCopy(strP, noteP, maxLen);

  MemHandleUnlock(noteH);
  MemHandleFree(noteH);

  StrNCat(strP, timStr, maxLen);
  StrNCat(strP, "-", maxLen);

  TimeString(timStr, end);

  StrNCat(strP, timStr, maxLen);
  StrNCat(strP, "\n", maxLen);

  SetNote(no, strP);

  MemHandleUnlock(strH);
  MemHandleFree(strH);
}

