
#include "titraxAll.h"

void 
EditFormInit(void)
{
  Char text[MAXTEXT+1];
  FormPtr frm = FrmGetActiveForm();
  FieldPtr fldP = GetObjectPtr(editFormField);

  GetText(EditedSlot(), text);
  FldSetTextHandle(fldP, GetRecordHandle(TextRecIdx(EditedSlot())));

  FrmDrawForm(frm);

  FldSetInsPtPosition(fldP, StrLen(text));
  
  CtlSetValue(GetObjectPtr(editFormTrack), Track(EditedSlot()));
  CtlSetValue(GetObjectPtr(editFormDateBook), DateBook(EditedSlot()));
  CtlSetValue(GetObjectPtr(editFormIgnore), Ignored(EditedSlot()));

  FrmSetFocus(frm, FrmGetObjectIndex(frm, editFormField));

  if (TextIsEmpty(EditedSlot()) == true)
	 GrfSetState(false, false, true);
}

Boolean
EditFormHandleEvent(EventPtr event)
{
  Boolean handled = false;

  switch (event->eType) {
  case ctlSelectEvent:
	 if (event->data.ctlEnter.controlID == editFormOK) {
		Int oldActiveSlot = ActiveSlot();

		FldSetDirty(GetObjectPtr(editFormField), true);
		FldSetTextHandle(GetObjectPtr(editFormField), 0);
		ReleaseRecordHandle(TextRecIdx(EditedSlot()), true);

		SetTrack(EditedSlot(), CtlGetValue(GetObjectPtr(editFormTrack)));
		SetDateBook(EditedSlot(), CtlGetValue(GetObjectPtr(editFormDateBook)));
		SetIgnored(EditedSlot(), CtlGetValue(GetObjectPtr(editFormIgnore)));

		FrmReturnToForm(mainForm);

		if (TextIsEmpty(EditedSlot()) == true) {
		  if (ActiveSlot() == EditedSlot())
			 DeActivateSlot(EditedSlot(), false);
		  ClearSlot(EditedSlot());
		}
		else {
		  ActivateSlot(EditedSlot(), false);
		}
		UpdateSlot(oldActiveSlot);
		UpdateSlot(EditedSlot());
		UpdateProjectList();
		UpdateProjectListButton();
		handled = true;
	 }
	 break;

  case frmOpenEvent:
	 EditFormInit();
	 handled = true;
	 break;

  case appStopEvent:
	 FldSetDirty(GetObjectPtr(editFormField), true);
	 FldSetTextHandle(GetObjectPtr(editFormField), 0);
	 ReleaseRecordHandle(TextRecIdx(EditedSlot()), true);
	 SetActualForm(editForm);
	 handled = false;
	 break;
	 
  case frmTitleSelectEvent:
	 if (MenuHack()) {
		MenuBarPtr menuP = MenuInit(editFormMenu);

		MenuSetActiveMenu(menuP);
		MenuDrawMenu(menuP);
		handled = true;
	 }
	 else
		handled = false;
	 break;

  case menuEvent:
	 MenuEraseStatus(0);
	 if (event->data.menu.itemID == editFormMenuKeyboard)
		SysKeyboardDialogV10();
	 if (event->data.menu.itemID == editFormMenuGraffiti)
		SysGraffitiReferenceDialog(referenceDefault);
	 if (event->data.menu.itemID == editFormMenuCut)
		FldCut(GetObjectPtr(editFormField));
	 if (event->data.menu.itemID == editFormMenuCopy)
		FldCopy(GetObjectPtr(editFormField));
	 if (event->data.menu.itemID == editFormMenuPaste)
		FldPaste(GetObjectPtr(editFormField));
	 if (event->data.menu.itemID == editFormMenuUndo)
		FldUndo(GetObjectPtr(editFormField));
	 if (event->data.menu.itemID == editFormMenuSelectAll)
		FldSetSelection(GetObjectPtr(editFormField), 0, 
							 FldGetTextLength(GetObjectPtr(editFormField)));
	 handled = true;
	 break;

  default:
	 handled = false;
  }
  return handled;
}

