
#include "titraxAll.h"

void
NoteFormInit(void)
{
  Char textStr[MAXTEXT+1];
  Char title[MAXTEXT+12];
  Int noteLen = NoteLen(EditedNoteSlot());
  FormPtr frm = FrmGetActiveForm();
  FieldPtr fldP = GetObjectPtr(noteFormField);

  FrmDrawForm(frm);

  GetText(EditedNoteSlot(), textStr);
  StrNCopy(title, "Notes for ", MAXTEXT+12);
  StrCat(title, textStr);
  FrmCopyTitle(frm, title);

  FldSetTextHandle(fldP, GetRecordHandle(NoteRecIdx(EditedNoteSlot())));
  FldSetInsPtPosition(fldP, noteLen);

  FrmSetFocus(frm, FrmGetObjectIndex(frm, noteFormField));

  if (NoteIsEmpty(EditedNoteSlot()) == true)
	 GrfSetState(false, false, true);

  FldDrawField(GetObjectPtr(noteFormField));

  NoteFormCheckScroll();
}

void
NoteFormCheckScroll()
{
  FormPtr frm = FrmGetActiveForm();
  Boolean canUp = FldScrollable(GetObjectPtr(noteFormField), up);
  Boolean canDown = FldScrollable(GetObjectPtr(noteFormField), down);
  
  FrmUpdateScrollers(frm, 
							FrmGetObjectIndex(frm, noteFormUp), 
							FrmGetObjectIndex(frm, noteFormDown),
							canUp, canDown);
}

void
ScrollField(Int amount, Int direction)
{
  FieldPtr fldP = GetObjectPtr(noteFormField);

  if (FldScrollable(fldP, up))
	 FldScrollField(fldP, amount, direction);

  NoteFormCheckScroll();
}

Boolean
NoteFormHandleEvent(EventPtr event)
{
  Boolean handled = false;

  switch (event->eType) {
  case ctlSelectEvent:
	 if (event->data.ctlEnter.controlID == noteFormOk) {
		FldCompactText(GetObjectPtr(noteFormField));
		FldSetDirty(GetObjectPtr(noteFormField), true);
		FldSetTextHandle(GetObjectPtr(noteFormField), 0);
		ReleaseRecordHandle(NoteRecIdx(EditedNoteSlot()), true);
		if (NoteIsEmpty(EditedNoteSlot()) == true)
		  ClearNote(EditedNoteSlot());
		FrmReturnToForm(mainForm);
		UpdateSlot(EditedNoteSlot());
		UpdateActiveSlot();
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == noteFormTimeStamp) {
		Char timStr[timeStringLength];

		TimeString(timStr, TimGetSeconds());
		FldInsert(GetObjectPtr(noteFormField), timStr, StrLen(timStr));
		NoteFormCheckScroll();
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == noteFormDateStamp) {
		Char datStr[dateStringLength];

		DateString(datStr);
		FldInsert(GetObjectPtr(noteFormField), datStr, StrLen(datStr));
		NoteFormCheckScroll();
		handled = true;
	 }
	 break;

  case ctlRepeatEvent:
	 if (event->data.ctlRepeat.controlID == noteFormUp) {
		ScrollField(1, up);
		handled = false;
	 }
	 else if (event->data.ctlRepeat.controlID == noteFormDown) {
		ScrollField(1, down);
		handled = false;
	 }
	 break;

  case keyDownEvent:
	 if (event->data.keyDown.chr == pageUpChr) {
		ScrollField(FldGetVisibleLines(GetObjectPtr(noteFormField)) - 1, up);
		handled = true;
	 }
	 else if (event->data.keyDown.chr == pageDownChr) {
		ScrollField(FldGetVisibleLines(GetObjectPtr(noteFormField)) - 1, down);
		handled = true;
	 }
	 else {
		handled = FrmHandleEvent(FrmGetActiveForm(), event);
		NoteFormCheckScroll();
	 }
	 break;

  case frmOpenEvent:
	 NoteFormInit();
	 handled = true;
	 break;

  case appStopEvent:
	 FldSetDirty(GetObjectPtr(noteFormField), true);
	 FldSetTextHandle(GetObjectPtr(noteFormField), 0);
	 ReleaseRecordHandle(NoteRecIdx(EditedNoteSlot()), true);
	 SetActualForm(noteForm);
	 handled = false;
	 break;

  case frmTitleSelectEvent:
	 if (MenuHack()) {
		MenuBarPtr menuP = MenuInit(noteFormMenu);

		MenuSetActiveMenu(menuP);
		MenuDrawMenu(menuP);
		handled = true;
	 }
	 else
		handled = false;
	 break;

  case menuEvent:
	 MenuEraseStatus(0);
	 if (event->data.menu.itemID == noteFormMenuKeyboard)
		SysKeyboardDialogV10();
	 if (event->data.menu.itemID == noteFormMenuGraffiti)
		SysGraffitiReferenceDialog(referenceDefault);
	 if (event->data.menu.itemID == noteFormMenuCut)
		FldCut(GetObjectPtr(noteFormField));
	 if (event->data.menu.itemID == noteFormMenuCopy)
		FldCopy(GetObjectPtr(noteFormField));
	 if (event->data.menu.itemID == noteFormMenuPaste)
		FldPaste(GetObjectPtr(noteFormField));
	 if (event->data.menu.itemID == noteFormMenuUndo)
		FldUndo(GetObjectPtr(noteFormField));
	 if (event->data.menu.itemID == noteFormMenuSelectAll)
		FldSetSelection(GetObjectPtr(noteFormField), 0, 
							 FldGetTextLength(GetObjectPtr(noteFormField)));
	 NoteFormCheckScroll();

	 handled = true;
	 break;

  default:
	 handled = false;
  }
  return handled;
}

