
#include "titraxAll.h"

typedef struct {
  Char list[MAXSLOT][MAXTEXT+1];
  CharPtr listP[MAXSLOT];
  Int listToSlot[MAXSLOT];
  Int slotToList[MAXSLOT];
  Int entries;
} ProjectListType;

static VoidHand projectListHand;
static ProjectListType* projectList;

void
CreateProjectList(void)
{
  projectListHand = MemHandleNew(sizeof(ProjectListType));
  ErrFatalDisplayIf(projectListHand == 0, "Out of memory for Project list.");

  projectList = (ProjectListType*)MemHandleLock(projectListHand);
  
  UpdateProjectList();
}

void
DeleteProjectList(void)
{
  MemHandleUnlock(projectListHand);
  MemHandleFree(projectListHand);
}

void
UpdateProjectList(void)
{
  Int row;
  Int slot;
  Char text[MAXTEXT+1];

  projectList->entries = 0;

  for(row = 0; row < MAXSLOT; row++) {
	 slot = RowToSlot(row);
	 if (TextIsEmpty(slot) == false) {
		GetText(slot, text);
		StrCopy(projectList->list[projectList->entries], text);
		projectList->listP[projectList->entries] = 
		  projectList->list[projectList->entries];
		projectList->listToSlot[projectList->entries] = slot;
		projectList->slotToList[slot] = projectList->entries;
		projectList->entries++;
	 }
  }
}

Int
ProjectListEntries(void)
{
  return projectList->entries;
}

Char**
ProjectListP(void)
{
  return projectList->listP;
}

Int
ProjectListNumToSlot(Int listNum)
{
  return projectList->listToSlot[listNum];
}

Int
SlotToProjectListNum(Int slot)
{
  return projectList->slotToList[slot];
}
