
#include "titraxAll.h"

CharPtr entryP[MAXSLOT];

void
ShiftFormCheckScroll(Int canUp, Int canDown)
{
  FormPtr frm = FrmGetActiveForm();

  FrmUpdateScrollers(frm, 
							FrmGetObjectIndex(frm, shiftFormUp),
							FrmGetObjectIndex(frm, shiftFormDown), 
							canUp, canDown);
}

void
ShiftFormInit(void)
{
  Int i;
  Int j = 0;
  Char** list = ProjectListP();
  Int selectedShiftSlot;

  ListPtr listP;
  FormPtr frm = FrmGetActiveForm();

  FrmDrawForm(frm);

  for(i = 0; i < ProjectListEntries(); i++) {
	 if (ProjectListNumToSlot(i) == ActiveSlot())
		continue;
	 entryP[j] = list[i];
	 SetShiftSlot(j, ProjectListNumToSlot(i));
	 j++;
  }

  listP = GetObjectPtr(shiftFormList);

  if (j > 0) {
	 LstSetListChoices(listP, entryP, j);
	 LstSetHeight(listP, j);
	 LstSetSelection(listP, 0);
	 CtlSetLabel(GetObjectPtr(shiftFormPopup), LstGetSelectionText(listP, LstGetSelection(listP)));
	 selectedShiftSlot = ShiftSlot(LstGetSelection(listP));
	 DrawDigits(Elapsed(ActiveSlot()), shiftFormDayHigh1);
	 DrawDigits(Elapsed(selectedShiftSlot), shiftFormDayHigh2);
  }
  else {
	 (void)FrmAlert(titraxShiftNoProjectsAlert);
	 LstSetSelection(listP, noListSelection);
	 CtlHideControl(GetObjectPtr(shiftFormPopup));
	 CtlHideControl(GetObjectPtr(shiftFormCommit));
	 ShiftFormCheckScroll(false, false);
  }

  if (Increment() == onemin)
	 CtlSetValue(GetObjectPtr(shiftFormMinLow1), 1);
  else if (Increment() == tenmins)
	 CtlSetValue(GetObjectPtr(shiftFormMinHigh1), 1);
  else if (Increment() == onehour)
	 CtlSetValue(GetObjectPtr(shiftFormHourLow1), 1);
  else if (Increment() == tenhours)
	 CtlSetValue(GetObjectPtr(shiftFormHourHigh1), 1);
  else if (Increment() == oneday)
	 CtlSetValue(GetObjectPtr(shiftFormDayLow1), 1);
  else if (Increment() == tendays)
	 CtlSetValue(GetObjectPtr(shiftFormDayHigh1), 1);
  else {
	 SetIncrement(onemin);
	 CtlSetValue(GetObjectPtr(shiftFormMinLow1), 1);
  }
}

Boolean
ShiftFormHandleEvent(EventPtr event)
{
  Boolean handled = false;
  static Int selectedShiftSlot;
  static Long transferAmount;
  static Long offLimitsTime;
  static Long selectedSlotElapsedTime;
  static Long currentlyActiveSlotElapsedTime;

  switch (event->eType) {
  case ctlSelectEvent:
	 if (event->data.ctlEnter.controlID == shiftFormCommit) {
		Long change, newSlotTime, currentElapsed, selectedElapsed;
		static Int tmpslot;

	   tmpslot = ActiveSlot();
	   currentElapsed = Elapsed(tmpslot);
	   selectedElapsed = Elapsed(selectedShiftSlot);
	   change = currentlyActiveSlotElapsedTime - currentElapsed;
	   newSlotTime = TimGetSeconds() + change;
	   if (DateBook(selectedShiftSlot)) {
	     AddAppointment(tmpslot, StartedAt(MAXSLOT), 
			    newSlotTime);
	   }
		if (Track(selectedShiftSlot))
		  AddTimeStamp(tmpslot, StartedAt(MAXSLOT), newSlotTime);

	   FrmReturnToForm(mainForm);
	   
	   SetElapsed(tmpslot, currentlyActiveSlotElapsedTime);
	   SetStartedAt(tmpslot,0);

		SetActiveSlot(selectedShiftSlot);
	   SetStartedAt(selectedShiftSlot, newSlotTime);
	   SetStartedAt(MAXSLOT, newSlotTime);
	   SetElapsed(selectedShiftSlot, selectedSlotElapsedTime+change); 
		
	   UpdateSlot(tmpslot);
	   UpdateSlot(selectedShiftSlot);

		UpdateProjectListButton();

		if (CenterActive())
		  ScrollCenterActive();

	   handled = true;
	 }

	 if (event->data.ctlEnter.controlID == shiftFormCancel) {
		FrmReturnToForm(mainForm);
		handled = true;
	 }
	 if (event->data.ctlEnter.controlID == shiftFormMinLow1) {
		SetIncrement(onemin);
		handled = true;
	 }
	 if (event->data.ctlEnter.controlID == shiftFormMinHigh1) {
		SetIncrement(tenmins);
		handled = true;
	 }
	 if (event->data.ctlEnter.controlID == shiftFormHourLow1) {
		SetIncrement(onehour);
		handled = true;
	 }
	 if (event->data.ctlEnter.controlID == shiftFormHourHigh1) {
		SetIncrement(tenhours);
		handled = true;
	 }
	 if (event->data.ctlEnter.controlID == shiftFormDayLow1) {
		SetIncrement(oneday);
		handled = true;
	 }
	 if (event->data.ctlEnter.controlID == shiftFormDayHigh1) {
		SetIncrement(tendays);
		handled = true;
	 }
	 break;

  case ctlRepeatEvent:
	 if (event->data.ctlEnter.controlID == shiftFormUp) {
		transferAmount = Increment();
		// no reverse shifting
		if ((currentlyActiveSlotElapsedTime + transferAmount) > 
			 Elapsed(ActiveSlot()))
		  transferAmount = Elapsed(ActiveSlot()) - 
			 currentlyActiveSlotElapsedTime;
		// no reverse shifting (this is a double check, i know...)
		if ((selectedSlotElapsedTime - transferAmount) < 
			 Elapsed(selectedShiftSlot))
		  transferAmount = selectedSlotElapsedTime;
		
		currentlyActiveSlotElapsedTime += transferAmount;
		selectedSlotElapsedTime -= transferAmount;

		DrawDigits(currentlyActiveSlotElapsedTime, shiftFormDayHigh1);
		DrawDigits(selectedSlotElapsedTime, shiftFormDayHigh2);
		
		ShiftFormCheckScroll((currentlyActiveSlotElapsedTime < 
									 Elapsed(ActiveSlot())),
									(currentlyActiveSlotElapsedTime > offLimitsTime));

		handled = false;
	 }

	 if (event->data.ctlEnter.controlID == shiftFormDown) {
		transferAmount = Increment();
		if (((currentlyActiveSlotElapsedTime - transferAmount) < offLimitsTime) 
			 && DateBook(ActiveSlot())) {
		  (void)FrmAlert(titraxShiftFormTooMuchAlert);
		  transferAmount = currentlyActiveSlotElapsedTime - offLimitsTime;
		}

		if (currentlyActiveSlotElapsedTime > transferAmount) {
		  currentlyActiveSlotElapsedTime -= transferAmount;
		  selectedSlotElapsedTime += transferAmount;
		}
		else {
		  selectedSlotElapsedTime += currentlyActiveSlotElapsedTime;
		  currentlyActiveSlotElapsedTime = 0;
		}

		DrawDigits(currentlyActiveSlotElapsedTime, shiftFormDayHigh1);
		DrawDigits(selectedSlotElapsedTime, shiftFormDayHigh2);
		
		ShiftFormCheckScroll((currentlyActiveSlotElapsedTime < 
									 Elapsed(ActiveSlot())),
									(currentlyActiveSlotElapsedTime > offLimitsTime));
		handled = false;
	 }
	 break;

  case popSelectEvent: {
	 Word selection = event->data.popSelect.selection;

	 currentlyActiveSlotElapsedTime = Elapsed(ActiveSlot());
	 if (DateBook(ActiveSlot()))
		offLimitsTime = currentlyActiveSlotElapsedTime - (TimGetSeconds() - StartedAt(MAXSLOT));
	 else
		offLimitsTime = 0;
	 DrawDigits(currentlyActiveSlotElapsedTime, shiftFormDayHigh1);
	 if (selection != noListSelection) {
		selectedShiftSlot = ShiftSlot(selection);
		selectedSlotElapsedTime = Elapsed(selectedShiftSlot);
		DrawDigits(selectedSlotElapsedTime, shiftFormDayHigh2);
		ShiftFormCheckScroll((currentlyActiveSlotElapsedTime < 
									 Elapsed(ActiveSlot())),
									(currentlyActiveSlotElapsedTime > offLimitsTime));
	 }
	 else
		ShiftFormCheckScroll(false, false);

	 handled = false; // so the OS will redraw the button for us
	 break;
  }

  case frmOpenEvent: {
	 ListPtr listP = GetObjectPtr(shiftFormList);

	 ShiftFormInit();
	 currentlyActiveSlotElapsedTime = Elapsed(ActiveSlot());

	 if (DateBook(ActiveSlot()))
		offLimitsTime = currentlyActiveSlotElapsedTime - 
		  (TimGetSeconds() - StartedAt(MAXSLOT));
	 else
		offLimitsTime = 0;

	 if (LstGetSelection(listP) != noListSelection) {
		selectedShiftSlot = ShiftSlot(LstGetSelection(listP));
		selectedSlotElapsedTime = Elapsed(selectedShiftSlot);
		ShiftFormCheckScroll((currentlyActiveSlotElapsedTime < 
									 Elapsed(ActiveSlot())),
									(currentlyActiveSlotElapsedTime > offLimitsTime));
	 }
	 else
		ShiftFormCheckScroll(false, false);

	 handled = true;
	 break;
  }

  case appStopEvent:
	 SetActualForm(shiftForm);
	 handled = false;
	 break;

  default:
	 handled = false;
  }
  return handled;
}

