
#include "titraxAll.h"

void
TimeFormCheckScroll(Boolean canUp, Boolean canDown)
{
  FormPtr frm = FrmGetActiveForm();

  FrmUpdateScrollers(frm,
							FrmGetObjectIndex(frm, timeFormUp),
							FrmGetObjectIndex(frm, timeFormDown),
							canUp, canDown);
}

void
TimeFormInit(void)
{
  FormPtr frm = FrmGetActiveForm();

  FrmDrawForm(frm);

  DrawDigits(Elapsed(ActiveSlot()), timeFormDayHigh);

  if (Increment() == onemin)
	 CtlSetValue(GetObjectPtr(timeFormMinLow), 1);
  else if (Increment() == tenmins)
	 CtlSetValue(GetObjectPtr(timeFormMinHigh), 1);
  else if (Increment() == onehour)
	 CtlSetValue(GetObjectPtr(timeFormHourLow), 1);
  else if (Increment() == tenhours)
	 CtlSetValue(GetObjectPtr(timeFormHourHigh), 1);
  else if (Increment() == oneday)
	 CtlSetValue(GetObjectPtr(timeFormDayLow), 1);
  else if (Increment() == tendays)
	 CtlSetValue(GetObjectPtr(timeFormDayHigh), 1);
  else {
	 SetIncrement(onemin);
	 CtlSetValue(GetObjectPtr(timeFormMinLow), 1);
  }
}

Boolean
TimeFormHandleEvent(EventPtr event)
{
  Boolean handled = false;
  static Long newElapsed = 0;

  switch (event->eType) {
  case ctlSelectEvent:
	 if (event->data.ctlEnter.controlID == timeFormCommit) {
		ULong change = newElapsed - Elapsed(ActiveSlot());

		SetElapsed(ActiveSlot(), Elapsed(ActiveSlot()) + change);
		SetStartedAt(MAXSLOT, StartedAt(ActiveSlot()) - change);
		FrmReturnToForm(mainForm);
		UpdateActiveSlot();
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == timeFormCancel) {
		FrmReturnToForm(mainForm);
		UpdateActiveSlot();
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == timeFormDayHigh) {
		SetIncrement(tendays);
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == timeFormDayLow) {
		SetIncrement(oneday);
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == timeFormHourHigh) {
		SetIncrement(tenhours);
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == timeFormHourLow) {
		SetIncrement(onehour);
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == timeFormMinHigh) {
		SetIncrement(tenmins);
		handled = true;
	 }

	 if (event->data.ctlEnter.controlID == timeFormMinLow) {
		SetIncrement(onemin);
		handled = true;
	 }
	 break;

  case ctlRepeatEvent:
	 if (event->data.ctlEnter.controlID == timeFormUp) {
		newElapsed += Increment();
		DrawDigits(newElapsed, timeFormDayHigh);
		handled = false;
	 }

	 if (event->data.ctlEnter.controlID == timeFormDown) {
		newElapsed -= Increment();
		if (newElapsed < 0)
		  newElapsed = 0;

		DrawDigits(newElapsed, timeFormDayHigh);
		handled = false;
	 }
	 TimeFormCheckScroll(true, newElapsed > 0);
	 break;

  case frmOpenEvent:
	 TimeFormInit();
	 newElapsed = Elapsed(ActiveSlot());
	 TimeFormCheckScroll(true, newElapsed > 0);
	 handled = true;
	 break;

  case appStopEvent:
	 SetActualForm(timeForm);
	 handled = false;
  break;

  default:
	 handled = false;
  }
  return handled;
}
