/*
 * titraxDB.h
 *
 * database subroutines for titrax
 *
 * $Id: titraxDB.h,v 3.5 1998/04/26 09:03:29 ga58 Exp $
 *
 * $Log: titraxDB.h,v $
 * Revision 3.5  1998/04/26 09:03:29  ga58
 *  - finished the conversion to a shared library version
 * CVS:
 * CVS:
 *
 * Revision 3.4  1998/04/19 15:44:30  ga58
 * This is the first branch of the 3.x series of titrax. Most of the new
 * features and code changes are described in the NEWS file.
 * CVS:
 * CVS:
 *
 * Revision 2.6  1998/04/13 09:22:33  ga58
 *  - added a new option: Clear note in datebook mode
 * CVS:
 * CVS:
 *
 * Revision 2.5  1998/04/10 16:54:10  ga58
 * code cleanups in some modules
 * added the list-code to titraxDB
 * modularized mainForm
 * removed Elapsed and StartedAt from titraxDB and integrated them into
 * titraxPref
 * reworked TextIsEmpty and NoteIsEmpty in titraxDB
 * tried to make the code faster
 * CVS:
 * CVS:
 *
 * Revision 2.4  1998/04/04 15:26:35  ga58
 * version 2.4
 * CVS:
 * CVS:
 *
 * Revision 1.1  1998/04/04 15:24:12  ga58
 * fist version in CVS
 * CVS:
 *
 * Revision 1.1.1.1  1998/04/04 15:04:07  ga58
 * first version
 *
 * Revision 1.2  1997/11/15 17:59:29  ga58
 * *** empty log message ***
 *
 * Revision 1.1  1997/11/14 17:51:04  ga58
 * Initial revision
 *
 */

#ifndef titraxDB_h
#define titraxDB_h

extern void CreateDatabase(void);
extern void OpenDatabase(void);
extern void CloseDatabase(void);

extern Handle GetRecordHandle(UInt idx);
extern void ReleaseRecordHandle(UInt idx, Int dirty);

extern void GetText(Int no, CharPtr charP);
extern void SetText(Int no, CharPtr charP);
extern Boolean EmptySlot(UInt idx);
extern Boolean TextIsEmpty(Int no);

extern VoidHand GetNote(Int no);
extern void SetNote(Int no, CharPtr charP);
extern Boolean NoteIsEmpty(Int no);
extern Int NoteLen(Int no);
extern void ClearNote(Int no);

#endif
