/*
 * Titrax preferences subroutines
 *
 * $Id: titraxPref.h,v 3.7 1998/04/27 06:36:47 ga58 Exp $
 *
 * $Log: titraxPref.h,v $
 * Revision 3.7  1998/04/27 06:36:47  ga58
 *  - the width of the command popup window and the project list window are now
 *    calculated dynamically.
 * CVS:
 * CVS:
 *
 * Revision 3.6  1998/04/26 09:03:29  ga58
 *  - finished the conversion to a shared library version
 * CVS:
 * CVS:
 *
 * Revision 3.5  1998/04/21 05:20:01  ga58
 *  - new functions SumElapsed. This is a preliminary step for implementing
 *    project flags. The first flag will be a ignored-flag. Projects with
 *    this flag set, will be ignored in the sum and in the sorting process.
 * CVS:
 * CVS:
 *
 * Revision 3.4  1998/04/19 15:44:30  ga58
 * This is the first branch of the 3.x series of titrax. Most of the new
 * features and code changes are described in the NEWS file.
 * CVS:
 * CVS:
 *
 * Revision 2.8  1998/04/13 09:22:34  ga58
 *  - added a new option: Clear note in datebook mode
 * CVS:
 * CVS:
 *
 * Revision 2.7  1998/04/12 09:31:10  ga58
 *  - a lot of minor changes in the UI
 *  - a lot of minor changes in the code
 *  - added new options
 * CVS:
 * CVS:
 *
 * Revision 2.6  1998/04/10 16:54:10  ga58
 * code cleanups in some modules
 * added the list-code to titraxDB
 * modularized mainForm
 * removed Elapsed and StartedAt from titraxDB and integrated them into
 * titraxPref
 * reworked TextIsEmpty and NoteIsEmpty in titraxDB
 * tried to make the code faster
 * CVS:
 * CVS:
 *
 * Revision 2.5  1998/04/05 16:23:56  ga58
 * removed LastCall and SetLastCall
 * CVS:
 * CVS:
 *
 * Revision 2.4  1998/04/04 15:26:35  ga58
 * version 2.4
 * CVS:
 * CVS:
 *
 * Revision 1.1  1998/04/04 15:24:12  ga58
 * fist version in CVS
 * CVS:
 *
 * Revision 1.1.1.1  1998/04/04 15:04:07  ga58
 * first version
 *
 * Revision 1.9  1998/04/04 14:41:06  ga58
 * *** empty log message ***
 *
 * Revision 1.8  1998/03/24 17:23:32  ga58
 * *** empty log message ***
 *
 * Revision 1.7  1998/03/24 07:50:50  ga58
 * *** empty log message ***
 *
 * Revision 1.6  1998/03/21 16:06:31  ga58
 * *** empty log message ***
 *
 * Revision 1.5  1998/02/13 15:26:55  ga58
 * *** empty log message ***
 *
 * Revision 1.4  1998/01/31 15:48:48  ga58
 * new pref: showDays
 *
 * Revision 1.3  1997/11/23 20:08:59  ga58
 * *** empty log message ***
 *
 * Revision 1.2  1997/11/15 17:59:29  ga58
 * *** empty log message ***
 *
 * Revision 1.1  1997/11/14 17:51:04  ga58
 * Initial revision
 *
 */

#ifndef titraxPref_h
#define titraxPref_h

#define tendays 864000
#define oneday 86400
#define tenhours 36000
#define onehour 3600
#define tenmins 600
#define onemin 60

#define descending -1
#define ascending 1

extern void CreatePrefs(void);
extern void ClearPrefs(void);
extern Boolean ReadPrefs(void);
extern void WritePrefs(void);
extern void DeletePrefs(void);

extern ULong Elapsed(Int no);
extern void SetElapsed(Int no, ULong val);
extern ULong SumElapsed(void);

extern ULong StartedAt(Int no);
extern void SetStartedAt(Int no, ULong val);

extern UInt TextRecIdx(Int no);
extern void SetTextRecIdx(Int no, UInt idx);

extern UInt NoteRecIdx(Int no);
extern void SetNoteRecIdx(Int no, UInt idx);

extern Int ActiveSlot(void);
extern void SetActiveSlot(Int no);

extern Int EditedSlot(void);
extern void SetEditedSlot(Int no);

extern Int EditedNoteSlot(void);
extern void SetEditedNoteSlot(Int no);

extern Int ActualForm(void);
extern void SetActualForm(Int f);

extern Int ShiftSlot(Int no);
extern void SetShiftSlot(Int no, Int val);

extern ULong Increment(void);
extern void SetIncrement(ULong val);

extern Boolean Track(Int no);
extern void SetTrack(Int no, Boolean val);

extern Boolean ShowDays(void);
extern void SetShowDays(Boolean val);

extern Int FirstRow(void);
extern void SetFirstRow(Int val);

extern Boolean DateBook(Int no);
extern void SetDateBook(Int no, Boolean val);

extern Boolean SaveDatebook(void);
extern void SetSaveDatebook(Boolean val);

extern Boolean SaveMemopad(void);
extern void SetSaveMemopad(Boolean val);

extern Boolean ShiftWarnings(void);
extern void SetShiftWarnings(Boolean val);

extern Boolean CenterActive(void);
extern void SetCenterActive(Boolean val);

extern Boolean SaveAllClearsAll(void);
extern void SetSaveAllClearsAll(Boolean val);

extern Boolean ClearClearsNote(void);
extern void SetClearClearsNote(Boolean val);

extern Boolean MenuHack(void);
extern void SetMenuHack(Boolean val);

extern Boolean AlwaysNewNote(void);
extern void SetAlwaysNewNote(Boolean val);

extern Int RowToSlot(Int row);
extern void SetRowToSlot(Int row, Int slot);
extern Int SlotToRow(Int slot);
extern Int* RowToSlotAddr(void);

extern Boolean Ignored(Int slot);
extern void SetIgnored(Int slot, Boolean val);

#endif
