/*
 * Vexed v1.3 - globals.c "Global variable declarations"
 * Copyright (C) 1999 James McCombe (cybertube@earthling.net)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * */

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#include "vexed.h"
#include "protos.h"

VoidHand Bitmap_Handle1, Bitmap_Handle2, Bitmap_Handle3, Bitmap_Handle4, Bitmap_Handle5, Bitmap_Handle6, Bitmap_Handle7,
	Bitmap_Handle8, Bitmap_Handle9;

BitmapPtr Bitmap [10];

int level [59] [9] [11] = 
{
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 2, 1, 0, 0, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 0, 0, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 0, 0, 9, 9, 9 },
		{ 9, 9, 9, 1, 0, 0, 2, 9, 9, 9 },
		{ 9, 9, 9, 9, 1, 2, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 1, 0, 0, 9, 9 },
		{ 9, 9, 9, 0, 0, 2, 0, 0, 9, 9 },
		{ 9, 9, 9, 0, 1, 3, 0, 0, 9, 9 },
		{ 9, 9, 9, 0, 2, 4, 0, 0, 9, 9 },
		{ 9, 9, 9, 2, 4, 3, 0, 3, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 0, 0, 9, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 0, 0, 9, 9, 9 },
		{ 9, 9, 5, 0, 7, 6, 0, 5, 9, 9 },
		{ 9, 9, 6, 0, 9, 9, 0, 7, 9, 9 },
		{ 9, 9, 9, 6, 0, 0, 7, 9, 9, 9 },
		{ 9, 9, 9, 9, 0, 0, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 2, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 1, 3, 0, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 1, 0, 1, 0, 9, 9 },
		{ 9, 9, 9, 9, 3, 0, 3, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 2, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 1, 0, 3, 9, 9, 9 },
		{ 9, 9, 9, 9, 4, 0, 4, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 0, 5, 9, 9, 9 },
		{ 9, 9, 9, 9, 0, 0, 4, 9, 9, 9 },
		{ 9, 9, 9, 9, 0, 0, 5, 9, 9, 9 },
		{ 9, 9, 9, 9, 3, 9, 1, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 0, 0, 0, 9, 9 },
		{ 9, 9, 9, 5, 0, 0, 0, 7, 9, 9 },
		{ 9, 9, 9, 9, 6, 0, 0, 9, 9, 9 },
		{ 9, 9, 9, 6, 7, 0, 2, 7, 9, 9 },
		{ 9, 9, 9, 5, 6, 0, 7, 2, 9, 9 },
		{ 9, 9, 9, 9, 5, 7, 2, 7, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 1, 3, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 3, 4, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 4, 1, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 1, 3, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 0, 0, 0, 0, 0, 4, 9, 9 },
		{ 9, 9, 0, 0, 0, 0, 0, 5, 9, 9 },
		{ 9, 9, 2, 0, 0, 1, 0, 2, 9, 9 },
		{ 9, 9, 1, 5, 0, 5, 0, 9, 9, 9 },
		{ 9, 9, 5, 2, 4, 9, 2, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 0, 2, 9, 9, 9 },
		{ 9, 9, 9, 1, 0, 0, 3, 2, 9, 9 },
		{ 9, 9, 9, 9, 1, 0, 2, 3, 9, 9 },
		{ 9, 9, 9, 9, 9, 0, 3, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 0, 0, 0, 0, 0, 0, 9, 9 },
                	{ 9, 3, 0, 0, 0, 0, 3, 0, 0, 9 },
           	     	{ 9, 4, 5, 4, 0, 0, 4, 7, 0, 9 },
                	{ 9, 5, 2, 3, 0, 0, 7, 3, 2, 9 },
                	{ 9, 7, 5, 4, 0, 9, 2, 5, 6, 9 },
                	{ 9, 2, 7, 5, 9, 9, 5, 6, 4, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 0, 0, 0, 0, 3, 4, 9, 9 },
                	{ 9, 9, 0, 0, 5, 0, 9, 9, 9, 9 },
                	{ 9, 9, 0, 0, 9, 0, 0, 0, 9, 9 },
               	{ 9, 9, 4, 0, 9, 0, 0, 0, 9, 9 },
                	{ 9, 9, 9, 9, 0, 0, 7, 3, 9, 9 },
                	{ 9, 9, 3, 0, 0, 5, 3, 7, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 2, 1, 3, 0, 3, 1, 2, 9 },
                	{ 9, 9, 9, 9, 9, 0, 9, 9, 9, 9 },
                	{ 9, 9, 9, 1, 0, 0, 0, 1, 9, 9 },
                	{ 9, 9, 9, 9, 0, 0, 0, 9, 9, 9 },
                	{ 9, 9, 9, 9, 0, 0, 0, 9, 9, 9 },
                	{ 9, 9, 9, 9, 2, 1, 3, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 1, 3, 4, 3, 0, 4, 3, 1, 9 },
                	{ 9, 9, 9, 9, 9, 0, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 0, 0, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 0, 0, 9, 9, 9 },
                	{ 9, 9, 9, 9, 4, 0, 0, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 0, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 5, 0, 0, 9, 9, 9 },
                	{ 9, 9, 9, 9, 7, 0, 0, 9, 9, 9 },
                	{ 9, 9, 9, 0, 6, 0, 6, 5, 9, 9 },
                	{ 9, 9, 9, 9, 7, 9, 5, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 1, 0, 9, 9, 9 },
                	{ 9, 9, 9, 1, 0, 3, 0, 1, 9, 9 },
                	{ 9, 9, 9, 9, 0, 1, 0, 3, 9, 9 },
                	{ 9, 9, 9, 3, 0, 9, 3, 1, 9, 9 },
                	{ 9, 9, 9, 9, 3, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 2, 1, 2, 0, 3, 2, 4, 9 },
                	{ 9, 9, 9, 2, 4, 0, 4, 1, 9, 9 },
                	{ 9, 9, 9, 9, 3, 0, 1, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 4, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 1, 3, 4, 0, 1, 9, 9 },
                	{ 9, 9, 9, 5, 9, 5, 1, 4, 9, 9 },
                	{ 9, 9, 9, 7, 0, 7, 5, 3, 9, 9 },
                	{ 9, 9, 9, 9, 0, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 5, 7, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 7, 1, 9, 9, 9, 9, 9 },
	    	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 5, 0, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 7, 0, 0, 9, 9 },
                	{ 9, 9, 9, 6, 0, 6, 0, 9, 9, 9 },
                	{ 9, 9, 9, 7, 0, 5, 0, 9, 9, 9 },
                	{ 9, 9, 9, 9, 0, 7, 0, 0, 9, 9 },
                	{ 9, 9, 9, 9, 9, 5, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 2, 0, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 0, 2, 9, 9, 9 },
                	{ 9, 9, 1, 3, 0, 0, 4, 9, 9, 9 },
                	{ 9, 9, 4, 1, 0, 0, 2, 3, 9, 9 },
                	{ 9, 9, 3, 4, 0, 4, 3, 9, 9, 9 },
                	{ 9, 9, 9, 9, 0, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 0, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 0, 1, 9, 9, 9 },
                	{ 9, 9, 9, 9, 0, 0, 3, 0, 9, 9 },
                	{ 9, 9, 9, 4, 0, 0, 5, 0, 9, 9 },
                	{ 9, 9, 9, 9, 1, 3, 9, 5, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 4, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
        	{
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 0, 2, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 1, 3, 9, 9, 9 },
                	{ 9, 9, 9, 3, 0, 2, 1, 9, 9, 9 },
                	{ 9, 9, 9, 4, 0, 3, 4, 0, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
                	{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
        	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 6, 0, 0, 0, 0, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 0, 0, 9, 9, 9 },
        		{ 9, 9, 8, 0, 0, 0, 6, 8, 9, 9 },
        		{ 9, 9, 9, 9, 0, 0, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 8, 0, 0, 9, 9, 9 },
        		{ 9, 9, 9, 9, 6, 0, 0, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 2, 9 },
        		{ 9, 9, 0, 0, 0, 0, 1, 0, 3, 9 },
        		{ 9, 9, 4, 0, 5, 0, 7, 0, 1, 9 },
        		{ 9, 9, 3, 0, 2, 0, 6, 0, 6, 9 },
        		{ 9, 9, 4, 0, 7, 0, 5, 0, 5, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 4, 0, 4, 0, 0, 9, 9 },
        		{ 9, 9, 9, 9, 0, 5, 0, 5, 9, 9 },
        		{ 9, 9, 9, 5, 0, 7, 0, 7, 9, 9 },
        		{ 9, 9, 9, 4, 0, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 0, 2, 1, 3, 4, 0, 9, 9 },
        		{ 9, 9, 0, 9, 9, 9, 5, 0, 9, 9 },
        		{ 9, 9, 5, 0, 9, 0, 2, 0, 9, 9 },
        		{ 9, 9, 4, 0, 0, 0, 9, 5, 9, 9 },
        		{ 9, 9, 3, 1, 9, 5, 2, 4, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 2, 1, 0, 0, 9, 9, 9 },
        		{ 9, 9, 9, 3, 2, 0, 0, 9, 9, 9 },
        		{ 9, 9, 9, 1, 3, 0, 4, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 0, 3, 9, 9, 9 },
        		{ 9, 9, 9, 3, 1, 0, 2, 9, 9, 9 },
        		{ 9, 9, 9, 4, 9, 0, 1, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 0, 3, 9, 9, 9 },
        		{ 9, 9, 9, 9, 0, 0, 4, 3, 9, 9 },
        		{ 9, 9, 9, 4, 0, 5, 7, 9, 9, 9 },
        		{ 9, 9, 9, 9, 3, 7, 3, 0, 9, 9 },
        		{ 9, 9, 9, 9, 9, 5, 4, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 0, 4, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 5, 9, 9, 9, 9 },
        		{ 9, 9, 9, 7, 0, 7, 0, 0, 9, 9 },
        		{ 9, 9, 9, 4, 7, 9, 6, 4, 9, 9 },
        		{ 9, 9, 4, 5, 9, 9, 9, 6, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 2, 0, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 0, 0, 1, 9, 9 },
        		{ 9, 9, 9, 1, 0, 0, 0, 3, 9, 9 },
        		{ 9, 9, 9, 3, 0, 0, 1, 2, 9, 9 },
        		{ 9, 9, 9, 4, 0, 4, 3, 9, 9, 9 },
        		{ 9, 9, 9, 3, 0, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 1, 9, 0, 0, 3, 0, 9, 9 },
        		{ 9, 9, 3, 9, 0, 0, 4, 0, 9, 9 },
        		{ 9, 9, 5, 0, 7, 0, 5, 4, 9, 9 },
        		{ 9, 9, 9, 9, 3, 0, 9, 3, 9, 9 },
        		{ 9, 9, 9, 9, 9, 1, 9, 7, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 0, 2, 0, 1, 0, 9, 9 },
        		{ 9, 9, 9, 0, 1, 2, 3, 0, 9, 9 },
        		{ 9, 9, 9, 4, 3, 1, 2, 0, 9, 9 },
        		{ 9, 9, 9, 2, 5, 3, 1, 5, 9, 9 },
        		{ 9, 9, 9, 9, 4, 5, 2, 1, 9, 9 },
        		{ 9, 9, 9, 9, 9, 4, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 0, 0, 0, 9, 9, 9, 9 },
        		{ 9, 2, 0, 0, 1, 3, 0, 0, 9, 9 },
        		{ 9, 9, 0, 0, 3, 9, 0, 0, 0, 9 },
        		{ 9, 4, 0, 0, 4, 0, 0, 0, 2, 9 },
        		{ 9, 9, 1, 0, 9, 0, 0, 9, 9, 9 },
        		{ 9, 9, 4, 9, 9, 9, 3, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 2, 1, 9, 9, 9, 9 },
        		{ 9, 9, 9, 0, 3, 4, 5, 9, 9, 9 },
        		{ 9, 9, 0, 0, 7, 1, 6, 5, 9, 9 },
        		{ 9, 9, 0, 0, 3, 4, 8, 7, 9, 9 },
        		{ 9, 9, 9, 0, 8, 6, 7, 9, 9, 9 },
        		{ 9, 9, 9, 9, 5, 2, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 3, 0, 0, 0, 0, 4, 9, 9 },
        		{ 9, 9, 9, 9, 0, 0, 9, 9, 9, 9 },
        		{ 9, 9, 9, 3, 5, 3, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 4, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 5, 0, 9, 9, 9, 9 },
        		{ 9, 9, 9, 0, 4, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 2, 1, 0, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 2, 0, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 0, 9, 9, 9 },
        		{ 9, 9, 9, 4, 1, 3, 0, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 4, 0, 9, 9, 9 },
        		{ 9, 9, 9, 2, 1, 3, 2, 4, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 1, 3, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 4, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 0, 5, 0, 9, 9, 9, 9 },
        		{ 9, 9, 0, 0, 3, 0, 0, 5, 9, 9 },
        		{ 9, 9, 3, 0, 9, 0, 0, 4, 9, 9 },
        		{ 9, 9, 1, 3, 1, 4, 5, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 0, 2, 0, 0, 0, 0, 9, 9 },
        		{ 9, 9, 0, 1, 0, 0, 3, 0, 9, 9 },
        		{ 9, 9, 1, 9, 1, 0, 9, 3, 9, 9 },
        		{ 9, 9, 9, 0, 4, 5, 0, 9, 9, 9 },
        		{ 9, 9, 5, 0, 3, 4, 5, 2, 9, 9 },
        		{ 9, 9, 9, 1, 5, 3, 2, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 0, 0, 2, 1, 9 },
        		{ 9, 9, 9, 9, 9, 0, 0, 1, 2, 9 },
        		{ 9, 9, 9, 0, 0, 0, 2, 3, 1, 9 },
        		{ 9, 9, 4, 1, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 3, 2, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 4, 3, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 2, 1, 0, 0, 9, 9, 9 },
        		{ 9, 9, 9, 3, 4, 0, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 5, 0, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 5, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 0, 1, 4, 9, 9, 9 },
        		{ 9, 9, 9, 0, 0, 3, 2, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 0, 0, 2, 1, 9 },
        		{ 9, 9, 9, 9, 9, 0, 0, 3, 2, 9 },
        		{ 9, 9, 9, 9, 9, 0, 2, 4, 1, 9 },
        		{ 9, 9, 3, 1, 0, 0, 9, 9, 9, 9 },
        		{ 9, 9, 4, 2, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 1, 4, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 0, 0, 2, 1, 9, 9, 9 },
        		{ 9, 9, 9, 3, 0, 1, 9, 9, 9, 9 },
        		{ 9, 9, 4, 1, 0, 3, 0, 1, 9, 9 },
        		{ 9, 9, 1, 2, 0, 4, 1, 9, 9, 9 },
        		{ 9, 9, 4, 1, 0, 1, 4, 9, 9, 9 },
        		{ 9, 9, 9, 9, 1, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 0, 0, 0, 9, 9, 9, 9 },
        		{ 9, 9, 9, 3, 4, 0, 0, 9, 9, 9 },
        		{ 9, 9, 9, 9, 5, 4, 0, 0, 9, 9 },
        		{ 9, 9, 9, 9, 9, 3, 0, 5, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 0, 3, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
        		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 1, 0, 0, 9, 9, 9, 9, 9 },
		{ 9, 9, 3, 0, 9, 3, 9, 9, 9, 9 },
		{ 9, 9, 9, 4, 0, 4, 5, 9, 9, 9 },
		{ 9, 9, 9, 5, 0, 1, 4, 5, 9, 9 },
		{ 9, 9, 9, 9, 0, 4, 1, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 1, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 2, 1, 0, 0, 0, 3, 9, 9 },
		{ 9, 9, 4, 3, 4, 0, 0, 4, 9, 9 },
		{ 9, 9, 9, 2, 3, 1, 0, 3, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 0, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 0, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 2, 9, 0, 0, 1, 9, 9 },
		{ 9, 9, 9, 1, 9, 0, 2, 3, 9, 9 },
		{ 9, 9, 9, 4, 0, 3, 5, 2, 9, 9 },
		{ 9, 9, 9, 9, 0, 4, 2, 5, 9, 9 },
		{ 9, 9, 9, 9, 0, 2, 5, 9, 9, 9 },
		{ 9, 9, 9, 9, 0, 1, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 2, 0, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 1, 0, 0, 0, 0, 9, 9 },
		{ 9, 9, 9, 9, 0, 0, 0, 2, 9, 9 },
		{ 9, 9, 9, 0, 0, 1, 0, 1, 9, 9 },
		{ 9, 9, 9, 0, 0, 2, 9, 2, 9, 9 },
		{ 9, 9, 9, 0, 0, 1, 2, 1, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 0, 2, 1, 0, 3, 1, 4, 9 },
		{ 9, 9, 0, 3, 5, 0, 5, 4, 9, 9 },
		{ 9, 9, 0, 9, 9, 0, 9, 9, 9, 9 },
		{ 9, 9, 3, 5, 2, 0, 3, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 0, 2, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 2, 0, 0, 9, 9 },
		{ 9, 9, 9, 1, 0, 3, 0, 0, 9, 9 },
		{ 9, 9, 9, 9, 0, 9, 0, 0, 9, 9 },
		{ 9, 9, 9, 0, 0, 3, 0, 0, 9, 9 },
		{ 9, 9, 9, 1, 0, 1, 0, 3, 9, 9 },
		{ 9, 9, 9, 2, 0, 2, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 2, 1, 0, 9, 9, 9, 9, 9 },
		{ 9, 9, 3, 2, 4, 0, 0, 9, 9, 9 },
		{ 9, 3, 9, 9, 9, 9, 0, 0, 9, 9 },
		{ 9, 5, 0, 0, 0, 0, 5, 0, 0, 9 },
		{ 9, 3, 0, 4, 2, 4, 2, 1, 2, 9 },
		{ 9, 9, 4, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 2, 0, 1, 9, 9, 9, 9 },
		{ 9, 0, 0, 1, 0, 9, 0, 0, 3, 9 },
		{ 9, 2, 0, 4, 0, 0, 3, 4, 9, 9 },
		{ 9, 9, 9, 9, 0, 0, 5, 9, 9, 9 },
		{ 9, 9, 9, 4, 0, 5, 9, 9, 9, 9 },
		{ 9, 9, 9, 5, 0, 1, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 2, 0, 0, 0, 0, 1, 9, 9 },
		{ 9, 3, 4, 0, 2, 1, 0, 5, 3, 9 },
		{ 9, 7, 5, 0, 9, 9, 0, 3, 4, 9 },
		{ 9, 9, 9, 0, 0, 0, 0, 9, 9, 9 },
		{ 9, 9, 9, 0, 0, 0, 7, 9, 9, 9 },
		{ 9, 9, 9, 9, 7, 5, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 0, 2, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 0, 1, 9, 9, 9, 9 },
		{ 9, 0, 0, 0, 0, 2, 0, 3, 4, 9 },
		{ 9, 5, 0, 0, 0, 1, 0, 4, 5, 9 },
		{ 9, 9, 9, 9, 0, 2, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 0, 3, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 2, 1, 3, 9, 9, 9 },
		{ 9, 9, 9, 9, 4, 2, 1, 9, 9, 9 },
		{ 9, 9, 9, 0, 3, 9, 4, 0, 9, 9 },
		{ 9, 9, 0, 0, 9, 9, 9, 0, 1, 9 },
		{ 9, 9, 0, 0, 4, 2, 4, 0, 3, 9 },
		{ 9, 9, 4, 3, 9, 9, 9, 3, 2, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 0, 0, 2, 1, 3, 0, 9, 9 },
		{ 9, 9, 0, 9, 9, 9, 9, 0, 1, 9 },
		{ 9, 9, 0, 0, 0, 4, 0, 0, 5, 9 },
		{ 9, 9, 5, 0, 0, 5, 0, 0, 2, 9 },
		{ 9, 9, 3, 0, 2, 3, 0, 0, 7, 9 },
		{ 9, 9, 2, 3, 5, 9, 1, 7, 4, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 2, 1, 0, 0, 0, 0, 3, 4, 9 },
		{ 9, 4, 5, 3, 0, 0, 7, 1, 5, 9 },
		{ 9, 5, 2, 4, 0, 0, 5, 4, 7, 9 },
		{ 9, 7, 4, 2, 0, 0, 9, 7, 4, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 0, 2, 9, 1, 0, 0, 9, 9 },
		{ 9, 9, 3, 4, 9, 9, 9, 0, 9, 9 },
		{ 9, 9, 4, 5, 0, 0, 9, 0, 9, 9 },
		{ 9, 9, 3, 7, 9, 0, 9, 0, 9, 9 },
		{ 9, 9, 7, 5, 2, 0, 0, 1, 9, 9 },
		{ 9, 9, 6, 2, 3, 0, 3, 6, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 0, 0, 0, 0, 0, 2, 0, 0, 9 },
		{ 9, 1, 0, 0, 3, 0, 4, 0, 0, 9 },
		{ 9, 5, 0, 0, 4, 3, 1, 2, 0, 9 },
		{ 9, 7, 0, 0, 3, 4, 2, 6, 0, 9 },
		{ 9, 5, 0, 0, 7, 8, 6, 2, 8, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 9, 9, 9, 2, 0, 9, 9, 0, 0, 9 },
                	{ 9, 9, 9, 9, 0, 0, 7, 0, 1, 9 },
		{ 9, 9, 9, 0, 7, 0, 1, 0, 9, 9 },
                	{ 9, 9, 0, 0, 5, 1, 2, 0, 9, 9 },
		{ 9, 9, 9, 0, 2, 9, 7, 0, 9, 9 },
		{ 9, 9, 9, 5, 7, 9, 1, 2, 1, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	},
	{
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 },
		{ 2, 0, 9, 9, 9, 9, 1, 0, 1, 9 },
		{ 9, 0, 9, 2, 0, 0, 3, 0, 4, 9 },
		{ 9, 0, 9, 9, 0, 0, 5, 0, 5, 9 },
		{ 9, 2, 0, 5, 4, 0, 3, 0, 3, 7 },
		{ 9, 9, 9, 9, 5, 0, 9, 0, 7, 5 },
		{ 9, 9, 9, 9, 3, 0, 9, 0, 9, 9 },
		{ 9, 9, 9, 9, 9, 9, 9, 9, 9, 9 }
	}
};

int current [9] [11];
int stored [9] [11]; // for storing the current state when the memory button is pushed
int RemainingBlocks;

struct {
	Boolean
		PieceMoveAnim, // whether the movement of a piece by the user is animated
		GravityAnim, // whether the gravity effect is animated
		EliminationAnim, // whether piece elimination is animated
		Sound; // whether game sound is on or off
	int CurrentLevel, SolvedLevels; // stores the level the user was last at
} VexedPreferences;
