/*
 * Vexed v1.3 - sound.c "Sound specific code for vexed"
 * Copyright (C) 1999 James McCombe (cybertube@earthling.net)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * */

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#include "Vexed.h"
#include "protos.h"

extern struct {
	Boolean
		PieceMoveAnim, // whether the movement of a piece by the user is animated
		GravityAnim, // whether the gravity effect is animated
		EliminationAnim, // whether piece elimination is animated
		Sound; // whether sound is on or off
	int CurrentLevel, SolvedLevels; // stores the level the user was last at
} VexedPreferences;

void SoundEffect(int effect)
{
SndCommandType s;

s.cmd = sndCmdFreqDurationAmp;
s.param3 = 0;
if (VexedPreferences.Sound) s.param3 = 64; // amplitude

if (effect == HighBeep)
	{
	s.param1 = 4000; // frequency
	s.param2 = 20; // duration (in ms)
	SndDoCmd(0, &s, 0);
	}

if (effect == LowBeep)
	{
	s.param1 = 150;
	s.param2 = 20;
	SndDoCmd(0, &s, 0);
	}

if (effect == HighSweepLow)
	{
	s.param2 = 2;
	for (s.param1 = 2000; s.param1 >=1500; s.param1 -= 50)
		SndDoCmd(0, &s, 0);
	}
}
