/*
 * Vexed v1.3 - system.c "Application independant stuff"
 * Copyright (C) 1999 James McCombe (cybertube@earthling.net)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * */

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#include "vexed.h"
#include "protos.h"

extern struct {
	Boolean
		PieceMoveAnim, // whether the movement of a piece by the user is animated
		GravityAnim, // whether the gravity effect is animated
		EliminationAnim, // whether piece elimination is animated
		Sound; // whether sound is on or off
	int CurrentLevel, SolvedLevels; // stores the level the user was last at
} VexedPreferences;

Boolean CompareLevelArrays(int Array1 [9] [11], int Array2 [9] [11])
{
int x, y;

for (y = 0; y <= 7; y ++)
	for (x = 0; x <= 9; x ++)
		if (!Array1[y][x] == Array2[y][x])
			{
			return 1;
			break;
			}
return 0;
}

void LoadPreferences()
{
// load application preferences into the structure shown above
if (!PrefGetAppPreferencesV10('vexd', 0, &VexedPreferences, sizeof(VexedPreferences)))
	{
	VexedPreferences.PieceMoveAnim = 1;
	VexedPreferences.GravityAnim = 1;
	VexedPreferences.EliminationAnim = 1;
	VexedPreferences.CurrentLevel = 0;
	VexedPreferences.SolvedLevels = 0;
	}
}

void SavePreferences()
{
// write out the application preferences
PrefSetAppPreferencesV10('vexd', 0, &VexedPreferences, sizeof(VexedPreferences));
}
