/* $Id: vmcse.c,v 1.1 2000/12/16 08:08:43 jaq Exp $ */

#include <Pilot.h>
#include "callback.h"
#include "vmcse.h"
#include "solutions.h"

static FieldPtr WriteString(CharPtr s, int field) {
	Handle hdl, oldhdl;
	FieldPtr fld;
	FormPtr frm;

	hdl = (Handle) MemHandleNew(StrLen(s) + 1);
	if (!hdl)
		return NULL;
	StrCopy(MemHandleLock((VoidHand) hdl), s);
	MemHandleUnlock((VoidHand) hdl);
	frm = FrmGetActiveForm();
	fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, field));
	ErrNonFatalDisplayIf(!fld, "missing field");
	oldhdl = FldGetTextHandle(fld);
	FldSetTextHandle(fld, hdl);
	FldDrawField(fld);
	if (oldhdl)
		MemHandleFree((VoidHand) oldhdl);
	return fld;
}

static Boolean MainFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;

#ifdef __GNUC__
    CALLBACK_PROLOGUE
#endif

    switch (e->eType) {
    case frmOpenEvent:
	frm = FrmGetActiveForm();
	FrmDrawForm(frm);
	WriteString("My Windows computer is not working!", DescField);
	handled = true;
	break;

    case menuEvent:
	MenuEraseStatus(NULL);

	switch(e->data.menu.itemID) {
	  case AbootMenu:
	    	FrmAlert(AbootAlert);
		handled = true;
		break;
	
	}

    	handled = true;
	break;

    case ctlSelectEvent:
	switch(e->data.ctlSelect.controlID) {
	  case ConsultButton:
	    	FrmPopupForm(AnswerForm);
	    	handled = true;
		break;
	  default:
		break;
	}
	break;

    default:
        break;
    }

#ifdef __GNUC__
    CALLBACK_EPILOGUE
#endif __GNUC__

    return handled;
}

static Boolean AnswerFormHandleEvent(EventPtr e) {
	Boolean handled = false;
	FormPtr frm;
	
#ifdef __GNUC__
	CALLBACK_PROLOGUE
#endif
	switch (e->eType) {
		case frmOpenEvent:
			frm = FrmGetActiveForm();
	  		FrmDrawForm(frm);
			WriteString(solutions[SysRandom(0) % SOLUTION_COUNT], AnswerField);
			handled = true; 
			break;
		case menuEvent:
			MenuEraseStatus(NULL);
			switch (e->data.menu.itemID) {
				case AbootMenu:
					FrmAlert(AbootAlert);
					handled = true;
					break;
			}
			handled = true;
			break;
		case ctlSelectEvent:
			switch (e->data.ctlSelect.controlID) {
				case AgainButton:
				  	FrmReturnToForm(MainForm);
					handled = true;
					break;
				default:
					break;
			}
			break;
		default:
			break;
	}
	
#ifdef __GNUC__
	CALLBACK_EPILOGUE
#endif __GNUC__
	return handled;
}


static Boolean ApplicationHandleEvent(EventPtr e)
{
    FormPtr frm;
    Word    formId;
    Boolean handled = false;

    if (e->eType == frmLoadEvent) {
	formId = e->data.frmLoad.formID;
	frm = FrmInitForm(formId);
	FrmSetActiveForm(frm);

	switch(formId) {
	case MainForm:
	    FrmSetEventHandler(frm, MainFormHandleEvent);
	    break;
	case AnswerForm:
	    FrmSetEventHandler(frm, AnswerFormHandleEvent);
	    break;
	default:
	    break;
	}
	handled = true;
    }

    return handled;
}

/* Get preferences, open (or create) app database */
static Word StartApplication(void)
{
    FrmGotoForm(MainForm);
    return 0;
}

/* Save preferences, close forms, close app database */
static void StopApplication(void)
{
    FrmSaveAllForms();
    FrmCloseAllForms();
}

/* The main event loop */
static void EventLoop(void)
{
    Word err;
    EventType e;

    do {
	EvtGetEvent(&e, evtWaitForever);
	if (! SysHandleEvent (&e))
	    if (! MenuHandleEvent (NULL, &e, &err))
		if (! ApplicationHandleEvent (&e))
		    FrmDispatchEvent (&e);
    } while (e.eType != appStopEvent);
}

/* check the rom version of the palm device
 *  * taken from Tom Dyas' tictactoe 0.95 code -- thanx, Tom :) */
static Err RomVersionCompat(DWord reqdVer, Word launchFlags) { 
  DWord romVersion; 
  Err err;

  FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion); 
  if (romVersion < reqdVer) { 
    	if ( (launchFlags &
					       (sysAppLaunchFlagNewGlobals |
						sysAppLaunchFlagUIApp)) ==
					      (sysAppLaunchFlagNewGlobals |
					       sysAppLaunchFlagUIApp)) {
		  FrmAlert(BadRomAlert);
						      /* Pilot 1.0 will
						       * continuously relaunch
						       * this app unless we
						       * switch to * another
						       * safe one */
						      if (romVersion <
							  0x02000000)
							AppLaunchWithCommand(sysFileCDefaultApp,
							    sysAppLaunchCmdNormalLaunch,
							    NULL); } return
							  (sysErrRomIncompatible);
		} return (0); }

/* Main entry point; it is unlikely you will need to change this except to
   handle other launch command codes */
DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
    Word err;

    err = RomVersionCompat(sysMakeROMVersion(2, 0, 0, sysROMStageRelease, 0), launchFlags);
    if (err)
      	return err;

    if (cmd == sysAppLaunchCmdNormalLaunch) {

	err = StartApplication();
	if (err) return err;

	EventLoop();
	StopApplication();

    } else {
	return sysErrParamErr;
    }

    return 0;
}
