
/*
 * ButtonLabel.java
 *
 *
 * Copyright (c) 2000, David M. Archer
 *
 * See LICENSE file for more information.
 *
 */

package wabadma.ui;

import waba.ui.*;
import waba.fx.*;
import waba.sys.*;

/**
 * A waba label control extended to provide a ControlEvent.PRESSED if it
 * is clicked on.
 *
 * @author David M. Archer <dmarcher@pobox.com>
 *
 * @version 0.1, 2000 Nov 21 - initial version
 */
public class ButtonLabel extends Label {

	public ButtonLabel(String s) {
		super(s);
	}

	public void onEvent(Event e) {
		if (e.type == PenEvent.PEN_UP) {
			PenEvent pe = (PenEvent)e;
			if (pe.x >= 0 && pe.x < this.width 
			&& pe.y >= 0 && pe.y < this.height)
				postEvent(new ControlEvent(ControlEvent.PRESSED, this));
		} 
	}
}
