
/*
 * NumericEdit.java
 *
 *
 * Copyright (c) 2000, David M. Archer
 *
 * See LICENSE file for more information.
 *
 */

package wabadma.ui;

import waba.ui.*;
import waba.fx.*;
import waba.sys.*;

/**
 * A waba edit control extended with methods to get and set int values.
 * No attempt to validate the values is (yet) done.
 *
 * @version 0.1, 2000 Nov 07
 * @author David M. Archer <dmarcher@pobox.com>
 */
public class NumericEdit extends Edit {

	/**
	 * get the int value of the control.
	 *
	 */
	public int getInt() {
		return Convert.toInt(this.getText());

	}


	/**
	 * set the control to the value of an int.
	 *
	 * @param i value to set control to
	 *
	 */
	public void setInt(int i) {	
		this.setText(Convert.toString(i));
	
	}
}


