
/*
 * DLWRandomTest.java
 *
 *
 * Copyright (c) 2000, David M. Archer
 *
 * See LICENSE file for more information.
 *
 */

import waba.ui.*;
import waba.fx.*;
import waba.sys.*;

import extra.ui.*;

import wabadma.ui.*;
import wabadma.util.*;

public class DLWRandomTest extends ExtraMainWindow {
	DLWRandom r;

   	static Button randomButton;
   	static Button exitButton;
   	static Button getButton;
	static OutputBox out;

	private final static int[] LINES_A = {96,97};
	private final static int BUTTON_H = 15;
	
	public DLWRandomTest() {
		super("DLWRandomTest");
		r=new DLWRandom();

		exitButton  = new Button("Exit");
		exitButton.setRect(40,144,80,BUTTON_H);
		add(exitButton);

		getButton  = new Button("Get");
		getButton.setRect(40,128,80,BUTTON_H);
		add(getButton);

		randomButton = new Button("Random(10)");
		randomButton.setRect(40,112,80,BUTTON_H);
		add(randomButton);

		// create a place to output text
		out = new OutputBox(0,16,this.width,80);
		add(out);

		out.println("DLWRandom init to "+r.get());
		this.repaint();
	}

	public void clearRect(Graphics g, int x, int y, int w, int h) {
		g.setColor(255,255,255);
		g.fillRect(x,y,w,h);
		g.setColor(0,0,0);
	}

	public void onPaint(Graphics g) {

		// Draw lines as per LINES_A
		for(int i=0;i<LINES_A.length;i++)
			g.drawLine(0,LINES_A[i],159,LINES_A[i]);

	 }

	public void onEvent(Event e) {
      		// buttons 
      		if (e.type == ControlEvent.PRESSED) {
			if (e.target instanceof Button) {	
				if (e.target == exitButton)
       			  		end();
				if (e.target == getButton) {
					out.println("got #: "+ r.next());
					this.repaint();
    				}
				if (e.target == randomButton) {
					out.println("random(10): "+r.random(10));
					this.repaint();
				}
			} 
		}				
  	 }

   public void end() {
      exit(0);
   }
}
